---
layout: global
title: INVALID_LIMIT_LIKE_EXPRESSION error class
displayTitle: INVALID_LIMIT_LIKE_EXPRESSION error class
license: |
  Licensed to the Apache Software Foundation (ASF) under one or more
  contributor license agreements.  See the NOTICE file distributed with
  this work for additional information regarding copyright ownership.
  The ASF licenses this file to You under the Apache License, Version 2.0
  (the "License"); you may not use this file except in compliance with
  the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
---

SQLSTATE: none assigned

The limit like expression `<expr>` is invalid.

This error class has the following derived error classes:

## DATA_TYPE

The `<name>` expression must be integer type, but got `<dataType>`.

## IS_NEGATIVE

The `<name>` expression must be equal to or greater than 0, but got `<v>`.

## IS_NULL

The evaluated `<name>` expression must not be null.

## IS_UNFOLDABLE

The `<name>` expression must evaluate to a constant value.


