/**
 * vis-timeline and vis-graph2d
 * https://visjs.github.io/vis-timeline/
 *
 * Create a fully customizable, interactive timeline with items and ranges.
 *
 * @version 7.7.2
 * @date    2023-03-22T11:14:31.874Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}function r(t){throw new Error('Could not dynamically require "'+t+'". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.')}var o,s,a={},l={get exports(){return a},set exports(t){a=t}};function h(){return o||(o=1,function(t,e){t.exports=function(){var e,i;function n(){return e.apply(null,arguments)}function o(t){e=t}function s(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function a(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function l(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function h(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(l(t,e))return!1;return!0}function u(t){return void 0===t}function c(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function d(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function p(t,e){var i,n=[],r=t.length;for(i=0;i<r;++i)n.push(e(t[i],i));return n}function f(t,e){for(var i in e)l(e,i)&&(t[i]=e[i]);return l(e,"toString")&&(t.toString=e.toString),l(e,"valueOf")&&(t.valueOf=e.valueOf),t}function m(t,e,i,n){return qi(t,e,i,n,!0).utc()}function v(){return{empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}}function g(t){return null==t._pf&&(t._pf=v()),t._pf}function y(t){if(null==t._isValid){var e=g(t),n=i.call(e.parsedDateParts,(function(t){return null!=t})),r=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidEra&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&n);if(t._strict&&(r=r&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return r;t._isValid=r}return t._isValid}function b(t){var e=m(NaN);return null!=t?f(g(e),t):g(e).userInvalidated=!0,e}i=Array.prototype.some?Array.prototype.some:function(t){var e,i=Object(this),n=i.length>>>0;for(e=0;e<n;e++)if(e in i&&t.call(this,i[e],e,i))return!0;return!1};var _=n.momentProperties=[],w=!1;function k(t,e){var i,n,r,o=_.length;if(u(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),u(e._i)||(t._i=e._i),u(e._f)||(t._f=e._f),u(e._l)||(t._l=e._l),u(e._strict)||(t._strict=e._strict),u(e._tzm)||(t._tzm=e._tzm),u(e._isUTC)||(t._isUTC=e._isUTC),u(e._offset)||(t._offset=e._offset),u(e._pf)||(t._pf=g(e)),u(e._locale)||(t._locale=e._locale),o>0)for(i=0;i<o;i++)u(r=e[n=_[i]])||(t[n]=r);return t}function x(t){k(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===w&&(w=!0,n.updateOffset(this),w=!1)}function D(t){return t instanceof x||null!=t&&null!=t._isAMomentObject}function S(t){!1===n.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function C(t,e){var i=!0;return f((function(){if(null!=n.deprecationHandler&&n.deprecationHandler(null,t),i){var r,o,s,a=[],h=arguments.length;for(o=0;o<h;o++){if(r="","object"==typeof arguments[o]){for(s in r+="\n["+o+"] ",arguments[0])l(arguments[0],s)&&(r+=s+": "+arguments[0][s]+", ");r=r.slice(0,-2)}else r=arguments[o];a.push(r)}S(t+"\nArguments: "+Array.prototype.slice.call(a).join("")+"\n"+(new Error).stack),i=!1}return e.apply(this,arguments)}),e)}var T,M={};function O(t,e){null!=n.deprecationHandler&&n.deprecationHandler(t,e),M[t]||(S(e),M[t]=!0)}function E(t){return"undefined"!=typeof Function&&t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function P(t){var e,i;for(i in t)l(t,i)&&(E(e=t[i])?this[i]=e:this["_"+i]=e);this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)}function I(t,e){var i,n=f({},t);for(i in e)l(e,i)&&(a(t[i])&&a(e[i])?(n[i]={},f(n[i],t[i]),f(n[i],e[i])):null!=e[i]?n[i]=e[i]:delete n[i]);for(i in t)l(t,i)&&!l(e,i)&&a(t[i])&&(n[i]=f({},n[i]));return n}function A(t){null!=t&&this.set(t)}n.suppressDeprecationWarnings=!1,n.deprecationHandler=null,T=Object.keys?Object.keys:function(t){var e,i=[];for(e in t)l(t,e)&&i.push(e);return i};var L={sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"};function N(t,e,i){var n=this._calendar[t]||this._calendar.sameElse;return E(n)?n.call(e,i):n}function R(t,e,i){var n=""+Math.abs(t),r=e-n.length;return(t>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+n}var F=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,j=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,Y={},H={};function z(t,e,i,n){var r=n;"string"==typeof n&&(r=function(){return this[n]()}),t&&(H[t]=r),e&&(H[e[0]]=function(){return R(r.apply(this,arguments),e[1],e[2])}),i&&(H[i]=function(){return this.localeData().ordinal(r.apply(this,arguments),t)})}function B(t){return t.match(/\[[\s\S]/)?t.replace(/^\[|\]$/g,""):t.replace(/\\/g,"")}function G(t){var e,i,n=t.match(F);for(e=0,i=n.length;e<i;e++)H[n[e]]?n[e]=H[n[e]]:n[e]=B(n[e]);return function(e){var r,o="";for(r=0;r<i;r++)o+=E(n[r])?n[r].call(e,t):n[r];return o}}function W(t,e){return t.isValid()?(e=V(e,t.localeData()),Y[e]=Y[e]||G(e),Y[e](t)):t.localeData().invalidDate()}function V(t,e){var i=5;function n(t){return e.longDateFormat(t)||t}for(j.lastIndex=0;i>=0&&j.test(t);)t=t.replace(j,n),j.lastIndex=0,i-=1;return t}var U={LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"};function X(t){var e=this._longDateFormat[t],i=this._longDateFormat[t.toUpperCase()];return e||!i?e:(this._longDateFormat[t]=i.match(F).map((function(t){return"MMMM"===t||"MM"===t||"DD"===t||"dddd"===t?t.slice(1):t})).join(""),this._longDateFormat[t])}var q="Invalid date";function $(){return this._invalidDate}var Z="%d",K=/\d{1,2}/;function J(t){return this._ordinal.replace("%d",t)}var Q={future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"};function tt(t,e,i,n){var r=this._relativeTime[i];return E(r)?r(t,e,i,n):r.replace(/%d/i,t)}function et(t,e){var i=this._relativeTime[t>0?"future":"past"];return E(i)?i(e):i.replace(/%s/i,e)}var it={};function nt(t,e){var i=t.toLowerCase();it[i]=it[i+"s"]=it[e]=t}function rt(t){return"string"==typeof t?it[t]||it[t.toLowerCase()]:void 0}function ot(t){var e,i,n={};for(i in t)l(t,i)&&(e=rt(i))&&(n[e]=t[i]);return n}var st={};function at(t,e){st[t]=e}function lt(t){var e,i=[];for(e in t)l(t,e)&&i.push({unit:e,priority:st[e]});return i.sort((function(t,e){return t.priority-e.priority})),i}function ht(t){return t%4==0&&t%100!=0||t%400==0}function ut(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function ct(t){var e=+t,i=0;return 0!==e&&isFinite(e)&&(i=ut(e)),i}function dt(t,e){return function(i){return null!=i?(ft(this,t,i),n.updateOffset(this,e),this):pt(this,t)}}function pt(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function ft(t,e,i){t.isValid()&&!isNaN(i)&&("FullYear"===e&&ht(t.year())&&1===t.month()&&29===t.date()?(i=ct(i),t._d["set"+(t._isUTC?"UTC":"")+e](i,t.month(),te(i,t.month()))):t._d["set"+(t._isUTC?"UTC":"")+e](i))}function mt(t){return E(this[t=rt(t)])?this[t]():this}function vt(t,e){if("object"==typeof t){var i,n=lt(t=ot(t)),r=n.length;for(i=0;i<r;i++)this[n[i].unit](t[n[i].unit])}else if(E(this[t=rt(t)]))return this[t](e);return this}var gt,yt=/\d/,bt=/\d\d/,_t=/\d{3}/,wt=/\d{4}/,kt=/[+-]?\d{6}/,xt=/\d\d?/,Dt=/\d\d\d\d?/,St=/\d\d\d\d\d\d?/,Ct=/\d{1,3}/,Tt=/\d{1,4}/,Mt=/[+-]?\d{1,6}/,Ot=/\d+/,Et=/[+-]?\d+/,Pt=/Z|[+-]\d\d:?\d\d/gi,It=/Z|[+-]\d\d(?::?\d\d)?/gi,At=/[+-]?\d+(\.\d{1,3})?/,Lt=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function Nt(t,e,i){gt[t]=E(e)?e:function(t,n){return t&&i?i:e}}function Rt(t,e){return l(gt,t)?gt[t](e._strict,e._locale):new RegExp(Ft(t))}function Ft(t){return jt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,i,n,r){return e||i||n||r})))}function jt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}gt={};var Yt={};function Ht(t,e){var i,n,r=e;for("string"==typeof t&&(t=[t]),c(e)&&(r=function(t,i){i[e]=ct(t)}),n=t.length,i=0;i<n;i++)Yt[t[i]]=r}function zt(t,e){Ht(t,(function(t,i,n,r){n._w=n._w||{},e(t,n._w,n,r)}))}function Bt(t,e,i){null!=e&&l(Yt,t)&&Yt[t](e,i._a,i,t)}var Gt,Wt=0,Vt=1,Ut=2,Xt=3,qt=4,$t=5,Zt=6,Kt=7,Jt=8;function Qt(t,e){return(t%e+e)%e}function te(t,e){if(isNaN(t)||isNaN(e))return NaN;var i=Qt(e,12);return t+=(e-i)/12,1===i?ht(t)?29:28:31-i%7%2}Gt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},z("M",["MM",2],"Mo",(function(){return this.month()+1})),z("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),z("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),nt("month","M"),at("month",8),Nt("M",xt),Nt("MM",xt,bt),Nt("MMM",(function(t,e){return e.monthsShortRegex(t)})),Nt("MMMM",(function(t,e){return e.monthsRegex(t)})),Ht(["M","MM"],(function(t,e){e[Vt]=ct(t)-1})),Ht(["MMM","MMMM"],(function(t,e,i,n){var r=i._locale.monthsParse(t,n,i._strict);null!=r?e[Vt]=r:g(i).invalidMonth=t}));var ee="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),ie="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),ne=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,re=Lt,oe=Lt;function se(t,e){return t?s(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||ne).test(e)?"format":"standalone"][t.month()]:s(this._months)?this._months:this._months.standalone}function ae(t,e){return t?s(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[ne.test(e)?"format":"standalone"][t.month()]:s(this._monthsShort)?this._monthsShort:this._monthsShort.standalone}function le(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)o=m([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(o,"").toLocaleLowerCase();return i?"MMM"===e?-1!==(r=Gt.call(this._shortMonthsParse,s))?r:null:-1!==(r=Gt.call(this._longMonthsParse,s))?r:null:"MMM"===e?-1!==(r=Gt.call(this._shortMonthsParse,s))||-1!==(r=Gt.call(this._longMonthsParse,s))?r:null:-1!==(r=Gt.call(this._longMonthsParse,s))||-1!==(r=Gt.call(this._shortMonthsParse,s))?r:null}function he(t,e,i){var n,r,o;if(this._monthsParseExact)return le.call(this,t,e,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(r=m([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[n]=new RegExp(o.replace(".",""),"i")),i&&"MMMM"===e&&this._longMonthsParse[n].test(t))return n;if(i&&"MMM"===e&&this._shortMonthsParse[n].test(t))return n;if(!i&&this._monthsParse[n].test(t))return n}}function ue(t,e){var i;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=ct(e);else if(!c(e=t.localeData().monthsParse(e)))return t;return i=Math.min(t.date(),te(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,i),t}function ce(t){return null!=t?(ue(this,t),n.updateOffset(this,!0),this):pt(this,"Month")}function de(){return te(this.year(),this.month())}function pe(t){return this._monthsParseExact?(l(this,"_monthsRegex")||me.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(l(this,"_monthsShortRegex")||(this._monthsShortRegex=re),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)}function fe(t){return this._monthsParseExact?(l(this,"_monthsRegex")||me.call(this),t?this._monthsStrictRegex:this._monthsRegex):(l(this,"_monthsRegex")||(this._monthsRegex=oe),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)}function me(){function t(t,e){return e.length-t.length}var e,i,n=[],r=[],o=[];for(e=0;e<12;e++)i=m([2e3,e]),n.push(this.monthsShort(i,"")),r.push(this.months(i,"")),o.push(this.months(i,"")),o.push(this.monthsShort(i,""));for(n.sort(t),r.sort(t),o.sort(t),e=0;e<12;e++)n[e]=jt(n[e]),r[e]=jt(r[e]);for(e=0;e<24;e++)o[e]=jt(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function ve(t){return ht(t)?366:365}z("Y",0,0,(function(){var t=this.year();return t<=9999?R(t,4):"+"+t})),z(0,["YY",2],0,(function(){return this.year()%100})),z(0,["YYYY",4],0,"year"),z(0,["YYYYY",5],0,"year"),z(0,["YYYYYY",6,!0],0,"year"),nt("year","y"),at("year",1),Nt("Y",Et),Nt("YY",xt,bt),Nt("YYYY",Tt,wt),Nt("YYYYY",Mt,kt),Nt("YYYYYY",Mt,kt),Ht(["YYYYY","YYYYYY"],Wt),Ht("YYYY",(function(t,e){e[Wt]=2===t.length?n.parseTwoDigitYear(t):ct(t)})),Ht("YY",(function(t,e){e[Wt]=n.parseTwoDigitYear(t)})),Ht("Y",(function(t,e){e[Wt]=parseInt(t,10)})),n.parseTwoDigitYear=function(t){return ct(t)+(ct(t)>68?1900:2e3)};var ge=dt("FullYear",!0);function ye(){return ht(this.year())}function be(t,e,i,n,r,o,s){var a;return t<100&&t>=0?(a=new Date(t+400,e,i,n,r,o,s),isFinite(a.getFullYear())&&a.setFullYear(t)):a=new Date(t,e,i,n,r,o,s),a}function _e(t){var e,i;return t<100&&t>=0?((i=Array.prototype.slice.call(arguments))[0]=t+400,e=new Date(Date.UTC.apply(null,i)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)):e=new Date(Date.UTC.apply(null,arguments)),e}function we(t,e,i){var n=7+e-i;return-(7+_e(t,0,n).getUTCDay()-e)%7+n-1}function ke(t,e,i,n,r){var o,s,a=1+7*(e-1)+(7+i-n)%7+we(t,n,r);return a<=0?s=ve(o=t-1)+a:a>ve(t)?(o=t+1,s=a-ve(t)):(o=t,s=a),{year:o,dayOfYear:s}}function xe(t,e,i){var n,r,o=we(t.year(),e,i),s=Math.floor((t.dayOfYear()-o-1)/7)+1;return s<1?n=s+De(r=t.year()-1,e,i):s>De(t.year(),e,i)?(n=s-De(t.year(),e,i),r=t.year()+1):(r=t.year(),n=s),{week:n,year:r}}function De(t,e,i){var n=we(t,e,i),r=we(t+1,e,i);return(ve(t)-n+r)/7}function Se(t){return xe(t,this._week.dow,this._week.doy).week}z("w",["ww",2],"wo","week"),z("W",["WW",2],"Wo","isoWeek"),nt("week","w"),nt("isoWeek","W"),at("week",5),at("isoWeek",5),Nt("w",xt),Nt("ww",xt,bt),Nt("W",xt),Nt("WW",xt,bt),zt(["w","ww","W","WW"],(function(t,e,i,n){e[n.substr(0,1)]=ct(t)}));var Ce={dow:0,doy:6};function Te(){return this._week.dow}function Me(){return this._week.doy}function Oe(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")}function Ee(t){var e=xe(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")}function Pe(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}function Ie(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}function Ae(t,e){return t.slice(e,7).concat(t.slice(0,e))}z("d",0,"do","day"),z("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),z("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),z("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),z("e",0,0,"weekday"),z("E",0,0,"isoWeekday"),nt("day","d"),nt("weekday","e"),nt("isoWeekday","E"),at("day",11),at("weekday",11),at("isoWeekday",11),Nt("d",xt),Nt("e",xt),Nt("E",xt),Nt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),Nt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),Nt("dddd",(function(t,e){return e.weekdaysRegex(t)})),zt(["dd","ddd","dddd"],(function(t,e,i,n){var r=i._locale.weekdaysParse(t,n,i._strict);null!=r?e.d=r:g(i).invalidWeekday=t})),zt(["d","e","E"],(function(t,e,i,n){e[n]=ct(t)}));var Le="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Ne="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Re="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Fe=Lt,je=Lt,Ye=Lt;function He(t,e){var i=s(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Ae(i,this._week.dow):t?i[t.day()]:i}function ze(t){return!0===t?Ae(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort}function Be(t){return!0===t?Ae(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin}function Ge(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)o=m([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(o,"").toLocaleLowerCase();return i?"dddd"===e?-1!==(r=Gt.call(this._weekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Gt.call(this._shortWeekdaysParse,s))?r:null:-1!==(r=Gt.call(this._minWeekdaysParse,s))?r:null:"dddd"===e?-1!==(r=Gt.call(this._weekdaysParse,s))||-1!==(r=Gt.call(this._shortWeekdaysParse,s))||-1!==(r=Gt.call(this._minWeekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Gt.call(this._shortWeekdaysParse,s))||-1!==(r=Gt.call(this._weekdaysParse,s))||-1!==(r=Gt.call(this._minWeekdaysParse,s))?r:null:-1!==(r=Gt.call(this._minWeekdaysParse,s))||-1!==(r=Gt.call(this._weekdaysParse,s))||-1!==(r=Gt.call(this._shortWeekdaysParse,s))?r:null}function We(t,e,i){var n,r,o;if(this._weekdaysParseExact)return Ge.call(this,t,e,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(r=m([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[n]=new RegExp(o.replace(".",""),"i")),i&&"dddd"===e&&this._fullWeekdaysParse[n].test(t))return n;if(i&&"ddd"===e&&this._shortWeekdaysParse[n].test(t))return n;if(i&&"dd"===e&&this._minWeekdaysParse[n].test(t))return n;if(!i&&this._weekdaysParse[n].test(t))return n}}function Ve(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=Pe(t,this.localeData()),this.add(t-e,"d")):e}function Ue(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")}function Xe(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=Ie(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7}function qe(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(l(this,"_weekdaysRegex")||(this._weekdaysRegex=Fe),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)}function $e(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(l(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=je),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)}function Ze(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(l(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Ye),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)}function Ke(){function t(t,e){return e.length-t.length}var e,i,n,r,o,s=[],a=[],l=[],h=[];for(e=0;e<7;e++)i=m([2e3,1]).day(e),n=jt(this.weekdaysMin(i,"")),r=jt(this.weekdaysShort(i,"")),o=jt(this.weekdays(i,"")),s.push(n),a.push(r),l.push(o),h.push(n),h.push(r),h.push(o);s.sort(t),a.sort(t),l.sort(t),h.sort(t),this._weekdaysRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+s.join("|")+")","i")}function Je(){return this.hours()%12||12}function Qe(){return this.hours()||24}function ti(t,e){z(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function ei(t,e){return e._meridiemParse}function ii(t){return"p"===(t+"").toLowerCase().charAt(0)}z("H",["HH",2],0,"hour"),z("h",["hh",2],0,Je),z("k",["kk",2],0,Qe),z("hmm",0,0,(function(){return""+Je.apply(this)+R(this.minutes(),2)})),z("hmmss",0,0,(function(){return""+Je.apply(this)+R(this.minutes(),2)+R(this.seconds(),2)})),z("Hmm",0,0,(function(){return""+this.hours()+R(this.minutes(),2)})),z("Hmmss",0,0,(function(){return""+this.hours()+R(this.minutes(),2)+R(this.seconds(),2)})),ti("a",!0),ti("A",!1),nt("hour","h"),at("hour",13),Nt("a",ei),Nt("A",ei),Nt("H",xt),Nt("h",xt),Nt("k",xt),Nt("HH",xt,bt),Nt("hh",xt,bt),Nt("kk",xt,bt),Nt("hmm",Dt),Nt("hmmss",St),Nt("Hmm",Dt),Nt("Hmmss",St),Ht(["H","HH"],Xt),Ht(["k","kk"],(function(t,e,i){var n=ct(t);e[Xt]=24===n?0:n})),Ht(["a","A"],(function(t,e,i){i._isPm=i._locale.isPM(t),i._meridiem=t})),Ht(["h","hh"],(function(t,e,i){e[Xt]=ct(t),g(i).bigHour=!0})),Ht("hmm",(function(t,e,i){var n=t.length-2;e[Xt]=ct(t.substr(0,n)),e[qt]=ct(t.substr(n)),g(i).bigHour=!0})),Ht("hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[Xt]=ct(t.substr(0,n)),e[qt]=ct(t.substr(n,2)),e[$t]=ct(t.substr(r)),g(i).bigHour=!0})),Ht("Hmm",(function(t,e,i){var n=t.length-2;e[Xt]=ct(t.substr(0,n)),e[qt]=ct(t.substr(n))})),Ht("Hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[Xt]=ct(t.substr(0,n)),e[qt]=ct(t.substr(n,2)),e[$t]=ct(t.substr(r))}));var ni=/[ap]\.?m?\.?/i,ri=dt("Hours",!0);function oi(t,e,i){return t>11?i?"pm":"PM":i?"am":"AM"}var si,ai={calendar:L,longDateFormat:U,invalidDate:q,ordinal:Z,dayOfMonthOrdinalParse:K,relativeTime:Q,months:ee,monthsShort:ie,week:Ce,weekdays:Le,weekdaysMin:Re,weekdaysShort:Ne,meridiemParse:ni},li={},hi={};function ui(t,e){var i,n=Math.min(t.length,e.length);for(i=0;i<n;i+=1)if(t[i]!==e[i])return i;return n}function ci(t){return t?t.toLowerCase().replace("_","-"):t}function di(t){for(var e,i,n,r,o=0;o<t.length;){for(e=(r=ci(t[o]).split("-")).length,i=(i=ci(t[o+1]))?i.split("-"):null;e>0;){if(n=fi(r.slice(0,e).join("-")))return n;if(i&&i.length>=e&&ui(r,i)>=e-1)break;e--}o++}return si}function pi(t){return null!=t.match("^[^/\\\\]*$")}function fi(e){var i=null;if(void 0===li[e]&&t&&t.exports&&pi(e))try{i=si._abbr,r("./locale/"+e),mi(i)}catch(t){li[e]=null}return li[e]}function mi(t,e){var i;return t&&((i=u(e)?yi(t):vi(t,e))?si=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),si._abbr}function vi(t,e){if(null!==e){var i,n=ai;if(e.abbr=t,null!=li[t])O("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=li[t]._config;else if(null!=e.parentLocale)if(null!=li[e.parentLocale])n=li[e.parentLocale]._config;else{if(null==(i=fi(e.parentLocale)))return hi[e.parentLocale]||(hi[e.parentLocale]=[]),hi[e.parentLocale].push({name:t,config:e}),null;n=i._config}return li[t]=new A(I(n,e)),hi[t]&&hi[t].forEach((function(t){vi(t.name,t.config)})),mi(t),li[t]}return delete li[t],null}function gi(t,e){if(null!=e){var i,n,r=ai;null!=li[t]&&null!=li[t].parentLocale?li[t].set(I(li[t]._config,e)):(null!=(n=fi(t))&&(r=n._config),e=I(r,e),null==n&&(e.abbr=t),(i=new A(e)).parentLocale=li[t],li[t]=i),mi(t)}else null!=li[t]&&(null!=li[t].parentLocale?(li[t]=li[t].parentLocale,t===mi()&&mi(t)):null!=li[t]&&delete li[t]);return li[t]}function yi(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return si;if(!s(t)){if(e=fi(t))return e;t=[t]}return di(t)}function bi(){return T(li)}function _i(t){var e,i=t._a;return i&&-2===g(t).overflow&&(e=i[Vt]<0||i[Vt]>11?Vt:i[Ut]<1||i[Ut]>te(i[Wt],i[Vt])?Ut:i[Xt]<0||i[Xt]>24||24===i[Xt]&&(0!==i[qt]||0!==i[$t]||0!==i[Zt])?Xt:i[qt]<0||i[qt]>59?qt:i[$t]<0||i[$t]>59?$t:i[Zt]<0||i[Zt]>999?Zt:-1,g(t)._overflowDayOfYear&&(e<Wt||e>Ut)&&(e=Ut),g(t)._overflowWeeks&&-1===e&&(e=Kt),g(t)._overflowWeekday&&-1===e&&(e=Jt),g(t).overflow=e),t}var wi=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ki=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,xi=/Z|[+-]\d\d(?::?\d\d)?/,Di=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],Si=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Ci=/^\/?Date\((-?\d+)/i,Ti=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,Mi={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Oi(t){var e,i,n,r,o,s,a=t._i,l=wi.exec(a)||ki.exec(a),h=Di.length,u=Si.length;if(l){for(g(t).iso=!0,e=0,i=h;e<i;e++)if(Di[e][1].exec(l[1])){r=Di[e][0],n=!1!==Di[e][2];break}if(null==r)return void(t._isValid=!1);if(l[3]){for(e=0,i=u;e<i;e++)if(Si[e][1].exec(l[3])){o=(l[2]||" ")+Si[e][0];break}if(null==o)return void(t._isValid=!1)}if(!n&&null!=o)return void(t._isValid=!1);if(l[4]){if(!xi.exec(l[4]))return void(t._isValid=!1);s="Z"}t._f=r+(o||"")+(s||""),zi(t)}else t._isValid=!1}function Ei(t,e,i,n,r,o){var s=[Pi(t),ie.indexOf(e),parseInt(i,10),parseInt(n,10),parseInt(r,10)];return o&&s.push(parseInt(o,10)),s}function Pi(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function Ii(t){return t.replace(/\([^()]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,"")}function Ai(t,e,i){return!t||Ne.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(g(i).weekdayMismatch=!0,i._isValid=!1,!1)}function Li(t,e,i){if(t)return Mi[t];if(e)return 0;var n=parseInt(i,10),r=n%100;return(n-r)/100*60+r}function Ni(t){var e,i=Ti.exec(Ii(t._i));if(i){if(e=Ei(i[4],i[3],i[2],i[5],i[6],i[7]),!Ai(i[1],e,t))return;t._a=e,t._tzm=Li(i[8],i[9],i[10]),t._d=_e.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),g(t).rfc2822=!0}else t._isValid=!1}function Ri(t){var e=Ci.exec(t._i);null===e?(Oi(t),!1===t._isValid&&(delete t._isValid,Ni(t),!1===t._isValid&&(delete t._isValid,t._strict?t._isValid=!1:n.createFromInputFallback(t)))):t._d=new Date(+e[1])}function Fi(t,e,i){return null!=t?t:null!=e?e:i}function ji(t){var e=new Date(n.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}function Yi(t){var e,i,n,r,o,s=[];if(!t._d){for(n=ji(t),t._w&&null==t._a[Ut]&&null==t._a[Vt]&&Hi(t),null!=t._dayOfYear&&(o=Fi(t._a[Wt],n[Wt]),(t._dayOfYear>ve(o)||0===t._dayOfYear)&&(g(t)._overflowDayOfYear=!0),i=_e(o,0,t._dayOfYear),t._a[Vt]=i.getUTCMonth(),t._a[Ut]=i.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=n[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[Xt]&&0===t._a[qt]&&0===t._a[$t]&&0===t._a[Zt]&&(t._nextDay=!0,t._a[Xt]=0),t._d=(t._useUTC?_e:be).apply(null,s),r=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[Xt]=24),t._w&&void 0!==t._w.d&&t._w.d!==r&&(g(t).weekdayMismatch=!0)}}function Hi(t){var e,i,n,r,o,s,a,l,h;null!=(e=t._w).GG||null!=e.W||null!=e.E?(o=1,s=4,i=Fi(e.GG,t._a[Wt],xe($i(),1,4).year),n=Fi(e.W,1),((r=Fi(e.E,1))<1||r>7)&&(l=!0)):(o=t._locale._week.dow,s=t._locale._week.doy,h=xe($i(),o,s),i=Fi(e.gg,t._a[Wt],h.year),n=Fi(e.w,h.week),null!=e.d?((r=e.d)<0||r>6)&&(l=!0):null!=e.e?(r=e.e+o,(e.e<0||e.e>6)&&(l=!0)):r=o),n<1||n>De(i,o,s)?g(t)._overflowWeeks=!0:null!=l?g(t)._overflowWeekday=!0:(a=ke(i,n,r,o,s),t._a[Wt]=a.year,t._dayOfYear=a.dayOfYear)}function zi(t){if(t._f!==n.ISO_8601)if(t._f!==n.RFC_2822){t._a=[],g(t).empty=!0;var e,i,r,o,s,a,l,h=""+t._i,u=h.length,c=0;for(l=(r=V(t._f,t._locale).match(F)||[]).length,e=0;e<l;e++)o=r[e],(i=(h.match(Rt(o,t))||[])[0])&&((s=h.substr(0,h.indexOf(i))).length>0&&g(t).unusedInput.push(s),h=h.slice(h.indexOf(i)+i.length),c+=i.length),H[o]?(i?g(t).empty=!1:g(t).unusedTokens.push(o),Bt(o,i,t)):t._strict&&!i&&g(t).unusedTokens.push(o);g(t).charsLeftOver=u-c,h.length>0&&g(t).unusedInput.push(h),t._a[Xt]<=12&&!0===g(t).bigHour&&t._a[Xt]>0&&(g(t).bigHour=void 0),g(t).parsedDateParts=t._a.slice(0),g(t).meridiem=t._meridiem,t._a[Xt]=Bi(t._locale,t._a[Xt],t._meridiem),null!==(a=g(t).era)&&(t._a[Wt]=t._locale.erasConvertYear(a,t._a[Wt])),Yi(t),_i(t)}else Ni(t);else Oi(t)}function Bi(t,e,i){var n;return null==i?e:null!=t.meridiemHour?t.meridiemHour(e,i):null!=t.isPM?((n=t.isPM(i))&&e<12&&(e+=12),n||12!==e||(e=0),e):e}function Gi(t){var e,i,n,r,o,s,a=!1,l=t._f.length;if(0===l)return g(t).invalidFormat=!0,void(t._d=new Date(NaN));for(r=0;r<l;r++)o=0,s=!1,e=k({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[r],zi(e),y(e)&&(s=!0),o+=g(e).charsLeftOver,o+=10*g(e).unusedTokens.length,g(e).score=o,a?o<n&&(n=o,i=e):(null==n||o<n||s)&&(n=o,i=e,s&&(a=!0));f(t,i||e)}function Wi(t){if(!t._d){var e=ot(t._i),i=void 0===e.day?e.date:e.day;t._a=p([e.year,e.month,i,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),Yi(t)}}function Vi(t){var e=new x(_i(Ui(t)));return e._nextDay&&(e.add(1,"d"),e._nextDay=void 0),e}function Ui(t){var e=t._i,i=t._f;return t._locale=t._locale||yi(t._l),null===e||void 0===i&&""===e?b({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),D(e)?new x(_i(e)):(d(e)?t._d=e:s(i)?Gi(t):i?zi(t):Xi(t),y(t)||(t._d=null),t))}function Xi(t){var e=t._i;u(e)?t._d=new Date(n.now()):d(e)?t._d=new Date(e.valueOf()):"string"==typeof e?Ri(t):s(e)?(t._a=p(e.slice(0),(function(t){return parseInt(t,10)})),Yi(t)):a(e)?Wi(t):c(e)?t._d=new Date(e):n.createFromInputFallback(t)}function qi(t,e,i,n,r){var o={};return!0!==e&&!1!==e||(n=e,e=void 0),!0!==i&&!1!==i||(n=i,i=void 0),(a(t)&&h(t)||s(t)&&0===t.length)&&(t=void 0),o._isAMomentObject=!0,o._useUTC=o._isUTC=r,o._l=i,o._i=t,o._f=e,o._strict=n,Vi(o)}function $i(t,e,i,n){return qi(t,e,i,n,!1)}n.createFromInputFallback=C("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),n.ISO_8601=function(){},n.RFC_2822=function(){};var Zi=C("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=$i.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:b()})),Ki=C("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=$i.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:b()}));function Ji(t,e){var i,n;if(1===e.length&&s(e[0])&&(e=e[0]),!e.length)return $i();for(i=e[0],n=1;n<e.length;++n)e[n].isValid()&&!e[n][t](i)||(i=e[n]);return i}function Qi(){return Ji("isBefore",[].slice.call(arguments,0))}function tn(){return Ji("isAfter",[].slice.call(arguments,0))}var en=function(){return Date.now?Date.now():+new Date},nn=["year","quarter","month","week","day","hour","minute","second","millisecond"];function rn(t){var e,i,n=!1,r=nn.length;for(e in t)if(l(t,e)&&(-1===Gt.call(nn,e)||null!=t[e]&&isNaN(t[e])))return!1;for(i=0;i<r;++i)if(t[nn[i]]){if(n)return!1;parseFloat(t[nn[i]])!==ct(t[nn[i]])&&(n=!0)}return!0}function on(){return this._isValid}function sn(){return On(NaN)}function an(t){var e=ot(t),i=e.year||0,n=e.quarter||0,r=e.month||0,o=e.week||e.isoWeek||0,s=e.day||0,a=e.hour||0,l=e.minute||0,h=e.second||0,u=e.millisecond||0;this._isValid=rn(e),this._milliseconds=+u+1e3*h+6e4*l+1e3*a*60*60,this._days=+s+7*o,this._months=+r+3*n+12*i,this._data={},this._locale=yi(),this._bubble()}function ln(t){return t instanceof an}function hn(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function un(t,e,i){var n,r=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),s=0;for(n=0;n<r;n++)(i&&t[n]!==e[n]||!i&&ct(t[n])!==ct(e[n]))&&s++;return s+o}function cn(t,e){z(t,0,0,(function(){var t=this.utcOffset(),i="+";return t<0&&(t=-t,i="-"),i+R(~~(t/60),2)+e+R(~~t%60,2)}))}cn("Z",":"),cn("ZZ",""),Nt("Z",It),Nt("ZZ",It),Ht(["Z","ZZ"],(function(t,e,i){i._useUTC=!0,i._tzm=pn(It,t)}));var dn=/([\+\-]|\d\d)/gi;function pn(t,e){var i,n,r=(e||"").match(t);return null===r?null:0===(n=60*(i=((r[r.length-1]||[])+"").match(dn)||["-",0,0])[1]+ct(i[2]))?0:"+"===i[0]?n:-n}function fn(t,e){var i,r;return e._isUTC?(i=e.clone(),r=(D(t)||d(t)?t.valueOf():$i(t).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+r),n.updateOffset(i,!1),i):$i(t).local()}function mn(t){return-Math.round(t._d.getTimezoneOffset())}function vn(t,e,i){var r,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=pn(It,t)))return this}else Math.abs(t)<16&&!i&&(t*=60);return!this._isUTC&&e&&(r=mn(this)),this._offset=t,this._isUTC=!0,null!=r&&this.add(r,"m"),o!==t&&(!e||this._changeInProgress?Ln(this,On(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,n.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:mn(this)}function gn(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()}function yn(t){return this.utcOffset(0,t)}function bn(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(mn(this),"m")),this}function _n(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=pn(Pt,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this}function wn(t){return!!this.isValid()&&(t=t?$i(t).utcOffset():0,(this.utcOffset()-t)%60==0)}function kn(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()}function xn(){if(!u(this._isDSTShifted))return this._isDSTShifted;var t,e={};return k(e,this),(e=Ui(e))._a?(t=e._isUTC?m(e._a):$i(e._a),this._isDSTShifted=this.isValid()&&un(e._a,t.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}function Dn(){return!!this.isValid()&&!this._isUTC}function Sn(){return!!this.isValid()&&this._isUTC}function Cn(){return!!this.isValid()&&this._isUTC&&0===this._offset}n.updateOffset=function(){};var Tn=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,Mn=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function On(t,e){var i,n,r,o=t,s=null;return ln(t)?o={ms:t._milliseconds,d:t._days,M:t._months}:c(t)||!isNaN(+t)?(o={},e?o[e]=+t:o.milliseconds=+t):(s=Tn.exec(t))?(i="-"===s[1]?-1:1,o={y:0,d:ct(s[Ut])*i,h:ct(s[Xt])*i,m:ct(s[qt])*i,s:ct(s[$t])*i,ms:ct(hn(1e3*s[Zt]))*i}):(s=Mn.exec(t))?(i="-"===s[1]?-1:1,o={y:En(s[2],i),M:En(s[3],i),w:En(s[4],i),d:En(s[5],i),h:En(s[6],i),m:En(s[7],i),s:En(s[8],i)}):null==o?o={}:"object"==typeof o&&("from"in o||"to"in o)&&(r=In($i(o.from),$i(o.to)),(o={}).ms=r.milliseconds,o.M=r.months),n=new an(o),ln(t)&&l(t,"_locale")&&(n._locale=t._locale),ln(t)&&l(t,"_isValid")&&(n._isValid=t._isValid),n}function En(t,e){var i=t&&parseFloat(t.replace(",","."));return(isNaN(i)?0:i)*e}function Pn(t,e){var i={};return i.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(i.months,"M").isAfter(e)&&--i.months,i.milliseconds=+e-+t.clone().add(i.months,"M"),i}function In(t,e){var i;return t.isValid()&&e.isValid()?(e=fn(e,t),t.isBefore(e)?i=Pn(t,e):((i=Pn(e,t)).milliseconds=-i.milliseconds,i.months=-i.months),i):{milliseconds:0,months:0}}function An(t,e){return function(i,n){var r;return null===n||isNaN(+n)||(O(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=i,i=n,n=r),Ln(this,On(i,n),t),this}}function Ln(t,e,i,r){var o=e._milliseconds,s=hn(e._days),a=hn(e._months);t.isValid()&&(r=null==r||r,a&&ue(t,pt(t,"Month")+a*i),s&&ft(t,"Date",pt(t,"Date")+s*i),o&&t._d.setTime(t._d.valueOf()+o*i),r&&n.updateOffset(t,s||a))}On.fn=an.prototype,On.invalid=sn;var Nn=An(1,"add"),Rn=An(-1,"subtract");function Fn(t){return"string"==typeof t||t instanceof String}function jn(t){return D(t)||d(t)||Fn(t)||c(t)||Hn(t)||Yn(t)||null==t}function Yn(t){var e,i,n=a(t)&&!h(t),r=!1,o=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"],s=o.length;for(e=0;e<s;e+=1)i=o[e],r=r||l(t,i);return n&&r}function Hn(t){var e=s(t),i=!1;return e&&(i=0===t.filter((function(e){return!c(e)&&Fn(t)})).length),e&&i}function zn(t){var e,i,n=a(t)&&!h(t),r=!1,o=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(e=0;e<o.length;e+=1)i=o[e],r=r||l(t,i);return n&&r}function Bn(t,e){var i=t.diff(e,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"}function Gn(t,e){1===arguments.length&&(arguments[0]?jn(arguments[0])?(t=arguments[0],e=void 0):zn(arguments[0])&&(e=arguments[0],t=void 0):(t=void 0,e=void 0));var i=t||$i(),r=fn(i,this).startOf("day"),o=n.calendarFormat(this,r)||"sameElse",s=e&&(E(e[o])?e[o].call(this,i):e[o]);return this.format(s||this.localeData().calendar(o,this,$i(i)))}function Wn(){return new x(this)}function Vn(t,e){var i=D(t)?t:$i(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=rt(e)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(e).valueOf())}function Un(t,e){var i=D(t)?t:$i(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=rt(e)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(e).valueOf()<i.valueOf())}function Xn(t,e,i,n){var r=D(t)?t:$i(t),o=D(e)?e:$i(e);return!!(this.isValid()&&r.isValid()&&o.isValid())&&("("===(n=n||"()")[0]?this.isAfter(r,i):!this.isBefore(r,i))&&(")"===n[1]?this.isBefore(o,i):!this.isAfter(o,i))}function qn(t,e){var i,n=D(t)?t:$i(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=rt(e)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(e).valueOf()<=i&&i<=this.clone().endOf(e).valueOf()))}function $n(t,e){return this.isSame(t,e)||this.isAfter(t,e)}function Zn(t,e){return this.isSame(t,e)||this.isBefore(t,e)}function Kn(t,e,i){var n,r,o;if(!this.isValid())return NaN;if(!(n=fn(t,this)).isValid())return NaN;switch(r=6e4*(n.utcOffset()-this.utcOffset()),e=rt(e)){case"year":o=Jn(this,n)/12;break;case"month":o=Jn(this,n);break;case"quarter":o=Jn(this,n)/3;break;case"second":o=(this-n)/1e3;break;case"minute":o=(this-n)/6e4;break;case"hour":o=(this-n)/36e5;break;case"day":o=(this-n-r)/864e5;break;case"week":o=(this-n-r)/6048e5;break;default:o=this-n}return i?o:ut(o)}function Jn(t,e){if(t.date()<e.date())return-Jn(e,t);var i=12*(e.year()-t.year())+(e.month()-t.month()),n=t.clone().add(i,"months");return-(i+(e-n<0?(e-n)/(n-t.clone().add(i-1,"months")):(e-n)/(t.clone().add(i+1,"months")-n)))||0}function Qn(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")}function tr(t){if(!this.isValid())return null;var e=!0!==t,i=e?this.clone().utc():this;return i.year()<0||i.year()>9999?W(i,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):E(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",W(i,"Z")):W(i,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")}function er(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t,e,i,n,r="moment",o="";return this.isLocal()||(r=0===this.utcOffset()?"moment.utc":"moment.parseZone",o="Z"),t="["+r+'("]',e=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",i="-MM-DD[T]HH:mm:ss.SSS",n=o+'[")]',this.format(t+e+i+n)}function ir(t){t||(t=this.isUtc()?n.defaultFormatUtc:n.defaultFormat);var e=W(this,t);return this.localeData().postformat(e)}function nr(t,e){return this.isValid()&&(D(t)&&t.isValid()||$i(t).isValid())?On({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()}function rr(t){return this.from($i(),t)}function or(t,e){return this.isValid()&&(D(t)&&t.isValid()||$i(t).isValid())?On({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()}function sr(t){return this.to($i(),t)}function ar(t){var e;return void 0===t?this._locale._abbr:(null!=(e=yi(t))&&(this._locale=e),this)}n.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",n.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var lr=C("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function hr(){return this._locale}var ur=1e3,cr=60*ur,dr=60*cr,pr=3506328*dr;function fr(t,e){return(t%e+e)%e}function mr(t,e,i){return t<100&&t>=0?new Date(t+400,e,i)-pr:new Date(t,e,i).valueOf()}function vr(t,e,i){return t<100&&t>=0?Date.UTC(t+400,e,i)-pr:Date.UTC(t,e,i)}function gr(t){var e,i;if(void 0===(t=rt(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?vr:mr,t){case"year":e=i(this.year(),0,1);break;case"quarter":e=i(this.year(),this.month()-this.month()%3,1);break;case"month":e=i(this.year(),this.month(),1);break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=i(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=fr(e+(this._isUTC?0:this.utcOffset()*cr),dr);break;case"minute":e=this._d.valueOf(),e-=fr(e,cr);break;case"second":e=this._d.valueOf(),e-=fr(e,ur)}return this._d.setTime(e),n.updateOffset(this,!0),this}function yr(t){var e,i;if(void 0===(t=rt(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?vr:mr,t){case"year":e=i(this.year()+1,0,1)-1;break;case"quarter":e=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=i(this.year(),this.month()+1,1)-1;break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=dr-fr(e+(this._isUTC?0:this.utcOffset()*cr),dr)-1;break;case"minute":e=this._d.valueOf(),e+=cr-fr(e,cr)-1;break;case"second":e=this._d.valueOf(),e+=ur-fr(e,ur)-1}return this._d.setTime(e),n.updateOffset(this,!0),this}function br(){return this._d.valueOf()-6e4*(this._offset||0)}function _r(){return Math.floor(this.valueOf()/1e3)}function wr(){return new Date(this.valueOf())}function kr(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]}function xr(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}}function Dr(){return this.isValid()?this.toISOString():null}function Sr(){return y(this)}function Cr(){return f({},g(this))}function Tr(){return g(this).overflow}function Mr(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}}function Or(t,e){var i,r,o,s=this._eras||yi("en")._eras;for(i=0,r=s.length;i<r;++i)switch("string"==typeof s[i].since&&(o=n(s[i].since).startOf("day"),s[i].since=o.valueOf()),typeof s[i].until){case"undefined":s[i].until=1/0;break;case"string":o=n(s[i].until).startOf("day").valueOf(),s[i].until=o.valueOf()}return s}function Er(t,e,i){var n,r,o,s,a,l=this.eras();for(t=t.toUpperCase(),n=0,r=l.length;n<r;++n)if(o=l[n].name.toUpperCase(),s=l[n].abbr.toUpperCase(),a=l[n].narrow.toUpperCase(),i)switch(e){case"N":case"NN":case"NNN":if(s===t)return l[n];break;case"NNNN":if(o===t)return l[n];break;case"NNNNN":if(a===t)return l[n]}else if([o,s,a].indexOf(t)>=0)return l[n]}function Pr(t,e){var i=t.since<=t.until?1:-1;return void 0===e?n(t.since).year():n(t.since).year()+(e-t.offset)*i}function Ir(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].name;if(n[t].until<=i&&i<=n[t].since)return n[t].name}return""}function Ar(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].narrow;if(n[t].until<=i&&i<=n[t].since)return n[t].narrow}return""}function Lr(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].abbr;if(n[t].until<=i&&i<=n[t].since)return n[t].abbr}return""}function Nr(){var t,e,i,r,o=this.localeData().eras();for(t=0,e=o.length;t<e;++t)if(i=o[t].since<=o[t].until?1:-1,r=this.clone().startOf("day").valueOf(),o[t].since<=r&&r<=o[t].until||o[t].until<=r&&r<=o[t].since)return(this.year()-n(o[t].since).year())*i+o[t].offset;return this.year()}function Rr(t){return l(this,"_erasNameRegex")||Gr.call(this),t?this._erasNameRegex:this._erasRegex}function Fr(t){return l(this,"_erasAbbrRegex")||Gr.call(this),t?this._erasAbbrRegex:this._erasRegex}function jr(t){return l(this,"_erasNarrowRegex")||Gr.call(this),t?this._erasNarrowRegex:this._erasRegex}function Yr(t,e){return e.erasAbbrRegex(t)}function Hr(t,e){return e.erasNameRegex(t)}function zr(t,e){return e.erasNarrowRegex(t)}function Br(t,e){return e._eraYearOrdinalRegex||Ot}function Gr(){var t,e,i=[],n=[],r=[],o=[],s=this.eras();for(t=0,e=s.length;t<e;++t)n.push(jt(s[t].name)),i.push(jt(s[t].abbr)),r.push(jt(s[t].narrow)),o.push(jt(s[t].name)),o.push(jt(s[t].abbr)),o.push(jt(s[t].narrow));this._erasRegex=new RegExp("^("+o.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+n.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+i.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+r.join("|")+")","i")}function Wr(t,e){z(0,[t,t.length],0,e)}function Vr(t){return Kr.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)}function Ur(t){return Kr.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)}function Xr(){return De(this.year(),1,4)}function qr(){return De(this.isoWeekYear(),1,4)}function $r(){var t=this.localeData()._week;return De(this.year(),t.dow,t.doy)}function Zr(){var t=this.localeData()._week;return De(this.weekYear(),t.dow,t.doy)}function Kr(t,e,i,n,r){var o;return null==t?xe(this,n,r).year:(e>(o=De(t,n,r))&&(e=o),Jr.call(this,t,e,i,n,r))}function Jr(t,e,i,n,r){var o=ke(t,e,i,n,r),s=_e(o.year,0,o.dayOfYear);return this.year(s.getUTCFullYear()),this.month(s.getUTCMonth()),this.date(s.getUTCDate()),this}function Qr(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)}z("N",0,0,"eraAbbr"),z("NN",0,0,"eraAbbr"),z("NNN",0,0,"eraAbbr"),z("NNNN",0,0,"eraName"),z("NNNNN",0,0,"eraNarrow"),z("y",["y",1],"yo","eraYear"),z("y",["yy",2],0,"eraYear"),z("y",["yyy",3],0,"eraYear"),z("y",["yyyy",4],0,"eraYear"),Nt("N",Yr),Nt("NN",Yr),Nt("NNN",Yr),Nt("NNNN",Hr),Nt("NNNNN",zr),Ht(["N","NN","NNN","NNNN","NNNNN"],(function(t,e,i,n){var r=i._locale.erasParse(t,n,i._strict);r?g(i).era=r:g(i).invalidEra=t})),Nt("y",Ot),Nt("yy",Ot),Nt("yyy",Ot),Nt("yyyy",Ot),Nt("yo",Br),Ht(["y","yy","yyy","yyyy"],Wt),Ht(["yo"],(function(t,e,i,n){var r;i._locale._eraYearOrdinalRegex&&(r=t.match(i._locale._eraYearOrdinalRegex)),i._locale.eraYearOrdinalParse?e[Wt]=i._locale.eraYearOrdinalParse(t,r):e[Wt]=parseInt(t,10)})),z(0,["gg",2],0,(function(){return this.weekYear()%100})),z(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),Wr("gggg","weekYear"),Wr("ggggg","weekYear"),Wr("GGGG","isoWeekYear"),Wr("GGGGG","isoWeekYear"),nt("weekYear","gg"),nt("isoWeekYear","GG"),at("weekYear",1),at("isoWeekYear",1),Nt("G",Et),Nt("g",Et),Nt("GG",xt,bt),Nt("gg",xt,bt),Nt("GGGG",Tt,wt),Nt("gggg",Tt,wt),Nt("GGGGG",Mt,kt),Nt("ggggg",Mt,kt),zt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,i,n){e[n.substr(0,2)]=ct(t)})),zt(["gg","GG"],(function(t,e,i,r){e[r]=n.parseTwoDigitYear(t)})),z("Q",0,"Qo","quarter"),nt("quarter","Q"),at("quarter",7),Nt("Q",yt),Ht("Q",(function(t,e){e[Vt]=3*(ct(t)-1)})),z("D",["DD",2],"Do","date"),nt("date","D"),at("date",9),Nt("D",xt),Nt("DD",xt,bt),Nt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),Ht(["D","DD"],Ut),Ht("Do",(function(t,e){e[Ut]=ct(t.match(xt)[0])}));var to=dt("Date",!0);function eo(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")}z("DDD",["DDDD",3],"DDDo","dayOfYear"),nt("dayOfYear","DDD"),at("dayOfYear",4),Nt("DDD",Ct),Nt("DDDD",_t),Ht(["DDD","DDDD"],(function(t,e,i){i._dayOfYear=ct(t)})),z("m",["mm",2],0,"minute"),nt("minute","m"),at("minute",14),Nt("m",xt),Nt("mm",xt,bt),Ht(["m","mm"],qt);var io=dt("Minutes",!1);z("s",["ss",2],0,"second"),nt("second","s"),at("second",15),Nt("s",xt),Nt("ss",xt,bt),Ht(["s","ss"],$t);var no,ro,oo=dt("Seconds",!1);for(z("S",0,0,(function(){return~~(this.millisecond()/100)})),z(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),z(0,["SSS",3],0,"millisecond"),z(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),z(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),z(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),z(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),z(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),z(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),nt("millisecond","ms"),at("millisecond",16),Nt("S",Ct,yt),Nt("SS",Ct,bt),Nt("SSS",Ct,_t),no="SSSS";no.length<=9;no+="S")Nt(no,Ot);function so(t,e){e[Zt]=ct(1e3*("0."+t))}for(no="S";no.length<=9;no+="S")Ht(no,so);function ao(){return this._isUTC?"UTC":""}function lo(){return this._isUTC?"Coordinated Universal Time":""}ro=dt("Milliseconds",!1),z("z",0,0,"zoneAbbr"),z("zz",0,0,"zoneName");var ho=x.prototype;function uo(t){return $i(1e3*t)}function co(){return $i.apply(null,arguments).parseZone()}function po(t){return t}ho.add=Nn,ho.calendar=Gn,ho.clone=Wn,ho.diff=Kn,ho.endOf=yr,ho.format=ir,ho.from=nr,ho.fromNow=rr,ho.to=or,ho.toNow=sr,ho.get=mt,ho.invalidAt=Tr,ho.isAfter=Vn,ho.isBefore=Un,ho.isBetween=Xn,ho.isSame=qn,ho.isSameOrAfter=$n,ho.isSameOrBefore=Zn,ho.isValid=Sr,ho.lang=lr,ho.locale=ar,ho.localeData=hr,ho.max=Ki,ho.min=Zi,ho.parsingFlags=Cr,ho.set=vt,ho.startOf=gr,ho.subtract=Rn,ho.toArray=kr,ho.toObject=xr,ho.toDate=wr,ho.toISOString=tr,ho.inspect=er,"undefined"!=typeof Symbol&&null!=Symbol.for&&(ho[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),ho.toJSON=Dr,ho.toString=Qn,ho.unix=_r,ho.valueOf=br,ho.creationData=Mr,ho.eraName=Ir,ho.eraNarrow=Ar,ho.eraAbbr=Lr,ho.eraYear=Nr,ho.year=ge,ho.isLeapYear=ye,ho.weekYear=Vr,ho.isoWeekYear=Ur,ho.quarter=ho.quarters=Qr,ho.month=ce,ho.daysInMonth=de,ho.week=ho.weeks=Oe,ho.isoWeek=ho.isoWeeks=Ee,ho.weeksInYear=$r,ho.weeksInWeekYear=Zr,ho.isoWeeksInYear=Xr,ho.isoWeeksInISOWeekYear=qr,ho.date=to,ho.day=ho.days=Ve,ho.weekday=Ue,ho.isoWeekday=Xe,ho.dayOfYear=eo,ho.hour=ho.hours=ri,ho.minute=ho.minutes=io,ho.second=ho.seconds=oo,ho.millisecond=ho.milliseconds=ro,ho.utcOffset=vn,ho.utc=yn,ho.local=bn,ho.parseZone=_n,ho.hasAlignedHourOffset=wn,ho.isDST=kn,ho.isLocal=Dn,ho.isUtcOffset=Sn,ho.isUtc=Cn,ho.isUTC=Cn,ho.zoneAbbr=ao,ho.zoneName=lo,ho.dates=C("dates accessor is deprecated. Use date instead.",to),ho.months=C("months accessor is deprecated. Use month instead",ce),ho.years=C("years accessor is deprecated. Use year instead",ge),ho.zone=C("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",gn),ho.isDSTShifted=C("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",xn);var fo=A.prototype;function mo(t,e,i,n){var r=yi(),o=m().set(n,e);return r[i](o,t)}function vo(t,e,i){if(c(t)&&(e=t,t=void 0),t=t||"",null!=e)return mo(t,e,i,"month");var n,r=[];for(n=0;n<12;n++)r[n]=mo(t,n,i,"month");return r}function go(t,e,i,n){"boolean"==typeof t?(c(e)&&(i=e,e=void 0),e=e||""):(i=e=t,t=!1,c(e)&&(i=e,e=void 0),e=e||"");var r,o=yi(),s=t?o._week.dow:0,a=[];if(null!=i)return mo(e,(i+s)%7,n,"day");for(r=0;r<7;r++)a[r]=mo(e,(r+s)%7,n,"day");return a}function yo(t,e){return vo(t,e,"months")}function bo(t,e){return vo(t,e,"monthsShort")}function _o(t,e,i){return go(t,e,i,"weekdays")}function wo(t,e,i){return go(t,e,i,"weekdaysShort")}function ko(t,e,i){return go(t,e,i,"weekdaysMin")}fo.calendar=N,fo.longDateFormat=X,fo.invalidDate=$,fo.ordinal=J,fo.preparse=po,fo.postformat=po,fo.relativeTime=tt,fo.pastFuture=et,fo.set=P,fo.eras=Or,fo.erasParse=Er,fo.erasConvertYear=Pr,fo.erasAbbrRegex=Fr,fo.erasNameRegex=Rr,fo.erasNarrowRegex=jr,fo.months=se,fo.monthsShort=ae,fo.monthsParse=he,fo.monthsRegex=fe,fo.monthsShortRegex=pe,fo.week=Se,fo.firstDayOfYear=Me,fo.firstDayOfWeek=Te,fo.weekdays=He,fo.weekdaysMin=Be,fo.weekdaysShort=ze,fo.weekdaysParse=We,fo.weekdaysRegex=qe,fo.weekdaysShortRegex=$e,fo.weekdaysMinRegex=Ze,fo.isPM=ii,fo.meridiem=oi,mi("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===ct(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),n.lang=C("moment.lang is deprecated. Use moment.locale instead.",mi),n.langData=C("moment.langData is deprecated. Use moment.localeData instead.",yi);var xo=Math.abs;function Do(){var t=this._data;return this._milliseconds=xo(this._milliseconds),this._days=xo(this._days),this._months=xo(this._months),t.milliseconds=xo(t.milliseconds),t.seconds=xo(t.seconds),t.minutes=xo(t.minutes),t.hours=xo(t.hours),t.months=xo(t.months),t.years=xo(t.years),this}function So(t,e,i,n){var r=On(e,i);return t._milliseconds+=n*r._milliseconds,t._days+=n*r._days,t._months+=n*r._months,t._bubble()}function Co(t,e){return So(this,t,e,1)}function To(t,e){return So(this,t,e,-1)}function Mo(t){return t<0?Math.floor(t):Math.ceil(t)}function Oo(){var t,e,i,n,r,o=this._milliseconds,s=this._days,a=this._months,l=this._data;return o>=0&&s>=0&&a>=0||o<=0&&s<=0&&a<=0||(o+=864e5*Mo(Po(a)+s),s=0,a=0),l.milliseconds=o%1e3,t=ut(o/1e3),l.seconds=t%60,e=ut(t/60),l.minutes=e%60,i=ut(e/60),l.hours=i%24,s+=ut(i/24),a+=r=ut(Eo(s)),s-=Mo(Po(r)),n=ut(a/12),a%=12,l.days=s,l.months=a,l.years=n,this}function Eo(t){return 4800*t/146097}function Po(t){return 146097*t/4800}function Io(t){if(!this.isValid())return NaN;var e,i,n=this._milliseconds;if("month"===(t=rt(t))||"quarter"===t||"year"===t)switch(e=this._days+n/864e5,i=this._months+Eo(e),t){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(e=this._days+Math.round(Po(this._months)),t){case"week":return e/7+n/6048e5;case"day":return e+n/864e5;case"hour":return 24*e+n/36e5;case"minute":return 1440*e+n/6e4;case"second":return 86400*e+n/1e3;case"millisecond":return Math.floor(864e5*e)+n;default:throw new Error("Unknown unit "+t)}}function Ao(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*ct(this._months/12):NaN}function Lo(t){return function(){return this.as(t)}}var No=Lo("ms"),Ro=Lo("s"),Fo=Lo("m"),jo=Lo("h"),Yo=Lo("d"),Ho=Lo("w"),zo=Lo("M"),Bo=Lo("Q"),Go=Lo("y");function Wo(){return On(this)}function Vo(t){return t=rt(t),this.isValid()?this[t+"s"]():NaN}function Uo(t){return function(){return this.isValid()?this._data[t]:NaN}}var Xo=Uo("milliseconds"),qo=Uo("seconds"),$o=Uo("minutes"),Zo=Uo("hours"),Ko=Uo("days"),Jo=Uo("months"),Qo=Uo("years");function ts(){return ut(this.days()/7)}var es=Math.round,is={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function ns(t,e,i,n,r){return r.relativeTime(e||1,!!i,t,n)}function rs(t,e,i,n){var r=On(t).abs(),o=es(r.as("s")),s=es(r.as("m")),a=es(r.as("h")),l=es(r.as("d")),h=es(r.as("M")),u=es(r.as("w")),c=es(r.as("y")),d=o<=i.ss&&["s",o]||o<i.s&&["ss",o]||s<=1&&["m"]||s<i.m&&["mm",s]||a<=1&&["h"]||a<i.h&&["hh",a]||l<=1&&["d"]||l<i.d&&["dd",l];return null!=i.w&&(d=d||u<=1&&["w"]||u<i.w&&["ww",u]),(d=d||h<=1&&["M"]||h<i.M&&["MM",h]||c<=1&&["y"]||["yy",c])[2]=e,d[3]=+t>0,d[4]=n,ns.apply(null,d)}function os(t){return void 0===t?es:"function"==typeof t&&(es=t,!0)}function ss(t,e){return void 0!==is[t]&&(void 0===e?is[t]:(is[t]=e,"s"===t&&(is.ss=e-1),!0))}function as(t,e){if(!this.isValid())return this.localeData().invalidDate();var i,n,r=!1,o=is;return"object"==typeof t&&(e=t,t=!1),"boolean"==typeof t&&(r=t),"object"==typeof e&&(o=Object.assign({},is,e),null!=e.s&&null==e.ss&&(o.ss=e.s-1)),n=rs(this,!r,o,i=this.localeData()),r&&(n=i.pastFuture(+this,n)),i.postformat(n)}var ls=Math.abs;function hs(t){return(t>0)-(t<0)||+t}function us(){if(!this.isValid())return this.localeData().invalidDate();var t,e,i,n,r,o,s,a,l=ls(this._milliseconds)/1e3,h=ls(this._days),u=ls(this._months),c=this.asSeconds();return c?(t=ut(l/60),e=ut(t/60),l%=60,t%=60,i=ut(u/12),u%=12,n=l?l.toFixed(3).replace(/\.?0+$/,""):"",r=c<0?"-":"",o=hs(this._months)!==hs(c)?"-":"",s=hs(this._days)!==hs(c)?"-":"",a=hs(this._milliseconds)!==hs(c)?"-":"",r+"P"+(i?o+i+"Y":"")+(u?o+u+"M":"")+(h?s+h+"D":"")+(e||t||l?"T":"")+(e?a+e+"H":"")+(t?a+t+"M":"")+(l?a+n+"S":"")):"P0D"}var cs=an.prototype;return cs.isValid=on,cs.abs=Do,cs.add=Co,cs.subtract=To,cs.as=Io,cs.asMilliseconds=No,cs.asSeconds=Ro,cs.asMinutes=Fo,cs.asHours=jo,cs.asDays=Yo,cs.asWeeks=Ho,cs.asMonths=zo,cs.asQuarters=Bo,cs.asYears=Go,cs.valueOf=Ao,cs._bubble=Oo,cs.clone=Wo,cs.get=Vo,cs.milliseconds=Xo,cs.seconds=qo,cs.minutes=$o,cs.hours=Zo,cs.days=Ko,cs.weeks=ts,cs.months=Jo,cs.years=Qo,cs.humanize=as,cs.toISOString=us,cs.toString=us,cs.toJSON=us,cs.locale=ar,cs.localeData=hr,cs.toIsoString=C("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",us),cs.lang=lr,z("X",0,0,"unix"),z("x",0,0,"valueOf"),Nt("x",Et),Nt("X",At),Ht("X",(function(t,e,i){i._d=new Date(1e3*parseFloat(t))})),Ht("x",(function(t,e,i){i._d=new Date(ct(t))})),
//! moment.js
n.version="2.29.4",o($i),n.fn=ho,n.min=Qi,n.max=tn,n.now=en,n.utc=m,n.unix=uo,n.months=yo,n.isDate=d,n.locale=mi,n.invalid=b,n.duration=On,n.isMoment=D,n.weekdays=_o,n.parseZone=co,n.localeData=yi,n.isDuration=ln,n.monthsShort=bo,n.weekdaysMin=ko,n.defineLocale=vi,n.updateLocale=gi,n.locales=bi,n.weekdaysShort=wo,n.normalizeUnits=rt,n.relativeTimeRounding=os,n.relativeTimeThreshold=ss,n.calendarFormat=Bn,n.prototype=ho,n.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},n}()}(l)),a}s=function(t){
//! moment.js locale configuration
function e(t,e,i,n){var r={m:["eine Minute","einer Minute"],h:["eine Stunde","einer Stunde"],d:["ein Tag","einem Tag"],dd:[t+" Tage",t+" Tagen"],w:["eine Woche","einer Woche"],M:["ein Monat","einem Monat"],MM:[t+" Monate",t+" Monaten"],y:["ein Jahr","einem Jahr"],yy:[t+" Jahre",t+" Jahren"]};return e?r[i][0]:r[i][1]}return t.defineLocale("de",{months:"Januar_Februar_März_April_Mai_Juni_Juli_August_September_Oktober_November_Dezember".split("_"),monthsShort:"Jan._Feb._März_Apr._Mai_Juni_Juli_Aug._Sep._Okt._Nov._Dez.".split("_"),monthsParseExact:!0,weekdays:"Sonntag_Montag_Dienstag_Mittwoch_Donnerstag_Freitag_Samstag".split("_"),weekdaysShort:"So._Mo._Di._Mi._Do._Fr._Sa.".split("_"),weekdaysMin:"So_Mo_Di_Mi_Do_Fr_Sa".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D. MMMM YYYY",LLL:"D. MMMM YYYY HH:mm",LLLL:"dddd, D. MMMM YYYY HH:mm"},calendar:{sameDay:"[heute um] LT [Uhr]",sameElse:"L",nextDay:"[morgen um] LT [Uhr]",nextWeek:"dddd [um] LT [Uhr]",lastDay:"[gestern um] LT [Uhr]",lastWeek:"[letzten] dddd [um] LT [Uhr]"},relativeTime:{future:"in %s",past:"vor %s",s:"ein paar Sekunden",ss:"%d Sekunden",m:e,mm:"%d Minuten",h:e,hh:"%d Stunden",d:e,dd:e,w:e,ww:"%d Wochen",M:e,MM:e,y:e,yy:e},dayOfMonthOrdinalParse:/\d{1,2}\./,ordinal:"%d.",week:{dow:1,doy:4}})},s(h()),function(t,e){e(h())}(0,(function(t){
//! moment.js locale configuration
var e="ene._feb._mar._abr._may._jun._jul._ago._sep._oct._nov._dic.".split("_"),i="ene_feb_mar_abr_may_jun_jul_ago_sep_oct_nov_dic".split("_"),n=[/^ene/i,/^feb/i,/^mar/i,/^abr/i,/^may/i,/^jun/i,/^jul/i,/^ago/i,/^sep/i,/^oct/i,/^nov/i,/^dic/i],r=/^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre|ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i;return t.defineLocale("es",{months:"enero_febrero_marzo_abril_mayo_junio_julio_agosto_septiembre_octubre_noviembre_diciembre".split("_"),monthsShort:function(t,n){return t?/-MMM-/.test(n)?i[t.month()]:e[t.month()]:e},monthsRegex:r,monthsShortRegex:r,monthsStrictRegex:/^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre)/i,monthsShortStrictRegex:/^(ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i,monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"domingo_lunes_martes_miércoles_jueves_viernes_sábado".split("_"),weekdaysShort:"dom._lun._mar._mié._jue._vie._sáb.".split("_"),weekdaysMin:"do_lu_ma_mi_ju_vi_sá".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"H:mm",LTS:"H:mm:ss",L:"DD/MM/YYYY",LL:"D [de] MMMM [de] YYYY",LLL:"D [de] MMMM [de] YYYY H:mm",LLLL:"dddd, D [de] MMMM [de] YYYY H:mm"},calendar:{sameDay:function(){return"[hoy a la"+(1!==this.hours()?"s":"")+"] LT"},nextDay:function(){return"[mañana a la"+(1!==this.hours()?"s":"")+"] LT"},nextWeek:function(){return"dddd [a la"+(1!==this.hours()?"s":"")+"] LT"},lastDay:function(){return"[ayer a la"+(1!==this.hours()?"s":"")+"] LT"},lastWeek:function(){return"[el] dddd [pasado a la"+(1!==this.hours()?"s":"")+"] LT"},sameElse:"L"},relativeTime:{future:"en %s",past:"hace %s",s:"unos segundos",ss:"%d segundos",m:"un minuto",mm:"%d minutos",h:"una hora",hh:"%d horas",d:"un día",dd:"%d días",w:"una semana",ww:"%d semanas",M:"un mes",MM:"%d meses",y:"un año",yy:"%d años"},dayOfMonthOrdinalParse:/\d{1,2}º/,ordinal:"%dº",week:{dow:1,doy:4},invalidDate:"Fecha inválida"})})),function(t,e){e(h())}(0,(function(t){
//! moment.js locale configuration
var e=/(janv\.?|févr\.?|mars|avr\.?|mai|juin|juil\.?|août|sept\.?|oct\.?|nov\.?|déc\.?|janvier|février|mars|avril|mai|juin|juillet|août|septembre|octobre|novembre|décembre)/i,i=[/^janv/i,/^févr/i,/^mars/i,/^avr/i,/^mai/i,/^juin/i,/^juil/i,/^août/i,/^sept/i,/^oct/i,/^nov/i,/^déc/i],n=t.defineLocale("fr",{months:"janvier_février_mars_avril_mai_juin_juillet_août_septembre_octobre_novembre_décembre".split("_"),monthsShort:"janv._févr._mars_avr._mai_juin_juil._août_sept._oct._nov._déc.".split("_"),monthsRegex:e,monthsShortRegex:e,monthsStrictRegex:/^(janvier|février|mars|avril|mai|juin|juillet|août|septembre|octobre|novembre|décembre)/i,monthsShortStrictRegex:/(janv\.?|févr\.?|mars|avr\.?|mai|juin|juil\.?|août|sept\.?|oct\.?|nov\.?|déc\.?)/i,monthsParse:i,longMonthsParse:i,shortMonthsParse:i,weekdays:"dimanche_lundi_mardi_mercredi_jeudi_vendredi_samedi".split("_"),weekdaysShort:"dim._lun._mar._mer._jeu._ven._sam.".split("_"),weekdaysMin:"di_lu_ma_me_je_ve_sa".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD/MM/YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[Aujourd’hui à] LT",nextDay:"[Demain à] LT",nextWeek:"dddd [à] LT",lastDay:"[Hier à] LT",lastWeek:"dddd [dernier à] LT",sameElse:"L"},relativeTime:{future:"dans %s",past:"il y a %s",s:"quelques secondes",ss:"%d secondes",m:"une minute",mm:"%d minutes",h:"une heure",hh:"%d heures",d:"un jour",dd:"%d jours",w:"une semaine",ww:"%d semaines",M:"un mois",MM:"%d mois",y:"un an",yy:"%d ans"},dayOfMonthOrdinalParse:/\d{1,2}(er|)/,ordinal:function(t,e){switch(e){case"D":return t+(1===t?"er":"");default:case"M":case"Q":case"DDD":case"d":return t+(1===t?"er":"e");case"w":case"W":return t+(1===t?"re":"e")}},week:{dow:1,doy:4}});return n})),function(t,e){e(h())}(0,(function(t){return t.defineLocale("it",{months:"gennaio_febbraio_marzo_aprile_maggio_giugno_luglio_agosto_settembre_ottobre_novembre_dicembre".split("_"),monthsShort:"gen_feb_mar_apr_mag_giu_lug_ago_set_ott_nov_dic".split("_"),weekdays:"domenica_lunedì_martedì_mercoledì_giovedì_venerdì_sabato".split("_"),weekdaysShort:"dom_lun_mar_mer_gio_ven_sab".split("_"),weekdaysMin:"do_lu_ma_me_gi_ve_sa".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD/MM/YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:function(){return"[Oggi a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},nextDay:function(){return"[Domani a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},nextWeek:function(){return"dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},lastDay:function(){return"[Ieri a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},lastWeek:function(){return 0===this.day()?"[La scorsa] dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT":"[Lo scorso] dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},sameElse:"L"},relativeTime:{future:"tra %s",past:"%s fa",s:"alcuni secondi",ss:"%d secondi",m:"un minuto",mm:"%d minuti",h:"un'ora",hh:"%d ore",d:"un giorno",dd:"%d giorni",w:"una settimana",ww:"%d settimane",M:"un mese",MM:"%d mesi",y:"un anno",yy:"%d anni"},dayOfMonthOrdinalParse:/\d{1,2}º/,ordinal:"%dº",week:{dow:1,doy:4}})})),function(t,e){e(h())}(0,(function(t){
//! moment.js locale configuration
var e=t.defineLocale("ja",{eras:[{since:"2019-05-01",offset:1,name:"令和",narrow:"㋿",abbr:"R"},{since:"1989-01-08",until:"2019-04-30",offset:1,name:"平成",narrow:"㍻",abbr:"H"},{since:"1926-12-25",until:"1989-01-07",offset:1,name:"昭和",narrow:"㍼",abbr:"S"},{since:"1912-07-30",until:"1926-12-24",offset:1,name:"大正",narrow:"㍽",abbr:"T"},{since:"1873-01-01",until:"1912-07-29",offset:6,name:"明治",narrow:"㍾",abbr:"M"},{since:"0001-01-01",until:"1873-12-31",offset:1,name:"西暦",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"紀元前",narrow:"BC",abbr:"BC"}],eraYearOrdinalRegex:/(元|\d+)年/,eraYearOrdinalParse:function(t,e){return"元"===e[1]?1:parseInt(e[1]||t,10)},months:"1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),monthsShort:"1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),weekdays:"日曜日_月曜日_火曜日_水曜日_木曜日_金曜日_土曜日".split("_"),weekdaysShort:"日_月_火_水_木_金_土".split("_"),weekdaysMin:"日_月_火_水_木_金_土".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"YYYY/MM/DD",LL:"YYYY年M月D日",LLL:"YYYY年M月D日 HH:mm",LLLL:"YYYY年M月D日 dddd HH:mm",l:"YYYY/MM/DD",ll:"YYYY年M月D日",lll:"YYYY年M月D日 HH:mm",llll:"YYYY年M月D日(ddd) HH:mm"},meridiemParse:/午前|午後/i,isPM:function(t){return"午後"===t},meridiem:function(t,e,i){return t<12?"午前":"午後"},calendar:{sameDay:"[今日] LT",nextDay:"[明日] LT",nextWeek:function(t){return t.week()!==this.week()?"[来週]dddd LT":"dddd LT"},lastDay:"[昨日] LT",lastWeek:function(t){return this.week()!==t.week()?"[先週]dddd LT":"dddd LT"},sameElse:"L"},dayOfMonthOrdinalParse:/\d{1,2}日/,ordinal:function(t,e){switch(e){case"y":return 1===t?"元年":t+"年";case"d":case"D":case"DDD":return t+"日";default:return t}},relativeTime:{future:"%s後",past:"%s前",s:"数秒",ss:"%d秒",m:"1分",mm:"%d分",h:"1時間",hh:"%d時間",d:"1日",dd:"%d日",M:"1ヶ月",MM:"%dヶ月",y:"1年",yy:"%d年"}});return e})),function(t,e){e(h())}(0,(function(t){
//! moment.js locale configuration
var e="jan._feb._mrt._apr._mei_jun._jul._aug._sep._okt._nov._dec.".split("_"),i="jan_feb_mrt_apr_mei_jun_jul_aug_sep_okt_nov_dec".split("_"),n=[/^jan/i,/^feb/i,/^maart|mrt.?$/i,/^apr/i,/^mei$/i,/^jun[i.]?$/i,/^jul[i.]?$/i,/^aug/i,/^sep/i,/^okt/i,/^nov/i,/^dec/i],r=/^(januari|februari|maart|april|mei|ju[nl]i|augustus|september|oktober|november|december|jan\.?|feb\.?|mrt\.?|apr\.?|ju[nl]\.?|aug\.?|sep\.?|okt\.?|nov\.?|dec\.?)/i,o=t.defineLocale("nl",{months:"januari_februari_maart_april_mei_juni_juli_augustus_september_oktober_november_december".split("_"),monthsShort:function(t,n){return t?/-MMM-/.test(n)?i[t.month()]:e[t.month()]:e},monthsRegex:r,monthsShortRegex:r,monthsStrictRegex:/^(januari|februari|maart|april|mei|ju[nl]i|augustus|september|oktober|november|december)/i,monthsShortStrictRegex:/^(jan\.?|feb\.?|mrt\.?|apr\.?|mei|ju[nl]\.?|aug\.?|sep\.?|okt\.?|nov\.?|dec\.?)/i,monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"zondag_maandag_dinsdag_woensdag_donderdag_vrijdag_zaterdag".split("_"),weekdaysShort:"zo._ma._di._wo._do._vr._za.".split("_"),weekdaysMin:"zo_ma_di_wo_do_vr_za".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD-MM-YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[vandaag om] LT",nextDay:"[morgen om] LT",nextWeek:"dddd [om] LT",lastDay:"[gisteren om] LT",lastWeek:"[afgelopen] dddd [om] LT",sameElse:"L"},relativeTime:{future:"over %s",past:"%s geleden",s:"een paar seconden",ss:"%d seconden",m:"één minuut",mm:"%d minuten",h:"één uur",hh:"%d uur",d:"één dag",dd:"%d dagen",w:"één week",ww:"%d weken",M:"één maand",MM:"%d maanden",y:"één jaar",yy:"%d jaar"},dayOfMonthOrdinalParse:/\d{1,2}(ste|de)/,ordinal:function(t){return t+(1===t||8===t||t>=20?"ste":"de")},week:{dow:1,doy:4}});return o})),function(t,e){e(h())}(0,(function(t){
//! moment.js locale configuration
var e="styczeń_luty_marzec_kwiecień_maj_czerwiec_lipiec_sierpień_wrzesień_październik_listopad_grudzień".split("_"),i="stycznia_lutego_marca_kwietnia_maja_czerwca_lipca_sierpnia_września_października_listopada_grudnia".split("_"),n=[/^sty/i,/^lut/i,/^mar/i,/^kwi/i,/^maj/i,/^cze/i,/^lip/i,/^sie/i,/^wrz/i,/^paź/i,/^lis/i,/^gru/i];function r(t){return t%10<5&&t%10>1&&~~(t/10)%10!=1}function o(t,e,i){var n=t+" ";switch(i){case"ss":return n+(r(t)?"sekundy":"sekund");case"m":return e?"minuta":"minutę";case"mm":return n+(r(t)?"minuty":"minut");case"h":return e?"godzina":"godzinę";case"hh":return n+(r(t)?"godziny":"godzin");case"ww":return n+(r(t)?"tygodnie":"tygodni");case"MM":return n+(r(t)?"miesiące":"miesięcy");case"yy":return n+(r(t)?"lata":"lat")}}return t.defineLocale("pl",{months:function(t,n){return t?/D MMMM/.test(n)?i[t.month()]:e[t.month()]:e},monthsShort:"sty_lut_mar_kwi_maj_cze_lip_sie_wrz_paź_lis_gru".split("_"),monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"niedziela_poniedziałek_wtorek_środa_czwartek_piątek_sobota".split("_"),weekdaysShort:"ndz_pon_wt_śr_czw_pt_sob".split("_"),weekdaysMin:"Nd_Pn_Wt_Śr_Cz_Pt_So".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd, D MMMM YYYY HH:mm"},calendar:{sameDay:"[Dziś o] LT",nextDay:"[Jutro o] LT",nextWeek:function(){switch(this.day()){case 0:return"[W niedzielę o] LT";case 2:return"[We wtorek o] LT";case 3:return"[W środę o] LT";case 6:return"[W sobotę o] LT";default:return"[W] dddd [o] LT"}},lastDay:"[Wczoraj o] LT",lastWeek:function(){switch(this.day()){case 0:return"[W zeszłą niedzielę o] LT";case 3:return"[W zeszłą środę o] LT";case 6:return"[W zeszłą sobotę o] LT";default:return"[W zeszły] dddd [o] LT"}},sameElse:"L"},relativeTime:{future:"za %s",past:"%s temu",s:"kilka sekund",ss:o,m:o,mm:o,h:o,hh:o,d:"1 dzień",dd:"%d dni",w:"tydzień",ww:o,M:"miesiąc",MM:o,y:"rok",yy:o},dayOfMonthOrdinalParse:/\d{1,2}\./,ordinal:"%d.",week:{dow:1,doy:4}})})),function(t,e){e(h())}(0,(function(t){function e(t,e,i){var n,r;return"m"===i?e?"минута":"минуту":t+" "+(n=+t,r={ss:e?"секунда_секунды_секунд":"секунду_секунды_секунд",mm:e?"минута_минуты_минут":"минуту_минуты_минут",hh:"час_часа_часов",dd:"день_дня_дней",ww:"неделя_недели_недель",MM:"месяц_месяца_месяцев",yy:"год_года_лет"}[i].split("_"),n%10==1&&n%100!=11?r[0]:n%10>=2&&n%10<=4&&(n%100<10||n%100>=20)?r[1]:r[2])}var i=[/^янв/i,/^фев/i,/^мар/i,/^апр/i,/^ма[йя]/i,/^июн/i,/^июл/i,/^авг/i,/^сен/i,/^окт/i,/^ноя/i,/^дек/i],n=t.defineLocale("ru",{months:{format:"января_февраля_марта_апреля_мая_июня_июля_августа_сентября_октября_ноября_декабря".split("_"),standalone:"январь_февраль_март_апрель_май_июнь_июль_август_сентябрь_октябрь_ноябрь_декабрь".split("_")},monthsShort:{format:"янв._февр._мар._апр._мая_июня_июля_авг._сент._окт._нояб._дек.".split("_"),standalone:"янв._февр._март_апр._май_июнь_июль_авг._сент._окт._нояб._дек.".split("_")},weekdays:{standalone:"воскресенье_понедельник_вторник_среда_четверг_пятница_суббота".split("_"),format:"воскресенье_понедельник_вторник_среду_четверг_пятницу_субботу".split("_"),isFormat:/\[ ?[Вв] ?(?:прошлую|следующую|эту)? ?] ?dddd/},weekdaysShort:"вс_пн_вт_ср_чт_пт_сб".split("_"),weekdaysMin:"вс_пн_вт_ср_чт_пт_сб".split("_"),monthsParse:i,longMonthsParse:i,shortMonthsParse:i,monthsRegex:/^(январ[ья]|янв\.?|феврал[ья]|февр?\.?|марта?|мар\.?|апрел[ья]|апр\.?|ма[йя]|июн[ья]|июн\.?|июл[ья]|июл\.?|августа?|авг\.?|сентябр[ья]|сент?\.?|октябр[ья]|окт\.?|ноябр[ья]|нояб?\.?|декабр[ья]|дек\.?)/i,monthsShortRegex:/^(январ[ья]|янв\.?|феврал[ья]|февр?\.?|марта?|мар\.?|апрел[ья]|апр\.?|ма[йя]|июн[ья]|июн\.?|июл[ья]|июл\.?|августа?|авг\.?|сентябр[ья]|сент?\.?|октябр[ья]|окт\.?|ноябр[ья]|нояб?\.?|декабр[ья]|дек\.?)/i,monthsStrictRegex:/^(январ[яь]|феврал[яь]|марта?|апрел[яь]|ма[яй]|июн[яь]|июл[яь]|августа?|сентябр[яь]|октябр[яь]|ноябр[яь]|декабр[яь])/i,monthsShortStrictRegex:/^(янв\.|февр?\.|мар[т.]|апр\.|ма[яй]|июн[ья.]|июл[ья.]|авг\.|сент?\.|окт\.|нояб?\.|дек\.)/i,longDateFormat:{LT:"H:mm",LTS:"H:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY г.",LLL:"D MMMM YYYY г., H:mm",LLLL:"dddd, D MMMM YYYY г., H:mm"},calendar:{sameDay:"[Сегодня, в] LT",nextDay:"[Завтра, в] LT",lastDay:"[Вчера, в] LT",nextWeek:function(t){if(t.week()===this.week())return 2===this.day()?"[Во] dddd, [в] LT":"[В] dddd, [в] LT";switch(this.day()){case 0:return"[В следующее] dddd, [в] LT";case 1:case 2:case 4:return"[В следующий] dddd, [в] LT";case 3:case 5:case 6:return"[В следующую] dddd, [в] LT"}},lastWeek:function(t){if(t.week()===this.week())return 2===this.day()?"[Во] dddd, [в] LT":"[В] dddd, [в] LT";switch(this.day()){case 0:return"[В прошлое] dddd, [в] LT";case 1:case 2:case 4:return"[В прошлый] dddd, [в] LT";case 3:case 5:case 6:return"[В прошлую] dddd, [в] LT"}},sameElse:"L"},relativeTime:{future:"через %s",past:"%s назад",s:"несколько секунд",ss:e,m:e,mm:e,h:"час",hh:e,d:"день",dd:e,w:"неделя",ww:e,M:"месяц",MM:e,y:"год",yy:e},meridiemParse:/ночи|утра|дня|вечера/i,isPM:function(t){return/^(дня|вечера)$/.test(t)},meridiem:function(t,e,i){return t<4?"ночи":t<12?"утра":t<17?"дня":"вечера"},dayOfMonthOrdinalParse:/\d{1,2}-(й|го|я)/,ordinal:function(t,e){switch(e){case"M":case"d":case"DDD":return t+"-й";case"D":return t+"-го";case"w":case"W":return t+"-я";default:return t}},week:{dow:1,doy:4}});return n})),function(t,e){e(h())}(0,(function(t){function e(t,e,i){var n,r;return"m"===i?e?"хвилина":"хвилину":"h"===i?e?"година":"годину":t+" "+(n=+t,r={ss:e?"секунда_секунди_секунд":"секунду_секунди_секунд",mm:e?"хвилина_хвилини_хвилин":"хвилину_хвилини_хвилин",hh:e?"година_години_годин":"годину_години_годин",dd:"день_дні_днів",MM:"місяць_місяці_місяців",yy:"рік_роки_років"}[i].split("_"),n%10==1&&n%100!=11?r[0]:n%10>=2&&n%10<=4&&(n%100<10||n%100>=20)?r[1]:r[2])}function i(t){return function(){return t+"о"+(11===this.hours()?"б":"")+"] LT"}}var n=t.defineLocale("uk",{months:{format:"січня_лютого_березня_квітня_травня_червня_липня_серпня_вересня_жовтня_листопада_грудня".split("_"),standalone:"січень_лютий_березень_квітень_травень_червень_липень_серпень_вересень_жовтень_листопад_грудень".split("_")},monthsShort:"січ_лют_бер_квіт_трав_черв_лип_серп_вер_жовт_лист_груд".split("_"),weekdays:function(t,e){var i={nominative:"неділя_понеділок_вівторок_середа_четвер_п’ятниця_субота".split("_"),accusative:"неділю_понеділок_вівторок_середу_четвер_п’ятницю_суботу".split("_"),genitive:"неділі_понеділка_вівторка_середи_четверга_п’ятниці_суботи".split("_")};return!0===t?i.nominative.slice(1,7).concat(i.nominative.slice(0,1)):t?i[/(\[[ВвУу]\]) ?dddd/.test(e)?"accusative":/\[?(?:минулої|наступної)? ?\] ?dddd/.test(e)?"genitive":"nominative"][t.day()]:i.nominative},weekdaysShort:"нд_пн_вт_ср_чт_пт_сб".split("_"),weekdaysMin:"нд_пн_вт_ср_чт_пт_сб".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY р.",LLL:"D MMMM YYYY р., HH:mm",LLLL:"dddd, D MMMM YYYY р., HH:mm"},calendar:{sameDay:i("[Сьогодні "),nextDay:i("[Завтра "),lastDay:i("[Вчора "),nextWeek:i("[У] dddd ["),lastWeek:function(){switch(this.day()){case 0:case 3:case 5:case 6:return i("[Минулої] dddd [").call(this);case 1:case 2:case 4:return i("[Минулого] dddd [").call(this)}},sameElse:"L"},relativeTime:{future:"за %s",past:"%s тому",s:"декілька секунд",ss:e,m:e,mm:e,h:"годину",hh:e,d:"день",dd:e,M:"місяць",MM:e,y:"рік",yy:e},meridiemParse:/ночі|ранку|дня|вечора/,isPM:function(t){return/^(дня|вечора)$/.test(t)},meridiem:function(t,e,i){return t<4?"ночі":t<12?"ранку":t<17?"дня":"вечора"},dayOfMonthOrdinalParse:/\d{1,2}-(й|го)/,ordinal:function(t,e){switch(e){case"M":case"d":case"DDD":case"w":case"W":return t+"-й";case"D":return t+"-го";default:return t}},week:{dow:1,doy:7}});return n}));var u={},c={get exports(){return u},set exports(t){u=t}},d=function(t){try{return!!t()}catch(t){return!0}},p=!d((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),f=p,m=Function.prototype,v=m.call,g=f&&m.bind.bind(v,v),y=f?g:function(t){return function(){return v.apply(t,arguments)}},b=Math.ceil,_=Math.floor,w=Math.trunc||function(t){var e=+t;return(e>0?_:b)(e)},k=function(t){var e=+t;return e!=e||0===e?0:w(e)},x=function(t){return t&&t.Math==Math&&t},D=x("object"==typeof globalThis&&globalThis)||x("object"==typeof window&&window)||x("object"==typeof self&&self)||x("object"==typeof e&&e)||function(){return this}()||Function("return this")(),S={},C={get exports(){return S},set exports(t){S=t}},T=D,M=Object.defineProperty,O=function(t,e){try{M(T,t,{value:e,configurable:!0,writable:!0})}catch(i){T[t]=e}return e},E="__core-js_shared__",P=D[E]||O(E,{}),I=P;(C.exports=function(t,e){return I[t]||(I[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var A,L,N=function(t){return null==t},R=N,F=TypeError,j=function(t){if(R(t))throw F("Can't call method on "+t);return t},Y=j,H=Object,z=function(t){return H(Y(t))},B=z,G=y({}.hasOwnProperty),W=Object.hasOwn||function(t,e){return G(B(t),e)},V=y,U=0,X=Math.random(),q=V(1..toString),$=function(t){return"Symbol("+(void 0===t?"":t)+")_"+q(++U+X,36)},Z="undefined"!=typeof navigator&&String(navigator.userAgent)||"",K=D,J=Z,Q=K.process,tt=K.Deno,et=Q&&Q.versions||tt&&tt.version,it=et&&et.v8;it&&(L=(A=it.split("."))[0]>0&&A[0]<4?1:+(A[0]+A[1])),!L&&J&&(!(A=J.match(/Edge\/(\d+)/))||A[1]>=74)&&(A=J.match(/Chrome\/(\d+)/))&&(L=+A[1]);var nt=L,rt=nt,ot=d,st=!!Object.getOwnPropertySymbols&&!ot((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&rt&&rt<41})),at=st&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,lt=S,ht=W,ut=$,ct=st,dt=at,pt=D.Symbol,ft=lt("wks"),mt=dt?pt.for||pt:pt&&pt.withoutSetter||ut,vt=function(t){return ht(ft,t)||(ft[t]=ct&&ht(pt,t)?pt[t]:mt("Symbol."+t)),ft[t]},gt={};gt[vt("toStringTag")]="z";var yt="[object z]"===String(gt),bt="object"==typeof document&&document.all,_t={all:bt,IS_HTMLDDA:void 0===bt&&void 0!==bt},wt=_t.all,kt=_t.IS_HTMLDDA?function(t){return"function"==typeof t||t===wt}:function(t){return"function"==typeof t},xt=y,Dt=xt({}.toString),St=xt("".slice),Ct=function(t){return St(Dt(t),8,-1)},Tt=yt,Mt=kt,Ot=Ct,Et=vt("toStringTag"),Pt=Object,It="Arguments"==Ot(function(){return arguments}()),At=Tt?Ot:function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Pt(t),Et))?i:It?Ot(e):"Object"==(n=Ot(e))&&Mt(e.callee)?"Arguments":n},Lt=At,Nt=String,Rt=function(t){if("Symbol"===Lt(t))throw TypeError("Cannot convert a Symbol value to a string");return Nt(t)},Ft=y,jt=k,Yt=Rt,Ht=j,zt=Ft("".charAt),Bt=Ft("".charCodeAt),Gt=Ft("".slice),Wt=function(t){return function(e,i){var n,r,o=Yt(Ht(e)),s=jt(i),a=o.length;return s<0||s>=a?t?"":void 0:(n=Bt(o,s))<55296||n>56319||s+1===a||(r=Bt(o,s+1))<56320||r>57343?t?zt(o,s):n:t?Gt(o,s,s+2):r-56320+(n-55296<<10)+65536}},Vt={codeAt:Wt(!1),charAt:Wt(!0)},Ut=kt,Xt=D.WeakMap,qt=Ut(Xt)&&/native code/.test(String(Xt)),$t=kt,Zt=_t.all,Kt=_t.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:$t(t)||t===Zt}:function(t){return"object"==typeof t?null!==t:$t(t)},Jt=!d((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),Qt={},te=Kt,ee=D.document,ie=te(ee)&&te(ee.createElement),ne=function(t){return ie?ee.createElement(t):{}},re=ne,oe=!Jt&&!d((function(){return 7!=Object.defineProperty(re("div"),"a",{get:function(){return 7}}).a})),se=Jt&&d((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),ae=Kt,le=String,he=TypeError,ue=function(t){if(ae(t))return t;throw he(le(t)+" is not an object")},ce=p,de=Function.prototype.call,pe=ce?de.bind(de):function(){return de.apply(de,arguments)},fe={},me=fe,ve=D,ge=kt,ye=function(t){return ge(t)?t:void 0},be=function(t,e){return arguments.length<2?ye(me[t])||ye(ve[t]):me[t]&&me[t][e]||ve[t]&&ve[t][e]},_e=y({}.isPrototypeOf),we=be,ke=kt,xe=_e,De=Object,Se=at?function(t){return"symbol"==typeof t}:function(t){var e=we("Symbol");return ke(e)&&xe(e.prototype,De(t))},Ce=String,Te=function(t){try{return Ce(t)}catch(t){return"Object"}},Me=kt,Oe=Te,Ee=TypeError,Pe=function(t){if(Me(t))return t;throw Ee(Oe(t)+" is not a function")},Ie=Pe,Ae=N,Le=function(t,e){var i=t[e];return Ae(i)?void 0:Ie(i)},Ne=pe,Re=kt,Fe=Kt,je=TypeError,Ye=pe,He=Kt,ze=Se,Be=Le,Ge=function(t,e){var i,n;if("string"===e&&Re(i=t.toString)&&!Fe(n=Ne(i,t)))return n;if(Re(i=t.valueOf)&&!Fe(n=Ne(i,t)))return n;if("string"!==e&&Re(i=t.toString)&&!Fe(n=Ne(i,t)))return n;throw je("Can't convert object to primitive value")},We=TypeError,Ve=vt("toPrimitive"),Ue=function(t,e){if(!He(t)||ze(t))return t;var i,n=Be(t,Ve);if(n){if(void 0===e&&(e="default"),i=Ye(n,t,e),!He(i)||ze(i))return i;throw We("Can't convert object to primitive value")}return void 0===e&&(e="number"),Ge(t,e)},Xe=Se,qe=function(t){var e=Ue(t,"string");return Xe(e)?e:e+""},$e=Jt,Ze=oe,Ke=se,Je=ue,Qe=qe,ti=TypeError,ei=Object.defineProperty,ii=Object.getOwnPropertyDescriptor,ni="enumerable",ri="configurable",oi="writable";Qt.f=$e?Ke?function(t,e,i){if(Je(t),e=Qe(e),Je(i),"function"==typeof t&&"prototype"===e&&"value"in i&&oi in i&&!i[oi]){var n=ii(t,e);n&&n[oi]&&(t[e]=i.value,i={configurable:ri in i?i[ri]:n[ri],enumerable:ni in i?i[ni]:n[ni],writable:!1})}return ei(t,e,i)}:ei:function(t,e,i){if(Je(t),e=Qe(e),Je(i),Ze)try{return ei(t,e,i)}catch(t){}if("get"in i||"set"in i)throw ti("Accessors not supported");return"value"in i&&(t[e]=i.value),t};var si,ai,li,hi=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},ui=Qt,ci=hi,di=Jt?function(t,e,i){return ui.f(t,e,ci(1,i))}:function(t,e,i){return t[e]=i,t},pi=$,fi=S("keys"),mi=function(t){return fi[t]||(fi[t]=pi(t))},vi={},gi=qt,yi=D,bi=Kt,_i=di,wi=W,ki=P,xi=mi,Di=vi,Si="Object already initialized",Ci=yi.TypeError,Ti=yi.WeakMap;if(gi||ki.state){var Mi=ki.state||(ki.state=new Ti);Mi.get=Mi.get,Mi.has=Mi.has,Mi.set=Mi.set,si=function(t,e){if(Mi.has(t))throw Ci(Si);return e.facade=t,Mi.set(t,e),e},ai=function(t){return Mi.get(t)||{}},li=function(t){return Mi.has(t)}}else{var Oi=xi("state");Di[Oi]=!0,si=function(t,e){if(wi(t,Oi))throw Ci(Si);return e.facade=t,_i(t,Oi,e),e},ai=function(t){return wi(t,Oi)?t[Oi]:{}},li=function(t){return wi(t,Oi)}}var Ei={set:si,get:ai,has:li,enforce:function(t){return li(t)?ai(t):si(t,{})},getterFor:function(t){return function(e){var i;if(!bi(e)||(i=ai(e)).type!==t)throw Ci("Incompatible receiver, "+t+" required");return i}}},Pi=p,Ii=Function.prototype,Ai=Ii.apply,Li=Ii.call,Ni="object"==typeof Reflect&&Reflect.apply||(Pi?Li.bind(Ai):function(){return Li.apply(Ai,arguments)}),Ri=Ct,Fi=y,ji=function(t){if("Function"===Ri(t))return Fi(t)},Yi={},Hi={},zi={}.propertyIsEnumerable,Bi=Object.getOwnPropertyDescriptor,Gi=Bi&&!zi.call({1:2},1);Hi.f=Gi?function(t){var e=Bi(this,t);return!!e&&e.enumerable}:zi;var Wi=d,Vi=Ct,Ui=Object,Xi=y("".split),qi=Wi((function(){return!Ui("z").propertyIsEnumerable(0)}))?function(t){return"String"==Vi(t)?Xi(t,""):Ui(t)}:Ui,$i=qi,Zi=j,Ki=function(t){return $i(Zi(t))},Ji=Jt,Qi=pe,tn=Hi,en=hi,nn=Ki,rn=qe,on=W,sn=oe,an=Object.getOwnPropertyDescriptor;Yi.f=Ji?an:function(t,e){if(t=nn(t),e=rn(e),sn)try{return an(t,e)}catch(t){}if(on(t,e))return en(!Qi(tn.f,t,e),t[e])};var ln=d,hn=kt,un=/#|\.prototype\./,cn=function(t,e){var i=pn[dn(t)];return i==mn||i!=fn&&(hn(e)?ln(e):!!e)},dn=cn.normalize=function(t){return String(t).replace(un,".").toLowerCase()},pn=cn.data={},fn=cn.NATIVE="N",mn=cn.POLYFILL="P",vn=cn,gn=Pe,yn=p,bn=ji(ji.bind),_n=function(t,e){return gn(t),void 0===e?t:yn?bn(t,e):function(){return t.apply(e,arguments)}},wn=D,kn=Ni,xn=ji,Dn=kt,Sn=Yi.f,Cn=vn,Tn=fe,Mn=_n,On=di,En=W,Pn=function(t){var e=function(i,n,r){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(i);case 2:return new t(i,n)}return new t(i,n,r)}return kn(t,this,arguments)};return e.prototype=t.prototype,e},In=function(t,e){var i,n,r,o,s,a,l,h,u,c=t.target,d=t.global,p=t.stat,f=t.proto,m=d?wn:p?wn[c]:(wn[c]||{}).prototype,v=d?Tn:Tn[c]||On(Tn,c,{})[c],g=v.prototype;for(o in e)n=!(i=Cn(d?o:c+(p?".":"#")+o,t.forced))&&m&&En(m,o),a=v[o],n&&(l=t.dontCallGetSet?(u=Sn(m,o))&&u.value:m[o]),s=n&&l?l:e[o],n&&typeof a==typeof s||(h=t.bind&&n?Mn(s,wn):t.wrap&&n?Pn(s):f&&Dn(s)?xn(s):s,(t.sham||s&&s.sham||a&&a.sham)&&On(h,"sham",!0),On(v,o,h),f&&(En(Tn,r=c+"Prototype")||On(Tn,r,{}),On(Tn[r],o,s),t.real&&g&&(i||!g[o])&&On(g,o,s)))},An=Jt,Ln=W,Nn=Function.prototype,Rn=An&&Object.getOwnPropertyDescriptor,Fn=Ln(Nn,"name"),jn={EXISTS:Fn,PROPER:Fn&&"something"===function(){}.name,CONFIGURABLE:Fn&&(!An||An&&Rn(Nn,"name").configurable)},Yn={},Hn=k,zn=Math.max,Bn=Math.min,Gn=function(t,e){var i=Hn(t);return i<0?zn(i+e,0):Bn(i,e)},Wn=k,Vn=Math.min,Un=function(t){return t>0?Vn(Wn(t),9007199254740991):0},Xn=function(t){return Un(t.length)},qn=Ki,$n=Gn,Zn=Xn,Kn=function(t){return function(e,i,n){var r,o=qn(e),s=Zn(o),a=$n(n,s);if(t&&i!=i){for(;s>a;)if((r=o[a++])!=r)return!0}else for(;s>a;a++)if((t||a in o)&&o[a]===i)return t||a||0;return!t&&-1}},Jn={includes:Kn(!0),indexOf:Kn(!1)},Qn=W,tr=Ki,er=Jn.indexOf,ir=vi,nr=y([].push),rr=function(t,e){var i,n=tr(t),r=0,o=[];for(i in n)!Qn(ir,i)&&Qn(n,i)&&nr(o,i);for(;e.length>r;)Qn(n,i=e[r++])&&(~er(o,i)||nr(o,i));return o},or=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],sr=rr,ar=or,lr=Object.keys||function(t){return sr(t,ar)},hr=Jt,ur=se,cr=Qt,dr=ue,pr=Ki,fr=lr;Yn.f=hr&&!ur?Object.defineProperties:function(t,e){dr(t);for(var i,n=pr(e),r=fr(e),o=r.length,s=0;o>s;)cr.f(t,i=r[s++],n[i]);return t};var mr,vr=be("document","documentElement"),gr=ue,yr=Yn,br=or,_r=vi,wr=vr,kr=ne,xr="prototype",Dr="script",Sr=mi("IE_PROTO"),Cr=function(){},Tr=function(t){return"<"+Dr+">"+t+"</"+Dr+">"},Mr=function(t){t.write(Tr("")),t.close();var e=t.parentWindow.Object;return t=null,e},Or=function(){try{mr=new ActiveXObject("htmlfile")}catch(t){}var t,e,i;Or="undefined"!=typeof document?document.domain&&mr?Mr(mr):(e=kr("iframe"),i="java"+Dr+":",e.style.display="none",wr.appendChild(e),e.src=String(i),(t=e.contentWindow.document).open(),t.write(Tr("document.F=Object")),t.close(),t.F):Mr(mr);for(var n=br.length;n--;)delete Or[xr][br[n]];return Or()};_r[Sr]=!0;var Er,Pr,Ir,Ar=Object.create||function(t,e){var i;return null!==t?(Cr[xr]=gr(t),i=new Cr,Cr[xr]=null,i[Sr]=t):i=Or(),void 0===e?i:yr.f(i,e)},Lr=!d((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Nr=W,Rr=kt,Fr=z,jr=Lr,Yr=mi("IE_PROTO"),Hr=Object,zr=Hr.prototype,Br=jr?Hr.getPrototypeOf:function(t){var e=Fr(t);if(Nr(e,Yr))return e[Yr];var i=e.constructor;return Rr(i)&&e instanceof i?i.prototype:e instanceof Hr?zr:null},Gr=di,Wr=function(t,e,i,n){return n&&n.enumerable?t[e]=i:Gr(t,e,i),t},Vr=d,Ur=kt,Xr=Kt,qr=Ar,$r=Br,Zr=Wr,Kr=vt("iterator"),Jr=!1;[].keys&&("next"in(Ir=[].keys())?(Pr=$r($r(Ir)))!==Object.prototype&&(Er=Pr):Jr=!0);var Qr=!Xr(Er)||Vr((function(){var t={};return Er[Kr].call(t)!==t}));Ur((Er=Qr?{}:qr(Er))[Kr])||Zr(Er,Kr,(function(){return this}));var to={IteratorPrototype:Er,BUGGY_SAFARI_ITERATORS:Jr},eo=At,io=yt?{}.toString:function(){return"[object "+eo(this)+"]"},no=yt,ro=Qt.f,oo=di,so=W,ao=io,lo=vt("toStringTag"),ho=function(t,e,i,n){if(t){var r=i?t:t.prototype;so(r,lo)||ro(r,lo,{configurable:!0,value:e}),n&&!no&&oo(r,"toString",ao)}},uo={},co=to.IteratorPrototype,po=Ar,fo=hi,mo=ho,vo=uo,go=function(){return this},yo=y,bo=Pe,_o=kt,wo=String,ko=TypeError,xo=function(t,e,i){try{return yo(bo(Object.getOwnPropertyDescriptor(t,e)[i]))}catch(t){}},Do=ue,So=function(t){if("object"==typeof t||_o(t))return t;throw ko("Can't set "+wo(t)+" as a prototype")},Co=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=xo(Object.prototype,"__proto__","set"))(i,[]),e=i instanceof Array}catch(t){}return function(i,n){return Do(i),So(n),e?t(i,n):i.__proto__=n,i}}():void 0),To=In,Mo=pe,Oo=function(t,e,i,n){var r=e+" Iterator";return t.prototype=po(co,{next:fo(+!n,i)}),mo(t,r,!1,!0),vo[r]=go,t},Eo=Br,Po=ho,Io=Wr,Ao=uo,Lo=jn.PROPER,No=to.BUGGY_SAFARI_ITERATORS,Ro=vt("iterator"),Fo="keys",jo="values",Yo="entries",Ho=function(){return this},zo=function(t,e,i,n,r,o,s){Oo(i,e,n);var a,l,h,u=function(t){if(t===r&&m)return m;if(!No&&t in p)return p[t];switch(t){case Fo:case jo:case Yo:return function(){return new i(this,t)}}return function(){return new i(this)}},c=e+" Iterator",d=!1,p=t.prototype,f=p[Ro]||p["@@iterator"]||r&&p[r],m=!No&&f||u(r),v="Array"==e&&p.entries||f;if(v&&(a=Eo(v.call(new t)))!==Object.prototype&&a.next&&(Po(a,c,!0,!0),Ao[c]=Ho),Lo&&r==jo&&f&&f.name!==jo&&(d=!0,m=function(){return Mo(f,this)}),r)if(l={values:u(jo),keys:o?m:u(Fo),entries:u(Yo)},s)for(h in l)(No||d||!(h in p))&&Io(p,h,l[h]);else To({target:e,proto:!0,forced:No||d},l);return s&&p[Ro]!==m&&Io(p,Ro,m,{name:r}),Ao[e]=m,l},Bo=function(t,e){return{value:t,done:e}},Go=Vt.charAt,Wo=Rt,Vo=Ei,Uo=zo,Xo=Bo,qo="String Iterator",$o=Vo.set,Zo=Vo.getterFor(qo);Uo(String,"String",(function(t){$o(this,{type:qo,string:Wo(t),index:0})}),(function(){var t,e=Zo(this),i=e.string,n=e.index;return n>=i.length?Xo(void 0,!0):(t=Go(i,n),e.index+=t.length,Xo(t,!1))}));var Ko=pe,Jo=ue,Qo=Le,ts=function(t,e,i){var n,r;Jo(t);try{if(!(n=Qo(t,"return"))){if("throw"===e)throw i;return i}n=Ko(n,t)}catch(t){r=!0,n=t}if("throw"===e)throw i;if(r)throw n;return Jo(n),i},es=ue,is=ts,ns=uo,rs=vt("iterator"),os=Array.prototype,ss=function(t){return void 0!==t&&(ns.Array===t||os[rs]===t)},as=kt,ls=P,hs=y(Function.toString);as(ls.inspectSource)||(ls.inspectSource=function(t){return hs(t)});var us=ls.inspectSource,cs=y,ds=d,ps=kt,fs=At,ms=us,vs=function(){},gs=[],ys=be("Reflect","construct"),bs=/^\s*(?:class|function)\b/,_s=cs(bs.exec),ws=!bs.exec(vs),ks=function(t){if(!ps(t))return!1;try{return ys(vs,gs,t),!0}catch(t){return!1}},xs=function(t){if(!ps(t))return!1;switch(fs(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return ws||!!_s(bs,ms(t))}catch(t){return!0}};xs.sham=!0;var Ds=!ys||ds((function(){var t;return ks(ks.call)||!ks(Object)||!ks((function(){t=!0}))||t}))?xs:ks,Ss=qe,Cs=Qt,Ts=hi,Ms=function(t,e,i){var n=Ss(e);n in t?Cs.f(t,n,Ts(0,i)):t[n]=i},Os=At,Es=Le,Ps=N,Is=uo,As=vt("iterator"),Ls=function(t){if(!Ps(t))return Es(t,As)||Es(t,"@@iterator")||Is[Os(t)]},Ns=pe,Rs=Pe,Fs=ue,js=Te,Ys=Ls,Hs=TypeError,zs=function(t,e){var i=arguments.length<2?Ys(t):e;if(Rs(i))return Fs(Ns(i,t));throw Hs(js(t)+" is not iterable")},Bs=_n,Gs=pe,Ws=z,Vs=function(t,e,i,n){try{return n?e(es(i)[0],i[1]):e(i)}catch(e){is(t,"throw",e)}},Us=ss,Xs=Ds,qs=Xn,$s=Ms,Zs=zs,Ks=Ls,Js=Array,Qs=vt("iterator"),ta=!1;try{var ea=0,ia={next:function(){return{done:!!ea++}},return:function(){ta=!0}};ia[Qs]=function(){return this},Array.from(ia,(function(){throw 2}))}catch(t){}var na=function(t,e){if(!e&&!ta)return!1;var i=!1;try{var n={};n[Qs]=function(){return{next:function(){return{done:i=!0}}}},t(n)}catch(t){}return i},ra=function(t){var e=Ws(t),i=Xs(this),n=arguments.length,r=n>1?arguments[1]:void 0,o=void 0!==r;o&&(r=Bs(r,n>2?arguments[2]:void 0));var s,a,l,h,u,c,d=Ks(e),p=0;if(!d||this===Js&&Us(d))for(s=qs(e),a=i?new this(s):Js(s);s>p;p++)c=o?r(e[p],p):e[p],$s(a,p,c);else for(u=(h=Zs(e,d)).next,a=i?new this:[];!(l=Gs(u,h)).done;p++)c=o?Vs(h,r,[l.value,p],!0):l.value,$s(a,p,c);return a.length=p,a};In({target:"Array",stat:!0,forced:!na((function(t){Array.from(t)}))},{from:ra});var oa=fe.Array.from;!function(t){t.exports=oa}(c);var sa=n(u),aa={},la={get exports(){return aa},set exports(t){aa=t}},ha={},ua={get exports(){return ha},set exports(t){ha=t}},ca=Ki,da=uo,pa=Ei;Qt.f;var fa=zo,ma=Bo,va="Array Iterator",ga=pa.set,ya=pa.getterFor(va);fa(Array,"Array",(function(t,e){ga(this,{type:va,target:ca(t),index:0,kind:e})}),(function(){var t=ya(this),e=t.target,i=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,ma(void 0,!0)):ma("keys"==i?n:"values"==i?e[n]:[n,e[n]],!1)}),"values"),da.Arguments=da.Array;var ba=Ls,_a={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},wa=D,ka=At,xa=di,Da=uo,Sa=vt("toStringTag");for(var Ca in _a){var Ta=wa[Ca],Ma=Ta&&Ta.prototype;Ma&&ka(Ma)!==Sa&&xa(Ma,Sa,Ca),Da[Ca]=Da.Array}var Oa=ba;!function(t){t.exports=Oa}(ua),function(t){t.exports=ha}(la);var Ea=n(aa),Pa={},Ia={get exports(){return Pa},set exports(t){Pa=t}},Aa={},La=rr,Na=or.concat("length","prototype");Aa.f=Object.getOwnPropertyNames||function(t){return La(t,Na)};var Ra={},Fa=Gn,ja=Xn,Ya=Ms,Ha=Array,za=Math.max,Ba=function(t,e,i){for(var n=ja(t),r=Fa(e,n),o=Fa(void 0===i?n:i,n),s=Ha(za(o-r,0)),a=0;r<o;r++,a++)Ya(s,a,t[r]);return s.length=a,s},Ga=Ct,Wa=Ki,Va=Aa.f,Ua=Ba,Xa="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Ra.f=function(t){return Xa&&"Window"==Ga(t)?function(t){try{return Va(t)}catch(t){return Ua(Xa)}}(t):Va(Wa(t))};var qa={};qa.f=Object.getOwnPropertySymbols;var $a=Qt,Za=function(t,e,i){return $a.f(t,e,i)},Ka={},Ja=vt;Ka.f=Ja;var Qa=fe,tl=W,el=Ka,il=Qt.f,nl=function(t){var e=Qa.Symbol||(Qa.Symbol={});tl(e,t)||il(e,t,{value:el.f(t)})},rl=pe,ol=be,sl=vt,al=Wr,ll=function(){var t=ol("Symbol"),e=t&&t.prototype,i=e&&e.valueOf,n=sl("toPrimitive");e&&!e[n]&&al(e,n,(function(t){return rl(i,this)}),{arity:1})},hl=Ct,ul=Array.isArray||function(t){return"Array"==hl(t)},cl=ul,dl=Ds,pl=Kt,fl=vt("species"),ml=Array,vl=function(t){var e;return cl(t)&&(e=t.constructor,(dl(e)&&(e===ml||cl(e.prototype))||pl(e)&&null===(e=e[fl]))&&(e=void 0)),void 0===e?ml:e},gl=function(t,e){return new(vl(t))(0===e?0:e)},yl=_n,bl=qi,_l=z,wl=Xn,kl=gl,xl=y([].push),Dl=function(t){var e=1==t,i=2==t,n=3==t,r=4==t,o=6==t,s=7==t,a=5==t||o;return function(l,h,u,c){for(var d,p,f=_l(l),m=bl(f),v=yl(h,u),g=wl(m),y=0,b=c||kl,_=e?b(l,g):i||s?b(l,0):void 0;g>y;y++)if((a||y in m)&&(p=v(d=m[y],y,f),t))if(e)_[y]=p;else if(p)switch(t){case 3:return!0;case 5:return d;case 6:return y;case 2:xl(_,d)}else switch(t){case 4:return!1;case 7:xl(_,d)}return o?-1:n||r?r:_}},Sl={forEach:Dl(0),map:Dl(1),filter:Dl(2),some:Dl(3),every:Dl(4),find:Dl(5),findIndex:Dl(6),filterReject:Dl(7)},Cl=In,Tl=D,Ml=pe,Ol=y,El=Jt,Pl=st,Il=d,Al=W,Ll=_e,Nl=ue,Rl=Ki,Fl=qe,jl=Rt,Yl=hi,Hl=Ar,zl=lr,Bl=Aa,Gl=Ra,Wl=qa,Vl=Yi,Ul=Qt,Xl=Yn,ql=Hi,$l=Wr,Zl=Za,Kl=S,Jl=vi,Ql=$,th=vt,eh=Ka,ih=nl,nh=ll,rh=ho,oh=Ei,sh=Sl.forEach,ah=mi("hidden"),lh="Symbol",hh="prototype",uh=oh.set,ch=oh.getterFor(lh),dh=Object[hh],ph=Tl.Symbol,fh=ph&&ph[hh],mh=Tl.TypeError,vh=Tl.QObject,gh=Vl.f,yh=Ul.f,bh=Gl.f,_h=ql.f,wh=Ol([].push),kh=Kl("symbols"),xh=Kl("op-symbols"),Dh=Kl("wks"),Sh=!vh||!vh[hh]||!vh[hh].findChild,Ch=El&&Il((function(){return 7!=Hl(yh({},"a",{get:function(){return yh(this,"a",{value:7}).a}})).a}))?function(t,e,i){var n=gh(dh,e);n&&delete dh[e],yh(t,e,i),n&&t!==dh&&yh(dh,e,n)}:yh,Th=function(t,e){var i=kh[t]=Hl(fh);return uh(i,{type:lh,tag:t,description:e}),El||(i.description=e),i},Mh=function(t,e,i){t===dh&&Mh(xh,e,i),Nl(t);var n=Fl(e);return Nl(i),Al(kh,n)?(i.enumerable?(Al(t,ah)&&t[ah][n]&&(t[ah][n]=!1),i=Hl(i,{enumerable:Yl(0,!1)})):(Al(t,ah)||yh(t,ah,Yl(1,{})),t[ah][n]=!0),Ch(t,n,i)):yh(t,n,i)},Oh=function(t,e){Nl(t);var i=Rl(e),n=zl(i).concat(Ah(i));return sh(n,(function(e){El&&!Ml(Eh,i,e)||Mh(t,e,i[e])})),t},Eh=function(t){var e=Fl(t),i=Ml(_h,this,e);return!(this===dh&&Al(kh,e)&&!Al(xh,e))&&(!(i||!Al(this,e)||!Al(kh,e)||Al(this,ah)&&this[ah][e])||i)},Ph=function(t,e){var i=Rl(t),n=Fl(e);if(i!==dh||!Al(kh,n)||Al(xh,n)){var r=gh(i,n);return!r||!Al(kh,n)||Al(i,ah)&&i[ah][n]||(r.enumerable=!0),r}},Ih=function(t){var e=bh(Rl(t)),i=[];return sh(e,(function(t){Al(kh,t)||Al(Jl,t)||wh(i,t)})),i},Ah=function(t){var e=t===dh,i=bh(e?xh:Rl(t)),n=[];return sh(i,(function(t){!Al(kh,t)||e&&!Al(dh,t)||wh(n,kh[t])})),n};Pl||(ph=function(){if(Ll(fh,this))throw mh("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?jl(arguments[0]):void 0,e=Ql(t),i=function(t){this===dh&&Ml(i,xh,t),Al(this,ah)&&Al(this[ah],e)&&(this[ah][e]=!1),Ch(this,e,Yl(1,t))};return El&&Sh&&Ch(dh,e,{configurable:!0,set:i}),Th(e,t)},$l(fh=ph[hh],"toString",(function(){return ch(this).tag})),$l(ph,"withoutSetter",(function(t){return Th(Ql(t),t)})),ql.f=Eh,Ul.f=Mh,Xl.f=Oh,Vl.f=Ph,Bl.f=Gl.f=Ih,Wl.f=Ah,eh.f=function(t){return Th(th(t),t)},El&&Zl(fh,"description",{configurable:!0,get:function(){return ch(this).description}})),Cl({global:!0,constructor:!0,wrap:!0,forced:!Pl,sham:!Pl},{Symbol:ph}),sh(zl(Dh),(function(t){ih(t)})),Cl({target:lh,stat:!0,forced:!Pl},{useSetter:function(){Sh=!0},useSimple:function(){Sh=!1}}),Cl({target:"Object",stat:!0,forced:!Pl,sham:!El},{create:function(t,e){return void 0===e?Hl(t):Oh(Hl(t),e)},defineProperty:Mh,defineProperties:Oh,getOwnPropertyDescriptor:Ph}),Cl({target:"Object",stat:!0,forced:!Pl},{getOwnPropertyNames:Ih}),nh(),rh(ph,lh),Jl[ah]=!0;var Lh=st&&!!Symbol.for&&!!Symbol.keyFor,Nh=In,Rh=be,Fh=W,jh=Rt,Yh=S,Hh=Lh,zh=Yh("string-to-symbol-registry"),Bh=Yh("symbol-to-string-registry");Nh({target:"Symbol",stat:!0,forced:!Hh},{for:function(t){var e=jh(t);if(Fh(zh,e))return zh[e];var i=Rh("Symbol")(e);return zh[e]=i,Bh[i]=e,i}});var Gh=In,Wh=W,Vh=Se,Uh=Te,Xh=Lh,qh=S("symbol-to-string-registry");Gh({target:"Symbol",stat:!0,forced:!Xh},{keyFor:function(t){if(!Vh(t))throw TypeError(Uh(t)+" is not a symbol");if(Wh(qh,t))return qh[t]}});var $h=y([].slice),Zh=ul,Kh=kt,Jh=Ct,Qh=Rt,tu=y([].push),eu=In,iu=be,nu=Ni,ru=pe,ou=y,su=d,au=kt,lu=Se,hu=$h,uu=function(t){if(Kh(t))return t;if(Zh(t)){for(var e=t.length,i=[],n=0;n<e;n++){var r=t[n];"string"==typeof r?tu(i,r):"number"!=typeof r&&"Number"!=Jh(r)&&"String"!=Jh(r)||tu(i,Qh(r))}var o=i.length,s=!0;return function(t,e){if(s)return s=!1,e;if(Zh(this))return e;for(var n=0;n<o;n++)if(i[n]===t)return e}}},cu=st,du=String,pu=iu("JSON","stringify"),fu=ou(/./.exec),mu=ou("".charAt),vu=ou("".charCodeAt),gu=ou("".replace),yu=ou(1..toString),bu=/[\uD800-\uDFFF]/g,_u=/^[\uD800-\uDBFF]$/,wu=/^[\uDC00-\uDFFF]$/,ku=!cu||su((function(){var t=iu("Symbol")();return"[null]"!=pu([t])||"{}"!=pu({a:t})||"{}"!=pu(Object(t))})),xu=su((function(){return'"\\udf06\\ud834"'!==pu("\udf06\ud834")||'"\\udead"'!==pu("\udead")})),Du=function(t,e){var i=hu(arguments),n=uu(e);if(au(n)||void 0!==t&&!lu(t))return i[1]=function(t,e){if(au(n)&&(e=ru(n,this,du(t),e)),!lu(e))return e},nu(pu,null,i)},Su=function(t,e,i){var n=mu(i,e-1),r=mu(i,e+1);return fu(_u,t)&&!fu(wu,r)||fu(wu,t)&&!fu(_u,n)?"\\u"+yu(vu(t,0),16):t};pu&&eu({target:"JSON",stat:!0,arity:3,forced:ku||xu},{stringify:function(t,e,i){var n=hu(arguments),r=nu(ku?Du:pu,null,n);return xu&&"string"==typeof r?gu(r,bu,Su):r}});var Cu=qa,Tu=z;In({target:"Object",stat:!0,forced:!st||d((function(){Cu.f(1)}))},{getOwnPropertySymbols:function(t){var e=Cu.f;return e?e(Tu(t)):[]}});var Mu=fe.Object.getOwnPropertySymbols;!function(t){t.exports=Mu}(Ia);var Ou=n(Pa),Eu={},Pu={get exports(){return Eu},set exports(t){Eu=t}},Iu={},Au={get exports(){return Iu},set exports(t){Iu=t}},Lu=In,Nu=d,Ru=Ki,Fu=Yi.f,ju=Jt;Lu({target:"Object",stat:!0,forced:!ju||Nu((function(){Fu(1)})),sham:!ju},{getOwnPropertyDescriptor:function(t,e){return Fu(Ru(t),e)}});var Yu=fe.Object,Hu=Au.exports=function(t,e){return Yu.getOwnPropertyDescriptor(t,e)};Yu.getOwnPropertyDescriptor.sham&&(Hu.sham=!0);var zu=Iu;!function(t){t.exports=zu}(Pu);var Bu=n(Eu),Gu={},Wu={get exports(){return Gu},set exports(t){Gu=t}},Vu=be,Uu=Aa,Xu=qa,qu=ue,$u=y([].concat),Zu=Vu("Reflect","ownKeys")||function(t){var e=Uu.f(qu(t)),i=Xu.f;return i?$u(e,i(t)):e},Ku=Zu,Ju=Ki,Qu=Yi,tc=Ms;In({target:"Object",stat:!0,sham:!Jt},{getOwnPropertyDescriptors:function(t){for(var e,i,n=Ju(t),r=Qu.f,o=Ku(n),s={},a=0;o.length>a;)void 0!==(i=r(n,e=o[a++]))&&tc(s,e,i);return s}});var ec=fe.Object.getOwnPropertyDescriptors;!function(t){t.exports=ec}(Wu);var ic=n(Gu),nc={},rc={get exports(){return nc},set exports(t){nc=t}},oc={},sc={get exports(){return oc},set exports(t){oc=t}},ac=In,lc=Jt,hc=Yn.f;ac({target:"Object",stat:!0,forced:Object.defineProperties!==hc,sham:!lc},{defineProperties:hc});var uc=fe.Object,cc=sc.exports=function(t,e){return uc.defineProperties(t,e)};uc.defineProperties.sham&&(cc.sham=!0);var dc=oc;!function(t){t.exports=dc}(rc);var pc=n(nc),fc={},mc={get exports(){return fc},set exports(t){fc=t}},vc={},gc={get exports(){return vc},set exports(t){vc=t}},yc=In,bc=Jt,_c=Qt.f;yc({target:"Object",stat:!0,forced:Object.defineProperty!==_c,sham:!bc},{defineProperty:_c});var wc=fe.Object,kc=gc.exports=function(t,e,i){return wc.defineProperty(t,e,i)};wc.defineProperty.sham&&(kc.sham=!0);var xc=vc;!function(t){t.exports=xc}(mc);var Dc=n(fc);function Sc(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var Cc={},Tc={get exports(){return Cc},set exports(t){Cc=t}},Mc={},Oc=xc;!function(t){t.exports=Oc}({get exports(){return Mc},set exports(t){Mc=t}}),function(t){t.exports=Mc}(Tc);var Ec=n(Cc),Pc={},Ic={get exports(){return Pc},set exports(t){Pc=t}},Ac={},Lc={get exports(){return Ac},set exports(t){Ac=t}},Nc=TypeError,Rc=function(t){if(t>9007199254740991)throw Nc("Maximum allowed index exceeded");return t},Fc=d,jc=nt,Yc=vt("species"),Hc=function(t){return jc>=51||!Fc((function(){var e=[];return(e.constructor={})[Yc]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},zc=In,Bc=d,Gc=ul,Wc=Kt,Vc=z,Uc=Xn,Xc=Rc,qc=Ms,$c=gl,Zc=Hc,Kc=nt,Jc=vt("isConcatSpreadable"),Qc=Kc>=51||!Bc((function(){var t=[];return t[Jc]=!1,t.concat()[0]!==t})),td=function(t){if(!Wc(t))return!1;var e=t[Jc];return void 0!==e?!!e:Gc(t)};zc({target:"Array",proto:!0,arity:1,forced:!Qc||!Zc("concat")},{concat:function(t){var e,i,n,r,o,s=Vc(this),a=$c(s,0),l=0;for(e=-1,n=arguments.length;e<n;e++)if(td(o=-1===e?s:arguments[e]))for(r=Uc(o),Xc(l+r),i=0;i<r;i++,l++)i in o&&qc(a,l,o[i]);else Xc(l+1),qc(a,l++,o);return a.length=l,a}}),nl("asyncIterator"),nl("hasInstance"),nl("isConcatSpreadable"),nl("iterator"),nl("match"),nl("matchAll"),nl("replace"),nl("search"),nl("species"),nl("split");var ed=ll;nl("toPrimitive"),ed();var id=be,nd=ho;nl("toStringTag"),nd(id("Symbol"),"Symbol"),nl("unscopables"),ho(D.JSON,"JSON",!0);var rd=fe.Symbol;nl("dispose");var od=rd;nl("asyncDispose");var sd=In,ad=y,ld=be("Symbol"),hd=ld.keyFor,ud=ad(ld.prototype.valueOf);sd({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==hd(ud(t))}catch(t){return!1}}});for(var cd=In,dd=S,pd=be,fd=y,md=Se,vd=vt,gd=pd("Symbol"),yd=gd.isWellKnown,bd=pd("Object","getOwnPropertyNames"),_d=fd(gd.prototype.valueOf),wd=dd("wks"),kd=0,xd=bd(gd),Dd=xd.length;kd<Dd;kd++)try{var Sd=xd[kd];md(gd[Sd])&&vd(Sd)}catch(t){}cd({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(yd&&yd(t))return!0;try{for(var e=_d(t),i=0,n=bd(wd),r=n.length;i<r;i++)if(wd[n[i]]==e)return!0}catch(t){}return!1}}),nl("matcher"),nl("metadataKey"),nl("observable"),nl("metadata"),nl("patternMatch"),nl("replaceAll");var Cd=od;!function(t){t.exports=Cd}(Lc),function(t){t.exports=Ac}(Ic);var Td=n(Pc),Md={},Od={get exports(){return Md},set exports(t){Md=t}},Ed={},Pd={get exports(){return Ed},set exports(t){Ed=t}},Id=Ka.f("iterator"),Ad=Id;!function(t){t.exports=Ad}(Pd),function(t){t.exports=Ed}(Od);var Ld=n(Md);function Nd(t){return Nd="function"==typeof Td&&"symbol"==typeof Ld?function(t){return typeof t}:function(t){return t&&"function"==typeof Td&&t.constructor===Td&&t!==Td.prototype?"symbol":typeof t},Nd(t)}var Rd={},Fd={get exports(){return Rd},set exports(t){Rd=t}},jd={},Yd={get exports(){return jd},set exports(t){jd=t}},Hd=Ka.f("toPrimitive");!function(t){t.exports=Hd}(Yd),function(t){t.exports=jd}(Fd);var zd=n(Rd);function Bd(t){var e=function(t,e){if("object"!==Nd(t)||null===t)return t;var i=t[zd];if(void 0!==i){var n=i.call(t,e||"default");if("object"!==Nd(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Nd(e)?e:String(e)}function Gd(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Ec(t,Bd(n.key),n)}}function Wd(t,e,i){return e&&Gd(t.prototype,e),i&&Gd(t,i),Ec(t,"prototype",{writable:!1}),t}function Vd(t,e,i){return(e=Bd(e))in t?Ec(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}var Ud={},Xd={get exports(){return Ud},set exports(t){Ud=t}},qd={},$d={get exports(){return qd},set exports(t){qd=t}};In({target:"Array",stat:!0},{isArray:ul});var Zd=fe.Array.isArray,Kd=Zd;!function(t){t.exports=Kd}($d),function(t){t.exports=qd}(Xd);var Jd=n(Ud);var Qd={},tp={get exports(){return Qd},set exports(t){Qd=t}},ep={},ip={get exports(){return ep},set exports(t){ep=t}},np=In,rp=ul,op=Ds,sp=Kt,ap=Gn,lp=Xn,hp=Ki,up=Ms,cp=vt,dp=$h,pp=Hc("slice"),fp=cp("species"),mp=Array,vp=Math.max;np({target:"Array",proto:!0,forced:!pp},{slice:function(t,e){var i,n,r,o=hp(this),s=lp(o),a=ap(t,s),l=ap(void 0===e?s:e,s);if(rp(o)&&(i=o.constructor,(op(i)&&(i===mp||rp(i.prototype))||sp(i)&&null===(i=i[fp]))&&(i=void 0),i===mp||void 0===i))return dp(o,a,l);for(n=new(void 0===i?mp:i)(vp(l-a,0)),r=0;a<l;a++,r++)a in o&&up(n,r,o[a]);return n.length=r,n}});var gp=fe,yp=function(t){return gp[t+"Prototype"]},bp=yp("Array").slice,_p=_e,wp=bp,kp=Array.prototype,xp=function(t){var e=t.slice;return t===kp||_p(kp,t)&&e===kp.slice?wp:e},Dp=xp,Sp=Dp;!function(t){t.exports=Sp}(ip),function(t){t.exports=ep}(tp);var Cp=n(Qd),Tp={},Mp={get exports(){return Tp},set exports(t){Tp=t}},Op={},Ep=oa;!function(t){t.exports=Ep}({get exports(){return Op},set exports(t){Op=t}}),function(t){t.exports=Op}(Mp);var Pp=n(Tp);function Ip(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function Ap(t,e){var i;if(t){if("string"==typeof t)return Ip(t,e);var n=Cp(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Pp(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Ip(t,e):void 0}}function Lp(t,e){return function(t){if(Jd(t))return t}(t)||function(t,e){var i=null==t?null:void 0!==Td&&Ea(t)||t["@@iterator"];if(null!=i){var n,r,o,s,a=[],l=!0,h=!1;try{if(o=(i=i.call(t)).next,0===e){if(Object(i)!==i)return;l=!1}else for(;!(l=(n=o.call(i)).done)&&(a.push(n.value),a.length!==e);l=!0);}catch(t){h=!0,r=t}finally{try{if(!l&&null!=i.return&&(s=i.return(),Object(s)!==s))return}finally{if(h)throw r}}return a}}(t,e)||Ap(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Np(t){return function(t){if(Jd(t))return Ip(t)}(t)||function(t){if(void 0!==Td&&null!=Ea(t)||null!=t["@@iterator"])return Pp(t)}(t)||Ap(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Rp={};!function(t){t.exports=rd}({get exports(){return Rp},set exports(t){Rp=t}});var Fp=n(Rp),jp={},Yp={get exports(){return jp},set exports(t){jp=t}},Hp=yp("Array").concat,zp=_e,Bp=Hp,Gp=Array.prototype,Wp=function(t){var e=t.concat;return t===Gp||zp(Gp,t)&&e===Gp.concat?Bp:e},Vp=Wp;!function(t){t.exports=Vp}(Yp);var Up=n(jp),Xp={};!function(t){t.exports=Dp}({get exports(){return Xp},set exports(t){Xp=t}});var qp=n(Xp),$p={},Zp={get exports(){return $p},set exports(t){$p=t}};In({target:"Reflect",stat:!0},{ownKeys:Zu});var Kp=fe.Reflect.ownKeys;!function(t){t.exports=Kp}(Zp);var Jp=n($p),Qp={};!function(t){t.exports=Zd}({get exports(){return Qp},set exports(t){Qp=t}});var tf=n(Qp),ef={},nf={get exports(){return ef},set exports(t){ef=t}},rf=Sl.map;In({target:"Array",proto:!0,forced:!Hc("map")},{map:function(t){return rf(this,t,arguments.length>1?arguments[1]:void 0)}});var of=yp("Array").map,sf=_e,af=of,lf=Array.prototype,hf=function(t){var e=t.map;return t===lf||sf(lf,t)&&e===lf.map?af:e},uf=hf;!function(t){t.exports=uf}(nf);var cf=n(ef),df={},pf={get exports(){return df},set exports(t){df=t}},ff=z,mf=lr;In({target:"Object",stat:!0,forced:d((function(){mf(1)}))},{keys:function(t){return mf(ff(t))}});var vf=fe.Object.keys;!function(t){t.exports=vf}(pf);var gf=n(df),yf={},bf={get exports(){return yf},set exports(t){yf=t}},_f=In,wf=Date,kf=y(wf.prototype.getTime);_f({target:"Date",stat:!0},{now:function(){return kf(new wf)}});var xf=fe.Date.now;!function(t){t.exports=xf}(bf);var Df=n(yf),Sf={},Cf={get exports(){return Sf},set exports(t){Sf=t}},Tf=y,Mf=Pe,Of=Kt,Ef=W,Pf=$h,If=p,Af=Function,Lf=Tf([].concat),Nf=Tf([].join),Rf={},Ff=function(t,e,i){if(!Ef(Rf,e)){for(var n=[],r=0;r<e;r++)n[r]="a["+r+"]";Rf[e]=Af("C,a","return new C("+Nf(n,",")+")")}return Rf[e](t,i)},jf=If?Af.bind:function(t){var e=Mf(this),i=e.prototype,n=Pf(arguments,1),r=function(){var i=Lf(n,Pf(arguments));return this instanceof r?Ff(e,i.length,i):e.apply(t,i)};return Of(i)&&(r.prototype=i),r},Yf=jf;In({target:"Function",proto:!0,forced:Function.bind!==Yf},{bind:Yf});var Hf=yp("Function").bind,zf=_e,Bf=Hf,Gf=Function.prototype,Wf=function(t){var e=t.bind;return t===Gf||zf(Gf,t)&&e===Gf.bind?Bf:e},Vf=Wf;!function(t){t.exports=Vf}(Cf);var Uf=n(Sf),Xf={},qf={get exports(){return Xf},set exports(t){Xf=t}},$f=d,Zf=function(t,e){var i=[][t];return!!i&&$f((function(){i.call(null,e||function(){return 1},1)}))},Kf=Sl.forEach,Jf=Zf("forEach")?[].forEach:function(t){return Kf(this,t,arguments.length>1?arguments[1]:void 0)};In({target:"Array",proto:!0,forced:[].forEach!=Jf},{forEach:Jf});var Qf=yp("Array").forEach,tm=At,em=W,im=_e,nm=Qf,rm=Array.prototype,om={DOMTokenList:!0,NodeList:!0},sm=function(t){var e=t.forEach;return t===rm||im(rm,t)&&e===rm.forEach||em(om,tm(t))?nm:e};!function(t){t.exports=sm}(qf);var am=n(Xf),lm={},hm={get exports(){return lm},set exports(t){lm=t}},um=In,cm=ul,dm=y([].reverse),pm=[1,2];um({target:"Array",proto:!0,forced:String(pm)===String(pm.reverse())},{reverse:function(){return cm(this)&&(this.length=this.length),dm(this)}});var fm=yp("Array").reverse,mm=_e,vm=fm,gm=Array.prototype,ym=function(t){var e=t.reverse;return t===gm||mm(gm,t)&&e===gm.reverse?vm:e},bm=ym;!function(t){t.exports=bm}(hm);var _m=n(lm),wm={},km={get exports(){return wm},set exports(t){wm=t}},xm=Jt,Dm=ul,Sm=TypeError,Cm=Object.getOwnPropertyDescriptor,Tm=xm&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),Mm=Te,Om=TypeError,Em=function(t,e){if(!delete t[e])throw Om("Cannot delete property "+Mm(e)+" of "+Mm(t))},Pm=In,Im=z,Am=Gn,Lm=k,Nm=Xn,Rm=Tm?function(t,e){if(Dm(t)&&!Cm(t,"length").writable)throw Sm("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Fm=Rc,jm=gl,Ym=Ms,Hm=Em,zm=Hc("splice"),Bm=Math.max,Gm=Math.min;Pm({target:"Array",proto:!0,forced:!zm},{splice:function(t,e){var i,n,r,o,s,a,l=Im(this),h=Nm(l),u=Am(t,h),c=arguments.length;for(0===c?i=n=0:1===c?(i=0,n=h-u):(i=c-2,n=Gm(Bm(Lm(e),0),h-u)),Fm(h+i-n),r=jm(l,n),o=0;o<n;o++)(s=u+o)in l&&Ym(r,o,l[s]);if(r.length=n,i<n){for(o=u;o<h-n;o++)a=o+i,(s=o+n)in l?l[a]=l[s]:Hm(l,a);for(o=h;o>h-n+i;o--)Hm(l,o-1)}else if(i>n)for(o=h-n;o>u;o--)a=o+i-1,(s=o+n-1)in l?l[a]=l[s]:Hm(l,a);for(o=0;o<i;o++)l[o+u]=arguments[o+2];return Rm(l,h-n+i),r}});var Wm=yp("Array").splice,Vm=_e,Um=Wm,Xm=Array.prototype,qm=function(t){var e=t.splice;return t===Xm||Vm(Xm,t)&&e===Xm.splice?Um:e},$m=qm;!function(t){t.exports=$m}(km);var Zm=n(wm),Km={},Jm={get exports(){return Km},set exports(t){Km=t}},Qm=Jt,tv=y,ev=pe,iv=d,nv=lr,rv=qa,ov=Hi,sv=z,av=qi,lv=Object.assign,hv=Object.defineProperty,uv=tv([].concat),cv=!lv||iv((function(){if(Qm&&1!==lv({b:1},lv(hv({},"a",{enumerable:!0,get:function(){hv(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol(),n="abcdefghijklmnopqrst";return t[i]=7,n.split("").forEach((function(t){e[t]=t})),7!=lv({},t)[i]||nv(lv({},e)).join("")!=n}))?function(t,e){for(var i=sv(t),n=arguments.length,r=1,o=rv.f,s=ov.f;n>r;)for(var a,l=av(arguments[r++]),h=o?uv(nv(l),o(l)):nv(l),u=h.length,c=0;u>c;)a=h[c++],Qm&&!ev(s,l,a)||(i[a]=l[a]);return i}:lv,dv=cv;In({target:"Object",stat:!0,arity:2,forced:Object.assign!==dv},{assign:dv});var pv=fe.Object.assign;!function(t){t.exports=pv}(Jm);var fv=n(Km),mv={},vv={get exports(){return mv},set exports(t){mv=t}},gv=Jn.includes;In({target:"Array",proto:!0,forced:d((function(){return!Array(1).includes()}))},{includes:function(t){return gv(this,t,arguments.length>1?arguments[1]:void 0)}});var yv=yp("Array").includes,bv=Kt,_v=Ct,wv=vt("match"),kv=function(t){var e;return bv(t)&&(void 0!==(e=t[wv])?!!e:"RegExp"==_v(t))},xv=TypeError,Dv=vt("match"),Sv=In,Cv=function(t){if(kv(t))throw xv("The method doesn't accept regular expressions");return t},Tv=j,Mv=Rt,Ov=function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[Dv]=!1,"/./"[t](e)}catch(t){}}return!1},Ev=y("".indexOf);Sv({target:"String",proto:!0,forced:!Ov("includes")},{includes:function(t){return!!~Ev(Mv(Tv(this)),Mv(Cv(t)),arguments.length>1?arguments[1]:void 0)}});var Pv=yp("String").includes,Iv=_e,Av=yv,Lv=Pv,Nv=Array.prototype,Rv=String.prototype,Fv=function(t){var e=t.includes;return t===Nv||Iv(Nv,t)&&e===Nv.includes?Av:"string"==typeof t||t===Rv||Iv(Rv,t)&&e===Rv.includes?Lv:e},jv=Fv;!function(t){t.exports=jv}(vv);var Yv=n(mv),Hv={},zv={get exports(){return Hv},set exports(t){Hv=t}},Bv=z,Gv=Br,Wv=Lr;In({target:"Object",stat:!0,forced:d((function(){Gv(1)})),sham:!Wv},{getPrototypeOf:function(t){return Gv(Bv(t))}});var Vv=fe.Object.getPrototypeOf;!function(t){t.exports=Vv}(zv);var Uv=n(Hv),Xv={},qv={get exports(){return Xv},set exports(t){Xv=t}},$v=Sl.filter;In({target:"Array",proto:!0,forced:!Hc("filter")},{filter:function(t){return $v(this,t,arguments.length>1?arguments[1]:void 0)}});var Zv=yp("Array").filter,Kv=_e,Jv=Zv,Qv=Array.prototype,tg=function(t){var e=t.filter;return t===Qv||Kv(Qv,t)&&e===Qv.filter?Jv:e},eg=tg;!function(t){t.exports=eg}(qv);var ig=n(Xv),ng={},rg={get exports(){return ng},set exports(t){ng=t}},og=Jt,sg=y,ag=lr,lg=Ki,hg=sg(Hi.f),ug=sg([].push),cg=function(t){return function(e){for(var i,n=lg(e),r=ag(n),o=r.length,s=0,a=[];o>s;)i=r[s++],og&&!hg(n,i)||ug(a,t?[i,n[i]]:n[i]);return a}},dg={entries:cg(!0),values:cg(!1)}.values;In({target:"Object",stat:!0},{values:function(t){return dg(t)}});var pg=fe.Object.values;!function(t){t.exports=pg}(rg);var fg=n(ng),mg={},vg={get exports(){return mg},set exports(t){mg=t}},gg="\t\n\v\f\r                　\u2028\u2029\ufeff",yg=j,bg=Rt,_g=gg,wg=y("".replace),kg=RegExp("^["+_g+"]+"),xg=RegExp("(^|[^"+_g+"])["+_g+"]+$"),Dg=function(t){return function(e){var i=bg(yg(e));return 1&t&&(i=wg(i,kg,"")),2&t&&(i=wg(i,xg,"$1")),i}},Sg={start:Dg(1),end:Dg(2),trim:Dg(3)},Cg=D,Tg=d,Mg=y,Og=Rt,Eg=Sg.trim,Pg=gg,Ig=Cg.parseInt,Ag=Cg.Symbol,Lg=Ag&&Ag.iterator,Ng=/^[+-]?0x/i,Rg=Mg(Ng.exec),Fg=8!==Ig(Pg+"08")||22!==Ig(Pg+"0x16")||Lg&&!Tg((function(){Ig(Object(Lg))}))?function(t,e){var i=Eg(Og(t));return Ig(i,e>>>0||(Rg(Ng,i)?16:10))}:Ig;In({global:!0,forced:parseInt!=Fg},{parseInt:Fg});var jg=fe.parseInt;!function(t){t.exports=jg}(vg);var Yg=n(mg),Hg={},zg={get exports(){return Hg},set exports(t){Hg=t}},Bg=In,Gg=Jn.indexOf,Wg=Zf,Vg=ji([].indexOf),Ug=!!Vg&&1/Vg([1],1,-0)<0;Bg({target:"Array",proto:!0,forced:Ug||!Wg("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return Ug?Vg(this,t,e)||0:Gg(this,t,e)}});var Xg=yp("Array").indexOf,qg=_e,$g=Xg,Zg=Array.prototype,Kg=function(t){var e=t.indexOf;return t===Zg||qg(Zg,t)&&e===Zg.indexOf?$g:e},Jg=Kg;!function(t){t.exports=Jg}(zg);var Qg=n(Hg),ty={},ey={get exports(){return ty},set exports(t){ty=t}},iy=jn.PROPER,ny=d,ry=gg,oy=Sg.trim;In({target:"String",proto:!0,forced:function(t){return ny((function(){return!!ry[t]()||"​᠎"!=="​᠎"[t]()||iy&&ry[t].name!==t}))}("trim")},{trim:function(){return oy(this)}});var sy=yp("String").trim,ay=_e,ly=sy,hy=String.prototype,uy=function(t){var e=t.trim;return"string"==typeof t||t===hy||ay(hy,t)&&e===hy.trim?ly:e},cy=uy;!function(t){t.exports=cy}(ey);var dy=n(ty),py={},fy={get exports(){return py},set exports(t){py=t}};In({target:"Object",stat:!0,sham:!Jt},{create:Ar});var my=fe.Object,vy=function(t,e){return my.create(t,e)};!function(t){t.exports=vy}(fy);var gy=n(py),yy={},by={get exports(){return yy},set exports(t){yy=t}},_y=fe,wy=Ni;_y.JSON||(_y.JSON={stringify:JSON.stringify});var ky=function(t,e,i){return wy(_y.JSON.stringify,null,arguments)},xy=ky;!function(t){t.exports=xy}(by);var Dy=n(yy),Sy={},Cy={get exports(){return Sy},set exports(t){Sy=t}},Ty="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,My=TypeError,Oy=function(t,e){if(t<e)throw My("Not enough arguments");return t},Ey=D,Py=Ni,Iy=kt,Ay=Ty,Ly=Z,Ny=$h,Ry=Oy,Fy=Ey.Function,jy=/MSIE .\./.test(Ly)||Ay&&function(){var t=Ey.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Yy=function(t,e){var i=e?2:1;return jy?function(n,r){var o=Ry(arguments.length,1)>i,s=Iy(n)?n:Fy(n),a=o?Ny(arguments,i):[],l=o?function(){Py(s,this,a)}:s;return e?t(l,r):t(l)}:t},Hy=In,zy=D,By=Yy(zy.setInterval,!0);Hy({global:!0,bind:!0,forced:zy.setInterval!==By},{setInterval:By});var Gy=In,Wy=D,Vy=Yy(Wy.setTimeout,!0);Gy({global:!0,bind:!0,forced:Wy.setTimeout!==Vy},{setTimeout:Vy});var Uy=fe.setTimeout;!function(t){t.exports=Uy}(Cy);var Xy=n(Sy),qy={},$y={get exports(){return qy},set exports(t){qy=t}},Zy=z,Ky=Gn,Jy=Xn,Qy=function(t){for(var e=Zy(this),i=Jy(e),n=arguments.length,r=Ky(n>1?arguments[1]:void 0,i),o=n>2?arguments[2]:void 0,s=void 0===o?i:Ky(o,i);s>r;)e[r++]=t;return e};In({target:"Array",proto:!0},{fill:Qy});var tb=yp("Array").fill,eb=_e,ib=tb,nb=Array.prototype,rb=function(t){var e=t.fill;return t===nb||eb(nb,t)&&e===nb.fill?ib:e},ob=rb;!function(t){t.exports=ob}($y);var sb=n(qy),ab={};!function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var r=0;r<n.length;r++)if((i=n[r])===e||i.fn===e){n.splice(r,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(i){n=0;for(var r=(i=i.slice(0)).length;n<r;++n)i[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}({get exports(){return ab},set exports(t){ab=t}});var lb,hb=ab;
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
	 * http://naver.github.io/egjs
	 *
	 * Forked By Naver egjs
	 * Copyright (c) hammerjs
	 * Licensed under the MIT license */function ub(){return ub=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t},ub.apply(this,arguments)}function cb(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function db(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}lb="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var r in n)n.hasOwnProperty(r)&&(e[r]=n[r])}return e}:Object.assign;var pb,fb=lb,mb=["","webkit","Moz","MS","ms","o"],vb="undefined"==typeof document?{style:{}}:document.createElement("div"),gb="function",yb=Math.round,bb=Math.abs,_b=Date.now;function wb(t,e){for(var i,n,r=e[0].toUpperCase()+e.slice(1),o=0;o<mb.length;){if((n=(i=mb[o])?i+r:e)in t)return n;o++}}pb="undefined"==typeof window?{}:window;var kb=wb(vb.style,"touchAction"),xb=void 0!==kb;var Db="compute",Sb="auto",Cb="manipulation",Tb="none",Mb="pan-x",Ob="pan-y",Eb=function(){if(!xb)return!1;var t={},e=pb.CSS&&pb.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||pb.CSS.supports("touch-action",i)})),t}(),Pb="ontouchstart"in pb,Ib=void 0!==wb(pb,"PointerEvent"),Ab=Pb&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Lb="touch",Nb="mouse",Rb=25,Fb=1,jb=2,Yb=4,Hb=8,zb=1,Bb=2,Gb=4,Wb=8,Vb=16,Ub=Bb|Gb,Xb=Wb|Vb,qb=Ub|Xb,$b=["x","y"],Zb=["clientX","clientY"];function Kb(t,e,i){var n;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(i,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(i,t[n],n,t)}function Jb(t,e){return typeof t===gb?t.apply(e&&e[0]||void 0,e):t}function Qb(t,e){return t.indexOf(e)>-1}var t_=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===Db&&(t=this.compute()),xb&&this.manager.element.style&&Eb[t]&&(this.manager.element.style[kb]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Kb(this.manager.recognizers,(function(e){Jb(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Qb(t,Tb))return Tb;var e=Qb(t,Mb),i=Qb(t,Ob);return e&&i?Tb:e||i?e?Mb:Ob:Qb(t,Cb)?Cb:Sb}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,r=Qb(n,Tb)&&!Eb[Tb],o=Qb(n,Ob)&&!Eb[Ob],s=Qb(n,Mb)&&!Eb[Mb];if(r){var a=1===t.pointers.length,l=t.distance<2,h=t.deltaTime<250;if(a&&l&&h)return}if(!s||!o)return r||o&&i&Ub||s&&i&Xb?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function e_(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function i_(t){var e=t.length;if(1===e)return{x:yb(t[0].clientX),y:yb(t[0].clientY)};for(var i=0,n=0,r=0;r<e;)i+=t[r].clientX,n+=t[r].clientY,r++;return{x:yb(i/e),y:yb(n/e)}}function n_(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:yb(t.pointers[i].clientX),clientY:yb(t.pointers[i].clientY)},i++;return{timeStamp:_b(),pointers:e,center:i_(e),deltaX:t.deltaX,deltaY:t.deltaY}}function r_(t,e,i){i||(i=$b);var n=e[i[0]]-t[i[0]],r=e[i[1]]-t[i[1]];return Math.sqrt(n*n+r*r)}function o_(t,e,i){i||(i=$b);var n=e[i[0]]-t[i[0]],r=e[i[1]]-t[i[1]];return 180*Math.atan2(r,n)/Math.PI}function s_(t,e){return t===e?zb:bb(t)>=bb(e)?t<0?Bb:Gb:e<0?Wb:Vb}function a_(t,e,i){return{x:e/t||0,y:i/t||0}}function l_(t,e){var i=t.session,n=e.pointers,r=n.length;i.firstInput||(i.firstInput=n_(e)),r>1&&!i.firstMultiple?i.firstMultiple=n_(e):1===r&&(i.firstMultiple=!1);var o=i.firstInput,s=i.firstMultiple,a=s?s.center:o.center,l=e.center=i_(n);e.timeStamp=_b(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=o_(a,l),e.distance=r_(a,l),function(t,e){var i=e.center,n=t.offsetDelta||{},r=t.prevDelta||{},o=t.prevInput||{};e.eventType!==Fb&&o.eventType!==Yb||(r=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=r.x+(i.x-n.x),e.deltaY=r.y+(i.y-n.y)}(i,e),e.offsetDirection=s_(e.deltaX,e.deltaY);var h,u,c=a_(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=c.x,e.overallVelocityY=c.y,e.overallVelocity=bb(c.x)>bb(c.y)?c.x:c.y,e.scale=s?(h=s.pointers,r_((u=n)[0],u[1],Zb)/r_(h[0],h[1],Zb)):1,e.rotation=s?function(t,e){return o_(e[1],e[0],Zb)+o_(t[1],t[0],Zb)}(s.pointers,n):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,n,r,o,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(e.eventType!==Hb&&(a>Rb||void 0===s.velocity)){var l=e.deltaX-s.deltaX,h=e.deltaY-s.deltaY,u=a_(a,l,h);n=u.x,r=u.y,i=bb(u.x)>bb(u.y)?u.x:u.y,o=s_(l,h),t.lastInterval=e}else i=s.velocity,n=s.velocityX,r=s.velocityY,o=s.direction;e.velocity=i,e.velocityX=n,e.velocityY=r,e.direction=o}(i,e);var d,p=t.element,f=e.srcEvent;e_(d=f.composedPath?f.composedPath()[0]:f.path?f.path[0]:f.target,p)&&(p=d),e.target=p}function h_(t,e,i){var n=i.pointers.length,r=i.changedPointers.length,o=e&Fb&&n-r==0,s=e&(Yb|Hb)&&n-r==0;i.isFirst=!!o,i.isFinal=!!s,o&&(t.session={}),i.eventType=e,l_(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function u_(t){return t.trim().split(/\s+/g)}function c_(t,e,i){Kb(u_(e),(function(e){t.addEventListener(e,i,!1)}))}function d_(t,e,i){Kb(u_(e),(function(e){t.removeEventListener(e,i,!1)}))}function p_(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var f_=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Jb(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&c_(this.element,this.evEl,this.domHandler),this.evTarget&&c_(this.target,this.evTarget,this.domHandler),this.evWin&&c_(p_(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&d_(this.element,this.evEl,this.domHandler),this.evTarget&&d_(this.target,this.evTarget,this.domHandler),this.evWin&&d_(p_(this.element),this.evWin,this.domHandler)},t}();function m_(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var n=0;n<t.length;){if(i&&t[n][i]==e||!i&&t[n]===e)return n;n++}return-1}var v_={pointerdown:Fb,pointermove:jb,pointerup:Yb,pointercancel:Hb,pointerout:Hb},g_={2:Lb,3:"pen",4:Nb,5:"kinect"},y_="pointerdown",b_="pointermove pointerup pointercancel";pb.MSPointerEvent&&!pb.PointerEvent&&(y_="MSPointerDown",b_="MSPointerMove MSPointerUp MSPointerCancel");var __=function(t){function e(){var i,n=e.prototype;return n.evEl=y_,n.evWin=b_,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return cb(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,n=t.type.toLowerCase().replace("ms",""),r=v_[n],o=g_[t.pointerType]||t.pointerType,s=o===Lb,a=m_(e,t.pointerId,"pointerId");r&Fb&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):r&(Yb|Hb)&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,r,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),i&&e.splice(a,1))},e}(f_);function w_(t){return Array.prototype.slice.call(t,0)}function k_(t,e,i){for(var n=[],r=[],o=0;o<t.length;){var s=e?t[o][e]:t[o];m_(r,s)<0&&n.push(t[o]),r[o]=s,o++}return i&&(n=e?n.sort((function(t,i){return t[e]>i[e]})):n.sort()),n}var x_={touchstart:Fb,touchmove:jb,touchend:Yb,touchcancel:Hb},D_="touchstart touchmove touchend touchcancel",S_=function(t){function e(){var i;return e.prototype.evTarget=D_,(i=t.apply(this,arguments)||this).targetIds={},i}return cb(e,t),e.prototype.handler=function(t){var e=x_[t.type],i=C_.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Lb,srcEvent:t})},e}(f_);function C_(t,e){var i,n,r=w_(t.touches),o=this.targetIds;if(e&(Fb|jb)&&1===r.length)return o[r[0].identifier]=!0,[r,r];var s=w_(t.changedTouches),a=[],l=this.target;if(n=r.filter((function(t){return e_(t.target,l)})),e===Fb)for(i=0;i<n.length;)o[n[i].identifier]=!0,i++;for(i=0;i<s.length;)o[s[i].identifier]&&a.push(s[i]),e&(Yb|Hb)&&delete o[s[i].identifier],i++;return a.length?[k_(n.concat(a),"identifier",!0),a]:void 0}var T_={mousedown:Fb,mousemove:jb,mouseup:Yb},M_="mousedown",O_="mousemove mouseup",E_=function(t){function e(){var i,n=e.prototype;return n.evEl=M_,n.evWin=O_,(i=t.apply(this,arguments)||this).pressed=!1,i}return cb(e,t),e.prototype.handler=function(t){var e=T_[t.type];e&Fb&&0===t.button&&(this.pressed=!0),e&jb&&1!==t.which&&(e=Yb),this.pressed&&(e&Yb&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:Nb,srcEvent:t}))},e}(f_),P_=2500,I_=25;function A_(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=n.indexOf(i);t>-1&&n.splice(t,1)}),P_)}}function L_(t,e){t&Fb?(this.primaryTouch=e.changedPointers[0].identifier,A_.call(this,e)):t&(Yb|Hb)&&A_.call(this,e)}function N_(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var r=this.lastTouches[n],o=Math.abs(e-r.x),s=Math.abs(i-r.y);if(o<=I_&&s<=I_)return!0}return!1}var R_=function(){return function(t){function e(e,i){var n;return(n=t.call(this,e,i)||this).handler=function(t,e,i){var r=i.pointerType===Lb,o=i.pointerType===Nb;if(!(o&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(r)L_.call(db(db(n)),e,i);else if(o&&N_.call(db(db(n)),i))return;n.callback(t,e,i)}},n.touch=new S_(n.manager,n.handler),n.mouse=new E_(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return cb(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(f_)}();function F_(t,e,i){return!!Array.isArray(t)&&(Kb(t,i[e],i),!0)}var j_=1,Y_=2,H_=4,z_=8,B_=z_,G_=16,W_=32,V_=1;function U_(t,e){var i=e.manager;return i?i.get(t):t}function X_(t){return t&G_?"cancel":t&z_?"end":t&H_?"move":t&Y_?"start":""}var q_=function(){function t(t){void 0===t&&(t={}),this.options=ub({enable:!0},t),this.id=V_++,this.manager=null,this.state=j_,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return fb(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(F_(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=U_(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return F_(t,"dropRecognizeWith",this)||(t=U_(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(F_(t,"requireFailure",this))return this;var e=this.requireFail;return-1===m_(e,t=U_(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(F_(t,"dropRequireFailure",this))return this;t=U_(t,this);var e=m_(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function n(i){e.manager.emit(i,t)}i<z_&&n(e.options.event+X_(i)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),i>=z_&&n(e.options.event+X_(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=W_},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(W_|j_)))return!1;t++}return!0},e.recognize=function(t){var e=fb({},t);if(!Jb(this.options.enable,[this,e]))return this.reset(),void(this.state=W_);this.state&(B_|G_|W_)&&(this.state=j_),this.state=this.process(e),this.state&(Y_|H_|z_|G_)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),$_=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ub({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}cb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Cb]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,r=t.distance<i.threshold,o=t.deltaTime<i.time;if(this.reset(),t.eventType&Fb&&0===this.count)return this.failTimeout();if(r&&o&&n){if(t.eventType!==Yb)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||r_(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=B_,e.tryEmit()}),i.interval),Y_):B_}return W_},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=W_}),this.options.interval),W_},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===B_&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(q_),Z_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ub({pointers:1},e))||this}cb(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,n=e&(Y_|H_),r=this.attrTest(t);return n&&(i&Hb||!r)?e|G_:n||r?i&Yb?e|z_:e&Y_?e|H_:Y_:W_},e}(q_);function K_(t){return t===Vb?"down":t===Wb?"up":t===Bb?"left":t===Gb?"right":""}var J_=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ub({event:"pan",threshold:10,pointers:1,direction:qb},e))||this).pX=null,i.pY=null,i}cb(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return t&Ub&&e.push(Ob),t&Xb&&e.push(Mb),e},i.directionTest=function(t){var e=this.options,i=!0,n=t.distance,r=t.direction,o=t.deltaX,s=t.deltaY;return r&e.direction||(e.direction&Ub?(r=0===o?zb:o<0?Bb:Gb,i=o!==this.pX,n=Math.abs(t.deltaX)):(r=0===s?zb:s<0?Wb:Vb,i=s!==this.pY,n=Math.abs(t.deltaY))),t.direction=r,i&&n>e.threshold&&r&e.direction},i.attrTest=function(t){return Z_.prototype.attrTest.call(this,t)&&(this.state&Y_||!(this.state&Y_)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=K_(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(Z_),Q_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ub({event:"swipe",threshold:10,velocity:.3,direction:Ub|Xb,pointers:1},e))||this}cb(e,t);var i=e.prototype;return i.getTouchAction=function(){return J_.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,n=this.options.direction;return n&(Ub|Xb)?i=e.overallVelocity:n&Ub?i=e.overallVelocityX:n&Xb&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&bb(i)>this.options.velocity&&e.eventType&Yb},i.emit=function(t){var e=K_(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Z_),tw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ub({event:"pinch",threshold:0,pointers:2},e))||this}cb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Tb]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&Y_)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(Z_),ew=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ub({event:"rotate",threshold:0,pointers:2},e))||this}cb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Tb]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&Y_)},e}(Z_),iw=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ub({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}cb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Sb]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,r=t.distance<i.threshold,o=t.deltaTime>i.time;if(this._input=t,!r||!n||t.eventType&(Yb|Hb)&&!o)this.reset();else if(t.eventType&Fb)this.reset(),this._timer=setTimeout((function(){e.state=B_,e.tryEmit()}),i.time);else if(t.eventType&Yb)return B_;return W_},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){this.state===B_&&(t&&t.eventType&Yb?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=_b(),this.manager.emit(this.options.event,this._input)))},e}(q_),nw={domEvents:!1,touchAction:Db,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},rw=[[ew,{enable:!1}],[tw,{enable:!1},["rotate"]],[Q_,{direction:Ub}],[J_,{direction:Ub},["swipe"]],[$_],[$_,{event:"doubletap",taps:2},["tap"]],[iw]];function ow(t,e){var i,n=t.element;n.style&&(Kb(t.options.cssProps,(function(r,o){i=wb(n.style,o),e?(t.oldCssProps[i]=n.style[i],n.style[i]=r):n.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var sw=function(){function t(t,e){var i,n=this;this.options=fb({},nw,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(Ib?__:Ab?S_:Pb?R_:E_))(i,h_),this.touchAction=new t_(this,this.options.touchAction),ow(this,!0),Kb(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return fb(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var n=this.recognizers,r=e.curRecognizer;(!r||r&&r.state&B_)&&(e.curRecognizer=null,r=null);for(var o=0;o<n.length;)i=n[o],2===e.stopped||r&&i!==r&&!i.canRecognizeWith(r)?i.reset():i.recognize(t),!r&&i.state&(Y_|H_|z_)&&(e.curRecognizer=i,r=i),o++}},e.get=function(t){if(t instanceof q_)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(F_(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(F_(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,n=m_(i,e);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return Kb(u_(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return Kb(u_(t),(function(t){e?i[t]&&i[t].splice(m_(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](e),n++}},e.destroy=function(){this.element&&ow(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),aw={touchstart:Fb,touchmove:jb,touchend:Yb,touchcancel:Hb},lw="touchstart",hw="touchstart touchmove touchend touchcancel",uw=function(t){function e(){var i,n=e.prototype;return n.evTarget=lw,n.evWin=hw,(i=t.apply(this,arguments)||this).started=!1,i}return cb(e,t),e.prototype.handler=function(t){var e=aw[t.type];if(e===Fb&&(this.started=!0),this.started){var i=cw.call(this,t,e);e&(Yb|Hb)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Lb,srcEvent:t})}},e}(f_);function cw(t,e){var i=w_(t.touches),n=w_(t.changedTouches);return e&(Yb|Hb)&&(i=k_(i.concat(n),"identifier",!0)),[i,n]}function dw(t,e,i){var n="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",r=window.console&&(window.console.warn||window.console.log);return r&&r.call(window.console,n,i),t.apply(this,arguments)}}var pw=dw((function(t,e,i){for(var n=Object.keys(e),r=0;r<n.length;)(!i||i&&void 0===t[n[r]])&&(t[n[r]]=e[n[r]]),r++;return t}),"extend","Use `assign`."),fw=dw((function(t,e){return pw(t,e,!0)}),"merge","Use `assign`.");function mw(t,e,i){var n,r=e.prototype;(n=t.prototype=Object.create(r)).constructor=t,n._super=r,i&&fb(n,i)}function vw(t,e){return function(){return t.apply(e,arguments)}}var gw=function(){var t=function(t,e){return void 0===e&&(e={}),new sw(t,ub({recognizers:rw.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=qb,t.DIRECTION_DOWN=Vb,t.DIRECTION_LEFT=Bb,t.DIRECTION_RIGHT=Gb,t.DIRECTION_UP=Wb,t.DIRECTION_HORIZONTAL=Ub,t.DIRECTION_VERTICAL=Xb,t.DIRECTION_NONE=zb,t.DIRECTION_DOWN=Vb,t.INPUT_START=Fb,t.INPUT_MOVE=jb,t.INPUT_END=Yb,t.INPUT_CANCEL=Hb,t.STATE_POSSIBLE=j_,t.STATE_BEGAN=Y_,t.STATE_CHANGED=H_,t.STATE_ENDED=z_,t.STATE_RECOGNIZED=B_,t.STATE_CANCELLED=G_,t.STATE_FAILED=W_,t.Manager=sw,t.Input=f_,t.TouchAction=t_,t.TouchInput=S_,t.MouseInput=E_,t.PointerEventInput=__,t.TouchMouseInput=R_,t.SingleTouchInput=uw,t.Recognizer=q_,t.AttrRecognizer=Z_,t.Tap=$_,t.Pan=J_,t.Swipe=Q_,t.Pinch=tw,t.Rotate=ew,t.Press=iw,t.on=c_,t.off=d_,t.each=Kb,t.merge=fw,t.extend=pw,t.bindFn=vw,t.assign=fb,t.inherit=mw,t.bindFn=vw,t.prefixed=wb,t.toArray=w_,t.inArray=m_,t.uniqueArray=k_,t.splitStr=u_,t.boolOrFn=Jb,t.hasParent=e_,t.addEventListeners=c_,t.removeEventListeners=d_,t.defaults=fb({},nw,{preset:rw}),t}();gw.defaults;var yw=gw;function bw(t,e){var i=gf(t);if(Ou){var n=Ou(t);e&&(n=ig(n).call(n,(function(e){return Bu(t,e).enumerable}))),i.push.apply(i,n)}return i}function _w(t){for(var e=1;e<arguments.length;e++){var i,n,r=null!=arguments[e]?arguments[e]:{};e%2?am(i=bw(Object(r),!0)).call(i,(function(e){Vd(t,e,r[e])})):ic?pc(t,ic(r)):am(n=bw(Object(r))).call(n,(function(e){Dc(t,e,Bu(r,e))}))}return t}function ww(t,e){var i=void 0!==Fp&&Ea(t)||t["@@iterator"];if(!i){if(tf(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return kw(t,e);var n=qp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return kw(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function kw(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var xw=Fp("DELETE");function Dw(t){for(var e,i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return Sw.apply(void 0,Up(e=[{},t]).call(e,n))}function Sw(){var t=Cw.apply(void 0,arguments);return Mw(t),t}function Cw(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<2)return e[0];var n;if(e.length>2)return Cw.apply(void 0,Up(n=[Sw(e[0],e[1])]).call(n,Np(qp(e).call(e,2))));var r,o=e[0],s=e[1],a=ww(Jp(s));try{for(a.s();!(r=a.n()).done;){var l=r.value;Object.prototype.propertyIsEnumerable.call(s,l)&&(s[l]===xw?delete o[l]:null===o[l]||null===s[l]||"object"!==Nd(o[l])||"object"!==Nd(s[l])||tf(o[l])||tf(s[l])?o[l]=Tw(s[l]):o[l]=Cw(o[l],s[l]))}}catch(t){a.e(t)}finally{a.f()}return o}function Tw(t){return tf(t)?cf(t).call(t,(function(t){return Tw(t)})):"object"===Nd(t)&&null!==t?Cw({},t):t}function Mw(t){for(var e=0,i=gf(t);e<i.length;e++){var n=i[e];t[n]===xw?delete t[n]:"object"===Nd(t[n])&&null!==t[n]&&Mw(t[n])}}var Ow="undefined"!=typeof window?window.Hammer||yw:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function Ew(t){var e,i=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){i._dom.overlay.parentNode.removeChild(i._dom.overlay)}));var n=Ow(this._dom.overlay);n.on("tap",Uf(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var r=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];am(r).call(r,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||i.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",i._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&i.deactivate()}}hb(Ew.prototype),Ew.current=null,Ew.prototype.destroy=function(){var t,e;this.deactivate();var i,n=ww(_m(t=Zm(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(i=n.n()).done;){(0,i.value)()}}catch(t){n.e(t)}finally{n.f()}},Ew.prototype.activate=function(){Ew.current&&Ew.current.deactivate(),Ew.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},Ew.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},Ew.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Pw=/^\/?Date\((-?\d+)/i,Iw=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Aw=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Lw=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,Nw=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function Rw(t){return t instanceof Number||"number"==typeof t}function Fw(t){return t instanceof String||"string"==typeof t}function jw(t){return"object"===Nd(t)&&null!==t}function Yw(t,e,i,n){var r=!1;!0===n&&(r=null===e[i]&&void 0!==t[i]),r?delete t[i]:t[i]=e[i]}var Hw=fv;function zw(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)||!0===i)if("object"===Nd(e[r])&&null!==e[r]&&Uv(e[r])===Object.prototype)void 0===t[r]?t[r]=zw({},e[r],i):"object"===Nd(t[r])&&null!==t[r]&&Uv(t[r])===Object.prototype?zw(t[r],e[r],i):Yw(t,e,r,n);else if(tf(e[r])){var o;t[r]=qp(o=e[r]).call(o)}else Yw(t,e,r,n);return t}function Bw(t){var e=Nd(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":tf(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function Gw(t,e){var i;return Up(i=[]).call(i,Np(t),[e])}function Ww(t){return qp(t).call(t)}var Vw=fg;var Uw={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),Fw(t)?t:Rw(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function Xw(t){var e;switch(t.length){case 3:case 4:return(e=Aw.exec(t))?{r:Yg(e[1]+e[1],16),g:Yg(e[2]+e[2],16),b:Yg(e[3]+e[3],16)}:null;case 6:case 7:return(e=Iw.exec(t))?{r:Yg(e[1],16),g:Yg(e[2],16),b:Yg(e[3],16)}:null;default:return null}}function qw(t,e,i){var n;return"#"+qp(n=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(n,1)}function $w(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),r=Math.max(t,Math.max(e,i));return n===r?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(r-n))/360,s:(r-n)/r,v:r}}var Zw={split:function(t){var e,i={};return am(e=t.split(";")).call(e,(function(t){if(""!=dy(t).call(t)){var e,n,r=t.split(":"),o=dy(e=r[0]).call(e),s=dy(n=r[1]).call(n);i[o]=s}})),i},join:function(t){var e;return cf(e=gf(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")}};function Kw(t,e,i){var n,r,o,s=Math.floor(6*t),a=6*t-s,l=i*(1-e),h=i*(1-a*e),u=i*(1-(1-a)*e);switch(s%6){case 0:n=i,r=u,o=l;break;case 1:n=h,r=i,o=l;break;case 2:n=l,r=i,o=u;break;case 3:n=l,r=h,o=i;break;case 4:n=u,r=l,o=i;break;case 5:n=i,r=l,o=h}return{r:Math.floor(255*n),g:Math.floor(255*r),b:Math.floor(255*o)}}function Jw(t,e,i){var n=Kw(t,e,i);return qw(n.r,n.g,n.b)}function Qw(t){var e=Xw(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return $w(e.r,e.g,e.b)}function tk(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function ek(t){return Lw.test(t)}function ik(t){return Nw.test(t)}function nk(t){if(null===t||"object"!==Nd(t))return null;if(t instanceof Element)return t;var e=gy(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==Nd(t[i])&&(e[i]=nk(t[i]));return e}var rk={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},ok=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Sc(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Wd(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return rk[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===Fw(t)){if(!0===ek(t)){var r=t.substr(4).substr(0,t.length-5).split(",");i={r:r[0],g:r[1],b:r[2],a:1}}else if(!0===ik(t)){var o=t.substr(5).substr(0,t.length-6).split(",");i={r:o[0],g:o[1],b:o[2],a:o[3]}}else if(!0===tk(t)){var s=Xw(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Dy(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=fv({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Xy((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=fv({},t)),this.color=t;var e=$w(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,r=this.centerCoordinates.x+n*Math.sin(i*e.h),o=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=o-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=$w(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=Kw(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=$w(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,r=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,r),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),sb(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var r=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var o=document.createElement("DIV");o.style.color="red",o.style.fontWeight="bold",o.style.padding="10px",o.innerText="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(o)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerText="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerText="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerText="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerText="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerText="cancel",this.cancelButton.onclick=Uf(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerText="apply",this.applyButton.onclick=Uf(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerText="save",this.saveButton.onclick=Uf(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerText="load last",this.loadButton.onclick=Uf(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new Ow(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.on("hammer.input",(function(e){e.isFirst&&t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,r,o=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,o,s),this.centerCoordinates={x:.5*o,y:.5*s},this.r=.49*o;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(r=0;r<this.r;r++)e=this.centerCoordinates.x+r*Math.sin(l*n),i=this.centerCoordinates.y+r*Math.cos(l*n),a=Kw(.002777777777777778*n,r*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,o,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,r=.5*this.colorPickerDiv.clientHeight,o=.5*this.colorPickerDiv.clientWidth,s=i-o,a=n-r,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),o),u=Math.cos(l)*h+r,c=Math.sin(l)*h+o;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=c-.5*this.colorPickerSelector.clientWidth+"px";var d=l/(2*Math.PI);d=d<0?d+1:d;var p=h/this.r,f=$w(this.color.r,this.color.g,this.color.b);f.h=d,f.s=p;var m=Kw(f.h,f.s,f.v);m.a=this.color.a,this.color=m,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();function sk(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<1)throw new TypeError("Invalid arguments.");if(1===e.length)return document.createTextNode(e[0]);var n=document.createElement(e[0]);return n.appendChild(sk.apply(void 0,Np(qp(e).call(e,1)))),n}var ak,lk=function(){function t(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:function(){return!1};Sc(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.hideOption=o,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},fv(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new ok(r),this.wrapper=void 0}return Wd(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(tf(t))this.options.filter=t.join();else if("object"===Nd(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==ig(t)&&(this.options.filter=ig(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===ig(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=ig(this.options),e=0,i=!1;for(var n in this.configureOptions)Object.prototype.hasOwnProperty.call(this.configureOptions,n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===Qg(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return am(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerText=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");if(n.className="vis-configuration vis-config-label vis-config-s"+e.length,!0===i){for(;n.firstChild;)n.removeChild(n.firstChild);n.appendChild(sk("i","b",t))}else n.innerText=t+":";return n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var r=0;void 0!==e&&-1!==Qg(t).call(t,e)&&(r=Qg(t).call(t,e));for(var o=0;o<t.length;o++){var s=document.createElement("option");s.value=t[o],o===r&&(s.selected="selected"),s.innerText=t[o],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],r=t[1],o=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=r,a.max=o}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){var u=1.2;e<0&&e*u<r?(a.min=Math.ceil(e*u),h=a.min,l="range increased"):e/u<r&&(a.min=Math.ceil(e/u),h=a.min,l="range increased"),e*u>o&&1!==o&&(a.max=Math.ceil(e*u),h=a.max,l="range increased"),a.value=e}else a.value=n;var c=document.createElement("input");c.className="vis-configuration vis-config-rangeinput",c.value=a.value;var d=this;a.onchange=function(){c.value=this.value,d._update(Number(this.value),i)},a.oninput=function(){c.value=this.value};var p=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,p,a,c);""!==l&&this.popupHistory[f]!==h&&(this.popupHistory[f]=h,this._setupPopup(l,f))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerText="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerText=t,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Xy((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Xy((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Nd(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var r=this;n.onchange=function(){r._update(this.checked,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var r=this;n.onchange=function(){r._update(this.value,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,r=t[1],o=document.createElement("div");"none"!==(e=void 0===e?r:e)?(o.className="vis-configuration vis-config-colorBlock",o.style.backgroundColor=e):o.className="vis-configuration vis-config-colorBlock none",e=void 0===e?r:e,o.onclick=function(){n._showColorPicker(e,o,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var r="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=r,n._update(r,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,r=ig(this.options),o=!1;for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){n=!0;var a=t[s],l=Gw(e,s);if("function"==typeof r&&!1===(n=r(s,e))&&!tf(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){o=!0;var h=this._getValue(l);if(tf(a))this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){if(!this.hideOption(e,s,this.moduleOptions))if(void 0!==a.enabled){var u=Gw(l,"enabled"),c=this._getValue(u);if(!0===c){var d=this._makeLabel(s,l,!0);this._makeItem(l,d),o=this._handleObject(a,l)||o}else this._makeCheckbox(a,c,l)}else{var p=this._makeLabel(s,l,!0);this._makeItem(l,p),o=this._handleObject(a,l)||o}}else console.error("dont know how to handle",a,s,l)}}return o}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var r=0;r<e.length;r++)"global"!==e[r]&&(void 0===n[e[r]]&&(n[e[r]]={}),r!==e.length-1?n=n[e[r]]:n[e[r]]=t);return i}},{key:"_printOptions",value:function(){for(var t=this.getOptions();this.optionsContainer.firstChild;)this.optionsContainer.removeChild(this.optionsContainer.firstChild);this.optionsContainer.appendChild(sk("pre","const options = "+Dy(t,null,2)))}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),hk=function(){function t(e,i){Sc(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Wd(t,[{key:"setPosition",value:function(t,e){this.x=Yg(t),this.y=Yg(e)}},{key:"setText",value:function(t){if(t instanceof Element){for(;this.frame.firstChild;)this.frame.removeChild(this.frame.firstChild);this.frame.appendChild(t)}else this.frame.innerText=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,r=this.frame.parentNode.clientWidth,o=0,s=0;if("flip"==this.overflowMethod){var a=!1,l=!0;this.y-e<this.padding&&(l=!1),this.x+i>r-this.padding&&(a=!0),o=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(o=this.x)+i+this.padding>r&&(o=r-i-this.padding),o<this.padding&&(o=this.padding);this.frame.style.left=o+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),uk=!1,ck="background: #FFeeee; color: #dd0000",dk=function(){function t(){Sc(this,t)}return Wd(t,null,[{key:"validate",value:function(e,i,n){uk=!1,ak=i;var r=i;return void 0!==n&&(r=i[n]),t.parse(e,r,[]),uk}},{key:"parse",value:function(e,i,n){for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&t.check(r,e,i,n)}},{key:"check",value:function(e,i,n,r){if(void 0!==n[e]||void 0!==n.__any__){var o=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",s="object"===t.getType(i[e]));var a=n[o];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,o,a,r)}else t.getSuggestion(e,n,r)}},{key:"checkFields",value:function(e,i,n,r,o,s){var a=function(i){console.error("%c"+i+t.printLocation(s,e),ck)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===Qg(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),uk=!0):"object"===l&&"__any__"!==r&&(s=Gw(s,e),t.parse(i[e],n[r],s)):void 0===o.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(gf(o))+". Received ["+l+'] "'+i[e]+'"'),uk=!0)}},{key:"getType",value:function(t){var e=Nd(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":tf(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var r,o=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,ak,[],!0);r=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':s.distance<=4&&o.distance>s.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(gf(i))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+r,ck),uk=!0}},{key:"findInOptions",value:function(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var c=void 0;if(void 0!==i[u].__type__&&!0===r){var d=t.findInOptions(e,i[u],Gw(n,u));o>d.distance&&(s=d.closestMatch,a=d.path,o=d.distance,h=d.indexMatch)}else{var p;-1!==Qg(p=u.toLowerCase()).call(p,l)&&(h=u),o>(c=t.levenshteinDistance(e,u))&&(s=u,a=Ww(n),o=c)}}return{closestMatch:s,path:a,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var r=0;r<n+1;r++)i+="  ";i+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return Dy(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,r=[];for(i=0;i<=e.length;i++)r[i]=[i];for(n=0;n<=t.length;n++)r[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?r[i][n]=r[i-1][n-1]:r[i][n]=Math.min(r[i-1][n-1]+1,Math.min(r[i][n-1]+1,r[i-1][n]+1));return r[e.length][t.length]}}]),t}(),pk=Ew,fk=ok,mk=lk,vk=Ow,gk=hk,yk=ck,bk=dk,_k=Object.freeze({__proto__:null,Activator:pk,Alea:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return function(t){var e=function(){for(var t=function(){var t=4022871197;return function(e){for(var i=e.toString(),n=0;n<i.length;n++){var r=.02519603282416938*(t+=i.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)}}(),e=t(" "),i=t(" "),n=t(" "),r=0;r<arguments.length;r++)(e-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(e+=1),(i-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(i+=1),(n-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(n+=1);return[e,i,n]}(t),i=Lp(e,3),n=i[0],r=i[1],o=i[2],s=1,a=function(){var t=2091639*n+2.3283064365386963e-10*s;return n=r,r=o,o=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}(e.length?e:[Df()])},ColorPicker:fk,Configurator:mk,DELETE:xw,HSVToHex:Jw,HSVToRGB:Kw,Hammer:vk,Popup:gk,RGBToHSV:$w,RGBToHex:qw,VALIDATOR_PRINT_STYLE:yk,Validator:bk,addClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=Up(i).call(i,ig(n).call(n,(function(t){return!Yv(i).call(i,t)}))),t.className=i.join(" ")},addCssText:function(t,e){var i=Zw.split(t.style.cssText),n=Zw.split(e),r=_w(_w({},i),n);t.style.cssText=Zw.join(r)},addEventListener:function(t,e,i,n){var r;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Yv(r=navigator.userAgent).call(r,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,i,n)):t.attachEvent("on"+e,i)},binarySearchCustom:function(t,e,i,n){for(var r=0,o=0,s=t.length-1;o<=s&&r<1e4;){var a=Math.floor((o+s)/2),l=t[a],h=e(void 0===n?l[i]:l[i][n]);if(0==h)return a;-1==h?o=a+1:s=a-1,r++}return-1},binarySearchValue:function(t,e,i,n,r){var o,s,a,l,h=0,u=0,c=t.length-1;for(r=null!=r?r:function(t,e){return t==e?0:t<e?-1:1};u<=c&&h<1e4;){if(l=Math.floor(.5*(c+u)),o=t[Math.max(0,l-1)][i],s=t[l][i],a=t[Math.min(t.length-1,l+1)][i],0==r(s,e))return l;if(r(o,e)<0&&r(s,e)>0)return"before"==n?Math.max(0,l-1):l;if(r(s,e)<0&&r(a,e)>0)return"before"==n?l:Math.min(t.length-1,l+1);r(s,e)<0?u=l+1:c=l-1,h++}return-1},bridgeObject:nk,copyAndExtendArray:Gw,copyArray:Ww,deepExtend:zw,deepObjectAssign:Sw,easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},extend:Hw,fillIfDefined:function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var r in e)if(void 0!==i[r])if(null===i[r]||"object"!==Nd(i[r]))Yw(e,i,r,n);else{var o=e[r],s=i[r];jw(o)&&jw(s)&&t(o,s,n)}},forEach:function(t,e){if(tf(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e(t[r],r,t)},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:Bw,hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},hexToHSV:Qw,hexToRGB:Xw,insertSort:function(t,e){for(var i=0;i<t.length;i++){var n=t[i],r=void 0;for(r=i;r>0&&e(n,t[r-1])<0;r--)t[r]=t[r-1];t[r]=n}return t},isDate:function(t){if(t instanceof Date)return!0;if(Fw(t)){if(Pw.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:Rw,isObject:jw,isString:Fw,isValidHex:tk,isValidRGB:ek,isValidRGBA:ik,mergeOptions:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=function(t){return null!=t},o=function(t){return null!==t&&"object"===Nd(t)};if(!o(t))throw new Error("Parameter mergeTarget must be an object");if(!o(e))throw new Error("Parameter options must be an object");if(!r(i))throw new Error("Parameter option must have a value");if(!o(n))throw new Error("Parameter globalOptions must be an object");var s=e[i],a=o(n)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(n)?n[i]:void 0,l=a?a.enabled:void 0;if(void 0!==s){if("boolean"==typeof s)return o(t[i])||(t[i]={}),void(t[i].enabled=s);if(null===s&&!o(t[i])){if(!r(a))return;t[i]=gy(a)}if(o(s)){var h=!0;void 0!==s.enabled?h=s.enabled:void 0!==l&&(h=a.enabled),function(t,e,i){o(t[i])||(t[i]={});var n=e[i],r=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(r[s]=n[s])}(t,e,i),t[i].enabled=h}}},option:Uw,overrideOpacity:function(t,e){if(Yv(t).call(t,"rgba"))return t;if(Yv(t).call(t,"rgb")){var i=t.substr(Qg(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=Xw(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},parseColor:function(t,e){if(Fw(t)){var i=t;if(ek(i)){var n,r=cf(n=i.substr(4).substr(0,i.length-5).split(",")).call(n,(function(t){return Yg(t)}));i=qw(r[0],r[1],r[2])}if(!0===tk(i)){var o=Qw(i),s={h:o.h,s:.8*o.s,v:Math.min(1,1.02*o.v)},a={h:o.h,s:Math.min(1,1.25*o.s),v:.8*o.v},l=Jw(a.h,a.s,a.v),h=Jw(s.h,s.s,s.v);return{background:i,border:l,highlight:{background:h,border:l},hover:{background:h,border:l}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:Fw(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:Fw(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:Fw(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:Fw(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},pureDeepObjectAssign:Dw,recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var i=e.firstChild;i&&(t(i),e.removeChild(i))}},removeClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=ig(i).call(i,(function(t){return!Yv(n).call(n,t)})),t.className=i.join(" ")},removeCssText:function(t,e){var i=Zw.split(t.style.cssText),n=Zw.split(e);for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&delete i[r];t.style.cssText=Zw.join(i)},removeEventListener:function(t,e,i,n){var r;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Yv(r=navigator.userAgent).call(r,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,i,n)):t.detachEvent("on"+e,i)},selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Nd(e)){for(var i=gy(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==Nd(e[t[n]])&&(i[t[n]]=nk(e[t[n]]));return i}return null},selectiveDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(tf(i))throw new TypeError("Arrays are not supported by deepExtend");for(var r=0;r<t.length;r++){var o=t[r];if(Object.prototype.hasOwnProperty.call(i,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?zw(e[o],i[o],!1,n):Yw(e,i,o,n);else{if(tf(i[o]))throw new TypeError("Arrays are not supported by deepExtend");Yw(e,i,o,n)}}return e},selectiveExtend:function(t,e){if(!tf(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),r=2;r<i;r++)n[r-2]=arguments[r];for(var o=0,s=n;o<s.length;o++)for(var a=s[o],l=0;l<t.length;l++){var h=t[l];a&&Object.prototype.hasOwnProperty.call(a,h)&&(e[h]=a[h])}return e},selectiveNotDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(tf(i))throw new TypeError("Arrays are not supported by deepExtend");for(var r in i)if(Object.prototype.hasOwnProperty.call(i,r)&&!Yv(t).call(t,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?zw(e[r],i[r]):Yw(e,i,r,n);else if(tf(i[r])){e[r]=[];for(var o=0;o<i[r].length;o++)e[r].push(i[r][o])}else Yw(e,i,r,n);return e},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:Vw,topMost:function(t,e){var i;tf(e)||(e=[e]);var n,r=ww(t);try{for(r.s();!(n=r.n()).done;){var o=n.value;if(o){i=o[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){r.e(t)}finally{r.f()}return i},updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)}});function wk(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])}function kk(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}}function xk(t){wk(t),kk(t),wk(t)}function Dk(t,e,i){var n;return e.hasOwnProperty(t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(n)),e[t].used.push(n),n}function Sk(t,e,i,n){var r;return e.hasOwnProperty(t)?e[t].redundant.length>0?(r=e[t].redundant[0],e[t].redundant.shift()):(r=document.createElement(t),void 0!==n?i.insertBefore(r,n):i.appendChild(r)):(r=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?i.insertBefore(r,n):i.appendChild(r)),e[t].used.push(r),r}function Ck(t,e,i,n,r,o){var s;if("circle"==i.style?((s=Dk("circle",n,r)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",e),s.setAttributeNS(null,"r",.5*i.size)):((s=Dk("rect",n,r)).setAttributeNS(null,"x",t-.5*i.size),s.setAttributeNS(null,"y",e-.5*i.size),s.setAttributeNS(null,"width",i.size),s.setAttributeNS(null,"height",i.size)),void 0!==i.styles&&s.setAttributeNS(null,"style",i.styles),s.setAttributeNS(null,"class",i.className+" vis-point"),o){var a=Dk("text",n,r);o.xOffset&&(t+=o.xOffset),o.yOffset&&(e+=o.yOffset),o.content&&(a.textContent=o.content),o.className&&a.setAttributeNS(null,"class",o.className+" vis-label"),a.setAttributeNS(null,"x",t),a.setAttributeNS(null,"y",e)}return s}function Tk(t,e,i,n,r,o,s,a){if(0!=n){n<0&&(e-=n*=-1);var l=Dk("rect",o,s);l.setAttributeNS(null,"x",t-.5*i),l.setAttributeNS(null,"y",e),l.setAttributeNS(null,"width",i),l.setAttributeNS(null,"height",n),l.setAttributeNS(null,"class",r),a&&l.setAttributeNS(null,"style",a)}}function Mk(){try{return navigator?navigator.languages&&navigator.languages.length?navigator.languages:navigator.userLanguage||navigator.language||navigator.browserLanguage||"en":"en"}catch(t){return"en"}}var Ok=Object.freeze({__proto__:null,cleanupElements:kk,drawBar:Tk,drawPoint:Ck,getDOMElement:Sk,getNavigatorLanguage:Mk,getSVGElement:Dk,prepareElements:wk,resetElements:xk});function Ek(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Pk={},Ik={get exports(){return Pk},set exports(t){Pk=t}},Ak={},Lk=vy;!function(t){t.exports=Lk}({get exports(){return Ak},set exports(t){Ak=t}}),function(t){t.exports=Ak}(Ik);var Nk=n(Pk),Rk={},Fk={get exports(){return Rk},set exports(t){Rk=t}},jk={},Yk={get exports(){return jk},set exports(t){jk=t}};In({target:"Object",stat:!0},{setPrototypeOf:Co});var Hk=fe.Object.setPrototypeOf;!function(t){t.exports=Hk}(Yk),function(t){t.exports=jk}(Fk);var zk=n(Rk),Bk={},Gk={get exports(){return Bk},set exports(t){Bk=t}},Wk={},Vk=Vf;!function(t){t.exports=Vk}({get exports(){return Wk},set exports(t){Wk=t}}),function(t){t.exports=Wk}(Gk);var Uk=n(Bk);function Xk(t,e){var i;return Xk=zk?Uk(i=zk).call(i):function(t,e){return t.__proto__=e,t},Xk(t,e)}function qk(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Nk(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),Ec(t,"prototype",{writable:!1}),e&&Xk(t,e)}function $k(t,e){if(e&&("object"===Nd(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return Ek(t)}var Zk={},Kk={get exports(){return Zk},set exports(t){Zk=t}},Jk={},Qk=Vv;!function(t){t.exports=Qk}({get exports(){return Jk},set exports(t){Jk=t}}),function(t){t.exports=Jk}(Kk);var tx=n(Zk);function ex(t){var e;return ex=zk?Uk(e=tx).call(e):function(t){return t.__proto__||tx(t)},ex(t)}var ix={},nx={get exports(){return ix},set exports(t){ix=t}},rx={};!function(t){var e=Pc,i=Md;function n(r){return t.exports=n="function"==typeof e&&"symbol"==typeof i?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(r)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return rx},set exports(t){rx=t}});var ox={},sx={get exports(){return ox},set exports(t){ox=t}},ax={},lx=sm;!function(t){t.exports=lx}({get exports(){return ax},set exports(t){ax=t}}),function(t){t.exports=ax}(sx);var hx={},ux={get exports(){return hx},set exports(t){hx=t}},cx={},dx={get exports(){return cx},set exports(t){cx=t}},px=W,fx=Zu,mx=Yi,vx=Qt,gx=Kt,yx=di,bx=Error,_x=y("".replace),wx=String(bx("zxcasd").stack),kx=/\n\s*at [^:]*:[^\n]*/,xx=kx.test(wx),Dx=hi,Sx=!d((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",Dx(1,7)),7!==t.stack)})),Cx=di,Tx=function(t,e){if(xx&&"string"==typeof t&&!bx.prepareStackTrace)for(;e--;)t=_x(t,kx,"");return t},Mx=Sx,Ox=Error.captureStackTrace,Ex=_n,Px=pe,Ix=ue,Ax=Te,Lx=ss,Nx=Xn,Rx=_e,Fx=zs,jx=Ls,Yx=ts,Hx=TypeError,zx=function(t,e){this.stopped=t,this.result=e},Bx=zx.prototype,Gx=function(t,e,i){var n,r,o,s,a,l,h,u=i&&i.that,c=!(!i||!i.AS_ENTRIES),d=!(!i||!i.IS_RECORD),p=!(!i||!i.IS_ITERATOR),f=!(!i||!i.INTERRUPTED),m=Ex(e,u),v=function(t){return n&&Yx(n,"normal",t),new zx(!0,t)},g=function(t){return c?(Ix(t),f?m(t[0],t[1],v):m(t[0],t[1])):f?m(t,v):m(t)};if(d)n=t.iterator;else if(p)n=t;else{if(!(r=jx(t)))throw Hx(Ax(t)+" is not iterable");if(Lx(r)){for(o=0,s=Nx(t);s>o;o++)if((a=g(t[o]))&&Rx(Bx,a))return a;return new zx(!1)}n=Fx(t,r)}for(l=d?t.next:n.next;!(h=Px(l,n)).done;){try{a=g(h.value)}catch(t){Yx(n,"throw",t)}if("object"==typeof a&&a&&Rx(Bx,a))return a}return new zx(!1)},Wx=Rt,Vx=In,Ux=_e,Xx=Br,qx=Co,$x=function(t,e,i){for(var n=fx(e),r=vx.f,o=mx.f,s=0;s<n.length;s++){var a=n[s];px(t,a)||i&&px(i,a)||r(t,a,o(e,a))}},Zx=Ar,Kx=di,Jx=hi,Qx=function(t,e){gx(e)&&"cause"in e&&yx(t,"cause",e.cause)},tD=function(t,e,i,n){Mx&&(Ox?Ox(t,e):Cx(t,"stack",Tx(i,n)))},eD=Gx,iD=function(t,e){return void 0===t?arguments.length<2?"":e:Wx(t)},nD=vt("toStringTag"),rD=Error,oD=[].push,sD=function(t,e){var i,n=Ux(aD,this);qx?i=qx(rD(),n?Xx(this):aD):(i=n?this:Zx(aD),Kx(i,nD,"Error")),void 0!==e&&Kx(i,"message",iD(e)),tD(i,sD,i.stack,1),arguments.length>2&&Qx(i,arguments[2]);var r=[];return eD(t,oD,{that:r}),Kx(i,"errors",r),i};qx?qx(sD,rD):$x(sD,rD,{name:!0});var aD=sD.prototype=Zx(rD.prototype,{constructor:Jx(1,sD),message:Jx(1,""),name:Jx(1,"AggregateError")});Vx({global:!0,constructor:!0,arity:2},{AggregateError:sD});var lD,hD,uD,cD,dD="undefined"!=typeof process&&"process"==Ct(process),pD=be,fD=Za,mD=Jt,vD=vt("species"),gD=function(t){var e=pD(t);mD&&e&&!e[vD]&&fD(e,vD,{configurable:!0,get:function(){return this}})},yD=_e,bD=TypeError,_D=function(t,e){if(yD(e,t))return t;throw bD("Incorrect invocation")},wD=Ds,kD=Te,xD=TypeError,DD=function(t){if(wD(t))return t;throw xD(kD(t)+" is not a constructor")},SD=ue,CD=DD,TD=N,MD=vt("species"),OD=function(t,e){var i,n=SD(t).constructor;return void 0===n||TD(i=SD(n)[MD])?e:CD(i)},ED=/(?:ipad|iphone|ipod).*applewebkit/i.test(Z),PD=D,ID=Ni,AD=_n,LD=kt,ND=W,RD=d,FD=vr,jD=$h,YD=ne,HD=Oy,zD=ED,BD=dD,GD=PD.setImmediate,WD=PD.clearImmediate,VD=PD.process,UD=PD.Dispatch,XD=PD.Function,qD=PD.MessageChannel,$D=PD.String,ZD=0,KD={},JD="onreadystatechange";RD((function(){lD=PD.location}));var QD=function(t){if(ND(KD,t)){var e=KD[t];delete KD[t],e()}},tS=function(t){return function(){QD(t)}},eS=function(t){QD(t.data)},iS=function(t){PD.postMessage($D(t),lD.protocol+"//"+lD.host)};GD&&WD||(GD=function(t){HD(arguments.length,1);var e=LD(t)?t:XD(t),i=jD(arguments,1);return KD[++ZD]=function(){ID(e,void 0,i)},hD(ZD),ZD},WD=function(t){delete KD[t]},BD?hD=function(t){VD.nextTick(tS(t))}:UD&&UD.now?hD=function(t){UD.now(tS(t))}:qD&&!zD?(cD=(uD=new qD).port2,uD.port1.onmessage=eS,hD=AD(cD.postMessage,cD)):PD.addEventListener&&LD(PD.postMessage)&&!PD.importScripts&&lD&&"file:"!==lD.protocol&&!RD(iS)?(hD=iS,PD.addEventListener("message",eS,!1)):hD=JD in YD("script")?function(t){FD.appendChild(YD("script"))[JD]=function(){FD.removeChild(this),QD(t)}}:function(t){setTimeout(tS(t),0)});var nS={set:GD,clear:WD},rS=function(){this.head=null,this.tail=null};rS.prototype={add:function(t){var e={item:t,next:null},i=this.tail;i?i.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var oS,sS,aS,lS,hS,uS=rS,cS=/ipad|iphone|ipod/i.test(Z)&&"undefined"!=typeof Pebble,dS=/web0s(?!.*chrome)/i.test(Z),pS=D,fS=_n,mS=Yi.f,vS=nS.set,gS=uS,yS=ED,bS=cS,_S=dS,wS=dD,kS=pS.MutationObserver||pS.WebKitMutationObserver,xS=pS.document,DS=pS.process,SS=pS.Promise,CS=mS(pS,"queueMicrotask"),TS=CS&&CS.value;if(!TS){var MS=new gS,OS=function(){var t,e;for(wS&&(t=DS.domain)&&t.exit();e=MS.get();)try{e()}catch(t){throw MS.head&&oS(),t}t&&t.enter()};yS||wS||_S||!kS||!xS?!bS&&SS&&SS.resolve?((lS=SS.resolve(void 0)).constructor=SS,hS=fS(lS.then,lS),oS=function(){hS(OS)}):wS?oS=function(){DS.nextTick(OS)}:(vS=fS(vS,pS),oS=function(){vS(OS)}):(sS=!0,aS=xS.createTextNode(""),new kS(OS).observe(aS,{characterData:!0}),oS=function(){aS.data=sS=!sS}),TS=function(t){MS.head||oS(),MS.add(t)}}var ES=TS,PS=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},IS=D.Promise,AS="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,LS=!AS&&!dD&&"object"==typeof window&&"object"==typeof document,NS=D,RS=IS,FS=kt,jS=vn,YS=us,HS=vt,zS=LS,BS=AS,GS=nt,WS=RS&&RS.prototype,VS=HS("species"),US=!1,XS=FS(NS.PromiseRejectionEvent),qS=jS("Promise",(function(){var t=YS(RS),e=t!==String(RS);if(!e&&66===GS)return!0;if(!WS.catch||!WS.finally)return!0;if(!GS||GS<51||!/native code/.test(t)){var i=new RS((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((i.constructor={})[VS]=n,!(US=i.then((function(){}))instanceof n))return!0}return!e&&(zS||BS)&&!XS})),$S={CONSTRUCTOR:qS,REJECTION_EVENT:XS,SUBCLASSING:US},ZS={},KS=Pe,JS=TypeError,QS=function(t){var e,i;this.promise=new t((function(t,n){if(void 0!==e||void 0!==i)throw JS("Bad Promise constructor");e=t,i=n})),this.resolve=KS(e),this.reject=KS(i)};ZS.f=function(t){return new QS(t)};var tC,eC,iC=In,nC=dD,rC=D,oC=pe,sC=Wr,aC=ho,lC=gD,hC=Pe,uC=kt,cC=Kt,dC=_D,pC=OD,fC=nS.set,mC=ES,vC=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},gC=PS,yC=uS,bC=Ei,_C=IS,wC=ZS,kC="Promise",xC=$S.CONSTRUCTOR,DC=$S.REJECTION_EVENT,SC=bC.getterFor(kC),CC=bC.set,TC=_C&&_C.prototype,MC=_C,OC=TC,EC=rC.TypeError,PC=rC.document,IC=rC.process,AC=wC.f,LC=AC,NC=!!(PC&&PC.createEvent&&rC.dispatchEvent),RC="unhandledrejection",FC=function(t){var e;return!(!cC(t)||!uC(e=t.then))&&e},jC=function(t,e){var i,n,r,o=e.value,s=1==e.state,a=s?t.ok:t.fail,l=t.resolve,h=t.reject,u=t.domain;try{a?(s||(2===e.rejection&&GC(e),e.rejection=1),!0===a?i=o:(u&&u.enter(),i=a(o),u&&(u.exit(),r=!0)),i===t.promise?h(EC("Promise-chain cycle")):(n=FC(i))?oC(n,i,l,h):l(i)):h(o)}catch(t){u&&!r&&u.exit(),h(t)}},YC=function(t,e){t.notified||(t.notified=!0,mC((function(){for(var i,n=t.reactions;i=n.get();)jC(i,t);t.notified=!1,e&&!t.rejection&&zC(t)})))},HC=function(t,e,i){var n,r;NC?((n=PC.createEvent("Event")).promise=e,n.reason=i,n.initEvent(t,!1,!0),rC.dispatchEvent(n)):n={promise:e,reason:i},!DC&&(r=rC["on"+t])?r(n):t===RC&&vC("Unhandled promise rejection",i)},zC=function(t){oC(fC,rC,(function(){var e,i=t.facade,n=t.value;if(BC(t)&&(e=gC((function(){nC?IC.emit("unhandledRejection",n,i):HC(RC,i,n)})),t.rejection=nC||BC(t)?2:1,e.error))throw e.value}))},BC=function(t){return 1!==t.rejection&&!t.parent},GC=function(t){oC(fC,rC,(function(){var e=t.facade;nC?IC.emit("rejectionHandled",e):HC("rejectionhandled",e,t.value)}))},WC=function(t,e,i){return function(n){t(e,n,i)}},VC=function(t,e,i){t.done||(t.done=!0,i&&(t=i),t.value=e,t.state=2,YC(t,!0))},UC=function(t,e,i){if(!t.done){t.done=!0,i&&(t=i);try{if(t.facade===e)throw EC("Promise can't be resolved itself");var n=FC(e);n?mC((function(){var i={done:!1};try{oC(n,e,WC(UC,i,t),WC(VC,i,t))}catch(e){VC(i,e,t)}})):(t.value=e,t.state=1,YC(t,!1))}catch(e){VC({done:!1},e,t)}}};xC&&(OC=(MC=function(t){dC(this,OC),hC(t),oC(tC,this);var e=SC(this);try{t(WC(UC,e),WC(VC,e))}catch(t){VC(e,t)}}).prototype,(tC=function(t){CC(this,{type:kC,done:!1,notified:!1,parent:!1,reactions:new yC,rejection:!1,state:0,value:void 0})}).prototype=sC(OC,"then",(function(t,e){var i=SC(this),n=AC(pC(this,MC));return i.parent=!0,n.ok=!uC(t)||t,n.fail=uC(e)&&e,n.domain=nC?IC.domain:void 0,0==i.state?i.reactions.add(n):mC((function(){jC(n,i)})),n.promise})),eC=function(){var t=new tC,e=SC(t);this.promise=t,this.resolve=WC(UC,e),this.reject=WC(VC,e)},wC.f=AC=function(t){return t===MC||undefined===t?new eC(t):LC(t)}),iC({global:!0,constructor:!0,wrap:!0,forced:xC},{Promise:MC}),aC(MC,kC,!1,!0),lC(kC);var XC=IS,qC=$S.CONSTRUCTOR||!na((function(t){XC.all(t).then(void 0,(function(){}))})),$C=pe,ZC=Pe,KC=ZS,JC=PS,QC=Gx;In({target:"Promise",stat:!0,forced:qC},{all:function(t){var e=this,i=KC.f(e),n=i.resolve,r=i.reject,o=JC((function(){var i=ZC(e.resolve),o=[],s=0,a=1;QC(t,(function(t){var l=s++,h=!1;a++,$C(i,e,t).then((function(t){h||(h=!0,o[l]=t,--a||n(o))}),r)})),--a||n(o)}));return o.error&&r(o.value),i.promise}});var tT=In,eT=$S.CONSTRUCTOR;IS&&IS.prototype,tT({target:"Promise",proto:!0,forced:eT,real:!0},{catch:function(t){return this.then(void 0,t)}});var iT=pe,nT=Pe,rT=ZS,oT=PS,sT=Gx;In({target:"Promise",stat:!0,forced:qC},{race:function(t){var e=this,i=rT.f(e),n=i.reject,r=oT((function(){var r=nT(e.resolve);sT(t,(function(t){iT(r,e,t).then(i.resolve,n)}))}));return r.error&&n(r.value),i.promise}});var aT=pe,lT=ZS;In({target:"Promise",stat:!0,forced:$S.CONSTRUCTOR},{reject:function(t){var e=lT.f(this);return aT(e.reject,void 0,t),e.promise}});var hT=ue,uT=Kt,cT=ZS,dT=function(t,e){if(hT(t),uT(e)&&e.constructor===t)return e;var i=cT.f(t);return(0,i.resolve)(e),i.promise},pT=In,fT=IS,mT=$S.CONSTRUCTOR,vT=dT,gT=be("Promise"),yT=!mT;pT({target:"Promise",stat:!0,forced:true},{resolve:function(t){return vT(yT&&this===gT?fT:this,t)}});var bT=pe,_T=Pe,wT=ZS,kT=PS,xT=Gx;In({target:"Promise",stat:!0,forced:qC},{allSettled:function(t){var e=this,i=wT.f(e),n=i.resolve,r=i.reject,o=kT((function(){var i=_T(e.resolve),r=[],o=0,s=1;xT(t,(function(t){var a=o++,l=!1;s++,bT(i,e,t).then((function(t){l||(l=!0,r[a]={status:"fulfilled",value:t},--s||n(r))}),(function(t){l||(l=!0,r[a]={status:"rejected",reason:t},--s||n(r))}))})),--s||n(r)}));return o.error&&r(o.value),i.promise}});var DT=pe,ST=Pe,CT=be,TT=ZS,MT=PS,OT=Gx,ET="No one promise resolved";In({target:"Promise",stat:!0,forced:qC},{any:function(t){var e=this,i=CT("AggregateError"),n=TT.f(e),r=n.resolve,o=n.reject,s=MT((function(){var n=ST(e.resolve),s=[],a=0,l=1,h=!1;OT(t,(function(t){var u=a++,c=!1;l++,DT(n,e,t).then((function(t){c||h||(h=!0,r(t))}),(function(t){c||h||(c=!0,s[u]=t,--l||o(new i(s,ET)))}))})),--l||o(new i(s,ET))}));return s.error&&o(s.value),n.promise}});var PT=In,IT=IS,AT=d,LT=be,NT=kt,RT=OD,FT=dT,jT=IT&&IT.prototype;PT({target:"Promise",proto:!0,real:!0,forced:!!IT&&AT((function(){jT.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=RT(this,LT("Promise")),i=NT(t);return this.then(i?function(i){return FT(e,t()).then((function(){return i}))}:t,i?function(i){return FT(e,t()).then((function(){throw i}))}:t)}});var YT=fe.Promise,HT=ZS,zT=PS;In({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=HT.f(this),i=zT(t);return(i.error?e.reject:e.resolve)(i.value),e.promise}});var BT=YT;!function(t){t.exports=BT}(dx),function(t){t.exports=cx}(ux);var GT={},WT={get exports(){return GT},set exports(t){GT=t}},VT={},UT=bm;!function(t){t.exports=UT}({get exports(){return VT},set exports(t){VT=t}}),function(t){t.exports=VT}(WT),function(t){var e=rx.default,i=Cc,n=Pc,r=Pk,o=Zk,s=ox,a=Rk,l=hx,h=GT,u=Qd;function c(){t.exports=c=function(){return d},t.exports.__esModule=!0,t.exports.default=t.exports;var d={},p=Object.prototype,f=p.hasOwnProperty,m=i||function(t,e,i){t[e]=i.value},v="function"==typeof n?n:{},g=v.iterator||"@@iterator",y=v.asyncIterator||"@@asyncIterator",b=v.toStringTag||"@@toStringTag";function _(t,e,n){return i(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{_({},"")}catch(t){_=function(t,e,i){return t[e]=i}}function w(t,e,i,n){var o=e&&e.prototype instanceof D?e:D,s=r(o.prototype),a=new R(n||[]);return m(s,"_invoke",{value:I(t,i,a)}),s}function k(t,e,i){try{return{type:"normal",arg:t.call(e,i)}}catch(t){return{type:"throw",arg:t}}}d.wrap=w;var x={};function D(){}function S(){}function C(){}var T={};_(T,g,(function(){return this}));var M=o&&o(o(F([])));M&&M!==p&&f.call(M,g)&&(T=M);var O=C.prototype=D.prototype=r(T);function E(t){var e;s(e=["next","throw","return"]).call(e,(function(e){_(t,e,(function(t){return this._invoke(e,t)}))}))}function P(t,i){function n(r,o,s,a){var l=k(t[r],t,o);if("throw"!==l.type){var h=l.arg,u=h.value;return u&&"object"==e(u)&&f.call(u,"__await")?i.resolve(u.__await).then((function(t){n("next",t,s,a)}),(function(t){n("throw",t,s,a)})):i.resolve(u).then((function(t){h.value=t,s(h)}),(function(t){return n("throw",t,s,a)}))}a(l.arg)}var r;m(this,"_invoke",{value:function(t,e){function o(){return new i((function(i,r){n(t,e,i,r)}))}return r=r?r.then(o,o):o()}})}function I(t,e,i){var n="suspendedStart";return function(r,o){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===r)throw o;return j()}for(i.method=r,i.arg=o;;){var s=i.delegate;if(s){var a=A(s,i);if(a){if(a===x)continue;return a}}if("next"===i.method)i.sent=i._sent=i.arg;else if("throw"===i.method){if("suspendedStart"===n)throw n="completed",i.arg;i.dispatchException(i.arg)}else"return"===i.method&&i.abrupt("return",i.arg);n="executing";var l=k(t,e,i);if("normal"===l.type){if(n=i.done?"completed":"suspendedYield",l.arg===x)continue;return{value:l.arg,done:i.done}}"throw"===l.type&&(n="completed",i.method="throw",i.arg=l.arg)}}}function A(t,e){var i=e.method,n=t.iterator[i];if(void 0===n)return e.delegate=null,"throw"===i&&t.iterator.return&&(e.method="return",e.arg=void 0,A(t,e),"throw"===e.method)||"return"!==i&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+i+"' method")),x;var r=k(n,t.iterator,e.arg);if("throw"===r.type)return e.method="throw",e.arg=r.arg,e.delegate=null,x;var o=r.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,x):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,x)}function L(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function N(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function R(t){this.tryEntries=[{tryLoc:"root"}],s(t).call(t,L,this),this.reset(!0)}function F(t){if(t){var e=t[g];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,n=function e(){for(;++i<t.length;)if(f.call(t,i))return e.value=t[i],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:j}}function j(){return{value:void 0,done:!0}}return S.prototype=C,m(O,"constructor",{value:C,configurable:!0}),m(C,"constructor",{value:S,configurable:!0}),S.displayName=_(C,b,"GeneratorFunction"),d.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===S||"GeneratorFunction"===(e.displayName||e.name))},d.mark=function(t){return a?a(t,C):(t.__proto__=C,_(t,b,"GeneratorFunction")),t.prototype=r(O),t},d.awrap=function(t){return{__await:t}},E(P.prototype),_(P.prototype,y,(function(){return this})),d.AsyncIterator=P,d.async=function(t,e,i,n,r){void 0===r&&(r=l);var o=new P(w(t,e,i,n),r);return d.isGeneratorFunction(e)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},E(O),_(O,b,"Generator"),_(O,g,(function(){return this})),_(O,"toString",(function(){return"[object Generator]"})),d.keys=function(t){var e=Object(t),i=[];for(var n in e)i.push(n);return h(i).call(i),function t(){for(;i.length;){var n=i.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},d.values=F,R.prototype={constructor:R,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,s(e=this.tryEntries).call(e,N),!t)for(var i in this)"t"===i.charAt(0)&&f.call(this,i)&&!isNaN(+u(i).call(i,1))&&(this[i]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function i(i,n){return o.type="throw",o.arg=t,e.next=i,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var r=this.tryEntries[n],o=r.completion;if("root"===r.tryLoc)return i("end");if(r.tryLoc<=this.prev){var s=f.call(r,"catchLoc"),a=f.call(r,"finallyLoc");if(s&&a){if(this.prev<r.catchLoc)return i(r.catchLoc,!0);if(this.prev<r.finallyLoc)return i(r.finallyLoc)}else if(s){if(this.prev<r.catchLoc)return i(r.catchLoc,!0)}else{if(!a)throw new Error("try statement without catch or finally");if(this.prev<r.finallyLoc)return i(r.finallyLoc)}}}},abrupt:function(t,e){for(var i=this.tryEntries.length-1;i>=0;--i){var n=this.tryEntries[i];if(n.tryLoc<=this.prev&&f.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var r=n;break}}r&&("break"===t||"continue"===t)&&r.tryLoc<=e&&e<=r.finallyLoc&&(r=null);var o=r?r.completion:{};return o.type=t,o.arg=e,r?(this.method="next",this.next=r.finallyLoc,x):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),x},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.finallyLoc===t)return this.complete(i.completion,i.afterLoc),N(i),x}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.tryLoc===t){var n=i.completion;if("throw"===n.type){var r=n.arg;N(i)}return r}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,i){return this.delegate={iterator:F(t),resultName:e,nextLoc:i},"next"===this.method&&(this.arg=void 0),x}},d}t.exports=c,t.exports.__esModule=!0,t.exports.default=t.exports}(nx);var XT=ix(),qT=XT;try{regeneratorRuntime=XT}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=XT:Function("r","regeneratorRuntime = r")(XT)}var $T={},ZT={get exports(){return $T},set exports(t){$T=t}},KT=Pe,JT=z,QT=qi,tM=Xn,eM=TypeError,iM=function(t){return function(e,i,n,r){KT(i);var o=JT(e),s=QT(o),a=tM(o),l=t?a-1:0,h=t?-1:1;if(n<2)for(;;){if(l in s){r=s[l],l+=h;break}if(l+=h,t?l<0:a<=l)throw eM("Reduce of empty array with no initial value")}for(;t?l>=0:a>l;l+=h)l in s&&(r=i(r,s[l],l,o));return r}},nM={left:iM(!1),right:iM(!0)}.left;In({target:"Array",proto:!0,forced:!dD&&nt>79&&nt<83||!Zf("reduce")},{reduce:function(t){var e=arguments.length;return nM(this,t,e,e>1?arguments[1]:void 0)}});var rM=yp("Array").reduce,oM=_e,sM=rM,aM=Array.prototype,lM=function(t){var e=t.reduce;return t===aM||oM(aM,t)&&e===aM.reduce?sM:e},hM=lM;!function(t){t.exports=hM}(ZT);var uM=n($T),cM={},dM={get exports(){return cM},set exports(t){cM=t}},pM=ul,fM=Xn,mM=Rc,vM=_n,gM=function(t,e,i,n,r,o,s,a){for(var l,h,u=r,c=0,d=!!s&&vM(s,a);c<n;)c in i&&(l=d?d(i[c],c,e):i[c],o>0&&pM(l)?(h=fM(l),u=gM(t,e,l,h,u,o-1)-1):(mM(u+1),t[u]=l),u++),c++;return u},yM=gM,bM=Pe,_M=z,wM=Xn,kM=gl;In({target:"Array",proto:!0},{flatMap:function(t){var e,i=_M(this),n=wM(i);return bM(t),(e=kM(i,0)).length=yM(e,i,i,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var xM=yp("Array").flatMap,DM=_e,SM=xM,CM=Array.prototype,TM=function(t){var e=t.flatMap;return t===CM||DM(CM,t)&&e===CM.flatMap?SM:e},MM=TM;!function(t){t.exports=MM}(dM);var OM=n(cM),EM={},PM={get exports(){return EM},set exports(t){EM=t}},IM={},AM={get exports(){return IM},set exports(t){IM=t}},LM=d((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),NM=d,RM=Kt,FM=Ct,jM=LM,YM=Object.isExtensible,HM=NM((function(){YM(1)}))||jM?function(t){return!!RM(t)&&((!jM||"ArrayBuffer"!=FM(t))&&(!YM||YM(t)))}:YM,zM=!d((function(){return Object.isExtensible(Object.preventExtensions({}))})),BM=In,GM=y,WM=vi,VM=Kt,UM=W,XM=Qt.f,qM=Aa,$M=Ra,ZM=HM,KM=zM,JM=!1,QM=$("meta"),tO=0,eO=function(t){XM(t,QM,{value:{objectID:"O"+tO++,weakData:{}}})},iO=AM.exports={enable:function(){iO.enable=function(){},JM=!0;var t=qM.f,e=GM([].splice),i={};i[QM]=1,t(i).length&&(qM.f=function(i){for(var n=t(i),r=0,o=n.length;r<o;r++)if(n[r]===QM){e(n,r,1);break}return n},BM({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:$M.f}))},fastKey:function(t,e){if(!VM(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!UM(t,QM)){if(!ZM(t))return"F";if(!e)return"E";eO(t)}return t[QM].objectID},getWeakData:function(t,e){if(!UM(t,QM)){if(!ZM(t))return!0;if(!e)return!1;eO(t)}return t[QM].weakData},onFreeze:function(t){return KM&&JM&&ZM(t)&&!UM(t,QM)&&eO(t),t}};WM[QM]=!0;var nO=In,rO=D,oO=IM,sO=d,aO=di,lO=Gx,hO=_D,uO=kt,cO=Kt,dO=ho,pO=Qt.f,fO=Sl.forEach,mO=Jt,vO=Ei.set,gO=Ei.getterFor,yO=function(t,e,i){var n,r=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),s=r?"set":"add",a=rO[t],l=a&&a.prototype,h={};if(mO&&uO(a)&&(o||l.forEach&&!sO((function(){(new a).entries().next()})))){var u=(n=e((function(e,i){vO(hO(e,u),{type:t,collection:new a}),null!=i&&lO(i,e[s],{that:e,AS_ENTRIES:r})}))).prototype,c=gO(t);fO(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in l)||o&&"clear"==t||aO(u,t,(function(i,n){var r=c(this).collection;if(!e&&o&&!cO(i))return"get"==t&&void 0;var s=r[t](0===i?0:i,n);return e?this:s}))})),o||pO(u,"size",{configurable:!0,get:function(){return c(this).collection.size}})}else n=i.getConstructor(e,t,r,s),oO.enable();return dO(n,t,!1,!0),h[t]=n,nO({global:!0,forced:!0},h),o||i.setStrong(n,t,r),n},bO=Wr,_O=Ar,wO=Za,kO=function(t,e,i){for(var n in e)i&&i.unsafe&&t[n]?t[n]=e[n]:bO(t,n,e[n],i);return t},xO=_n,DO=_D,SO=N,CO=Gx,TO=zo,MO=Bo,OO=gD,EO=Jt,PO=IM.fastKey,IO=Ei.set,AO=Ei.getterFor,LO={getConstructor:function(t,e,i,n){var r=t((function(t,r){DO(t,o),IO(t,{type:e,index:_O(null),first:void 0,last:void 0,size:0}),EO||(t.size=0),SO(r)||CO(r,t[n],{that:t,AS_ENTRIES:i})})),o=r.prototype,s=AO(e),a=function(t,e,i){var n,r,o=s(t),a=l(t,e);return a?a.value=i:(o.last=a={index:r=PO(e,!0),key:e,value:i,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=a),n&&(n.next=a),EO?o.size++:t.size++,"F"!==r&&(o.index[r]=a)),t},l=function(t,e){var i,n=s(t),r=PO(e);if("F"!==r)return n.index[r];for(i=n.first;i;i=i.next)if(i.key==e)return i};return kO(o,{clear:function(){for(var t=s(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,EO?t.size=0:this.size=0},delete:function(t){var e=this,i=s(e),n=l(e,t);if(n){var r=n.next,o=n.previous;delete i.index[n.index],n.removed=!0,o&&(o.next=r),r&&(r.previous=o),i.first==n&&(i.first=r),i.last==n&&(i.last=o),EO?i.size--:e.size--}return!!n},forEach:function(t){for(var e,i=s(this),n=xO(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:i.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!l(this,t)}}),kO(o,i?{get:function(t){var e=l(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),EO&&wO(o,"size",{configurable:!0,get:function(){return s(this).size}}),r},setStrong:function(t,e,i){var n=e+" Iterator",r=AO(e),o=AO(n);TO(t,e,(function(t,e){IO(this,{type:n,target:t,state:r(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?MO("keys"==e?i.key:"values"==e?i.value:[i.key,i.value],!1):(t.target=void 0,MO(void 0,!0))}),i?"entries":"values",!i,!0),OO(e)}};yO("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),LO);var NO=fe.Map;!function(t){t.exports=NO}(PM);var RO=n(EM),FO={},jO={get exports(){return FO},set exports(t){FO=t}};yO("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),LO);var YO=fe.Set;!function(t){t.exports=YO}(jO);var HO=n(FO),zO={};!function(t){t.exports=Id}({get exports(){return zO},set exports(t){zO=t}});var BO=n(zO),GO={},WO={get exports(){return GO},set exports(t){GO=t}},VO={},UO=zs;!function(t){t.exports=UO}({get exports(){return VO},set exports(t){VO=t}}),function(t){t.exports=VO}(WO);var XO=n(GO),qO={},$O={get exports(){return qO},set exports(t){qO=t}},ZO=Ba,KO=Math.floor,JO=function(t,e){var i=t.length,n=KO(i/2);return i<8?QO(t,e):tE(t,JO(ZO(t,0,n),e),JO(ZO(t,n),e),e)},QO=function(t,e){for(var i,n,r=t.length,o=1;o<r;){for(n=o,i=t[o];n&&e(t[n-1],i)>0;)t[n]=t[--n];n!==o++&&(t[n]=i)}return t},tE=function(t,e,i,n){for(var r=e.length,o=i.length,s=0,a=0;s<r||a<o;)t[s+a]=s<r&&a<o?n(e[s],i[a])<=0?e[s++]:i[a++]:s<r?e[s++]:i[a++];return t},eE=JO,iE=Z.match(/firefox\/(\d+)/i),nE=!!iE&&+iE[1],rE=/MSIE|Trident/.test(Z),oE=Z.match(/AppleWebKit\/(\d+)\./),sE=!!oE&&+oE[1],aE=In,lE=y,hE=Pe,uE=z,cE=Xn,dE=Em,pE=Rt,fE=d,mE=eE,vE=Zf,gE=nE,yE=rE,bE=nt,_E=sE,wE=[],kE=lE(wE.sort),xE=lE(wE.push),DE=fE((function(){wE.sort(void 0)})),SE=fE((function(){wE.sort(null)})),CE=vE("sort"),TE=!fE((function(){if(bE)return bE<70;if(!(gE&&gE>3)){if(yE)return!0;if(_E)return _E<603;var t,e,i,n,r="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:i=3;break;case 68:case 71:i=4;break;default:i=2}for(n=0;n<47;n++)wE.push({k:e+n,v:i})}for(wE.sort((function(t,e){return e.v-t.v})),n=0;n<wE.length;n++)e=wE[n].k.charAt(0),r.charAt(r.length-1)!==e&&(r+=e);return"DGBEFHACIJK"!==r}}));aE({target:"Array",proto:!0,forced:DE||!SE||!CE||!TE},{sort:function(t){void 0!==t&&hE(t);var e=uE(this);if(TE)return void 0===t?kE(e):kE(e,t);var i,n,r=[],o=cE(e);for(n=0;n<o;n++)n in e&&xE(r,e[n]);for(mE(r,function(t){return function(e,i){return void 0===i?-1:void 0===e?1:void 0!==t?+t(e,i)||0:pE(e)>pE(i)?1:-1}}(t)),i=cE(r),n=0;n<i;)e[n]=r[n++];for(;n<o;)dE(e,n++);return e}});var ME=yp("Array").sort,OE=_e,EE=ME,PE=Array.prototype,IE=function(t){var e=t.sort;return t===PE||OE(PE,t)&&e===PE.sort?EE:e},AE=IE;!function(t){t.exports=AE}($O);var LE=n(qO),NE={},RE={get exports(){return NE},set exports(t){NE=t}},FE=Sl.some;In({target:"Array",proto:!0,forced:!Zf("some")},{some:function(t){return FE(this,t,arguments.length>1?arguments[1]:void 0)}});var jE=yp("Array").some,YE=_e,HE=jE,zE=Array.prototype,BE=function(t){var e=t.some;return t===zE||YE(zE,t)&&e===zE.some?HE:e},GE=BE;!function(t){t.exports=GE}(RE);var WE=n(NE),VE={},UE={get exports(){return VE},set exports(t){VE=t}},XE=yp("Array").keys,qE=At,$E=W,ZE=_e,KE=XE,JE=Array.prototype,QE={DOMTokenList:!0,NodeList:!0},tP=function(t){var e=t.keys;return t===JE||ZE(JE,t)&&e===JE.keys||$E(QE,qE(t))?KE:e};!function(t){t.exports=tP}(UE);var eP=n(VE),iP={},nP={get exports(){return iP},set exports(t){iP=t}},rP=yp("Array").values,oP=At,sP=W,aP=_e,lP=rP,hP=Array.prototype,uP={DOMTokenList:!0,NodeList:!0},cP=function(t){var e=t.values;return t===hP||aP(hP,t)&&e===hP.values||sP(uP,oP(t))?lP:e};!function(t){t.exports=cP}(nP);var dP=n(iP),pP={},fP={get exports(){return pP},set exports(t){pP=t}},mP=yp("Array").entries,vP=At,gP=W,yP=_e,bP=mP,_P=Array.prototype,wP={DOMTokenList:!0,NodeList:!0},kP=function(t){var e=t.entries;return t===_P||yP(_P,t)&&e===_P.entries||gP(wP,vP(t))?bP:e};!function(t){t.exports=kP}(fP);var xP=n(pP),DP={},SP={get exports(){return DP},set exports(t){DP=t}},CP=In,TP=Ni,MP=jf,OP=DD,EP=ue,PP=Kt,IP=Ar,AP=d,LP=be("Reflect","construct"),NP=Object.prototype,RP=[].push,FP=AP((function(){function t(){}return!(LP((function(){}),[],t)instanceof t)})),jP=!AP((function(){LP((function(){}))})),YP=FP||jP;CP({target:"Reflect",stat:!0,forced:YP,sham:YP},{construct:function(t,e){OP(t),EP(e);var i=arguments.length<3?t:OP(arguments[2]);if(jP&&!FP)return LP(t,e,i);if(t==i){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return TP(RP,n,e),new(TP(MP,t,n))}var r=i.prototype,o=IP(PP(r)?r:NP),s=TP(t,o,e);return PP(s)?s:o}});var HP=fe.Reflect.construct;!function(t){t.exports=HP}(SP);var zP=n(DP);let BP;const GP=new Uint8Array(16);function WP(){if(!BP&&(BP="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!BP))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return BP(GP)}const VP=[];for(let t=0;t<256;++t)VP.push((t+256).toString(16).slice(1));var UP,XP={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};function qP(t,e,i){if(XP.randomUUID&&!e&&!t)return XP.randomUUID();const n=(t=t||{}).random||(t.rng||WP)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){i=i||0;for(let t=0;t<16;++t)e[i+t]=n[t];return e}return function(t,e=0){return(VP[t[e+0]]+VP[t[e+1]]+VP[t[e+2]]+VP[t[e+3]]+"-"+VP[t[e+4]]+VP[t[e+5]]+"-"+VP[t[e+6]]+VP[t[e+7]]+"-"+VP[t[e+8]]+VP[t[e+9]]+"-"+VP[t[e+10]]+VP[t[e+11]]+VP[t[e+12]]+VP[t[e+13]]+VP[t[e+14]]+VP[t[e+15]]).toLowerCase()}(n)}function $P(t,e){var i=gf(t);if(Ou){var n=Ou(t);e&&(n=ig(n).call(n,(function(e){return Bu(t,e).enumerable}))),i.push.apply(i,n)}return i}function ZP(t){for(var e=1;e<arguments.length;e++){var i,n,r=null!=arguments[e]?arguments[e]:{};e%2?am(i=$P(Object(r),!0)).call(i,(function(e){Vd(t,e,r[e])})):ic?pc(t,ic(r)):am(n=$P(Object(r))).call(n,(function(e){Dc(t,e,Bu(r,e))}))}return t}function KP(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}function JP(t,e){var i=void 0!==Fp&&Ea(t)||t["@@iterator"];if(!i){if(tf(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return QP(t,e);var n=qp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return QP(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function QP(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var tI=function(){function t(e,i,n){var r,o,s;Sc(this,t),Vd(this,"_source",void 0),Vd(this,"_transformers",void 0),Vd(this,"_target",void 0),Vd(this,"_listeners",{add:Uf(r=this._add).call(r,this),remove:Uf(o=this._remove).call(o,this),update:Uf(s=this._update).call(s,this)}),this._source=e,this._transformers=i,this._target=n}return Wd(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return uM(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),eI=function(){function t(e){Sc(this,t),Vd(this,"_source",void 0),Vd(this,"_transformers",[]),this._source=e}return Wd(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return ig(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return cf(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return OM(e).call(e,t)})),this}},{key:"to",value:function(t){return new tI(this._source,this._transformers,t)}}]),t}();function iI(t){return"string"==typeof t||"number"==typeof t}var nI=function(){function t(e){Sc(this,t),Vd(this,"delay",void 0),Vd(this,"max",void 0),Vd(this,"_queue",[]),Vd(this,"_timeout",null),Vd(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(e)}return Wd(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,i=0;i<e.length;i++){var n=e[i];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var i=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];i.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Xy((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;am(t=Zm(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,i){var n=new t(i);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var r=[{name:"flush",original:void 0}];if(i&&i.replace)for(var o=0;o<i.replace.length;o++){var s=i.replace[o];r.push({name:s,original:e[s]}),n.replace(e,s)}return n._extended={object:e,methods:r},n}}]),t}(),rI=function(){function t(){Sc(this,t),Vd(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),Vd(this,"subscribe",t.prototype.on),Vd(this,"unsubscribe",t.prototype.off)}return Wd(t,[{key:"_trigger",value:function(t,e,i){var n,r;if("*"===t)throw new Error("Cannot trigger event *");am(n=Up(r=[]).call(r,Np(this._subscribers[t]),Np(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=i?i:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var i;this._subscribers[t]=ig(i=this._subscribers[t]).call(i,(function(t){return t!==e}))}}]),t}();UP=BO;var oI=function(){function t(e){Sc(this,t),Vd(this,"_pairs",void 0),this._pairs=e}return Wd(t,[{key:UP,value:qT.mark((function t(){var e,i,n,r,o;return qT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=JP(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Lp(i.value,2),r=n[0],o=n[1],t.next=7,[r,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:qT.mark((function t(){var e,i,n,r,o;return qT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=JP(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Lp(i.value,2),r=n[0],o=n[1],t.next=7,[r,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:qT.mark((function t(){var e,i,n,r;return qT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=JP(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Lp(i.value,1),r=n[0],t.next=7,r;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:qT.mark((function t(){var e,i,n,r;return qT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=JP(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Lp(i.value,2),r=n[1],t.next=7,r;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return cf(t=Np(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return cf(t=Np(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Np(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=gy(null),i=JP(this._pairs);try{for(i.s();!(t=i.n()).done;){var n=Lp(t.value,2),r=n[0],o=n[1];e[r]=o}}catch(t){i.e(t)}finally{i.f()}return e}},{key:"toMap",value:function(){return new RO(this._pairs)}},{key:"toIdSet",value:function(){return new HO(this.toIdArray())}},{key:"toItemSet",value:function(){return new HO(this.toItemArray())}},{key:"cache",value:function(){return new t(Np(this._pairs))}},{key:"distinct",value:function(t){var e,i=new HO,n=JP(this._pairs);try{for(n.s();!(e=n.n()).done;){var r=Lp(e.value,2),o=r[0],s=r[1];i.add(t(s,o))}}catch(t){n.e(t)}finally{n.f()}return i}},{key:"filter",value:function(e){var i=this._pairs;return new t(Vd({},BO,qT.mark((function t(){var n,r,o,s,a;return qT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=JP(i),t.prev=1,n.s();case 3:if((r=n.n()).done){t.next=10;break}if(o=Lp(r.value,2),s=o[0],a=o[1],!e(a,s)){t.next=8;break}return t.next=8,[s,a];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,i=JP(this._pairs);try{for(i.s();!(e=i.n()).done;){var n=Lp(e.value,2),r=n[0];t(n[1],r)}}catch(t){i.e(t)}finally{i.f()}}},{key:"map",value:function(e){var i=this._pairs;return new t(Vd({},BO,qT.mark((function t(){var n,r,o,s,a;return qT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=JP(i),t.prev=1,n.s();case 3:if((r=n.n()).done){t.next=9;break}return o=Lp(r.value,2),s=o[0],a=o[1],t.next=7,[s,e(a,s)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=XO(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],r=t(i.value[1],i.value[0]);!(i=e.next()).done;){var o=Lp(i.value,2),s=o[0],a=o[1],l=t(a,s);l>r&&(r=l,n=a)}return n}},{key:"min",value:function(t){var e=XO(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],r=t(i.value[1],i.value[0]);!(i=e.next()).done;){var o=Lp(i.value,2),s=o[0],a=o[1],l=t(a,s);l<r&&(r=l,n=a)}return n}},{key:"reduce",value:function(t,e){var i,n=JP(this._pairs);try{for(n.s();!(i=n.n()).done;){var r=Lp(i.value,2),o=r[0];e=t(e,r[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var i=this;return new t(Vd({},BO,(function(){var t;return XO(LE(t=Np(i._pairs)).call(t,(function(t,i){var n=Lp(t,2),r=n[0],o=n[1],s=Lp(i,2),a=s[0],l=s[1];return e(o,l,r,a)})))})))}}]),t}();var sI=function(t){qk(i,t);var e=KP(i);function i(t,n){var r;return Sc(this,i),Vd(Ek(r=e.call(this)),"flush",void 0),Vd(Ek(r),"length",void 0),Vd(Ek(r),"_options",void 0),Vd(Ek(r),"_data",void 0),Vd(Ek(r),"_idProp",void 0),Vd(Ek(r),"_queue",null),t&&!tf(t)&&(n=t,t=[]),r._options=n||{},r._data=new RO,r.length=0,r._idProp=r._options.fieldId||"id",t&&t.length&&r.add(t),r.setOptions(n),r}return Wd(i,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=nI.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Nd(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var i,n=this,r=[];if(tf(t)){var o=cf(t).call(t,(function(t){return t[n._idProp]}));if(WE(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var s=0,a=t.length;s<a;s++)i=this._addItem(t[s]),r.push(i)}else{if(!t||"object"!==Nd(t))throw new Error("Unknown dataType");i=this._addItem(t),r.push(i)}return r.length&&this._trigger("add",{items:r},e),r}},{key:"update",value:function(t,e){var i=this,n=[],r=[],o=[],s=[],a=this._idProp,l=function(t){var e=t[a];if(null!=e&&i._data.has(e)){var l=t,h=fv({},i._data.get(e)),u=i._updateItem(l);r.push(u),s.push(l),o.push(h)}else{var c=i._addItem(t);n.push(c)}};if(tf(t))for(var h=0,u=t.length;h<u;h++)t[h]&&"object"===Nd(t[h])?l(t[h]):console.warn("Ignoring input item, which is not an object at index "+h);else{if(!t||"object"!==Nd(t))throw new Error("Unknown dataType");l(t)}if(n.length&&this._trigger("add",{items:n},e),r.length){var c={items:r,oldData:o,data:s};this._trigger("update",c,e)}return Up(n).call(n,r)}},{key:"updateOnly",value:function(t,e){var i,n=this;tf(t)||(t=[t]);var r=cf(i=cf(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(i,(function(t){var e=t.oldData,i=t.update,r=e[n._idProp],o=Dw(e,i);return n._data.set(r,o),{id:r,oldData:e,updatedData:o}}));if(r.length){var o={items:cf(r).call(r,(function(t){return t.id})),oldData:cf(r).call(r,(function(t){return t.oldData})),data:cf(r).call(r,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var i=void 0,n=void 0,r=void 0;iI(t)?(i=t,r=e):tf(t)?(n=t,r=e):r=t;var o,s=r&&"Object"===r.returnType?"Object":"Array",a=r&&ig(r),l=[],h=void 0,u=void 0,c=void 0;if(null!=i)(h=this._data.get(i))&&a&&!a(h)&&(h=void 0);else if(null!=n)for(var d=0,p=n.length;d<p;d++)null==(h=this._data.get(n[d]))||a&&!a(h)||l.push(h);else for(var f,m=0,v=(u=Np(eP(f=this._data).call(f))).length;m<v;m++)c=u[m],null==(h=this._data.get(c))||a&&!a(h)||l.push(h);if(r&&r.order&&null==i&&this._sort(l,r.order),r&&r.fields){var g=r.fields;if(null!=i&&null!=h)h=this._filterFields(h,g);else for(var y=0,b=l.length;y<b;y++)l[y]=this._filterFields(l[y],g)}if("Object"==s){for(var _={},w=0,k=l.length;w<k;w++){var x=l[w];_[x[this._idProp]]=x}return _}return null!=i?null!==(o=h)&&void 0!==o?o:null:l}},{key:"getIds",value:function(t){var e=this._data,i=t&&ig(t),n=t&&t.order,r=Np(eP(e).call(e)),o=[];if(i)if(n){for(var s=[],a=0,l=r.length;a<l;a++){var h=r[a],u=this._data.get(h);null!=u&&i(u)&&s.push(u)}this._sort(s,n);for(var c=0,d=s.length;c<d;c++)o.push(s[c][this._idProp])}else for(var p=0,f=r.length;p<f;p++){var m=r[p],v=this._data.get(m);null!=v&&i(v)&&o.push(v[this._idProp])}else if(n){for(var g=[],y=0,b=r.length;y<b;y++){var _=r[y];g.push(e.get(_))}this._sort(g,n);for(var w=0,k=g.length;w<k;w++)o.push(g[w][this._idProp])}else for(var x=0,D=r.length;x<D;x++){var S=r[x],C=e.get(S);null!=C&&o.push(C[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var i=e&&ig(e),n=this._data,r=Np(eP(n).call(n));if(e&&e.order)for(var o=this.get(e),s=0,a=o.length;s<a;s++){var l=o[s];t(l,l[this._idProp])}else for(var h=0,u=r.length;h<u;h++){var c=r[h],d=this._data.get(c);null==d||i&&!i(d)||t(d,c)}}},{key:"map",value:function(t,e){for(var i=e&&ig(e),n=[],r=this._data,o=Np(eP(r).call(r)),s=0,a=o.length;s<a;s++){var l=o[s],h=this._data.get(l);null==h||i&&!i(h)||n.push(t(h,l))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var i;return t?uM(i=tf(e)?e:gf(e)).call(i,(function(e,i){return e[i]=t[i],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var i=e;LE(t).call(t,(function(t,e){var n=t[i],r=e[i];return n>r?1:n<r?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");LE(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var i=[],n=[],r=tf(t)?t:[t],o=0,s=r.length;o<s;o++){var a=this._remove(r[o]);if(a){var l=a[this._idProp];null!=l&&(i.push(l),n.push(a))}}return i.length&&this._trigger("remove",{items:i,oldData:n},e),i}},{key:"_remove",value:function(t){var e;if(iI(t)?e=t:t&&"object"===Nd(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var i=this._data.get(e)||null;return this._data.delete(e),--this.length,i}return null}},{key:"clear",value:function(t){for(var e,i=Np(eP(e=this._data).call(e)),n=[],r=0,o=i.length;r<o;r++)n.push(this._data.get(i[r]));return this._data.clear(),this.length=0,this._trigger("remove",{items:i,oldData:n},t),i}},{key:"max",value:function(t){var e,i,n=null,r=null,o=JP(dP(e=this._data).call(e));try{for(o.s();!(i=o.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==r||a>r)&&(n=s,r=a)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,i,n=null,r=null,o=JP(dP(e=this._data).call(e));try{for(o.s();!(i=o.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==r||a<r)&&(n=s,r=a)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,i=Np(eP(e).call(e)),n=[],r=0,o=0,s=i.length;o<s;o++){for(var a=i[o],l=e.get(a)[t],h=!1,u=0;u<r;u++)if(n[u]==l){h=!0;break}h||void 0===l||(n[r]=l,r++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=qP()),t}(t,this._idProp),i=e[this._idProp];if(this._data.has(i))throw new Error("Cannot add item: item with id "+i+" already exists");return this._data.set(i,e),++this.length,i}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Dy(t)+")");var i=this._data.get(e);if(!i)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,ZP(ZP({},i),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new oI(Vd({},BO,qT.mark((function i(){var n,r,o,s;return qT.wrap((function(i){for(;;)switch(i.prev=i.next){case 0:n=JP(t),i.prev=1,n.s();case 3:if((r=n.n()).done){i.next=11;break}if(o=r.value,null==(s=e.get(o))){i.next=9;break}return i.next=9,[o,s];case 9:i.next=3;break;case 11:i.next=16;break;case 13:i.prev=13,i.t0=i.catch(1),n.e(i.t0);case 16:return i.prev=16,n.f(),i.finish(16);case 19:case"end":return i.stop()}}),i,null,[[1,13,16,19]])}))))}var i;return new oI(Vd({},BO,Uf(i=xP(this._data)).call(i,this._data)))}}]),i}(rI),aI=function(t){qk(i,t);var e=KP(i);function i(t,n){var r,o;return Sc(this,i),Vd(Ek(o=e.call(this)),"length",0),Vd(Ek(o),"_listener",void 0),Vd(Ek(o),"_data",void 0),Vd(Ek(o),"_ids",new HO),Vd(Ek(o),"_options",void 0),o._options=n||{},o._listener=Uf(r=o._onEvent).call(r,Ek(o)),o.setData(t),o}return Wd(i,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:ig(this._options)}),i=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:i})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:ig(this._options)}),r=0,o=n.length;r<o;r++){var s=n[r];this._ids.add(s)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new sI;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:ig(this._options)}),e=Np(this._ids),i={},n=[],r=[],o=[],s=0,a=t.length;s<a;s++){var l=t[s];i[l]=!0,this._ids.has(l)||(n.push(l),this._ids.add(l))}for(var h=0,u=e.length;h<u;h++){var c=e[h],d=this._data.get(c);null==d?console.error("If you see this, report it please."):i[c]||(r.push(c),o.push(d),this._ids.delete(c))}this.length+=n.length-r.length,n.length&&this._trigger("add",{items:n}),r.length&&this._trigger("remove",{items:r,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var i,n=null;iI(t)||tf(t)?(n=t,i=e):i=t;var r=fv({},this._options,i),o=ig(this._options),s=i&&ig(i);return o&&s&&(r.filter=function(t){return o(t)&&s(t)}),null==n?this._data.get(r):this._data.get(n,r)}},{key:"getIds",value:function(t){if(this._data.length){var e,i=ig(this._options),n=null!=t?ig(t):null;return e=n?i?function(t){return i(t)&&n(t)}:n:i,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var i,n,r=ig(this._options),o=e&&ig(e);n=o?r?function(t){return r(t)&&o(t)}:o:r,am(i=this._data).call(i,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var i,n,r=ig(this._options),o=e&&ig(e);return n=o?r?function(t){return r(t)&&o(t)}:o:r,cf(i=this._data).call(i,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Vd({},BO,Uf(e=eP(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",r={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=JP(Jp(i.prototype));try{for(o.s();!(e=o.n()).done;){var s=e.value;Dc(this,s,r)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,i){if(e&&e.items&&this._data){var n=e.items,r=[],o=[],s=[],a=[],l=[],h=[];switch(t){case"add":for(var u=0,c=n.length;u<c;u++){var d=n[u];this.get(d)&&(this._ids.add(d),r.push(d))}break;case"update":for(var p=0,f=n.length;p<f;p++){var m=n[p];this.get(m)?this._ids.has(m)?(o.push(m),l.push(e.data[p]),a.push(e.oldData[p])):(this._ids.add(m),r.push(m)):this._ids.has(m)&&(this._ids.delete(m),s.push(m),h.push(e.oldData[p]))}break;case"remove":for(var v=0,g=n.length;v<g;v++){var y=n[v];this._ids.has(y)&&(this._ids.delete(y),s.push(y),h.push(e.oldData[v]))}}this.length+=r.length-s.length,r.length&&this._trigger("add",{items:r},i),o.length&&this._trigger("update",{items:o,oldData:a,data:l},i),s.length&&this._trigger("remove",{items:s,oldData:h},i)}}}]),i}(rI);function lI(t,e){return"object"===Nd(e)&&null!==e&&t===e.idProp&&"function"==typeof am(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof cf(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&function(t,e){return"object"===Nd(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof am(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof cf(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}(t,e.getDataSet())}var hI="undefined"!=typeof window&&window.moment||h(),uI=n(h()),cI={},dI={get exports(){return cI},set exports(t){cI=t}},pI={},fI={},mI={get exports(){return fI},set exports(t){fI=t}},vI={};function gI(){var t={"align-content":!1,"align-items":!1,"align-self":!1,"alignment-adjust":!1,"alignment-baseline":!1,all:!1,"anchor-point":!1,animation:!1,"animation-delay":!1,"animation-direction":!1,"animation-duration":!1,"animation-fill-mode":!1,"animation-iteration-count":!1,"animation-name":!1,"animation-play-state":!1,"animation-timing-function":!1,azimuth:!1,"backface-visibility":!1,background:!0,"background-attachment":!0,"background-clip":!0,"background-color":!0,"background-image":!0,"background-origin":!0,"background-position":!0,"background-repeat":!0,"background-size":!0,"baseline-shift":!1,binding:!1,bleed:!1,"bookmark-label":!1,"bookmark-level":!1,"bookmark-state":!1,border:!0,"border-bottom":!0,"border-bottom-color":!0,"border-bottom-left-radius":!0,"border-bottom-right-radius":!0,"border-bottom-style":!0,"border-bottom-width":!0,"border-collapse":!0,"border-color":!0,"border-image":!0,"border-image-outset":!0,"border-image-repeat":!0,"border-image-slice":!0,"border-image-source":!0,"border-image-width":!0,"border-left":!0,"border-left-color":!0,"border-left-style":!0,"border-left-width":!0,"border-radius":!0,"border-right":!0,"border-right-color":!0,"border-right-style":!0,"border-right-width":!0,"border-spacing":!0,"border-style":!0,"border-top":!0,"border-top-color":!0,"border-top-left-radius":!0,"border-top-right-radius":!0,"border-top-style":!0,"border-top-width":!0,"border-width":!0,bottom:!1,"box-decoration-break":!0,"box-shadow":!0,"box-sizing":!0,"box-snap":!0,"box-suppress":!0,"break-after":!0,"break-before":!0,"break-inside":!0,"caption-side":!1,chains:!1,clear:!0,clip:!1,"clip-path":!1,"clip-rule":!1,color:!0,"color-interpolation-filters":!0,"column-count":!1,"column-fill":!1,"column-gap":!1,"column-rule":!1,"column-rule-color":!1,"column-rule-style":!1,"column-rule-width":!1,"column-span":!1,"column-width":!1,columns:!1,contain:!1,content:!1,"counter-increment":!1,"counter-reset":!1,"counter-set":!1,crop:!1,cue:!1,"cue-after":!1,"cue-before":!1,cursor:!1,direction:!1,display:!0,"display-inside":!0,"display-list":!0,"display-outside":!0,"dominant-baseline":!1,elevation:!1,"empty-cells":!1,filter:!1,flex:!1,"flex-basis":!1,"flex-direction":!1,"flex-flow":!1,"flex-grow":!1,"flex-shrink":!1,"flex-wrap":!1,float:!1,"float-offset":!1,"flood-color":!1,"flood-opacity":!1,"flow-from":!1,"flow-into":!1,font:!0,"font-family":!0,"font-feature-settings":!0,"font-kerning":!0,"font-language-override":!0,"font-size":!0,"font-size-adjust":!0,"font-stretch":!0,"font-style":!0,"font-synthesis":!0,"font-variant":!0,"font-variant-alternates":!0,"font-variant-caps":!0,"font-variant-east-asian":!0,"font-variant-ligatures":!0,"font-variant-numeric":!0,"font-variant-position":!0,"font-weight":!0,grid:!1,"grid-area":!1,"grid-auto-columns":!1,"grid-auto-flow":!1,"grid-auto-rows":!1,"grid-column":!1,"grid-column-end":!1,"grid-column-start":!1,"grid-row":!1,"grid-row-end":!1,"grid-row-start":!1,"grid-template":!1,"grid-template-areas":!1,"grid-template-columns":!1,"grid-template-rows":!1,"hanging-punctuation":!1,height:!0,hyphens:!1,icon:!1,"image-orientation":!1,"image-resolution":!1,"ime-mode":!1,"initial-letters":!1,"inline-box-align":!1,"justify-content":!1,"justify-items":!1,"justify-self":!1,left:!1,"letter-spacing":!0,"lighting-color":!0,"line-box-contain":!1,"line-break":!1,"line-grid":!1,"line-height":!1,"line-snap":!1,"line-stacking":!1,"line-stacking-ruby":!1,"line-stacking-shift":!1,"line-stacking-strategy":!1,"list-style":!0,"list-style-image":!0,"list-style-position":!0,"list-style-type":!0,margin:!0,"margin-bottom":!0,"margin-left":!0,"margin-right":!0,"margin-top":!0,"marker-offset":!1,"marker-side":!1,marks:!1,mask:!1,"mask-box":!1,"mask-box-outset":!1,"mask-box-repeat":!1,"mask-box-slice":!1,"mask-box-source":!1,"mask-box-width":!1,"mask-clip":!1,"mask-image":!1,"mask-origin":!1,"mask-position":!1,"mask-repeat":!1,"mask-size":!1,"mask-source-type":!1,"mask-type":!1,"max-height":!0,"max-lines":!1,"max-width":!0,"min-height":!0,"min-width":!0,"move-to":!1,"nav-down":!1,"nav-index":!1,"nav-left":!1,"nav-right":!1,"nav-up":!1,"object-fit":!1,"object-position":!1,opacity:!1,order:!1,orphans:!1,outline:!1,"outline-color":!1,"outline-offset":!1,"outline-style":!1,"outline-width":!1,overflow:!1,"overflow-wrap":!1,"overflow-x":!1,"overflow-y":!1,padding:!0,"padding-bottom":!0,"padding-left":!0,"padding-right":!0,"padding-top":!0,page:!1,"page-break-after":!1,"page-break-before":!1,"page-break-inside":!1,"page-policy":!1,pause:!1,"pause-after":!1,"pause-before":!1,perspective:!1,"perspective-origin":!1,pitch:!1,"pitch-range":!1,"play-during":!1,position:!1,"presentation-level":!1,quotes:!1,"region-fragment":!1,resize:!1,rest:!1,"rest-after":!1,"rest-before":!1,richness:!1,right:!1,rotation:!1,"rotation-point":!1,"ruby-align":!1,"ruby-merge":!1,"ruby-position":!1,"shape-image-threshold":!1,"shape-outside":!1,"shape-margin":!1,size:!1,speak:!1,"speak-as":!1,"speak-header":!1,"speak-numeral":!1,"speak-punctuation":!1,"speech-rate":!1,stress:!1,"string-set":!1,"tab-size":!1,"table-layout":!1,"text-align":!0,"text-align-last":!0,"text-combine-upright":!0,"text-decoration":!0,"text-decoration-color":!0,"text-decoration-line":!0,"text-decoration-skip":!0,"text-decoration-style":!0,"text-emphasis":!0,"text-emphasis-color":!0,"text-emphasis-position":!0,"text-emphasis-style":!0,"text-height":!0,"text-indent":!0,"text-justify":!0,"text-orientation":!0,"text-overflow":!0,"text-shadow":!0,"text-space-collapse":!0,"text-transform":!0,"text-underline-position":!0,"text-wrap":!0,top:!1,transform:!1,"transform-origin":!1,"transform-style":!1,transition:!1,"transition-delay":!1,"transition-duration":!1,"transition-property":!1,"transition-timing-function":!1,"unicode-bidi":!1,"vertical-align":!1,visibility:!1,"voice-balance":!1,"voice-duration":!1,"voice-family":!1,"voice-pitch":!1,"voice-range":!1,"voice-rate":!1,"voice-stress":!1,"voice-volume":!1,volume:!1,"white-space":!1,widows:!1,width:!0,"will-change":!1,"word-break":!0,"word-spacing":!0,"word-wrap":!0,"wrap-flow":!1,"wrap-through":!1,"writing-mode":!1,"z-index":!1};return t}var yI=/javascript\s*\:/gim;vI.whiteList=gI(),vI.getDefaultWhiteList=gI,vI.onAttr=function(t,e,i){},vI.onIgnoreAttr=function(t,e,i){},vI.safeAttrValue=function(t,e){return yI.test(e)?"":e};var bI={indexOf:function(t,e){var i,n;if(Array.prototype.indexOf)return t.indexOf(e);for(i=0,n=t.length;i<n;i++)if(t[i]===e)return i;return-1},forEach:function(t,e,i){var n,r;if(Array.prototype.forEach)return t.forEach(e,i);for(n=0,r=t.length;n<r;n++)e.call(i,t[n],n,t)},trim:function(t){return String.prototype.trim?t.trim():t.replace(/(^\s*)|(\s*$)/g,"")},trimRight:function(t){return String.prototype.trimRight?t.trimRight():t.replace(/(\s*$)/g,"")}};var _I=function(t,e){";"!==(t=bI.trimRight(t))[t.length-1]&&(t+=";");var i=t.length,n=!1,r=0,o=0,s="";function a(){if(!n){var i=bI.trim(t.slice(r,o)),a=i.indexOf(":");if(-1!==a){var l=bI.trim(i.slice(0,a)),h=bI.trim(i.slice(a+1));if(l){var u=e(r,s.length,l,h,i);u&&(s+=u+"; ")}}}r=o+1}for(;o<i;o++){var l=t[o];if("/"===l&&"*"===t[o+1]){var h=t.indexOf("*/",o+2);if(-1===h)break;r=(o=h+1)+1,n=!1}else"("===l?n=!0:")"===l?n=!1:";"===l?n||a():"\n"===l&&a()}return bI.trim(s)},wI=vI,kI=_I;function xI(t){return null==t}function DI(t){(t=function(t){var e={};for(var i in t)e[i]=t[i];return e}(t||{})).whiteList=t.whiteList||wI.whiteList,t.onAttr=t.onAttr||wI.onAttr,t.onIgnoreAttr=t.onIgnoreAttr||wI.onIgnoreAttr,t.safeAttrValue=t.safeAttrValue||wI.safeAttrValue,this.options=t}DI.prototype.process=function(t){if(!(t=(t=t||"").toString()))return"";var e=this.options,i=e.whiteList,n=e.onAttr,r=e.onIgnoreAttr,o=e.safeAttrValue,s=kI(t,(function(t,e,s,a,l){var h=i[s],u=!1;if(!0===h?u=h:"function"==typeof h?u=h(a):h instanceof RegExp&&(u=h.test(a)),!0!==u&&(u=!1),a=o(s,a)){var c,d={position:e,sourcePosition:t,source:l,isWhite:u};return u?xI(c=n(s,a,d))?s+":"+a:c:xI(c=r(s,a,d))?void 0:c}}));return s};var SI=DI;!function(t,e){var i=vI,n=SI;for(var r in e=t.exports=function(t,e){return new n(e).process(t)},e.FilterCSS=n,i)e[r]=i[r];"undefined"!=typeof window&&(window.filterCSS=t.exports)}(mI,fI);var CI={indexOf:function(t,e){var i,n;if(Array.prototype.indexOf)return t.indexOf(e);for(i=0,n=t.length;i<n;i++)if(t[i]===e)return i;return-1},forEach:function(t,e,i){var n,r;if(Array.prototype.forEach)return t.forEach(e,i);for(n=0,r=t.length;n<r;n++)e.call(i,t[n],n,t)},trim:function(t){return String.prototype.trim?t.trim():t.replace(/(^\s*)|(\s*$)/g,"")},spaceIndex:function(t){var e=/\s|\n|\t/.exec(t);return e?e.index:-1}},TI=fI.FilterCSS,MI=fI.getDefaultWhiteList,OI=CI;function EI(){return{a:["target","href","title"],abbr:["title"],address:[],area:["shape","coords","href","alt"],article:[],aside:[],audio:["autoplay","controls","crossorigin","loop","muted","preload","src"],b:[],bdi:["dir"],bdo:["dir"],big:[],blockquote:["cite"],br:[],caption:[],center:[],cite:[],code:[],col:["align","valign","span","width"],colgroup:["align","valign","span","width"],dd:[],del:["datetime"],details:["open"],div:[],dl:[],dt:[],em:[],figcaption:[],figure:[],font:["color","size","face"],footer:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],hr:[],i:[],img:["src","alt","title","width","height"],ins:["datetime"],li:[],mark:[],nav:[],ol:[],p:[],pre:[],s:[],section:[],small:[],span:[],sub:[],summary:[],sup:[],strong:[],strike:[],table:["width","border","align","valign"],tbody:["align","valign"],td:["width","rowspan","colspan","align","valign"],tfoot:["align","valign"],th:["width","rowspan","colspan","align","valign"],thead:["align","valign"],tr:["rowspan","align","valign"],tt:[],u:[],ul:[],video:["autoplay","controls","crossorigin","loop","muted","playsinline","poster","preload","src","height","width"]}}var PI=new TI;function II(t){return t.replace(AI,"&lt;").replace(LI,"&gt;")}var AI=/</g,LI=/>/g,NI=/"/g,RI=/&quot;/g,FI=/&#([a-zA-Z0-9]*);?/gim,jI=/&colon;?/gim,YI=/&newline;?/gim,HI=/((j\s*a\s*v\s*a|v\s*b|l\s*i\s*v\s*e)\s*s\s*c\s*r\s*i\s*p\s*t\s*|m\s*o\s*c\s*h\s*a):/gi,zI=/e\s*x\s*p\s*r\s*e\s*s\s*s\s*i\s*o\s*n\s*\(.*/gi,BI=/u\s*r\s*l\s*\(.*/gi;function GI(t){return t.replace(NI,"&quot;")}function WI(t){return t.replace(RI,'"')}function VI(t){return t.replace(FI,(function(t,e){return"x"===e[0]||"X"===e[0]?String.fromCharCode(parseInt(e.substr(1),16)):String.fromCharCode(parseInt(e,10))}))}function UI(t){return t.replace(jI,":").replace(YI," ")}function XI(t){for(var e="",i=0,n=t.length;i<n;i++)e+=t.charCodeAt(i)<32?" ":t.charAt(i);return OI.trim(e)}function qI(t){return t=XI(t=UI(t=VI(t=WI(t))))}function $I(t){return t=II(t=GI(t))}pI.whiteList={a:["target","href","title"],abbr:["title"],address:[],area:["shape","coords","href","alt"],article:[],aside:[],audio:["autoplay","controls","crossorigin","loop","muted","preload","src"],b:[],bdi:["dir"],bdo:["dir"],big:[],blockquote:["cite"],br:[],caption:[],center:[],cite:[],code:[],col:["align","valign","span","width"],colgroup:["align","valign","span","width"],dd:[],del:["datetime"],details:["open"],div:[],dl:[],dt:[],em:[],figcaption:[],figure:[],font:["color","size","face"],footer:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],hr:[],i:[],img:["src","alt","title","width","height"],ins:["datetime"],li:[],mark:[],nav:[],ol:[],p:[],pre:[],s:[],section:[],small:[],span:[],sub:[],summary:[],sup:[],strong:[],strike:[],table:["width","border","align","valign"],tbody:["align","valign"],td:["width","rowspan","colspan","align","valign"],tfoot:["align","valign"],th:["width","rowspan","colspan","align","valign"],thead:["align","valign"],tr:["rowspan","align","valign"],tt:[],u:[],ul:[],video:["autoplay","controls","crossorigin","loop","muted","playsinline","poster","preload","src","height","width"]},pI.getDefaultWhiteList=EI,pI.onTag=function(t,e,i){},pI.onIgnoreTag=function(t,e,i){},pI.onTagAttr=function(t,e,i){},pI.onIgnoreTagAttr=function(t,e,i){},pI.safeAttrValue=function(t,e,i,n){if(i=qI(i),"href"===e||"src"===e){if("#"===(i=OI.trim(i)))return"#";if("http://"!==i.substr(0,7)&&"https://"!==i.substr(0,8)&&"mailto:"!==i.substr(0,7)&&"tel:"!==i.substr(0,4)&&"data:image/"!==i.substr(0,11)&&"ftp://"!==i.substr(0,6)&&"./"!==i.substr(0,2)&&"../"!==i.substr(0,3)&&"#"!==i[0]&&"/"!==i[0])return""}else if("background"===e){if(HI.lastIndex=0,HI.test(i))return""}else if("style"===e){if(zI.lastIndex=0,zI.test(i))return"";if(BI.lastIndex=0,BI.test(i)&&(HI.lastIndex=0,HI.test(i)))return"";!1!==n&&(i=(n=n||PI).process(i))}return i=$I(i)},pI.escapeHtml=II,pI.escapeQuote=GI,pI.unescapeQuote=WI,pI.escapeHtmlEntities=VI,pI.escapeDangerHtml5Entities=UI,pI.clearNonPrintableCharacter=XI,pI.friendlyAttrValue=qI,pI.escapeAttrValue=$I,pI.onIgnoreTagStripAll=function(){return""},pI.StripTagBody=function(t,e){"function"!=typeof e&&(e=function(){});var i=!Array.isArray(t),n=[],r=!1;return{onIgnoreTag:function(o,s,a){if(function(e){return!!i||-1!==OI.indexOf(t,e)}(o)){if(a.isClosing){var l="[/removed]",h=a.position+l.length;return n.push([!1!==r?r:a.position,h]),r=!1,l}return r||(r=a.position),"[removed]"}return e(o,s,a)},remove:function(t){var e="",i=0;return OI.forEach(n,(function(n){e+=t.slice(i,n[0]),i=n[1]})),e+=t.slice(i)}}},pI.stripCommentTag=function(t){for(var e="",i=0;i<t.length;){var n=t.indexOf("\x3c!--",i);if(-1===n){e+=t.slice(i);break}e+=t.slice(i,n);var r=t.indexOf("--\x3e",n);if(-1===r)break;i=r+3}return e},pI.stripBlankChar=function(t){var e=t.split("");return(e=e.filter((function(t){var e=t.charCodeAt(0);return 127!==e&&(!(e<=31)||(10===e||13===e))}))).join("")},pI.cssFilter=PI,pI.getDefaultCSSWhiteList=MI;var ZI={},KI=CI;function JI(t){var e,i=KI.spaceIndex(t);return e=-1===i?t.slice(1,-1):t.slice(1,i+1),"/"===(e=KI.trim(e).toLowerCase()).slice(0,1)&&(e=e.slice(1)),"/"===e.slice(-1)&&(e=e.slice(0,-1)),e}function QI(t){return"</"===t.slice(0,2)}var tA=/[^a-zA-Z0-9\\_:.-]/gim;function eA(t,e){for(;e<t.length;e++){var i=t[e];if(" "!==i)return"="===i?e:-1}}function iA(t,e){for(;e<t.length;e++){var i=t[e];if(" "!==i)return"'"===i||'"'===i?e:-1}}function nA(t,e){for(;e>0;e--){var i=t[e];if(" "!==i)return"="===i?e:-1}}function rA(t){return function(t){return'"'===t[0]&&'"'===t[t.length-1]||"'"===t[0]&&"'"===t[t.length-1]}(t)?t.substr(1,t.length-2):t}ZI.parseTag=function(t,e,i){var n="",r=0,o=!1,s=!1,a=0,l=t.length,h="",u="";t:for(a=0;a<l;a++){var c=t.charAt(a);if(!1===o){if("<"===c){o=a;continue}}else if(!1===s){if("<"===c){n+=i(t.slice(r,a)),o=a,r=a;continue}if(">"===c||a===l-1){n+=i(t.slice(r,o)),h=JI(u=t.slice(o,a+1)),n+=e(o,n.length,h,u,QI(u)),r=a+1,o=!1;continue}if('"'===c||"'"===c)for(var d=1,p=t.charAt(a-d);""===p.trim()||"="===p;){if("="===p){s=c;continue t}p=t.charAt(a-++d)}}else if(c===s){s=!1;continue}}return r<l&&(n+=i(t.substr(r))),n},ZI.parseAttr=function(t,e){var i=0,n=0,r=[],o=!1,s=t.length;function a(t,i){if(!((t=(t=KI.trim(t)).replace(tA,"").toLowerCase()).length<1)){var n=e(t,i||"");n&&r.push(n)}}for(var l=0;l<s;l++){var h,u=t.charAt(l);if(!1!==o||"="!==u)if(!1===o||l!==n)if(/\s|\n|\t/.test(u)){if(t=t.replace(/\s|\n|\t/g," "),!1===o){if(-1===(h=eA(t,l))){a(KI.trim(t.slice(i,l))),o=!1,i=l+1;continue}l=h-1;continue}if(-1===(h=nA(t,l-1))){a(o,rA(KI.trim(t.slice(i,l)))),o=!1,i=l+1;continue}}else;else{if(-1===(h=t.indexOf(u,l+1)))break;a(o,KI.trim(t.slice(n+1,h))),o=!1,i=(l=h)+1}else o=t.slice(i,l),i=l+1,n='"'===t.charAt(i)||"'"===t.charAt(i)?i:iA(t,l+1)}return i<t.length&&(!1===o?a(t.slice(i)):a(o,rA(KI.trim(t.slice(i))))),KI.trim(r.join(" "))};var oA=fI.FilterCSS,sA=pI,aA=ZI,lA=aA.parseTag,hA=aA.parseAttr,uA=CI;function cA(t){return null==t}function dA(t){(t=function(t){var e={};for(var i in t)e[i]=t[i];return e}(t||{})).stripIgnoreTag&&(t.onIgnoreTag&&console.error('Notes: cannot use these two options "stripIgnoreTag" and "onIgnoreTag" at the same time'),t.onIgnoreTag=sA.onIgnoreTagStripAll),t.whiteList||t.allowList?t.whiteList=function(t){var e={};for(var i in t)Array.isArray(t[i])?e[i.toLowerCase()]=t[i].map((function(t){return t.toLowerCase()})):e[i.toLowerCase()]=t[i];return e}(t.whiteList||t.allowList):t.whiteList=sA.whiteList,t.onTag=t.onTag||sA.onTag,t.onTagAttr=t.onTagAttr||sA.onTagAttr,t.onIgnoreTag=t.onIgnoreTag||sA.onIgnoreTag,t.onIgnoreTagAttr=t.onIgnoreTagAttr||sA.onIgnoreTagAttr,t.safeAttrValue=t.safeAttrValue||sA.safeAttrValue,t.escapeHtml=t.escapeHtml||sA.escapeHtml,this.options=t,!1===t.css?this.cssFilter=!1:(t.css=t.css||{},this.cssFilter=new oA(t.css))}dA.prototype.process=function(t){if(!(t=(t=t||"").toString()))return"";var e=this.options,i=e.whiteList,n=e.onTag,r=e.onIgnoreTag,o=e.onTagAttr,s=e.onIgnoreTagAttr,a=e.safeAttrValue,l=e.escapeHtml,h=this.cssFilter;e.stripBlankChar&&(t=sA.stripBlankChar(t)),e.allowCommentTag||(t=sA.stripCommentTag(t));var u=!1;e.stripIgnoreTagBody&&(u=sA.StripTagBody(e.stripIgnoreTagBody,r),r=u.onIgnoreTag);var c=lA(t,(function(t,e,u,c,d){var p={sourcePosition:t,position:e,isClosing:d,isWhite:Object.prototype.hasOwnProperty.call(i,u)},f=n(u,c,p);if(!cA(f))return f;if(p.isWhite){if(p.isClosing)return"</"+u+">";var m=function(t){var e=uA.spaceIndex(t);if(-1===e)return{html:"",closing:"/"===t[t.length-2]};var i="/"===(t=uA.trim(t.slice(e+1,-1)))[t.length-1];return i&&(t=uA.trim(t.slice(0,-1))),{html:t,closing:i}}(c),v=i[u],g=hA(m.html,(function(t,e){var i=-1!==uA.indexOf(v,t),n=o(u,t,e,i);return cA(n)?i?(e=a(u,t,e,h))?t+'="'+e+'"':t:cA(n=s(u,t,e,i))?void 0:n:n}));return c="<"+u,g&&(c+=" "+g),m.closing&&(c+=" /"),c+=">"}return cA(f=r(u,c,p))?l(c):f}),l);return u&&(c=u.remove(c)),c};var pA=dA;!function(t,e){var i=pI,n=ZI,r=pA;function o(t,e){return new r(e).process(t)}(e=t.exports=o).filterXSS=o,e.FilterXSS=r,function(){for(var t in i)e[t]=i[t];for(var r in n)e[r]=n[r]}(),"undefined"!=typeof window&&(window.filterXSS=t.exports),"undefined"!=typeof self&&"undefined"!=typeof DedicatedWorkerGlobalScope&&self instanceof DedicatedWorkerGlobalScope&&(self.filterXSS=t.exports)}(dI,cI);var fA=cI;function mA(t,e){var i=gf(t);if(Ou){var n=Ou(t);e&&(n=ig(n).call(n,(function(e){return Bu(t,e).enumerable}))),i.push.apply(i,n)}return i}function vA(t){for(var e=1;e<arguments.length;e++){var i,n,r=null!=arguments[e]?arguments[e]:{};e%2?am(i=mA(Object(r),!0)).call(i,(function(e){Vd(t,e,r[e])})):ic?pc(t,ic(r)):am(n=mA(Object(r))).call(n,(function(e){Dc(t,e,Bu(r,e))}))}return t}function gA(t){var e;if(!t)return!1;var i=null!==(e=t.idProp)&&void 0!==e?e:t._idProp;return!!i&&lI(i,t)}var yA=/^\/?Date\((-?\d+)/i,bA=/^\d+$/;function _A(t,e){var i;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return Fw(t)&&!isNaN(Date.parse(t))?uI(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":try{return _A(t,"Moment").toDate()}catch(i){throw i instanceof TypeError?new TypeError("Cannot convert object of type "+Bw(t)+" to type "+e):i}case"Moment":if(Rw(t))return uI(t);if(t instanceof Date)return uI(t.valueOf());if(uI.isMoment(t))return uI(t);if(Fw(t))return(i=yA.exec(t))?uI(Number(i[1])):(i=bA.exec(t),uI(i?Number(t):t));throw new TypeError("Cannot convert object of type "+Bw(t)+" to type "+e);case"ISODate":if(Rw(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(uI.isMoment(t))return t.toDate().toISOString();if(Fw(t))return(i=yA.exec(t))?new Date(Number(i[1])).toISOString():uI(t).format();throw new Error("Cannot convert object of type "+Bw(t)+" to type ISODate");case"ASPDate":if(Rw(t))return"/Date("+t+")/";if(t instanceof Date||uI.isMoment(t))return"/Date("+t.valueOf()+")/";if(Fw(t))return"/Date("+((i=yA.exec(t))?new Date(Number(i[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+Bw(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function wA(t){var e,i,n,r,o,s,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{start:"Date",end:"Date"},l=t._idProp,h=new sI({fieldId:l}),u=cf(e=function(t){return new eI(t)}(t)).call(e,(function(t){var e;return uM(e=gf(t)).call(e,(function(e,i){return e[i]=_A(t[i],a[i]),e}),{})})).to(h);return u.all().start(),{add:function(){var e;return(e=t.getDataSet()).add.apply(e,arguments)},remove:function(){var e;return(e=t.getDataSet()).remove.apply(e,arguments)},update:function(){var e;return(e=t.getDataSet()).update.apply(e,arguments)},updateOnly:function(){var e;return(e=t.getDataSet()).updateOnly.apply(e,arguments)},clear:function(){var e;return(e=t.getDataSet()).clear.apply(e,arguments)},forEach:Uf(i=am(h)).call(i,h),get:Uf(n=h.get).call(n,h),getIds:Uf(r=h.getIds).call(r,h),off:Uf(o=h.off).call(o,h),on:Uf(s=h.on).call(s,h),get length(){return h.length},idProp:l,type:a,rawDS:t,coercedDS:h,dispose:function(){return u.stop()}}}var kA=function(t){var e=new fA.FilterXSS(t);return function(t){return e.process(t)}},xA=function(t){return t},DA=kA(),SA=vA(vA({},_k),{},{convert:_A,setupXSSProtection:function(t){t&&(!0===t.disabled?(DA=xA,console.warn("You disabled XSS protection for vis-Timeline. I sure hope you know what you're doing!")):t.filterOptions&&(DA=kA(t.filterOptions)))}});Dc(SA,"xss",{get:function(){return DA}});var CA={},TA={get exports(){return CA},set exports(t){CA=t}},MA=D,OA=d,EA=Rt,PA=Sg.trim,IA=gg,AA=y("".charAt),LA=MA.parseFloat,NA=MA.Symbol,RA=NA&&NA.iterator,FA=1/LA(IA+"-0")!=-1/0||RA&&!OA((function(){LA(Object(RA))}))?function(t){var e=PA(EA(t)),i=LA(e);return 0===i&&"-"==AA(e,0)?-0:i}:LA;In({global:!0,forced:parseFloat!=FA},{parseFloat:FA});var jA=fe.parseFloat;!function(t){t.exports=jA}(TA);var YA=n(CA),HA=function(){function t(e,i){Sc(this,t),this.options=null,this.props=null}return Wd(t,[{key:"setOptions",value:function(t){t&&SA.extend(this.options,t)}},{key:"redraw",value:function(){return!1}},{key:"destroy",value:function(){}},{key:"_isResized",value:function(){var t=this.props._previousWidth!==this.props.width||this.props._previousHeight!==this.props.height;return this.props._previousWidth=this.props.width,this.props._previousHeight=this.props.height,t}}]),t}(),zA={},BA={get exports(){return zA},set exports(t){zA=t}},GA=k,WA=Rt,VA=j,UA=RangeError;In({target:"String",proto:!0},{repeat:function(t){var e=WA(VA(this)),i="",n=GA(t);if(n<0||n==1/0)throw UA("Wrong number of repetitions");for(;n>0;(n>>>=1)&&(e+=e))1&n&&(i+=e);return i}});var XA=yp("String").repeat,qA=_e,$A=XA,ZA=String.prototype,KA=function(t){var e=t.repeat;return"string"==typeof t||t===ZA||qA(ZA,t)&&e===ZA.repeat?$A:e},JA=KA;!function(t){t.exports=JA}(BA);var QA=n(zA);function tL(t,e,i){if(i&&!tf(i))return tL(t,e,[i]);if(e.hiddenDates=[],i&&1==tf(i)){for(var n,r=0;r<i.length;r++)if(void 0===QA(i[r])){var o={};o.start=t(i[r].start).toDate().valueOf(),o.end=t(i[r].end).toDate().valueOf(),e.hiddenDates.push(o)}LE(n=e.hiddenDates).call(n,(function(t,e){return t.start-e.start}))}}function eL(t,e,i){if(i&&!tf(i))return eL(t,e,[i]);if(i&&void 0!==e.domProps.centerContainer.width){tL(t,e,i);for(var n=t(e.range.start),r=t(e.range.end),o=(e.range.end-e.range.start)/e.domProps.centerContainer.width,s=0;s<i.length;s++)if(void 0!==QA(i[s])){var a=t(i[s].start),l=t(i[s].end);if("Invalid Date"==a._d)throw new Error("Supplied start date is not valid: ".concat(i[s].start));if("Invalid Date"==l._d)throw new Error("Supplied end date is not valid: ".concat(i[s].end));if(l-a>=4*o){var h=0,u=r.clone();switch(QA(i[s])){case"daily":a.day()!=l.day()&&(h=1),a.dayOfYear(n.dayOfYear()),a.year(n.year()),a.subtract(7,"days"),l.dayOfYear(n.dayOfYear()),l.year(n.year()),l.subtract(7-h,"days"),u.add(1,"weeks");break;case"weekly":var c=l.diff(a,"days"),d=a.day();a.date(n.date()),a.month(n.month()),a.year(n.year()),l=a.clone(),a.day(d),l.day(d),l.add(c,"days"),a.subtract(1,"weeks"),l.subtract(1,"weeks"),u.add(1,"weeks");break;case"monthly":a.month()!=l.month()&&(h=1),a.month(n.month()),a.year(n.year()),a.subtract(1,"months"),l.month(n.month()),l.year(n.year()),l.subtract(1,"months"),l.add(h,"months"),u.add(1,"months");break;case"yearly":a.year()!=l.year()&&(h=1),a.year(n.year()),a.subtract(1,"years"),l.year(n.year()),l.subtract(1,"years"),l.add(h,"years"),u.add(1,"years");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",QA(i[s]))}for(;a<u;)switch(e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()}),QA(i[s])){case"daily":a.add(1,"days"),l.add(1,"days");break;case"weekly":a.add(1,"weeks"),l.add(1,"weeks");break;case"monthly":a.add(1,"months"),l.add(1,"months");break;case"yearly":a.add(1,"y"),l.add(1,"y");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",QA(i[s]))}e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()})}}iL(e);var p=dL(e.range.start,e.hiddenDates),f=dL(e.range.end,e.hiddenDates),m=e.range.start,v=e.range.end;1==p.hidden&&(m=1==e.range.startToFront?p.startDate-1:p.endDate+1),1==f.hidden&&(v=1==e.range.endToFront?f.startDate-1:f.endDate+1),1!=p.hidden&&1!=f.hidden||e.range._applyRange(m,v)}}function iL(t){for(var e,i=t.hiddenDates,n=[],r=0;r<i.length;r++)for(var o=0;o<i.length;o++)r!=o&&1!=i[o].remove&&1!=i[r].remove&&(i[o].start>=i[r].start&&i[o].end<=i[r].end?i[o].remove=!0:i[o].start>=i[r].start&&i[o].start<=i[r].end?(i[r].end=i[o].end,i[o].remove=!0):i[o].end>=i[r].start&&i[o].end<=i[r].end&&(i[r].start=i[o].start,i[o].remove=!0));for(r=0;r<i.length;r++)!0!==i[r].remove&&n.push(i[r]);t.hiddenDates=n,LE(e=t.hiddenDates).call(e,(function(t,e){return t.start-e.start}))}function nL(t,e,i){for(var n=!1,r=e.current.valueOf(),o=0;o<e.hiddenDates.length;o++){var s=e.hiddenDates[o].start,a=e.hiddenDates[o].end;if(r>=s&&r<a){n=!0;break}}if(1==n&&r<e._end.valueOf()&&r!=i){var l=t(i),h=t(a);l.year()!=h.year()?e.switchedYear=!0:l.month()!=h.month()?e.switchedMonth=!0:l.dayOfYear()!=h.dayOfYear()&&(e.switchedDay=!0),e.current=h}}function rL(t,e,i){var n;if(0==t.body.hiddenDates.length)return n=t.range.conversion(i),(e.valueOf()-n.offset)*n.scale;var r=dL(e,t.body.hiddenDates);1==r.hidden&&(e=r.startDate);var o=sL(t.body.hiddenDates,t.range.start,t.range.end);if(e<t.range.start){n=t.range.conversion(i,o);var s=aL(t.body.hiddenDates,e,n.offset);return e=t.options.moment(e).toDate().valueOf(),e+=s,-(n.offset-e.valueOf())*n.scale}if(e>t.range.end){var a={start:t.range.start,end:e};return e=lL(t.options.moment,t.body.hiddenDates,a,e),n=t.range.conversion(i,o),(e.valueOf()-n.offset)*n.scale}return e=lL(t.options.moment,t.body.hiddenDates,t.range,e),n=t.range.conversion(i,o),(e.valueOf()-n.offset)*n.scale}function oL(t,e,i){if(0==t.body.hiddenDates.length){var n=t.range.conversion(i);return new Date(e/n.scale+n.offset)}var r=sL(t.body.hiddenDates,t.range.start,t.range.end),o=(t.range.end-t.range.start-r)*e/i,s=uL(t.body.hiddenDates,t.range,o);return new Date(s+o+t.range.start)}function sL(t,e,i){for(var n=0,r=0;r<t.length;r++){var o=t[r].start,s=t[r].end;o>=e&&s<i&&(n+=s-o)}return n}function aL(t,e,i){for(var n=0,r=0;r<t.length;r++){var o=t[r].start,s=t[r].end;o>=e&&s<=i&&(n+=s-o)}return n}function lL(t,e,i,n){return n=t(n).toDate().valueOf(),n-=hL(t,e,i,n)}function hL(t,e,i,n){var r=0;n=t(n).toDate().valueOf();for(var o=0;o<e.length;o++){var s=e[o].start,a=e[o].end;s>=i.start&&a<i.end&&n>=a&&(r+=a-s)}return r}function uL(t,e,i){for(var n=0,r=0,o=e.start,s=0;s<t.length;s++){var a=t[s].start,l=t[s].end;if(a>=e.start&&l<e.end){if(r+=a-o,o=l,r>=i)break;n+=l-a}}return n}function cL(t,e,i,n){var r=dL(e,t);return 1==r.hidden?i<0?1==n?r.startDate-(r.endDate-e)-1:r.startDate-1:1==n?r.endDate+(e-r.startDate)+1:r.endDate+1:e}function dL(t,e){for(var i=0;i<e.length;i++){var n=e[i].start,r=e[i].end;if(t>=n&&t<r)return{hidden:!0,startDate:n,endDate:r}}return{hidden:!1,startDate:n,endDate:r}}var pL=Object.freeze({__proto__:null,convertHiddenOptions:tL,correctTimeForHidden:lL,getAccumulatedHiddenDuration:uL,getHiddenDurationBefore:hL,getHiddenDurationBeforeStart:aL,getHiddenDurationBetween:sL,getIsHidden:dL,printDates:function(t){for(var e=0;e<t.length;e++)console.log(e,new Date(t[e].start),new Date(t[e].end),t[e].start,t[e].end,t[e].remove)},removeDuplicates:iL,snapAwayFromHidden:cL,stepOverHiddenDates:nL,toScreen:rL,toTime:oL,updateHiddenDates:eL});function fL(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}var mL=function(t){qk(i,t);var e=fL(i);function i(t,n){var r,o,s,a,l,h,u,c;Sc(this,i),c=e.call(this);var d=hI().hours(0).minutes(0).seconds(0).milliseconds(0),p=d.clone().add(-3,"days").valueOf(),f=d.clone().add(3,"days").valueOf();return c.millisecondsPerPixelCache=void 0,void 0===n?(c.start=p,c.end=f):(c.start=n.start||p,c.end=n.end||f),c.rolling=!1,c.body=t,c.deltaDifference=0,c.scaleOffset=0,c.startToFront=!1,c.endToFront=!0,c.defaultOptions={rtl:!1,start:null,end:null,moment:hI,direction:"horizontal",moveable:!0,zoomable:!0,min:null,max:null,zoomMin:10,zoomMax:31536e10,rollingMode:{follow:!1,offset:.5}},c.options=SA.extend({},c.defaultOptions),c.props={touch:{}},c.animationTimer=null,c.body.emitter.on("panstart",Uf(r=c._onDragStart).call(r,Ek(c))),c.body.emitter.on("panmove",Uf(o=c._onDrag).call(o,Ek(c))),c.body.emitter.on("panend",Uf(s=c._onDragEnd).call(s,Ek(c))),c.body.emitter.on("mousewheel",Uf(a=c._onMouseWheel).call(a,Ek(c))),c.body.emitter.on("touch",Uf(l=c._onTouch).call(l,Ek(c))),c.body.emitter.on("pinch",Uf(h=c._onPinch).call(h,Ek(c))),c.body.dom.rollingModeBtn.addEventListener("click",Uf(u=c.startRolling).call(u,Ek(c))),c.setOptions(n),c}return Wd(i,[{key:"setOptions",value:function(t){if(t){SA.selectiveExtend(["animation","direction","min","max","zoomMin","zoomMax","moveable","zoomable","moment","activate","hiddenDates","zoomKey","zoomFriction","rtl","showCurrentTime","rollingMode","horizontalScroll"],this.options,t),t.rollingMode&&t.rollingMode.follow&&this.startRolling(),("start"in t||"end"in t)&&this.setRange(t.start,t.end)}}},{key:"startRolling",value:function(){var t=this;!function e(){t.stopRolling(),t.rolling=!0;var i=t.end-t.start,n=SA.convert(new Date,"Date").valueOf(),r=t.options.rollingMode&&t.options.rollingMode.offset||.5,o=n-i*r,s=n+i*(1-r);t.setRange(o,s,{animation:!1}),(i=1/t.conversion(t.body.domProps.center.width).scale/10)<30&&(i=30),i>1e3&&(i=1e3),t.body.dom.rollingModeBtn.style.visibility="hidden",t.currentTimeTimer=Xy(e,i)}()}},{key:"stopRolling",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),this.rolling=!1,this.body.dom.rollingModeBtn.style.visibility="visible")}},{key:"setRange",value:function(t,e,i,n,r){i||(i={}),!0!==i.byUser&&(i.byUser=!1);var o=this,s=null!=t?SA.convert(t,"Date").valueOf():null,a=null!=e?SA.convert(e,"Date").valueOf():null;if(this._cancelAnimation(),this.millisecondsPerPixelCache=void 0,i.animation){var l,h=this.start,u=this.end,c="object"===Nd(i.animation)&&"duration"in i.animation?i.animation.duration:500,d="object"===Nd(i.animation)&&"easingFunction"in i.animation?i.animation.easingFunction:"easeInOutQuad",p=SA.easingFunctions[d];if(!p)throw new Error(Up(l="Unknown easing function ".concat(Dy(d),". Choose from: ")).call(l,gf(SA.easingFunctions).join(", ")));var f=Df(),m=!1;return function t(){if(!o.props.touch.dragging){var e=Df()-f,l=p(e/c),d=e>c,g=d||null===s?s:h+(s-h)*l,y=d||null===a?a:u+(a-u)*l;v=o._applyRange(g,y),eL(o.options.moment,o.body,o.options.hiddenDates),m=m||v;var b={start:new Date(o.start),end:new Date(o.end),byUser:i.byUser,event:i.event};if(r&&r(l,v,d),v&&o.body.emitter.emit("rangechange",b),d){if(m&&(o.body.emitter.emit("rangechanged",b),n))return n()}else o.animationTimer=Xy(t,20)}}()}var v=this._applyRange(s,a);if(eL(this.options.moment,this.body,this.options.hiddenDates),v){var g={start:new Date(this.start),end:new Date(this.end),byUser:i.byUser,event:i.event};if(this.body.emitter.emit("rangechange",g),clearTimeout(o.timeoutID),o.timeoutID=Xy((function(){o.body.emitter.emit("rangechanged",g)}),200),n)return n()}}},{key:"getMillisecondsPerPixel",value:function(){return void 0===this.millisecondsPerPixelCache&&(this.millisecondsPerPixelCache=(this.end-this.start)/this.body.dom.center.clientWidth),this.millisecondsPerPixelCache}},{key:"_cancelAnimation",value:function(){this.animationTimer&&(clearTimeout(this.animationTimer),this.animationTimer=null)}},{key:"_applyRange",value:function(t,e){var i,n=null!=t?SA.convert(t,"Date").valueOf():this.start,r=null!=e?SA.convert(e,"Date").valueOf():this.end,o=null!=this.options.max?SA.convert(this.options.max,"Date").valueOf():null,s=null!=this.options.min?SA.convert(this.options.min,"Date").valueOf():null;if(isNaN(n)||null===n)throw new Error('Invalid start "'.concat(t,'"'));if(isNaN(r)||null===r)throw new Error('Invalid end "'.concat(e,'"'));if(r<n&&(r=n),null!==s&&n<s&&(n+=i=s-n,r+=i,null!=o&&r>o&&(r=o)),null!==o&&r>o&&(n-=i=r-o,r-=i,null!=s&&n<s&&(n=s)),null!==this.options.zoomMin){var a=YA(this.options.zoomMin);if(a<0&&(a=0),r-n<a){this.end-this.start===a&&n>=this.start-.5&&r<=this.end?(n=this.start,r=this.end):(n-=(i=a-(r-n))/2,r+=i/2)}}if(null!==this.options.zoomMax){var l=YA(this.options.zoomMax);l<0&&(l=0),r-n>l&&(this.end-this.start===l&&n<this.start&&r>this.end?(n=this.start,r=this.end):(n+=(i=r-n-l)/2,r-=i/2))}var h=this.start!=n||this.end!=r;return n>=this.start&&n<=this.end||r>=this.start&&r<=this.end||this.start>=n&&this.start<=r||this.end>=n&&this.end<=r||this.body.emitter.emit("checkRangedItems"),this.start=n,this.end=r,h}},{key:"getRange",value:function(){return{start:this.start,end:this.end}}},{key:"conversion",value:function(t,e){return i.conversion(this.start,this.end,t,e)}},{key:"_onDragStart",value:function(t){this.deltaDifference=0,this.previousDelta=0,this.options.moveable&&this._isInsideRange(t)&&this.props.touch.allowDragging&&(this.stopRolling(),this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.dragging=!0,this.body.dom.root&&(this.body.dom.root.style.cursor="move"))}},{key:"_onDrag",value:function(t){if(t&&this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging){var e=this.options.direction;vL(e);var i="horizontal"==e?t.deltaX:t.deltaY;i-=this.deltaDifference;var n=this.props.touch.end-this.props.touch.start;n-=sL(this.body.hiddenDates,this.start,this.end);var r,o="horizontal"==e?this.body.domProps.center.width:this.body.domProps.center.height;r=this.options.rtl?i/o*n:-i/o*n;var s=this.props.touch.start+r,a=this.props.touch.end+r,l=cL(this.body.hiddenDates,s,this.previousDelta-i,!0),h=cL(this.body.hiddenDates,a,this.previousDelta-i,!0);if(l!=s||h!=a)return this.deltaDifference+=i,this.props.touch.start=l,this.props.touch.end=h,void this._onDrag(t);this.previousDelta=i,this._applyRange(s,a);var u=new Date(this.start),c=new Date(this.end);this.body.emitter.emit("rangechange",{start:u,end:c,byUser:!0,event:t}),this.body.emitter.emit("panmove")}}},{key:"_onDragEnd",value:function(t){this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging&&(this.props.touch.dragging=!1,this.body.dom.root&&(this.body.dom.root.style.cursor="auto"),this.body.emitter.emit("rangechanged",{start:new Date(this.start),end:new Date(this.end),byUser:!0,event:t}))}},{key:"_onMouseWheel",value:function(t){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail?e=-t.detail/3:t.deltaY&&(e=-t.deltaY/3),!(this.options.zoomKey&&!t[this.options.zoomKey]&&this.options.zoomable||!this.options.zoomable&&this.options.moveable)&&this.options.zoomable&&this.options.moveable&&this._isInsideRange(t)&&e){var i,n,r=this.options.zoomFriction||5;if(i=e<0?1-e/r:1/(1+e/r),this.rolling){var o=this.options.rollingMode&&this.options.rollingMode.offset||.5;n=this.start+(this.end-this.start)*o}else{var s=this.getPointer({x:t.clientX,y:t.clientY},this.body.dom.center);n=this._pointerToDate(s)}this.zoom(i,n,e,t),t.preventDefault()}}},{key:"_onTouch",value:function(t){this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.allowDragging=!0,this.props.touch.center=null,this.props.touch.centerDate=null,this.scaleOffset=0,this.deltaDifference=0,SA.preventDefault(t)}},{key:"_onPinch",value:function(t){if(this.options.zoomable&&this.options.moveable){SA.preventDefault(t),this.props.touch.allowDragging=!1,this.props.touch.center||(this.props.touch.center=this.getPointer(t.center,this.body.dom.center),this.props.touch.centerDate=this._pointerToDate(this.props.touch.center)),this.stopRolling();var e=1/(t.scale+this.scaleOffset),i=this.props.touch.centerDate,n=sL(this.body.hiddenDates,this.start,this.end),r=hL(this.options.moment,this.body.hiddenDates,this,i),o=n-r,s=i-r+(this.props.touch.start-(i-r))*e,a=i+o+(this.props.touch.end-(i+o))*e;this.startToFront=1-e<=0,this.endToFront=e-1<=0;var l=cL(this.body.hiddenDates,s,1-e,!0),h=cL(this.body.hiddenDates,a,e-1,!0);l==s&&h==a||(this.props.touch.start=l,this.props.touch.end=h,this.scaleOffset=1-t.scale,s=l,a=h);var u={animation:!1,byUser:!0,event:t};this.setRange(s,a,u),this.startToFront=!1,this.endToFront=!0}}},{key:"_isInsideRange",value:function(t){var e=t.center?t.center.x:t.clientX,i=this.body.dom.centerContainer.getBoundingClientRect(),n=this.options.rtl?e-i.left:i.right-e,r=this.body.util.toTime(n);return r>=this.start&&r<=this.end}},{key:"_pointerToDate",value:function(t){var e,i=this.options.direction;if(vL(i),"horizontal"==i)return this.body.util.toTime(t.x).valueOf();var n=this.body.domProps.center.height;return e=this.conversion(n),t.y/e.scale+e.offset}},{key:"getPointer",value:function(t,e){var i=e.getBoundingClientRect();return this.options.rtl?{x:i.right-t.x,y:t.y-i.top}:{x:t.x-i.left,y:t.y-i.top}}},{key:"zoom",value:function(t,e,i,n){null==e&&(e=(this.start+this.end)/2);var r=sL(this.body.hiddenDates,this.start,this.end),o=hL(this.options.moment,this.body.hiddenDates,this,e),s=r-o,a=e-o+(this.start-(e-o))*t,l=e+s+(this.end-(e+s))*t;this.startToFront=!(i>0),this.endToFront=!(-i>0);var h=cL(this.body.hiddenDates,a,i,!0),u=cL(this.body.hiddenDates,l,-i,!0);h==a&&u==l||(a=h,l=u);var c={animation:!1,byUser:!0,event:n};this.setRange(a,l,c),this.startToFront=!1,this.endToFront=!0}},{key:"move",value:function(t){var e=this.end-this.start,i=this.start+e*t,n=this.end+e*t;this.start=i,this.end=n}},{key:"moveTo",value:function(t){var e=(this.start+this.end)/2-t,i=this.start-e,n=this.end-e;this.setRange(i,n,{animation:!1,byUser:!0,event:null})}}],[{key:"conversion",value:function(t,e,i,n){return void 0===n&&(n=0),0!=i&&e-t!=0?{offset:t,scale:i/(e-t-n)}:{offset:0,scale:1}}}]),i}(HA);function vL(t){if("horizontal"!=t&&"vertical"!=t)throw new TypeError('Unknown direction "'.concat(t,'". Choose "horizontal" or "vertical".'))}var gL={},yL=fe.setInterval;!function(t){t.exports=yL}({get exports(){return gL},set exports(t){gL=t}});var bL,_L=n(gL),wL=null;"undefined"!=typeof window?bL=function t(e,i){var n=i||{preventDefault:!1};if(e.Manager){var r=e,o=function(e,i){var o=Object.create(n);return i&&r.assign(o,i),t(new r(e,o),o)};return r.assign(o,r),o.Manager=function(e,i){var o=Object.create(n);return i&&r.assign(o,i),t(new r.Manager(e,o),o)},o}var s=Object.create(e),a=e.element;function l(t){return t.match(/[^ ]+/g)}function h(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var i=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof i&&(t.srcEvent.stopPropagation=function(){i(),t.stopPropagation()}),t.firstTarget=wL;for(var n=wL;n&&!e;){var r=n.hammer;if(r)for(var o,s=0;s<r.length;s++)if(o=r[s]._handlers[t.type])for(var a=0;a<o.length&&!e;a++)o[a](t);n=n.parentNode}}return a.hammer||(a.hammer=[]),a.hammer.push(s),e.on("hammer.input",(function(t){!0!==n.preventDefault&&n.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(wL=t.target)})),s._handlers={},s.on=function(t,i){return l(t).forEach((function(t){var n=s._handlers[t];n||(s._handlers[t]=n=[],e.on(t,h)),n.push(i)})),s},s.off=function(t,i){return l(t).forEach((function(t){var n=s._handlers[t];n&&((n=i?n.filter((function(t){return t!==i})):[]).length>0?s._handlers[t]=n:(e.off(t,h),delete s._handlers[t]))})),s},s.emit=function(t,i){wL=i.target,e.emit(t,i)},s.destroy=function(){var t=e.element.hammer,i=t.indexOf(s);-1!==i&&t.splice(i,1),t.length||delete e.element.hammer,s._handlers={},e.destroy()},s}(window.Hammer||yw,{preventDefault:"mouse"}):bL=function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(e){return{set:t}}}}()};var kL=bL;function xL(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)}var DL=function(){function t(e,i,n,r,o){Sc(this,t),this.moment=o&&o.moment||hI,this.options=o||{},this.current=this.moment(),this._start=this.moment(),this._end=this.moment(),this.autoScale=!0,this.scale="day",this.step=1,this.setRange(e,i,n),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,tf(r)?this.hiddenDates=r:this.hiddenDates=null!=r?[r]:[],this.format=t.FORMAT}return Wd(t,[{key:"setMoment",value:function(t){this.moment=t,this.current=this.moment(this.current.valueOf()),this._start=this.moment(this._start.valueOf()),this._end=this.moment(this._end.valueOf())}},{key:"setFormat",value:function(e){var i=SA.deepExtend({},t.FORMAT);this.format=SA.deepExtend(i,e)}},{key:"setRange",value:function(t,e,i){if(!(t instanceof Date&&e instanceof Date))throw"No legal start or end date in method setRange";this._start=null!=t?this.moment(t.valueOf()):Df(),this._end=null!=e?this.moment(e.valueOf()):Df(),this.autoScale&&this.setMinimumStep(i)}},{key:"start",value:function(){this.current=this._start.clone(),this.roundToMinor()}},{key:"roundToMinor",value:function(){switch("week"==this.scale&&this.current.weekday(0),this.scale){case"year":this.current.year(this.step*Math.floor(this.current.year()/this.step)),this.current.month(0);case"month":this.current.date(1);case"week":case"day":case"weekday":this.current.hours(0);case"hour":this.current.minutes(0);case"minute":this.current.seconds(0);case"second":this.current.milliseconds(0)}if(1!=this.step){var t=this.current.clone();switch(this.scale){case"millisecond":this.current.subtract(this.current.milliseconds()%this.step,"milliseconds");break;case"second":this.current.subtract(this.current.seconds()%this.step,"seconds");break;case"minute":this.current.subtract(this.current.minutes()%this.step,"minutes");break;case"hour":this.current.subtract(this.current.hours()%this.step,"hours");break;case"weekday":case"day":this.current.subtract((this.current.date()-1)%this.step,"day");break;case"week":this.current.subtract(this.current.week()%this.step,"week");break;case"month":this.current.subtract(this.current.month()%this.step,"month");break;case"year":this.current.subtract(this.current.year()%this.step,"year")}t.isSame(this.current)||(this.current=this.moment(cL(this.hiddenDates,this.current.valueOf(),-1,!0)))}}},{key:"hasNext",value:function(){return this.current.valueOf()<=this._end.valueOf()}},{key:"next",value:function(){var t=this.current.valueOf();switch(this.scale){case"millisecond":this.current.add(this.step,"millisecond");break;case"second":this.current.add(this.step,"second");break;case"minute":this.current.add(this.step,"minute");break;case"hour":this.current.add(this.step,"hour"),this.current.month()<6?this.current.subtract(this.current.hours()%this.step,"hour"):this.current.hours()%this.step!=0&&this.current.add(this.step-this.current.hours()%this.step,"hour");break;case"weekday":case"day":this.current.add(this.step,"day");break;case"week":if(0!==this.current.weekday())this.current.weekday(0),this.current.add(this.step,"week");else if(!1===this.options.showMajorLabels)this.current.add(this.step,"week");else{var e=this.current.clone();e.add(1,"week"),e.isSame(this.current,"month")?this.current.add(this.step,"week"):(this.current.add(this.step,"week"),this.current.date(1))}break;case"month":this.current.add(this.step,"month");break;case"year":this.current.add(this.step,"year")}if(1!=this.step)switch(this.scale){case"millisecond":this.current.milliseconds()>0&&this.current.milliseconds()<this.step&&this.current.milliseconds(0);break;case"second":this.current.seconds()>0&&this.current.seconds()<this.step&&this.current.seconds(0);break;case"minute":this.current.minutes()>0&&this.current.minutes()<this.step&&this.current.minutes(0);break;case"hour":this.current.hours()>0&&this.current.hours()<this.step&&this.current.hours(0);break;case"weekday":case"day":this.current.date()<this.step+1&&this.current.date(1);break;case"week":this.current.week()<this.step&&this.current.week(1);break;case"month":this.current.month()<this.step&&this.current.month(0)}this.current.valueOf()==t&&(this.current=this._end.clone()),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,nL(this.moment,this,t)}},{key:"getCurrent",value:function(){return this.current.clone()}},{key:"setScale",value:function(t){t&&"string"==typeof t.scale&&(this.scale=t.scale,this.step=t.step>0?t.step:1,this.autoScale=!1)}},{key:"setAutoScale",value:function(t){this.autoScale=t}},{key:"setMinimumStep",value:function(t){if(null!=t){var e=31104e6,i=2592e6,n=864e5,r=36e5,o=6e4,s=1e3;1e3*e>t&&(this.scale="year",this.step=1e3),500*e>t&&(this.scale="year",this.step=500),100*e>t&&(this.scale="year",this.step=100),50*e>t&&(this.scale="year",this.step=50),10*e>t&&(this.scale="year",this.step=10),5*e>t&&(this.scale="year",this.step=5),e>t&&(this.scale="year",this.step=1),7776e6>t&&(this.scale="month",this.step=3),i>t&&(this.scale="month",this.step=1),6048e5>t&&this.options.showWeekScale&&(this.scale="week",this.step=1),1728e5>t&&(this.scale="day",this.step=2),n>t&&(this.scale="day",this.step=1),432e5>t&&(this.scale="weekday",this.step=1),144e5>t&&(this.scale="hour",this.step=4),r>t&&(this.scale="hour",this.step=1),9e5>t&&(this.scale="minute",this.step=15),6e5>t&&(this.scale="minute",this.step=10),3e5>t&&(this.scale="minute",this.step=5),o>t&&(this.scale="minute",this.step=1),15e3>t&&(this.scale="second",this.step=15),1e4>t&&(this.scale="second",this.step=10),5e3>t&&(this.scale="second",this.step=5),s>t&&(this.scale="second",this.step=1),200>t&&(this.scale="millisecond",this.step=200),100>t&&(this.scale="millisecond",this.step=100),50>t&&(this.scale="millisecond",this.step=50),10>t&&(this.scale="millisecond",this.step=10),5>t&&(this.scale="millisecond",this.step=5),1>t&&(this.scale="millisecond",this.step=1)}}},{key:"isMajor",value:function(){if(1==this.switchedYear)switch(this.scale){case"year":case"month":case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedMonth)switch(this.scale){case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedDay)switch(this.scale){case"millisecond":case"second":case"minute":case"hour":return!0;default:return!1}var t=this.moment(this.current);switch(this.scale){case"millisecond":return 0==t.milliseconds();case"second":return 0==t.seconds();case"minute":return 0==t.hours()&&0==t.minutes();case"hour":return 0==t.hours();case"weekday":case"day":return this.options.showWeekScale?1==t.isoWeekday():1==t.date();case"week":return 1==t.date();case"month":return 0==t.month();default:return!1}}},{key:"getLabelMinor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.minorLabels)return this.format.minorLabels(t,this.scale,this.step);var e=this.format.minorLabels[this.scale];return"week"===this.scale&&1===t.date()&&0!==t.weekday()?"":e&&e.length>0?this.moment(t).format(e):""}},{key:"getLabelMajor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.majorLabels)return this.format.majorLabels(t,this.scale,this.step);var e=this.format.majorLabels[this.scale];return e&&e.length>0?this.moment(t).format(e):""}},{key:"getClassName",value:function(){var t,e=this.moment,i=this.moment(this.current),n=i.locale?i.locale("en"):i.lang("en"),r=this.step,o=[];function s(t){return t/r%2==0?" vis-even":" vis-odd"}function a(t){return t.isSame(Df(),"day")?" vis-today":t.isSame(e().add(1,"day"),"day")?" vis-tomorrow":t.isSame(e().add(-1,"day"),"day")?" vis-yesterday":""}function l(t){return t.isSame(Df(),"week")?" vis-current-week":""}function h(t){return t.isSame(Df(),"month")?" vis-current-month":""}switch(this.scale){case"millisecond":o.push(a(n)),o.push(s(n.milliseconds()));break;case"second":o.push(a(n)),o.push(s(n.seconds()));break;case"minute":o.push(a(n)),o.push(s(n.minutes()));break;case"hour":o.push(Up(t="vis-h".concat(n.hours())).call(t,4==this.step?"-h"+(n.hours()+4):"")),o.push(a(n)),o.push(s(n.hours()));break;case"weekday":o.push("vis-".concat(n.format("dddd").toLowerCase())),o.push(a(n)),o.push(l(n)),o.push(s(n.date()));break;case"day":o.push("vis-day".concat(n.date())),o.push("vis-".concat(n.format("MMMM").toLowerCase())),o.push(a(n)),o.push(h(n)),o.push(this.step<=2?a(n):""),o.push(this.step<=2?"vis-".concat(n.format("dddd").toLowerCase()):""),o.push(s(n.date()-1));break;case"week":o.push("vis-week".concat(n.format("w"))),o.push(l(n)),o.push(s(n.week()));break;case"month":o.push("vis-".concat(n.format("MMMM").toLowerCase())),o.push(h(n)),o.push(s(n.month()));break;case"year":o.push("vis-year".concat(n.year())),o.push(function(t){return t.isSame(Df(),"year")?" vis-current-year":""}(n)),o.push(s(n.year()))}return ig(o).call(o,String).join(" ")}}],[{key:"snap",value:function(t,e,i){var n=hI(t);if("year"==e){var r=n.year()+Math.round(n.month()/12);n.year(Math.round(r/i)*i),n.month(0),n.date(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("month"==e)n.date()>15?(n.date(1),n.add(1,"month")):n.date(1),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("week"==e)n.weekday()>2?(n.weekday(0),n.add(1,"week")):n.weekday(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("day"==e){switch(i){case 5:case 2:n.hours(24*Math.round(n.hours()/24));break;default:n.hours(12*Math.round(n.hours()/12))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("weekday"==e){switch(i){case 5:case 2:n.hours(12*Math.round(n.hours()/12));break;default:n.hours(6*Math.round(n.hours()/6))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("hour"==e){if(4===i)n.minutes(60*Math.round(n.minutes()/60));else n.minutes(30*Math.round(n.minutes()/30));n.seconds(0),n.milliseconds(0)}else if("minute"==e){switch(i){case 15:case 10:n.minutes(5*Math.round(n.minutes()/5)),n.seconds(0);break;case 5:n.seconds(60*Math.round(n.seconds()/60));break;default:n.seconds(30*Math.round(n.seconds()/30))}n.milliseconds(0)}else if("second"==e)switch(i){case 15:case 10:n.seconds(5*Math.round(n.seconds()/5)),n.milliseconds(0);break;case 5:n.milliseconds(1e3*Math.round(n.milliseconds()/1e3));break;default:n.milliseconds(500*Math.round(n.milliseconds()/500))}else if("millisecond"==e){var o=i>5?i/2:1;n.milliseconds(Math.round(n.milliseconds()/o)*o)}return n}}]),t}();function SL(t,e){void 0===e&&(e={});var i=e.insertAt;if(t&&"undefined"!=typeof document){var n=document.head||document.getElementsByTagName("head")[0],r=document.createElement("style");r.type="text/css","top"===i&&n.firstChild?n.insertBefore(r,n.firstChild):n.appendChild(r),r.styleSheet?r.styleSheet.cssText=t:r.appendChild(document.createTextNode(t))}}DL.FORMAT={minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}};function CL(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}SL(".vis-time-axis{overflow:hidden;position:relative}.vis-time-axis.vis-foreground{left:0;top:0;width:100%}.vis-time-axis.vis-background{height:100%;left:0;position:absolute;top:0;width:100%}.vis-time-axis .vis-text{box-sizing:border-box;color:#4d4d4d;overflow:hidden;padding:3px;position:absolute;white-space:nowrap}.vis-time-axis .vis-text.vis-measure{margin-left:0;margin-right:0;padding-left:0;padding-right:0;position:absolute;visibility:hidden}.vis-time-axis .vis-grid.vis-vertical{border-left:1px solid;position:absolute}.vis-time-axis .vis-grid.vis-vertical-rtl{border-right:1px solid;position:absolute}.vis-time-axis .vis-grid.vis-minor{border-color:#e5e5e5}.vis-time-axis .vis-grid.vis-major{border-color:#bfbfbf}");var TL=function(t){qk(i,t);var e=CL(i);function i(t,n){var r;return Sc(this,i),(r=e.call(this)).dom={foreground:null,lines:[],majorTexts:[],minorTexts:[],redundant:{lines:[],majorTexts:[],minorTexts:[]}},r.props={range:{start:0,end:0,minimumStep:0},lineTop:0},r.defaultOptions={orientation:{axis:"bottom"},showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,maxMinorChars:7,format:SA.extend({},DL.FORMAT),moment:hI,timeAxis:null},r.options=SA.extend({},r.defaultOptions),r.body=t,r._create(),r.setOptions(n),r}return Wd(i,[{key:"setOptions",value:function(t){t&&(SA.selectiveExtend(["showMinorLabels","showMajorLabels","showWeekScale","maxMinorChars","hiddenDates","timeAxis","moment","rtl"],this.options,t),SA.selectiveDeepExtend(["format"],this.options,t),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.axis=t.orientation:"object"===Nd(t.orientation)&&"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis)),"locale"in t&&("function"==typeof hI.locale?hI.locale(t.locale):hI.lang(t.locale)))}},{key:"_create",value:function(){this.dom.foreground=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.foreground.className="vis-time-axis vis-foreground",this.dom.background.className="vis-time-axis vis-background"}},{key:"destroy",value:function(){this.dom.foreground.parentNode&&this.dom.foreground.parentNode.removeChild(this.dom.foreground),this.dom.background.parentNode&&this.dom.background.parentNode.removeChild(this.dom.background),this.body=null}},{key:"redraw",value:function(){var t=this.props,e=this.dom.foreground,i=this.dom.background,n="top"==this.options.orientation.axis?this.body.dom.top:this.body.dom.bottom,r=e.parentNode!==n;this._calculateCharSize();var o=this.options.showMinorLabels&&"none"!==this.options.orientation.axis,s=this.options.showMajorLabels&&"none"!==this.options.orientation.axis;t.minorLabelHeight=o?t.minorCharHeight:0,t.majorLabelHeight=s?t.majorCharHeight:0,t.height=t.minorLabelHeight+t.majorLabelHeight,t.width=e.offsetWidth,t.minorLineHeight=this.body.domProps.root.height-t.majorLabelHeight-("top"==this.options.orientation.axis?this.body.domProps.bottom.height:this.body.domProps.top.height),t.minorLineWidth=1,t.majorLineHeight=t.minorLineHeight+t.majorLabelHeight,t.majorLineWidth=1;var a=e.nextSibling,l=i.nextSibling;return e.parentNode&&e.parentNode.removeChild(e),i.parentNode&&i.parentNode.removeChild(i),e.style.height="".concat(this.props.height,"px"),this._repaintLabels(),a?n.insertBefore(e,a):n.appendChild(e),l?this.body.dom.backgroundVertical.insertBefore(i,l):this.body.dom.backgroundVertical.appendChild(i),this._isResized()||r}},{key:"_repaintLabels",value:function(){var t=this.options.orientation.axis,e=SA.convert(this.body.range.start,"Number"),i=SA.convert(this.body.range.end,"Number"),n=this.body.util.toTime((this.props.minorCharWidth||10)*this.options.maxMinorChars).valueOf(),r=n-hL(this.options.moment,this.body.hiddenDates,this.body.range,n);r-=this.body.util.toTime(0).valueOf();var o=new DL(new Date(e),new Date(i),r,this.body.hiddenDates,this.options);o.setMoment(this.options.moment),this.options.format&&o.setFormat(this.options.format),this.options.timeAxis&&o.setScale(this.options.timeAxis),this.step=o;var s,a,l,h,u,c,d=this.dom;d.redundant.lines=d.lines,d.redundant.majorTexts=d.majorTexts,d.redundant.minorTexts=d.minorTexts,d.lines=[],d.majorTexts=[],d.minorTexts=[];var p,f,m,v=0,g=void 0,y=0,b=1e3;for(o.start(),a=o.getCurrent(),h=this.body.util.toScreen(a);o.hasNext()&&y<b;){if(y++,u=o.isMajor(),m=o.getClassName(),s=a,l=h,o.next(),a=o.getCurrent(),p=v,v=(h=this.body.util.toScreen(a))-l,"week"===o.scale)c=!0;else c=v>=.4*p;if(this.options.showMinorLabels&&c){var _=this._repaintMinorText(l,o.getLabelMinor(s),t,m);_.style.width="".concat(v,"px")}u&&this.options.showMajorLabels?(l>0&&(null==g&&(g=l),_=this._repaintMajorText(l,o.getLabelMajor(s),t,m)),f=this._repaintMajorLine(l,v,t,m)):c?f=this._repaintMinorLine(l,v,t,m):f&&(f.style.width="".concat(Yg(f.style.width)+v,"px"))}if(y!==b||ML||(console.warn("Something is wrong with the Timeline scale. Limited drawing of grid lines to ".concat(b," lines.")),ML=!0),this.options.showMajorLabels){var w=this.body.util.toTime(0),k=o.getLabelMajor(w),x=k.length*(this.props.majorCharWidth||10)+10;(null==g||x<g)&&this._repaintMajorText(0,k,t,m)}am(SA).call(SA,this.dom.redundant,(function(t){for(;t.length;){var e=t.pop();e&&e.parentNode&&e.parentNode.removeChild(e)}}))}},{key:"_repaintMinorText",value:function(t,e,i,n){var r=this.dom.redundant.minorTexts.shift();if(!r){var o=document.createTextNode("");(r=document.createElement("div")).appendChild(o),this.dom.foreground.appendChild(r)}this.dom.minorTexts.push(r),r.innerHTML=SA.xss(e);var s="top"==i?this.props.majorLabelHeight:0;return this._setXY(r,t,s),r.className="vis-text vis-minor ".concat(n),r}},{key:"_repaintMajorText",value:function(t,e,i,n){var r=this.dom.redundant.majorTexts.shift();if(!r){var o=document.createElement("div");(r=document.createElement("div")).appendChild(o),this.dom.foreground.appendChild(r)}r.childNodes[0].innerHTML=SA.xss(e),r.className="vis-text vis-major ".concat(n);var s="top"==i?0:this.props.minorLabelHeight;return this._setXY(r,t,s),this.dom.majorTexts.push(r),r}},{key:"_setXY",value:function(t,e,i){var n,r=this.options.rtl?-1*e:e;t.style.transform=Up(n="translate(".concat(r,"px, ")).call(n,i,"px)")}},{key:"_repaintMinorLine",value:function(t,e,i,n){var r,o=this.dom.redundant.lines.shift();o||(o=document.createElement("div"),this.dom.background.appendChild(o)),this.dom.lines.push(o);var s=this.props;o.style.width="".concat(e,"px"),o.style.height="".concat(s.minorLineHeight,"px");var a="top"==i?s.majorLabelHeight:this.body.domProps.top.height,l=t-s.minorLineWidth/2;return this._setXY(o,l,a),o.className=Up(r="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-minor ")).call(r,n),o}},{key:"_repaintMajorLine",value:function(t,e,i,n){var r,o=this.dom.redundant.lines.shift();o||(o=document.createElement("div"),this.dom.background.appendChild(o)),this.dom.lines.push(o);var s=this.props;o.style.width="".concat(e,"px"),o.style.height="".concat(s.majorLineHeight,"px");var a="top"==i?0:this.body.domProps.top.height,l=t-s.majorLineWidth/2;return this._setXY(o,l,a),o.className=Up(r="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-major ")).call(r,n),o}},{key:"_calculateCharSize",value:function(){this.dom.measureCharMinor||(this.dom.measureCharMinor=document.createElement("DIV"),this.dom.measureCharMinor.className="vis-text vis-minor vis-measure",this.dom.measureCharMinor.style.position="absolute",this.dom.measureCharMinor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMinor)),this.props.minorCharHeight=this.dom.measureCharMinor.clientHeight,this.props.minorCharWidth=this.dom.measureCharMinor.clientWidth,this.dom.measureCharMajor||(this.dom.measureCharMajor=document.createElement("DIV"),this.dom.measureCharMajor.className="vis-text vis-major vis-measure",this.dom.measureCharMajor.style.position="absolute",this.dom.measureCharMajor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMajor)),this.props.majorCharHeight=this.dom.measureCharMajor.clientHeight,this.props.majorCharWidth=this.dom.measureCharMajor.clientWidth}}]),i}(HA),ML=!1;function OL(t){var e,i=t&&t.preventDefault||!1,n=t&&t.container||window,r={},o={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){h(t,"keydown")},l=function(t){h(t,"keyup")},h=function(t,e){if(void 0!==o[e][t.keyCode]){for(var n=o[e][t.keyCode],r=0;r<n.length;r++)(void 0===n[r].shift||1==n[r].shift&&1==t.shiftKey||0==n[r].shift&&0==t.shiftKey)&&n[r].fn(t);1==i&&t.preventDefault()}};return r.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===o[i][s[t].code]&&(o[i][s[t].code]=[]),o[i][s[t].code].push({fn:e,shift:s[t].shift})},r.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&r.bind(i,t,e)},r.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},r.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],r=o[i][s[t].code];if(void 0!==r)for(var a=0;a<r.length;a++)r[a].fn==e&&r[a].shift==s[t].shift||n.push(o[i][s[t].code][a]);o[i][s[t].code]=n}else o[i][s[t].code]=[]},r.reset=function(){o={keydown:{},keyup:{}}},r.destroy=function(){o={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",l,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",l,!0),r}function EL(t){var e,i;this.active=!1,this.dom={container:t},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=kL(this.dom.overlay),this.hammer.on("tap",Uf(e=this._onTapOverlay).call(e,this));var n=this,r=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];am(r).call(r,(function(t){n.hammer.on(t,(function(t){t.stopPropagation()}))})),document&&document.body&&(this.onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||n.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=OL(),this.escListener=Uf(i=this.deactivate).call(i,this)}SL(".vis .overlay{height:100%;left:0;position:absolute;top:0;width:100%;z-index:10}.vis-active{box-shadow:0 0 10px #86d5f8}"),hb(EL.prototype),EL.current=null,EL.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},EL.prototype.activate=function(){var t;EL.current&&EL.current.deactivate(),EL.current=this,this.active=!0,this.dom.overlay.style.display="none",SA.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),Uf(t=this.keycharm).call(t,"esc",this.escListener)},EL.prototype.deactivate=function(){EL.current===this&&(EL.current=null),this.active=!1,this.dom.overlay.style.display="",SA.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},EL.prototype._onTapOverlay=function(t){this.activate(),t.stopPropagation()};var PL={current:"current",time:"time",deleteSelected:"Delete selected"},IL={current:"attuale",time:"tempo",deleteSelected:"Cancella la selezione"},AL={current:"huidige",time:"tijd",deleteSelected:"Selectie verwijderen"},LL={current:"Aktuelle",time:"Zeit",deleteSelected:"Lösche Auswahl"},NL={current:"actuel",time:"heure",deleteSelected:"Effacer la selection"},RL={current:"corriente",time:"hora",deleteSelected:"Eliminar selección"},FL={current:"поточний",time:"час",deleteSelected:"Видалити обране"},jL={current:"текущее",time:"время",deleteSelected:"Удалить выбранное"},YL={current:"aktualny",time:"czas",deleteSelected:"Usuń wybrane"},HL={current:"atual",time:"data",deleteSelected:"Apagar selecionado"},zL={current:"現在",time:"時刻",deleteSelected:"選択されたものを削除"},BL={current:"nuvarande",time:"tid",deleteSelected:"Radera valda"},GL={current:"nåværende",time:"tid",deleteSelected:"Slett valgte"},WL={current:"einamas",time:"laikas",deleteSelected:"Pašalinti pasirinktą"},VL={en:PL,en_EN:PL,en_US:PL,it:IL,it_IT:IL,it_CH:IL,nl:AL,nl_NL:AL,nl_BE:AL,de:LL,de_DE:LL,fr:NL,fr_FR:NL,fr_CA:NL,fr_BE:NL,es:RL,es_ES:RL,uk:FL,uk_UA:FL,ru:jL,ru_RU:jL,pl:YL,pl_PL:YL,pt:HL,pt_BR:HL,pt_PT:HL,ja:zL,ja_JP:zL,lt:WL,lt_LT:WL,sv:BL,sv_SE:BL,nb:GL,nn:GL,nb_NO:GL,nn_NO:GL};function UL(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}SL(".vis-custom-time{background-color:#6e94ff;cursor:move;width:2px;z-index:1}.vis-custom-time>.vis-custom-time-marker{background-color:inherit;color:#fff;cursor:auto;font-size:12px;padding:3px 5px;top:0;white-space:nowrap;z-index:inherit}");var XL=function(t){qk(i,t);var e=UL(i);function i(t,n){var r,o;Sc(this,i),(o=e.call(this)).body=t,o.defaultOptions={moment:hI,locales:VL,locale:"en",id:void 0,title:void 0},o.options=SA.extend({},o.defaultOptions),o.setOptions(n),o.options.locales=SA.extend({},VL,o.options.locales);var s=o.defaultOptions.locales[o.defaultOptions.locale];return am(r=gf(o.options.locales)).call(r,(function(t){o.options.locales[t]=SA.extend({},s,o.options.locales[t])})),n&&null!=n.time?o.customTime=n.time:o.customTime=new Date,o.eventParams={},o._create(),o}return Wd(i,[{key:"setOptions",value:function(t){t&&SA.selectiveExtend(["moment","locale","locales","id","title","rtl","snap"],this.options,t)}},{key:"_create",value:function(){var t,e,i,n=document.createElement("div");n["custom-time"]=this,n.className="vis-custom-time ".concat(this.options.id||""),n.style.position="absolute",n.style.top="0px",n.style.height="100%",this.bar=n;var r=document.createElement("div");function o(t){this.body.range._onMouseWheel(t)}r.style.position="relative",r.style.top="0px",this.options.rtl?r.style.right="-10px":r.style.left="-10px",r.style.height="100%",r.style.width="20px",r.addEventListener?(r.addEventListener("mousewheel",Uf(o).call(o,this),!1),r.addEventListener("DOMMouseScroll",Uf(o).call(o,this),!1)):r.attachEvent("onmousewheel",Uf(o).call(o,this)),n.appendChild(r),this.hammer=new kL(r),this.hammer.on("panstart",Uf(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",Uf(e=this._onDrag).call(e,this)),this.hammer.on("panend",Uf(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:kL.DIRECTION_ALL}),this.hammer.get("press").set({time:1e4})}},{key:"destroy",value:function(){this.hide(),this.hammer.destroy(),this.hammer=null,this.body=null}},{key:"redraw",value:function(){var t=this.body.dom.backgroundVertical;this.bar.parentNode!=t&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),t.appendChild(this.bar));var e=this.body.util.toScreen(this.customTime),i=this.options.locales[this.options.locale];i||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),i=this.options.locales.en);var n,r=this.options.title;void 0===r?r=(r=Up(n="".concat(i.time,": ")).call(n,this.options.moment(this.customTime).format("dddd, MMMM Do YYYY, H:mm:ss"))).charAt(0).toUpperCase()+r.substring(1):"function"==typeof r&&(r=r.call(this,this.customTime));return this.options.rtl?this.bar.style.right="".concat(e,"px"):this.bar.style.left="".concat(e,"px"),this.bar.title=r,!1}},{key:"hide",value:function(){this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar)}},{key:"setCustomTime",value:function(t){this.customTime=SA.convert(t,"Date"),this.redraw()}},{key:"getCustomTime",value:function(){return new Date(this.customTime.valueOf())}},{key:"setCustomMarker",value:function(t,e){var i,n,r=document.createElement("div");(r.className="vis-custom-time-marker",r.innerHTML=SA.xss(t),r.style.position="absolute",e)&&(r.setAttribute("contenteditable","true"),r.addEventListener("pointerdown",(function(){r.focus()})),r.addEventListener("input",Uf(i=this._onMarkerChange).call(i,this)),r.title=t,r.addEventListener("blur",Uf(n=function(t){this.title!=t.target.innerHTML&&(this._onMarkerChanged(t),this.title=t.target.innerHTML)}).call(n,this)));this.bar.appendChild(r)}},{key:"setCustomTitle",value:function(t){this.options.title=t}},{key:"_onDragStart",value:function(t){this.eventParams.dragging=!0,this.eventParams.customTime=this.customTime,t.stopPropagation()}},{key:"_onDrag",value:function(t){if(this.eventParams.dragging){var e=this.options.rtl?-1*t.deltaX:t.deltaX,i=this.body.util.toScreen(this.eventParams.customTime)+e,n=this.body.util.toTime(i),r=this.body.util.getScale(),o=this.body.util.getStep(),s=this.options.snap,a=s?s(n,r,o):n;this.setCustomTime(a),this.body.emitter.emit("timechange",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation()}}},{key:"_onDragEnd",value:function(t){this.eventParams.dragging&&(this.body.emitter.emit("timechanged",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation())}},{key:"_onMarkerChange",value:function(t){this.body.emitter.emit("markerchange",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}},{key:"_onMarkerChanged",value:function(t){this.body.emitter.emit("markerchanged",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}}],[{key:"customTimeFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("custom-time"))return e["custom-time"];e=e.parentNode}return null}}]),i}(HA);SL("");SL('.vis-current-time{background-color:#ff7f6e;pointer-events:none;width:2px;z-index:1}.vis-rolling-mode-btn{background:#3876c2;border-radius:50%;color:#fff;cursor:pointer;font-size:28px;font-weight:700;height:40px;opacity:.8;position:absolute;right:20px;text-align:center;top:7px;width:40px}.vis-rolling-mode-btn:before{content:"\\26F6"}.vis-rolling-mode-btn:hover{opacity:1}');SL(".vis-panel{box-sizing:border-box;margin:0;padding:0;position:absolute}.vis-panel.vis-bottom,.vis-panel.vis-center,.vis-panel.vis-left,.vis-panel.vis-right,.vis-panel.vis-top{border:1px #bfbfbf}.vis-panel.vis-center,.vis-panel.vis-left,.vis-panel.vis-right{border-bottom-style:solid;border-top-style:solid;overflow:hidden}.vis-left.vis-panel.vis-vertical-scroll,.vis-right.vis-panel.vis-vertical-scroll{height:100%;overflow-x:hidden;overflow-y:scroll}.vis-left.vis-panel.vis-vertical-scroll{direction:rtl}.vis-left.vis-panel.vis-vertical-scroll .vis-content,.vis-right.vis-panel.vis-vertical-scroll{direction:ltr}.vis-right.vis-panel.vis-vertical-scroll .vis-content{direction:rtl}.vis-panel.vis-bottom,.vis-panel.vis-center,.vis-panel.vis-top{border-left-style:solid;border-right-style:solid}.vis-background{overflow:hidden}.vis-panel>.vis-content{position:relative}.vis-panel .vis-shadow{box-shadow:0 0 10px rgba(0,0,0,.8);height:1px;position:absolute;width:100%}.vis-panel .vis-shadow.vis-top{left:0;top:-1px}.vis-panel .vis-shadow.vis-bottom{bottom:-1px;left:0}");SL(".vis-graph-group0{fill:#4f81bd;fill-opacity:0;stroke-width:2px;stroke:#4f81bd}.vis-graph-group1{fill:#f79646;fill-opacity:0;stroke-width:2px;stroke:#f79646}.vis-graph-group2{fill:#8c51cf;fill-opacity:0;stroke-width:2px;stroke:#8c51cf}.vis-graph-group3{fill:#75c841;fill-opacity:0;stroke-width:2px;stroke:#75c841}.vis-graph-group4{fill:#ff0100;fill-opacity:0;stroke-width:2px;stroke:#ff0100}.vis-graph-group5{fill:#37d8e6;fill-opacity:0;stroke-width:2px;stroke:#37d8e6}.vis-graph-group6{fill:#042662;fill-opacity:0;stroke-width:2px;stroke:#042662}.vis-graph-group7{fill:#00ff26;fill-opacity:0;stroke-width:2px;stroke:#00ff26}.vis-graph-group8{fill:#f0f;fill-opacity:0;stroke-width:2px;stroke:#f0f}.vis-graph-group9{fill:#8f3938;fill-opacity:0;stroke-width:2px;stroke:#8f3938}.vis-timeline .vis-fill{fill-opacity:.1;stroke:none}.vis-timeline .vis-bar{fill-opacity:.5;stroke-width:1px}.vis-timeline .vis-point{stroke-width:2px;fill-opacity:1}.vis-timeline .vis-legend-background{stroke-width:1px;fill-opacity:.9;fill:#fff;stroke:#c2c2c2}.vis-timeline .vis-outline{stroke-width:1px;fill-opacity:1;fill:#fff;stroke:#e5e5e5}.vis-timeline .vis-icon-fill{fill-opacity:.3;stroke:none}");SL(".vis-timeline{border:1px solid #bfbfbf;box-sizing:border-box;margin:0;overflow:hidden;padding:0;position:relative}.vis-loading-screen{height:100%;left:0;position:absolute;top:0;width:100%}");SL(".vis [class*=span]{min-height:0;width:auto}");var qL=function(){function t(){Sc(this,t)}return Wd(t,[{key:"_create",value:function(t){var e,i,n,r=this;this.dom={},this.dom.container=t,this.dom.container.style.position="relative",this.dom.root=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.backgroundVertical=document.createElement("div"),this.dom.backgroundHorizontal=document.createElement("div"),this.dom.centerContainer=document.createElement("div"),this.dom.leftContainer=document.createElement("div"),this.dom.rightContainer=document.createElement("div"),this.dom.center=document.createElement("div"),this.dom.left=document.createElement("div"),this.dom.right=document.createElement("div"),this.dom.top=document.createElement("div"),this.dom.bottom=document.createElement("div"),this.dom.shadowTop=document.createElement("div"),this.dom.shadowBottom=document.createElement("div"),this.dom.shadowTopLeft=document.createElement("div"),this.dom.shadowBottomLeft=document.createElement("div"),this.dom.shadowTopRight=document.createElement("div"),this.dom.shadowBottomRight=document.createElement("div"),this.dom.rollingModeBtn=document.createElement("div"),this.dom.loadingScreen=document.createElement("div"),this.dom.root.className="vis-timeline",this.dom.background.className="vis-panel vis-background",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical",this.dom.backgroundHorizontal.className="vis-panel vis-background vis-horizontal",this.dom.centerContainer.className="vis-panel vis-center",this.dom.leftContainer.className="vis-panel vis-left",this.dom.rightContainer.className="vis-panel vis-right",this.dom.top.className="vis-panel vis-top",this.dom.bottom.className="vis-panel vis-bottom",this.dom.left.className="vis-content",this.dom.center.className="vis-content",this.dom.right.className="vis-content",this.dom.shadowTop.className="vis-shadow vis-top",this.dom.shadowBottom.className="vis-shadow vis-bottom",this.dom.shadowTopLeft.className="vis-shadow vis-top",this.dom.shadowBottomLeft.className="vis-shadow vis-bottom",this.dom.shadowTopRight.className="vis-shadow vis-top",this.dom.shadowBottomRight.className="vis-shadow vis-bottom",this.dom.rollingModeBtn.className="vis-rolling-mode-btn",this.dom.loadingScreen.className="vis-loading-screen",this.dom.root.appendChild(this.dom.background),this.dom.root.appendChild(this.dom.backgroundVertical),this.dom.root.appendChild(this.dom.backgroundHorizontal),this.dom.root.appendChild(this.dom.centerContainer),this.dom.root.appendChild(this.dom.leftContainer),this.dom.root.appendChild(this.dom.rightContainer),this.dom.root.appendChild(this.dom.top),this.dom.root.appendChild(this.dom.bottom),this.dom.root.appendChild(this.dom.rollingModeBtn),this.dom.centerContainer.appendChild(this.dom.center),this.dom.leftContainer.appendChild(this.dom.left),this.dom.rightContainer.appendChild(this.dom.right),this.dom.centerContainer.appendChild(this.dom.shadowTop),this.dom.centerContainer.appendChild(this.dom.shadowBottom),this.dom.leftContainer.appendChild(this.dom.shadowTopLeft),this.dom.leftContainer.appendChild(this.dom.shadowBottomLeft),this.dom.rightContainer.appendChild(this.dom.shadowTopRight),this.dom.rightContainer.appendChild(this.dom.shadowBottomRight),this.props={root:{},background:{},centerContainer:{},leftContainer:{},rightContainer:{},center:{},left:{},right:{},top:{},bottom:{},border:{},scrollTop:0,scrollTopMin:0},this.on("rangechange",(function(){!0===r.initialDrawDone&&r._redraw()})),this.on("rangechanged",(function(){r.initialRangeChangeDone||(r.initialRangeChangeDone=!0)})),this.on("touch",Uf(e=this._onTouch).call(e,this)),this.on("panmove",Uf(i=this._onDrag).call(i,this));var o=this;this._origRedraw=Uf(n=this._redraw).call(n,this),this._redraw=SA.throttle(this._origRedraw),this.on("_change",(function(t){o.itemSet&&o.itemSet.initialItemSetDrawn&&t&&1==t.queue?o._redraw():o._origRedraw()})),this.hammer=new kL(this.dom.root);var s=this.hammer.get("pinch").set({enable:!0});s&&function(t){t.getTouchAction=function(){return["pan-y"]}}(s),this.hammer.get("pan").set({threshold:5,direction:kL.DIRECTION_ALL}),this.timelineListeners={};var a,l,h=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];function u(t){this.isActive()&&this.emit("mousewheel",t);var e=0,i=0;if("detail"in t&&(i=-1*t.detail),"wheelDelta"in t&&(i=t.wheelDelta),"wheelDeltaY"in t&&(i=t.wheelDeltaY),"wheelDeltaX"in t&&(e=-1*t.wheelDeltaX),"axis"in t&&t.axis===t.HORIZONTAL_AXIS&&(e=-1*i,i=0),"deltaY"in t&&(i=-1*t.deltaY),"deltaX"in t&&(e=t.deltaX),t.deltaMode&&(1===t.deltaMode?(e*=40,i*=40):(e*=40,i*=800)),this.options.preferZoom){if(!this.options.zoomKey||t[this.options.zoomKey])return}else if(this.options.zoomKey&&t[this.options.zoomKey])return;if(this.options.verticalScroll||this.options.horizontalScroll)if(this.options.verticalScroll&&Math.abs(i)>=Math.abs(e)){var n=this.props.scrollTop,r=n+i;if(this.isActive())this._setScrollTop(r)!==n&&(this._redraw(),this.emit("scroll",t),t.preventDefault())}else if(this.options.horizontalScroll){var o=(Math.abs(e)>=Math.abs(i)?e:i)/120*(this.range.end-this.range.start)/20,s=this.range.start+o,a=this.range.end+o,l={animation:!1,byUser:!0,event:t};this.range.setRange(s,a,l),t.preventDefault()}}am(h).call(h,(function(t){var e=function(e){o.isActive()&&o.emit(t,e)};o.hammer.on(t,e),o.timelineListeners[t]=e})),xL(this.hammer,(function(t){o.emit("touch",t)})),a=this.hammer,(l=function(t){o.emit("release",t)}).inputHandler=function(t){t.isFinal&&l(t)},a.on("hammer.input",l.inputHandler);var c="onwheel"in document.createElement("div")?"wheel":void 0!==document.onmousewheel?"mousewheel":this.dom.centerContainer.addEventListener?"DOMMouseScroll":"onmousewheel";function d(t){if(o.options.verticalScroll&&(t.preventDefault(),o.isActive())){var e=-t.target.scrollTop;o._setScrollTop(e),o._redraw(),o.emit("scrollSide",t)}}this.dom.top.addEventListener,this.dom.bottom.addEventListener,this.dom.centerContainer.addEventListener(c,Uf(u).call(u,this),!1),this.dom.top.addEventListener(c,Uf(u).call(u,this),!1),this.dom.bottom.addEventListener(c,Uf(u).call(u,this),!1),this.dom.left.parentNode.addEventListener("scroll",Uf(d).call(d,this)),this.dom.right.parentNode.addEventListener("scroll",Uf(d).call(d,this));var p=!1;function f(t){var e;if(t.preventDefault&&(o.emit("dragover",o.getEventProperties(t)),t.preventDefault()),Qg(e=t.target.className).call(e,"timeline")>-1&&!p)return t.dataTransfer.dropEffect="move",p=!0,!1}function m(t){t.preventDefault&&t.preventDefault(),t.stopPropagation&&t.stopPropagation();try{var e=JSON.parse(t.dataTransfer.getData("text"));if(!e||!e.content)return}catch(t){return!1}return p=!1,t.center={x:t.clientX,y:t.clientY},"item"!==e.target?o.itemSet._onAddItem(t):o.itemSet._onDropObjectOnItem(t),o.emit("drop",o.getEventProperties(t)),!1}if(this.dom.center.addEventListener("dragover",Uf(f).call(f,this),!1),this.dom.center.addEventListener("drop",Uf(m).call(m,this),!1),this.customTimes=[],this.touch={},this.redrawCount=0,this.initialDrawDone=!1,this.initialRangeChangeDone=!1,!t)throw new Error("No container provided");t.appendChild(this.dom.root),t.appendChild(this.dom.loadingScreen)}},{key:"setOptions",value:function(t){var e;if(t){if(SA.selectiveExtend(["width","height","minHeight","maxHeight","autoResize","start","end","clickToUse","dataAttributes","hiddenDates","locale","locales","moment","preferZoom","rtl","zoomKey","horizontalScroll","verticalScroll","longSelectPressTime","snap"],this.options,t),this.dom.rollingModeBtn.style.visibility="hidden",this.options.rtl&&(this.dom.container.style.direction="rtl",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical-rtl"),this.options.verticalScroll&&(this.options.rtl?this.dom.rightContainer.className="vis-panel vis-right vis-vertical-scroll":this.dom.leftContainer.className="vis-panel vis-left vis-vertical-scroll"),"object"!==Nd(this.options.orientation)&&(this.options.orientation={item:void 0,axis:void 0}),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation={item:t.orientation,axis:t.orientation}:"object"===Nd(t.orientation)&&("item"in t.orientation&&(this.options.orientation.item=t.orientation.item),"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis))),"both"===this.options.orientation.axis){if(!this.timeAxis2){var i=this.timeAxis2=new TL(this.body);i.setOptions=function(t){var e=t?SA.extend({},t):{};e.orientation="top",TL.prototype.setOptions.call(i,e)},this.components.push(i)}}else if(this.timeAxis2){var n,r,o=Qg(n=this.components).call(n,this.timeAxis2);if(-1!==o)Zm(r=this.components).call(r,o,1);this.timeAxis2.destroy(),this.timeAxis2=null}"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),"hiddenDates"in this.options&&tL(this.options.moment,this.body,this.options.hiddenDates),"clickToUse"in t&&(t.clickToUse?this.activator||(this.activator=new EL(this.dom.root)):this.activator&&(this.activator.destroy(),delete this.activator)),this._initAutoResize()}if(am(e=this.components).call(e,(function(e){return e.setOptions(t)})),"configure"in t){var s;this.configurator||(this.configurator=this._createConfigurator()),this.configurator.setOptions(t.configure);var a=SA.deepExtend({},this.options);am(s=this.components).call(s,(function(t){SA.deepExtend(a,t.options)})),this.configurator.setModuleOptions({global:a})}this._redraw()}},{key:"isActive",value:function(){return!this.activator||this.activator.active}},{key:"destroy",value:function(){var t;for(var e in this.setItems(null),this.setGroups(null),this.off(),this._stopAutoResize(),this.dom.root.parentNode&&this.dom.root.parentNode.removeChild(this.dom.root),this.dom=null,this.activator&&(this.activator.destroy(),delete this.activator),this.timelineListeners)this.timelineListeners.hasOwnProperty(e)&&delete this.timelineListeners[e];this.timelineListeners=null,this.hammer&&this.hammer.destroy(),this.hammer=null,am(t=this.components).call(t,(function(t){return t.destroy()})),this.body=null}},{key:"setCustomTime",value:function(t,e){var i,n=ig(i=this.customTimes).call(i,(function(t){return e===t.options.id}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(Dy(e)));n.length>0&&n[0].setCustomTime(t)}},{key:"getCustomTime",value:function(t){var e,i=ig(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===i.length)throw new Error("No custom time bar found with id ".concat(Dy(t)));return i[0].getCustomTime()}},{key:"setCustomTimeMarker",value:function(t,e,i){var n,r=ig(n=this.customTimes).call(n,(function(t){return t.options.id===e}));if(0===r.length)throw new Error("No custom time bar found with id ".concat(Dy(e)));r.length>0&&r[0].setCustomMarker(t,i)}},{key:"setCustomTimeTitle",value:function(t,e){var i,n=ig(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(Dy(e)));if(n.length>0)return n[0].setCustomTitle(t)}},{key:"getEventProperties",value:function(t){return{event:t}}},{key:"addCustomTime",value:function(t,e){var i,n=void 0!==t?SA.convert(t,"Date"):new Date,r=WE(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(r)throw new Error("A custom time with id ".concat(Dy(e)," already exists"));var o=new XL(this.body,SA.extend({},this.options,{time:n,id:e,snap:this.itemSet?this.itemSet.options.snap:this.options.snap}));return this.customTimes.push(o),this.components.push(o),this._redraw(),e}},{key:"removeCustomTime",value:function(t){var e,i=this,n=ig(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(Dy(t)));am(n).call(n,(function(t){var e,n,r,o;Zm(e=i.customTimes).call(e,Qg(n=i.customTimes).call(n,t),1),Zm(r=i.components).call(r,Qg(o=i.components).call(o,t),1),t.destroy()}))}},{key:"getVisibleItems",value:function(){return this.itemSet&&this.itemSet.getVisibleItems()||[]}},{key:"getItemsAtCurrentTime",value:function(t){return this.time=t,this.itemSet&&this.itemSet.getItemsAtCurrentTime(this.time)||[]}},{key:"getVisibleGroups",value:function(){return this.itemSet&&this.itemSet.getVisibleGroups()||[]}},{key:"fit",value:function(t,e){var i=this.getDataRange();if(null!==i.min||null!==i.max){var n=i.max-i.min,r=new Date(i.min.valueOf()-.01*n),o=new Date(i.max.valueOf()+.01*n),s=!t||void 0===t.animation||t.animation;this.range.setRange(r,o,{animation:s},e)}}},{key:"getDataRange",value:function(){throw new Error("Cannot invoke abstract method getDataRange")}},{key:"setWindow",value:function(t,e,i,n){var r,o;"function"==typeof arguments[2]&&(n=arguments[2],i={}),1==arguments.length?(r=void 0===(o=arguments[0]).animation||o.animation,this.range.setRange(o.start,o.end,{animation:r})):2==arguments.length&&"function"==typeof arguments[1]?(n=arguments[1],r=void 0===(o=arguments[0]).animation||o.animation,this.range.setRange(o.start,o.end,{animation:r},n)):(r=!i||void 0===i.animation||i.animation,this.range.setRange(t,e,{animation:r},n))}},{key:"moveTo",value:function(t,e,i){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.range.end-this.range.start,r=SA.convert(t,"Date").valueOf(),o=r-n/2,s=r+n/2,a=!e||void 0===e.animation||e.animation;this.range.setRange(o,s,{animation:a},i)}},{key:"getWindow",value:function(){var t=this.range.getRange();return{start:new Date(t.start),end:new Date(t.end)}}},{key:"zoomIn",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),r=n.start.valueOf(),o=n.end.valueOf(),s=o-r,a=(s-s/(1+t))/2,l=r+a,h=o-a;this.setWindow(l,h,e,i)}}},{key:"zoomOut",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),r=n.start.valueOf(),o=n.end.valueOf(),s=o-r,a=r-s*t/2,l=o+s*t/2;this.setWindow(a,l,e,i)}}},{key:"redraw",value:function(){this._redraw()}},{key:"_redraw",value:function(){var t;this.redrawCount++;var e=this.dom;if(e&&e.container&&0!=e.root.offsetWidth){var i=!1,n=this.options,r=this.props;eL(this.options.moment,this.body,this.options.hiddenDates),"top"==n.orientation?(SA.addClassName(e.root,"vis-top"),SA.removeClassName(e.root,"vis-bottom")):(SA.removeClassName(e.root,"vis-top"),SA.addClassName(e.root,"vis-bottom")),n.rtl?(SA.addClassName(e.root,"vis-rtl"),SA.removeClassName(e.root,"vis-ltr")):(SA.addClassName(e.root,"vis-ltr"),SA.removeClassName(e.root,"vis-rtl")),e.root.style.maxHeight=SA.option.asSize(n.maxHeight,""),e.root.style.minHeight=SA.option.asSize(n.minHeight,""),e.root.style.width=SA.option.asSize(n.width,"");var o=e.root.offsetWidth;r.border.left=1,r.border.right=1,r.border.top=1,r.border.bottom=1,r.center.height=e.center.offsetHeight,r.left.height=e.left.offsetHeight,r.right.height=e.right.offsetHeight,r.top.height=e.top.clientHeight||-r.border.top,r.bottom.height=Math.round(e.bottom.getBoundingClientRect().height)||e.bottom.clientHeight||-r.border.bottom;var s=Math.max(r.left.height,r.center.height,r.right.height),a=r.top.height+s+r.bottom.height+r.border.top+r.border.bottom;e.root.style.height=SA.option.asSize(n.height,"".concat(a,"px")),r.root.height=e.root.offsetHeight,r.background.height=r.root.height;var l=r.root.height-r.top.height-r.bottom.height;r.centerContainer.height=l,r.leftContainer.height=l,r.rightContainer.height=r.leftContainer.height,r.root.width=o,r.background.width=r.root.width,this.initialDrawDone||(r.scrollbarWidth=SA.getScrollBarWidth());var h=e.leftContainer.clientWidth,u=e.rightContainer.clientWidth;n.verticalScroll?n.rtl?(r.left.width=h||-r.border.left,r.right.width=u+r.scrollbarWidth||-r.border.right):(r.left.width=h+r.scrollbarWidth||-r.border.left,r.right.width=u||-r.border.right):(r.left.width=h||-r.border.left,r.right.width=u||-r.border.right),this._setDOM();var c=this._updateScrollTop();"top"!=n.orientation.item&&(c+=Math.max(r.centerContainer.height-r.center.height-r.border.top-r.border.bottom,0)),e.center.style.transform="translateY(".concat(c,"px)");var d=0==r.scrollTop?"hidden":"",p=r.scrollTop==r.scrollTopMin?"hidden":"";e.shadowTop.style.visibility=d,e.shadowBottom.style.visibility=p,e.shadowTopLeft.style.visibility=d,e.shadowBottomLeft.style.visibility=p,e.shadowTopRight.style.visibility=d,e.shadowBottomRight.style.visibility=p,n.verticalScroll&&(e.rightContainer.className="vis-panel vis-right vis-vertical-scroll",e.leftContainer.className="vis-panel vis-left vis-vertical-scroll",e.shadowTopRight.style.visibility="hidden",e.shadowBottomRight.style.visibility="hidden",e.shadowTopLeft.style.visibility="hidden",e.shadowBottomLeft.style.visibility="hidden",e.left.style.top="0px",e.right.style.top="0px"),(!n.verticalScroll||r.center.height<r.centerContainer.height)&&(e.left.style.top="".concat(c,"px"),e.right.style.top="".concat(c,"px"),e.rightContainer.className=e.rightContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),e.leftContainer.className=e.leftContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),r.left.width=h||-r.border.left,r.right.width=u||-r.border.right,this._setDOM());var f=r.center.height>r.centerContainer.height;this.hammer.get("pan").set({direction:f?kL.DIRECTION_ALL:kL.DIRECTION_HORIZONTAL}),this.hammer.get("press").set({time:this.options.longSelectPressTime}),am(t=this.components).call(t,(function(t){i=t.redraw()||i}));if(i){if(this.redrawCount<5)return void this.body.emitter.emit("_change");console.log("WARNING: infinite loop in redraw?")}else this.redrawCount=0;this.body.emitter.emit("changed")}}},{key:"_setDOM",value:function(){var t=this.props,e=this.dom;t.leftContainer.width=t.left.width,t.rightContainer.width=t.right.width;var i=t.root.width-t.left.width-t.right.width;t.center.width=i,t.centerContainer.width=i,t.top.width=i,t.bottom.width=i,e.background.style.height="".concat(t.background.height,"px"),e.backgroundVertical.style.height="".concat(t.background.height,"px"),e.backgroundHorizontal.style.height="".concat(t.centerContainer.height,"px"),e.centerContainer.style.height="".concat(t.centerContainer.height,"px"),e.leftContainer.style.height="".concat(t.leftContainer.height,"px"),e.rightContainer.style.height="".concat(t.rightContainer.height,"px"),e.background.style.width="".concat(t.background.width,"px"),e.backgroundVertical.style.width="".concat(t.centerContainer.width,"px"),e.backgroundHorizontal.style.width="".concat(t.background.width,"px"),e.centerContainer.style.width="".concat(t.center.width,"px"),e.top.style.width="".concat(t.top.width,"px"),e.bottom.style.width="".concat(t.bottom.width,"px"),e.background.style.left="0",e.background.style.top="0",e.backgroundVertical.style.left="".concat(t.left.width+t.border.left,"px"),e.backgroundVertical.style.top="0",e.backgroundHorizontal.style.left="0",e.backgroundHorizontal.style.top="".concat(t.top.height,"px"),e.centerContainer.style.left="".concat(t.left.width,"px"),e.centerContainer.style.top="".concat(t.top.height,"px"),e.leftContainer.style.left="0",e.leftContainer.style.top="".concat(t.top.height,"px"),e.rightContainer.style.left="".concat(t.left.width+t.center.width,"px"),e.rightContainer.style.top="".concat(t.top.height,"px"),e.top.style.left="".concat(t.left.width,"px"),e.top.style.top="0",e.bottom.style.left="".concat(t.left.width,"px"),e.bottom.style.top="".concat(t.top.height+t.centerContainer.height,"px"),e.center.style.left="0",e.left.style.left="0",e.right.style.left="0"}},{key:"setCurrentTime",value:function(t){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");this.currentTime.setCurrentTime(t)}},{key:"getCurrentTime",value:function(){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");return this.currentTime.getCurrentTime()}},{key:"_toTime",value:function(t){return oL(this,t,this.props.center.width)}},{key:"_toGlobalTime",value:function(t){return oL(this,t,this.props.root.width)}},{key:"_toScreen",value:function(t){return rL(this,t,this.props.center.width)}},{key:"_toGlobalScreen",value:function(t){return rL(this,t,this.props.root.width)}},{key:"_initAutoResize",value:function(){1==this.options.autoResize?this._startAutoResize():this._stopAutoResize()}},{key:"_startAutoResize",value:function(){var t=this;this._stopAutoResize(),this._onResize=function(){if(1==t.options.autoResize){if(t.dom.root){var e=t.dom.root.offsetHeight,i=t.dom.root.offsetWidth;i==t.props.lastWidth&&e==t.props.lastHeight||(t.props.lastWidth=i,t.props.lastHeight=e,t.props.scrollbarWidth=SA.getScrollBarWidth(),t.body.emitter.emit("_change"))}}else t._stopAutoResize()},SA.addEventListener(window,"resize",this._onResize),t.dom.root&&(t.props.lastWidth=t.dom.root.offsetWidth,t.props.lastHeight=t.dom.root.offsetHeight),this.watchTimer=_L(this._onResize,1e3)}},{key:"_stopAutoResize",value:function(){this.watchTimer&&(clearInterval(this.watchTimer),this.watchTimer=void 0),this._onResize&&(SA.removeEventListener(window,"resize",this._onResize),this._onResize=null)}},{key:"_onTouch",value:function(t){this.touch.allowDragging=!0,this.touch.initialScrollTop=this.props.scrollTop}},{key:"_onPinch",value:function(t){this.touch.allowDragging=!1}},{key:"_onDrag",value:function(t){if(t&&this.touch.allowDragging){var e=t.deltaY,i=this._getScrollTop(),n=this._setScrollTop(this.touch.initialScrollTop+e);this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),n!=i&&this.emit("verticalDrag")}}},{key:"_setScrollTop",value:function(t){return this.props.scrollTop=t,this._updateScrollTop(),this.props.scrollTop}},{key:"_updateScrollTop",value:function(){var t=Math.min(this.props.centerContainer.height-this.props.border.top-this.props.border.bottom-this.props.center.height,0);return t!=this.props.scrollTopMin&&("top"!=this.options.orientation.item&&(this.props.scrollTop+=t-this.props.scrollTopMin),this.props.scrollTopMin=t),this.props.scrollTop>0&&(this.props.scrollTop=0),this.props.scrollTop<t&&(this.props.scrollTop=t),this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),this.props.scrollTop}},{key:"_getScrollTop",value:function(){return this.props.scrollTop}},{key:"_createConfigurator",value:function(){throw new Error("Cannot invoke abstract method _createConfigurator")}}]),t}();function $L(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}hb(qL.prototype);var ZL=function(t){qk(i,t);var e=$L(i);function i(t,n){var r,o;Sc(this,i),(o=e.call(this)).body=t,o.defaultOptions={rtl:!1,showCurrentTime:!0,alignCurrentTime:void 0,moment:hI,locales:VL,locale:"en"},o.options=SA.extend({},o.defaultOptions),o.setOptions(n),o.options.locales=SA.extend({},VL,o.options.locales);var s=o.defaultOptions.locales[o.defaultOptions.locale];return am(r=gf(o.options.locales)).call(r,(function(t){o.options.locales[t]=SA.extend({},s,o.options.locales[t])})),o.offset=0,o._create(),o}return Wd(i,[{key:"_create",value:function(){var t=document.createElement("div");t.className="vis-current-time",t.style.position="absolute",t.style.top="0px",t.style.height="100%",this.bar=t}},{key:"destroy",value:function(){this.options.showCurrentTime=!1,this.redraw(),this.body=null}},{key:"setOptions",value:function(t){t&&SA.selectiveExtend(["rtl","showCurrentTime","alignCurrentTime","moment","locale","locales"],this.options,t)}},{key:"redraw",value:function(){if(this.options.showCurrentTime){var t,e,i=this.body.dom.backgroundVertical;this.bar.parentNode!=i&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),i.appendChild(this.bar),this.start());var n=this.options.moment(Df()+this.offset);this.options.alignCurrentTime&&(n=n.startOf(this.options.alignCurrentTime));var r=this.body.util.toScreen(n),o=this.options.locales[this.options.locale];o||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),o=this.options.locales.en);var s=Up(t=Up(e="".concat(o.current," ")).call(e,o.time,": ")).call(t,n.format("dddd, MMMM Do YYYY, H:mm:ss"));s=s.charAt(0).toUpperCase()+s.substring(1),this.options.rtl?this.bar.style.transform="translateX(".concat(-1*r,"px)"):this.bar.style.transform="translateX(".concat(r,"px)"),this.bar.title=s}else this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),this.stop();return!1}},{key:"start",value:function(){var t=this;!function e(){t.stop();var i=1/t.body.range.conversion(t.body.domProps.center.width).scale/10;i<30&&(i=30),i>1e3&&(i=1e3),t.redraw(),t.body.emitter.emit("currentTimeTick"),t.currentTimeTimer=Xy(e,i)}()}},{key:"stop",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),delete this.currentTimeTimer)}},{key:"setCurrentTime",value:function(t){var e=SA.convert(t,"Date").valueOf(),i=Df();this.offset=e-i,this.redraw()}},{key:"getCurrentTime",value:function(){return new Date(Df()+this.offset)}}]),i}(HA),KL={},JL={get exports(){return KL},set exports(t){KL=t}},QL=In,tN=Sl.find,eN="find",iN=!0;eN in[]&&Array(1)[eN]((function(){iN=!1})),QL({target:"Array",proto:!0,forced:iN},{find:function(t){return tN(this,t,arguments.length>1?arguments[1]:void 0)}});var nN=yp("Array").find,rN=_e,oN=nN,sN=Array.prototype,aN=function(t){var e=t.find;return t===sN||rN(sN,t)&&e===sN.find?oN:e},lN=aN;!function(t){t.exports=lN}(JL);var hN=n(KL),uN={},cN={get exports(){return uN},set exports(t){uN=t}},dN=In,pN=Sl.findIndex,fN="findIndex",mN=!0;fN in[]&&Array(1)[fN]((function(){mN=!1})),dN({target:"Array",proto:!0,forced:mN},{findIndex:function(t){return pN(this,t,arguments.length>1?arguments[1]:void 0)}});var vN=yp("Array").findIndex,gN=_e,yN=vN,bN=Array.prototype,_N=function(t){var e=t.findIndex;return t===bN||gN(bN,t)&&e===bN.findIndex?yN:e},wN=_N;!function(t){t.exports=wN}(cN);var kN=n(uN);function xN(t,e){var i=void 0!==Fp&&Ea(t)||t["@@iterator"];if(!i){if(tf(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return DN(t,e);var n=qp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return DN(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function DN(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var SN=.001;function CN(t){LE(t).call(t,(function(t,e){return t.data.start-e.data.start}))}function TN(t){LE(t).call(t,(function(t,e){return("end"in t.data?t.data.end:t.data.start)-("end"in e.data?e.data.end:e.data.start)}))}function MN(t,e,i,n){return null===AN(t,e.item,!1,(function(t){return t.stack&&(i||null===t.top)}),(function(t){return t.stack}),(function(t){return e.axis}),n)}function ON(t,e,i){var n=AN(t,e.item,!1,(function(t){return t.stack}),(function(t){return!0}),(function(t){return t.baseTop}));i.height=n-i.top+.5*e.item.vertical}function EN(t,e,i,n){for(var r=0;r<t.length;r++)if(null==t[r].data.subgroup)t[r].top=e.item.vertical;else if(void 0!==t[r].data.subgroup&&n){var o=0;for(var s in i)i.hasOwnProperty(s)&&1==i[s].visible&&i[s].index<i[t[r].data.subgroup].index&&(o+=i[s].height,i[t[r].data.subgroup].top=o);t[r].top=o+.5*e.item.vertical}n||PN(t,e,i)}function PN(t,e,i){var n;AN(LE(n=fg(i)).call(n,(function(t,e){return t.index>e.index?1:t.index<e.index?-1:0})),{vertical:0},!0,(function(t){return!0}),(function(t){return!0}),(function(t){return 0}));for(var r=0;r<t.length;r++)void 0!==t[r].data.subgroup&&(t[r].top=i[t[r].data.subgroup].top+.5*e.item.vertical)}function IN(t,e,i){var n=!1,r=[];for(var o in i)i[o].hasOwnProperty("index")?r[i[o].index]=o:r.push(o);for(var s=0;s<r.length;s++)if(o=r[s],i.hasOwnProperty(o)){for(var a in n=n||i[o].stack,i[o].top=0,i)i[a].visible&&i[o].index>i[a].index&&(i[o].top+=i[a].height);for(var l=t[o],h=0;h<l.length;h++)void 0!==l[h].data.subgroup&&(l[h].top=i[l[h].data.subgroup].top+.5*e.item.vertical,i[o].stack&&(l[h].baseTop=l[h].top));n&&i[o].stack&&ON(t[o],e,i[o])}}function AN(t,e,n,r,o,s,a){var l=function(t){return t.start},h=function(t){return t.end};if(!n){var u=!(!t[0]||!t[0].options.rtl);l=u?function(t){return t.right}:function(t){return t.left},h=function(t){return l(t)+t.width+e.horizontal}}var c,d=[],p=[],f=null,m=0,v=xN(t);try{var g=function(){var t=c.value;if(r(t))d.push(t);else if(o(t)){var e=l(t);null!==f&&e<f-SN&&(m=0),f=e,m=LN(p,(function(t){return l(t)-SN>e}),m),Zm(p).call(p,m,0,t),m++}};for(v.s();!(c=v.n()).done;)g()}catch(t){v.e(t)}finally{v.f()}f=null;var y=null;m=0;for(var b=0,_=0,w=0,k=function(){var t,n,r=d.shift();r.top=s(r);var u=l(r),c=h(r);null!==f&&u<f-SN&&(b=0,_=0,m=0,y=null),f=u,b=LN(p,(function(t){return u<h(t)-SN}),b),(null===y||y<c-SN)&&(_=LN(p,(function(t){return c<l(t)-SN}),Math.max(b,_))),null!==y&&y-SN>c&&(_=function(t,e,n,r){n||(n=0);r||(r=t.length);for(i=r-1;i>=n;i--)if(e(t[i]))return i;return n-1}(p,(function(t){return c+SN>=l(t)}),b,horizontalOVerlapEndIndex)+1);for(var v,g,k,x=LE(t=ig(n=qp(p).call(p,b,_)).call(n,(function(t){return u<h(t)-SN&&c-SN>l(t)}))).call(t,(function(t,e){return t.top-e.top})),D=0;D<x.length;D++){var S=x[D];g=S,k=e,(v=r).top-k.vertical+SN<g.top+g.height&&v.top+v.height+k.vertical-SN>g.top&&(r.top=S.top+S.height+e.vertical)}o(r)&&(m=LN(p,(function(t){return l(t)-SN>u}),m),Zm(p).call(p,m,0,r),m++);var C=r.top+r.height;if(C>w&&(w=C),a&&a())return{v:null}};d.length>0;){var x=k();if("object"===Nd(x))return x.v}return w}function LN(t,e,i){var n;i||(i=0);var r=kN(n=qp(t).call(t,i)).call(n,e);return-1===r?t.length:r+i}var NN=Object.freeze({__proto__:null,nostack:EN,orderByEnd:TN,orderByStart:CN,stack:MN,stackSubgroups:PN,stackSubgroupsWithInnerStack:IN,substack:ON}),RN="__background__",FN=function(){function t(e,i,n){var r=this;if(Sc(this,t),this.groupId=e,this.subgroups={},this.subgroupStack={},this.subgroupStackAll=!1,this.subgroupVisibility={},this.doInnerStack=!1,this.shouldBailStackItems=!1,this.subgroupIndex=0,this.subgroupOrderer=i&&i.subgroupOrder,this.itemSet=n,this.isVisible=null,this.stackDirty=!0,this._disposeCallbacks=[],i&&i.nestedGroups&&(this.nestedGroups=i.nestedGroups,0==i.showNested?this.showNested=!1:this.showNested=!0),i&&i.subgroupStack)if("boolean"==typeof i.subgroupStack)this.doInnerStack=i.subgroupStack,this.subgroupStackAll=i.subgroupStack;else for(var o in i.subgroupStack)this.subgroupStack[o]=i.subgroupStack[o],this.doInnerStack=this.doInnerStack||i.subgroupStack[o];i&&i.heightMode?this.heightMode=i.heightMode:this.heightMode=n.options.groupHeightMode,this.nestedInGroup=null,this.dom={},this.props={label:{width:0,height:0}},this.className=null,this.items={},this.visibleItems=[],this.itemsInRange=[],this.orderedItems={byStart:[],byEnd:[]},this.checkRangedItems=!1;var s=function(){r.checkRangedItems=!0};this.itemSet.body.emitter.on("checkRangedItems",s),this._disposeCallbacks.push((function(){r.itemSet.body.emitter.off("checkRangedItems",s)})),this._create(),this.setData(i)}return Wd(t,[{key:"_create",value:function(){var t=document.createElement("div");this.itemSet.options.groupEditable.order?t.className="vis-label draggable":t.className="vis-label",this.dom.label=t;var e=document.createElement("div");e.className="vis-inner",t.appendChild(e),this.dom.inner=e;var i=document.createElement("div");i.className="vis-group",i["vis-group"]=this,this.dom.foreground=i,this.dom.background=document.createElement("div"),this.dom.background.className="vis-group",this.dom.axis=document.createElement("div"),this.dom.axis.className="vis-group",this.dom.marker=document.createElement("div"),this.dom.marker.style.visibility="hidden",this.dom.marker.style.position="absolute",this.dom.marker.innerHTML="",this.dom.background.appendChild(this.dom.marker)}},{key:"setData",value:function(t){if(!this.itemSet.groupTouchParams.isDragging){var e,i,n;if(t&&t.subgroupVisibility)for(var r in t.subgroupVisibility)this.subgroupVisibility[r]=t.subgroupVisibility[r];if(this.itemSet.options&&this.itemSet.options.groupTemplate)e=(i=Uf(n=this.itemSet.options.groupTemplate).call(n,this))(t,this.dom.inner);else e=t&&t.content;if(e instanceof Element){for(;this.dom.inner.firstChild;)this.dom.inner.removeChild(this.dom.inner.firstChild);this.dom.inner.appendChild(e)}else e instanceof Object&&e.isReactComponent||(e instanceof Object?i(t,this.dom.inner):this.dom.inner.innerHTML=null!=e?SA.xss(e):SA.xss(this.groupId||""));this.dom.label.title=t&&t.title||"",this.dom.inner.firstChild?SA.removeClassName(this.dom.inner,"vis-hidden"):SA.addClassName(this.dom.inner,"vis-hidden"),t&&t.nestedGroups?(this.nestedGroups&&this.nestedGroups==t.nestedGroups||(this.nestedGroups=t.nestedGroups),void 0===t.showNested&&void 0!==this.showNested||(0==t.showNested?this.showNested=!1:this.showNested=!0),SA.addClassName(this.dom.label,"vis-nesting-group"),this.showNested?(SA.removeClassName(this.dom.label,"collapsed"),SA.addClassName(this.dom.label,"expanded")):(SA.removeClassName(this.dom.label,"expanded"),SA.addClassName(this.dom.label,"collapsed"))):this.nestedGroups&&(this.nestedGroups=null,SA.removeClassName(this.dom.label,"collapsed"),SA.removeClassName(this.dom.label,"expanded"),SA.removeClassName(this.dom.label,"vis-nesting-group")),t&&(t.treeLevel||t.nestedInGroup)?(SA.addClassName(this.dom.label,"vis-nested-group"),t.treeLevel?SA.addClassName(this.dom.label,"vis-group-level-"+t.treeLevel):SA.addClassName(this.dom.label,"vis-group-level-unknown-but-gte1")):SA.addClassName(this.dom.label,"vis-group-level-0");var o=t&&t.className||null;o!=this.className&&(this.className&&(SA.removeClassName(this.dom.label,this.className),SA.removeClassName(this.dom.foreground,this.className),SA.removeClassName(this.dom.background,this.className),SA.removeClassName(this.dom.axis,this.className)),SA.addClassName(this.dom.label,o),SA.addClassName(this.dom.foreground,o),SA.addClassName(this.dom.background,o),SA.addClassName(this.dom.axis,o),this.className=o),this.style&&(SA.removeCssText(this.dom.label,this.style),this.style=null),t&&t.style&&(SA.addCssText(this.dom.label,t.style),this.style=t.style)}}},{key:"getLabelWidth",value:function(){return this.props.label.width}},{key:"_didMarkerHeightChange",value:function(){var t=this.dom.marker.clientHeight;if(t!=this.lastMarkerHeight){this.lastMarkerHeight=t;var e={},i=0;if(am(SA).call(SA,this.items,(function(t,n){if(t.dirty=!0,t.displayed){e[n]=t.redraw(!0),i=e[n].length}})),i>0)for(var n=function(t){am(SA).call(SA,e,(function(e){e[t]()}))},r=0;r<i;r++)n(r);return!0}return!1}},{key:"_calculateGroupSizeAndPosition",value:function(){var t=this.dom.foreground,e=t.offsetTop,i=t.offsetLeft,n=t.offsetWidth;this.top=e,this.right=i,this.width=n}},{key:"_shouldBailItemsRedraw",value:function(){var t=this,e=this.itemSet.options.onTimeout,i={relativeBailingTime:this.itemSet.itemsSettingTime,bailTimeMs:e&&e.timeoutMs,userBailFunction:e&&e.callback,shouldBailStackItems:this.shouldBailStackItems},n=null;if(!this.itemSet.initialDrawDone){if(i.shouldBailStackItems)return!0;Math.abs(Df()-new Date(i.relativeBailingTime))>i.bailTimeMs&&(i.userBailFunction&&null==this.itemSet.userContinueNotBail?i.userBailFunction((function(e){t.itemSet.userContinueNotBail=e,n=!e})):n=0==t.itemSet.userContinueNotBail)}return n}},{key:"_redrawItems",value:function(t,e,i,n){var r=this;if(t||this.stackDirty||this.isVisible&&!e){var o,s,a,l,h,u,c={byEnd:ig(o=this.orderedItems.byEnd).call(o,(function(t){return!t.isCluster})),byStart:ig(s=this.orderedItems.byStart).call(s,(function(t){return!t.isCluster}))},d={byEnd:Np(new HO(ig(a=cf(l=this.orderedItems.byEnd).call(l,(function(t){return t.cluster}))).call(a,(function(t){return!!t})))),byStart:Np(new HO(ig(h=cf(u=this.orderedItems.byStart).call(u,(function(t){return t.cluster}))).call(h,(function(t){return!!t}))))},p=function(){var t,e,i,o=r._updateItemsInRange(c,ig(t=r.visibleItems).call(t,(function(t){return!t.isCluster})),n),s=r._updateClustersInRange(d,ig(e=r.visibleItems).call(e,(function(t){return t.isCluster})),n);return Up(i=[]).call(i,Np(o),Np(s))},f=function(t){var e={},i=function(i){var n,o=ig(n=r.visibleItems).call(n,(function(t){return t.data.subgroup===i}));e[i]=t?LE(o).call(o,(function(e,i){return t(e.data,i.data)})):o};for(var n in r.subgroups)i(n);return e};if("function"==typeof this.itemSet.options.order){var m=this;if(this.doInnerStack&&this.itemSet.options.stackSubgroups){IN(f(this.itemSet.options.order),i,this.subgroups),this.visibleItems=p(),this._updateSubGroupHeights(i)}else{var v,g,y,b;this.visibleItems=p(),this._updateSubGroupHeights(i);var _=LE(v=ig(g=qp(y=this.visibleItems).call(y)).call(g,(function(t){return t.isCluster||!t.isCluster&&!t.cluster}))).call(v,(function(t,e){return m.itemSet.options.order(t.data,e.data)}));this.shouldBailStackItems=MN(_,i,!0,Uf(b=this._shouldBailItemsRedraw).call(b,this))}}else{var w;if(this.visibleItems=p(),this._updateSubGroupHeights(i),this.itemSet.options.stack)if(this.doInnerStack&&this.itemSet.options.stackSubgroups)IN(f(),i,this.subgroups);else this.shouldBailStackItems=MN(this.visibleItems,i,!0,Uf(w=this._shouldBailItemsRedraw).call(w,this));else EN(this.visibleItems,i,this.subgroups,this.itemSet.options.stackSubgroups)}for(var k=0;k<this.visibleItems.length;k++)this.visibleItems[k].repositionX(),void 0!==this.subgroupVisibility[this.visibleItems[k].data.subgroup]&&(this.subgroupVisibility[this.visibleItems[k].data.subgroup]||this.visibleItems[k].hide());this.itemSet.options.cluster&&am(SA).call(SA,this.items,(function(t){t.cluster&&t.displayed&&t.hide()})),this.shouldBailStackItems&&this.itemSet.body.emitter.emit("destroyTimeline"),this.stackDirty=!1}}},{key:"_didResize",value:function(t,e){t=SA.updateProperty(this,"height",e)||t;var i=this.dom.inner.clientWidth,n=this.dom.inner.clientHeight;return t=SA.updateProperty(this.props.label,"width",i)||t,t=SA.updateProperty(this.props.label,"height",n)||t}},{key:"_applyGroupHeight",value:function(t){this.dom.background.style.height="".concat(t,"px"),this.dom.foreground.style.height="".concat(t,"px"),this.dom.label.style.height="".concat(t,"px")}},{key:"_updateItemsVerticalPosition",value:function(t){for(var e=0,i=this.visibleItems.length;e<i;e++){var n=this.visibleItems[e];n.repositionY(t),this.isVisible||this.groupId==RN||n.displayed&&n.hide()}}},{key:"redraw",value:function(t,e,i,n){var r,o,s,a,l,h,u,c=this,d=!1,p=this.isVisible,f=[function(){i=c._didMarkerHeightChange.call(c)||i},Uf(r=this._updateSubGroupHeights).call(r,this,e),Uf(o=this._calculateGroupSizeAndPosition).call(o,this),function(){var i;c.isVisible=Uf(i=c._isGroupVisible).call(i,c)(t,e)},function(){var n;Uf(n=c._redrawItems).call(n,c)(i,p,e,t)},Uf(s=this._updateSubgroupsSizes).call(s,this),function(){var t;h=Uf(t=c._calculateHeight).call(t,c)(e)},Uf(a=this._calculateGroupSizeAndPosition).call(a,this),function(){var t;d=Uf(t=c._didResize).call(t,c)(d,h)},function(){var t;Uf(t=c._applyGroupHeight).call(t,c)(h)},function(){var t;Uf(t=c._updateItemsVerticalPosition).call(t,c)(e)},Uf(l=function(){return!c.isVisible&&c.height&&(d=!1),d}).call(l,this)];return n?f:(am(f).call(f,(function(t){u=t()})),u)}},{key:"_updateSubGroupHeights",value:function(t){var e=this;if(gf(this.subgroups).length>0){var i=this;this._resetSubgroups(),am(SA).call(SA,this.visibleItems,(function(n){void 0!==n.data.subgroup&&(i.subgroups[n.data.subgroup].height=Math.max(i.subgroups[n.data.subgroup].height,n.height+t.item.vertical),i.subgroups[n.data.subgroup].visible=void 0===e.subgroupVisibility[n.data.subgroup]||Boolean(e.subgroupVisibility[n.data.subgroup]))}))}}},{key:"_isGroupVisible",value:function(t,e){return this.top<=t.body.domProps.centerContainer.height-t.body.domProps.scrollTop+e.axis&&this.top+this.height+e.axis>=-t.body.domProps.scrollTop}},{key:"_calculateHeight",value:function(t){var e,i;if((i="fixed"===this.heightMode?SA.toArray(this.items):this.visibleItems).length>0){var n=i[0].top,r=i[0].top+i[0].height;if(am(SA).call(SA,i,(function(t){n=Math.min(n,t.top),r=Math.max(r,t.top+t.height)})),n>t.axis){var o=n-t.axis;r-=o,am(SA).call(SA,i,(function(t){t.top-=o}))}e=Math.ceil(r+t.item.vertical/2),"fitItems"!==this.heightMode&&(e=Math.max(e,this.props.label.height))}else e=this.props.label.height;return e}},{key:"show",value:function(){this.dom.label.parentNode||this.itemSet.dom.labelSet.appendChild(this.dom.label),this.dom.foreground.parentNode||this.itemSet.dom.foreground.appendChild(this.dom.foreground),this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background),this.dom.axis.parentNode||this.itemSet.dom.axis.appendChild(this.dom.axis)}},{key:"hide",value:function(){var t=this.dom.label;t.parentNode&&t.parentNode.removeChild(t);var e=this.dom.foreground;e.parentNode&&e.parentNode.removeChild(e);var i=this.dom.background;i.parentNode&&i.parentNode.removeChild(i);var n=this.dom.axis;n.parentNode&&n.parentNode.removeChild(n)}},{key:"add",value:function(t){var e;if(this.items[t.id]=t,t.setParent(this),this.stackDirty=!0,void 0!==t.data.subgroup&&(this._addToSubgroup(t),this.orderSubgroups()),!Yv(e=this.visibleItems).call(e,t)){var i=this.itemSet.body.range;this._checkIfVisible(t,this.visibleItems,i)}}},{key:"_addToSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;null!=e&&void 0===this.subgroups[e]&&(this.subgroups[e]={height:0,top:0,start:t.data.start,end:t.data.end||t.data.start,visible:!1,index:this.subgroupIndex,items:[],stack:this.subgroupStackAll||this.subgroupStack[e]||!1},this.subgroupIndex++),new Date(t.data.start)<new Date(this.subgroups[e].start)&&(this.subgroups[e].start=t.data.start);var i=t.data.end||t.data.start;new Date(i)>new Date(this.subgroups[e].end)&&(this.subgroups[e].end=i),this.subgroups[e].items.push(t)}},{key:"_updateSubgroupsSizes",value:function(){var t=this;if(t.subgroups){var e=function(){var e,n=t.subgroups[i].items[0].data.end||t.subgroups[i].items[0].data.start,r=t.subgroups[i].items[0].data.start,o=n-1;am(e=t.subgroups[i].items).call(e,(function(t){new Date(t.data.start)<new Date(r)&&(r=t.data.start);var e=t.data.end||t.data.start;new Date(e)>new Date(o)&&(o=e)})),t.subgroups[i].start=r,t.subgroups[i].end=new Date(o-1)};for(var i in t.subgroups)e()}}},{key:"orderSubgroups",value:function(){if(void 0!==this.subgroupOrderer){var t=[];if("string"==typeof this.subgroupOrderer){for(var e in this.subgroups)t.push({subgroup:e,sortField:this.subgroups[e].items[0].data[this.subgroupOrderer]});LE(t).call(t,(function(t,e){return t.sortField-e.sortField}))}else if("function"==typeof this.subgroupOrderer){for(var i in this.subgroups)t.push(this.subgroups[i].items[0].data);LE(t).call(t,this.subgroupOrderer)}if(t.length>0)for(var n=0;n<t.length;n++)this.subgroups[t[n].subgroup].index=n}}},{key:"_resetSubgroups",value:function(){for(var t in this.subgroups)this.subgroups.hasOwnProperty(t)&&(this.subgroups[t].visible=!1,this.subgroups[t].height=0)}},{key:"remove",value:function(t){var e,i;delete this.items[t.id],t.setParent(null),this.stackDirty=!0;var n=Qg(e=this.visibleItems).call(e,t);-1!=n&&Zm(i=this.visibleItems).call(i,n,1),void 0!==t.data.subgroup&&(this._removeFromSubgroup(t),this.orderSubgroups())}},{key:"_removeFromSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;if(null!=e){var i=this.subgroups[e];if(i){var n,r,o=Qg(n=i.items).call(n,t);if(o>=0)Zm(r=i.items).call(r,o,1),i.items.length?this._updateSubgroupsSizes():delete this.subgroups[e]}}}},{key:"removeFromDataSet",value:function(t){this.itemSet.removeItem(t.id)}},{key:"order",value:function(){for(var t=SA.toArray(this.items),e=[],i=[],n=0;n<t.length;n++)void 0!==t[n].data.end&&i.push(t[n]),e.push(t[n]);this.orderedItems={byStart:e,byEnd:i},CN(this.orderedItems.byStart),TN(this.orderedItems.byEnd)}},{key:"_updateItemsInRange",value:function(t,e,i){var n=[],r={};if(!this.isVisible&&this.groupId!=RN){for(var o=0;o<e.length;o++){var s=e[o];s.displayed&&s.hide()}return n}var a=(i.end-i.start)/4,l=i.start-a,h=i.end+a;if(e.length>0)for(var u=0;u<e.length;u++)this._checkIfVisibleWithReference(e[u],n,r,i);var c=SA.binarySearchCustom(t.byStart,(function(t){return t<l?-1:t<=h?0:1}),"data","start");if(this._traceVisible(c,t.byStart,n,r,(function(t){return t.data.start<l||t.data.start>h})),1==this.checkRangedItems){this.checkRangedItems=!1;for(var d=0;d<t.byEnd.length;d++)this._checkIfVisibleWithReference(t.byEnd[d],n,r,i)}else{var p=SA.binarySearchCustom(t.byEnd,(function(t){var e=t.start;return t.end<l?-1:e<=h?0:1}),"data");this._traceVisible(p,t.byEnd,n,r,(function(t){return t.data.end<l||t.data.start>h}))}for(var f={},m=0,v=0;v<n.length;v++){var g=n[v];if(!g.displayed){f[v]=g.redraw(!0),m=f[v].length}}if(m>0)for(var y=function(t){am(SA).call(SA,f,(function(e){e[t]()}))},b=0;b<m;b++)y(b);for(var _=0;_<n.length;_++)n[_].repositionX();return n}},{key:"_traceVisible",value:function(t,e,i,n,r){if(-1!=t){for(var o=t;o>=0;o--){var s=e[o];if(r(s))break;s.isCluster&&!s.hasItems()||s.cluster||void 0===n[s.id]&&(n[s.id]=!0,i.push(s))}for(var a=t+1;a<e.length;a++){var l=e[a];if(r(l))break;l.isCluster&&!l.hasItems()||l.cluster||void 0===n[l.id]&&(n[l.id]=!0,i.push(l))}}}},{key:"_checkIfVisible",value:function(t,e,i){t.isVisible(i)?(t.displayed||t.show(),t.repositionX(),e.push(t)):t.displayed&&t.hide()}},{key:"_checkIfVisibleWithReference",value:function(t,e,i,n){t.isVisible(n)?void 0===i[t.id]&&(i[t.id]=!0,e.push(t)):t.displayed&&t.hide()}},{key:"_updateClustersInRange",value:function(t,e,i){var n=[],r={};if(e.length>0)for(var o=0;o<e.length;o++)this._checkIfVisibleWithReference(e[o],n,r,i);for(var s=0;s<t.byStart.length;s++)this._checkIfVisibleWithReference(t.byStart[s],n,r,i);for(var a=0;a<t.byEnd.length;a++)this._checkIfVisibleWithReference(t.byEnd[a],n,r,i);for(var l={},h=0,u=0;u<n.length;u++){var c=n[u];if(!c.displayed){l[u]=c.redraw(!0),h=l[u].length}}if(h>0)for(var d=0;d<h;d++)am(SA).call(SA,l,(function(t){t[d]()}));for(var p=0;p<n.length;p++)n[p].repositionX();return n}},{key:"changeSubgroup",value:function(t,e,i){this._removeFromSubgroup(t,e),this._addToSubgroup(t,i),this.orderSubgroups()}},{key:"dispose",value:function(){var t;for(this.hide();t=this._disposeCallbacks.pop();)t()}}]),t}();function jN(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}var YN=function(t){qk(i,t);var e=jN(i);function i(t,n,r){var o;return Sc(this,i),(o=e.call(this,t,n,r)).width=0,o.height=0,o.top=0,o.left=0,o}return Wd(i,[{key:"redraw",value:function(t,e,i){this.visibleItems=this._updateItemsInRange(this.orderedItems,this.visibleItems,t),this.width=this.dom.background.offsetWidth,this.dom.background.style.height="0";for(var n=0,r=this.visibleItems.length;n<r;n++){this.visibleItems[n].repositionY(e)}return!1}},{key:"show",value:function(){this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background)}}]),i}(FN);function HN(t,e){var i=void 0!==Fp&&Ea(t)||t["@@iterator"];if(!i){if(tf(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return zN(t,e);var n=qp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zN(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function zN(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}SL('.vis-item{background-color:#d5ddf6;border-color:#97b0f8;border-width:1px;color:#1a1a1a;display:inline-block;position:absolute;z-index:1}.vis-item.vis-selected{background-color:#fff785;border-color:#ffc200;z-index:2}.vis-editable.vis-selected{cursor:move}.vis-item.vis-point.vis-selected{background-color:#fff785}.vis-item.vis-box{border-radius:2px;border-style:solid;text-align:center}.vis-item.vis-point{background:none}.vis-item.vis-dot{border-radius:4px;border-style:solid;border-width:4px;padding:0;position:absolute}.vis-item.vis-range{border-radius:2px;border-style:solid;box-sizing:border-box}.vis-item.vis-background{background-color:rgba(213,221,246,.4);border:none;box-sizing:border-box;margin:0;padding:0}.vis-item .vis-item-overflow{height:100%;margin:0;overflow:hidden;padding:0;position:relative;width:100%}.vis-item-visible-frame{white-space:nowrap}.vis-item.vis-range .vis-item-content{display:inline-block;position:relative}.vis-item.vis-background .vis-item-content{display:inline-block;position:absolute}.vis-item.vis-line{border-left-style:solid;border-left-width:1px;padding:0;position:absolute;width:0}.vis-item .vis-item-content{box-sizing:border-box;padding:5px;white-space:nowrap}.vis-item .vis-onUpdateTime-tooltip{background:#4f81bd;border-radius:1px;color:#fff;padding:5px;position:absolute;text-align:center;transition:.4s;-o-transition:.4s;-moz-transition:.4s;-webkit-transition:.4s;white-space:nowrap;width:200px}.vis-item .vis-delete,.vis-item .vis-delete-rtl{box-sizing:border-box;cursor:pointer;height:24px;padding:0 5px;position:absolute;top:0;-webkit-transition:background .2s linear;-moz-transition:background .2s linear;-ms-transition:background .2s linear;-o-transition:background .2s linear;transition:background .2s linear;width:24px}.vis-item .vis-delete{right:-24px}.vis-item .vis-delete-rtl{left:-24px}.vis-item .vis-delete-rtl:after,.vis-item .vis-delete:after{color:red;content:"\\00D7";font-family:arial,sans-serif;font-size:22px;font-weight:700;-webkit-transition:color .2s linear;-moz-transition:color .2s linear;-ms-transition:color .2s linear;-o-transition:color .2s linear;transition:color .2s linear}.vis-item .vis-delete-rtl:hover,.vis-item .vis-delete:hover{background:red}.vis-item .vis-delete-rtl:hover:after,.vis-item .vis-delete:hover:after{color:#fff}.vis-item .vis-drag-center{cursor:move;height:100%;left:0;position:absolute;top:0;width:100%}.vis-item.vis-range .vis-drag-left{cursor:w-resize;left:-4px}.vis-item.vis-range .vis-drag-left,.vis-item.vis-range .vis-drag-right{height:100%;max-width:20%;min-width:2px;position:absolute;top:0;width:24px}.vis-item.vis-range .vis-drag-right{cursor:e-resize;right:-4px}.vis-range.vis-item.vis-readonly .vis-drag-left,.vis-range.vis-item.vis-readonly .vis-drag-right{cursor:auto}.vis-item.vis-cluster{border-radius:2px;border-style:solid;text-align:center;vertical-align:center}.vis-item.vis-cluster-line{border-left-style:solid;border-left-width:1px;padding:0;position:absolute;width:0}.vis-item.vis-cluster-dot{border-radius:4px;border-style:solid;border-width:4px;padding:0;position:absolute}');var BN=function(){function t(e,i,n){var r,o=this;Sc(this,t),this.id=null,this.parent=null,this.data=e,this.dom=null,this.conversion=i||{},this.defaultOptions={locales:VL,locale:"en"},this.options=SA.extend({},this.defaultOptions,n),this.options.locales=SA.extend({},VL,this.options.locales);var s=this.defaultOptions.locales[this.defaultOptions.locale];am(r=gf(this.options.locales)).call(r,(function(t){o.options.locales[t]=SA.extend({},s,o.options.locales[t])})),this.selected=!1,this.displayed=!1,this.groupShowing=!0,this.selectable=n&&n.selectable||!1,this.dirty=!0,this.top=null,this.right=null,this.left=null,this.width=null,this.height=null,this.setSelectability(e),this.editable=null,this._updateEditStatus()}return Wd(t,[{key:"select",value:function(){this.selectable&&(this.selected=!0,this.dirty=!0,this.displayed&&this.redraw())}},{key:"unselect",value:function(){this.selected=!1,this.dirty=!0,this.displayed&&this.redraw()}},{key:"setData",value:function(t){null!=t.group&&this.data.group!=t.group&&null!=this.parent&&this.parent.itemSet._moveToGroup(this,t.group),this.setSelectability(t),this.parent&&(this.parent.stackDirty=!0),null!=t.subgroup&&this.data.subgroup!=t.subgroup&&null!=this.parent&&this.parent.changeSubgroup(this,this.data.subgroup,t.subgroup),this.data=t,this._updateEditStatus(),this.dirty=!0,this.displayed&&this.redraw()}},{key:"setSelectability",value:function(t){t&&(this.selectable=void 0===t.selectable||Boolean(t.selectable))}},{key:"setParent",value:function(t){this.displayed?(this.hide(),this.parent=t,this.parent&&this.show()):this.parent=t}},{key:"isVisible",value:function(t){return!1}},{key:"show",value:function(){return!1}},{key:"hide",value:function(){return!1}},{key:"redraw",value:function(){}},{key:"repositionX",value:function(){}},{key:"repositionY",value:function(){}},{key:"_repaintDragCenter",value:function(){if(this.selected&&this.editable.updateTime&&!this.dom.dragCenter){var t,e,i=this,n=document.createElement("div");n.className="vis-drag-center",n.dragCenterItem=this,this.hammerDragCenter=new kL(n),this.hammerDragCenter.on("tap",(function(t){i.parent.itemSet.body.emitter.emit("click",{event:t,item:i.id})})),this.hammerDragCenter.on("doubletap",(function(t){t.stopPropagation(),i.parent.itemSet._onUpdateItem(i),i.parent.itemSet.body.emitter.emit("doubleClick",{event:t,item:i.id})})),this.hammerDragCenter.on("panstart",(function(t){t.stopPropagation(),i.parent.itemSet._onDragStart(t)})),this.hammerDragCenter.on("panmove",Uf(t=i.parent.itemSet._onDrag).call(t,i.parent.itemSet)),this.hammerDragCenter.on("panend",Uf(e=i.parent.itemSet._onDragEnd).call(e,i.parent.itemSet)),this.hammerDragCenter.get("press").set({time:1e4}),this.dom.box?this.dom.dragLeft?this.dom.box.insertBefore(n,this.dom.dragLeft):this.dom.box.appendChild(n):this.dom.point&&this.dom.point.appendChild(n),this.dom.dragCenter=n}else!this.selected&&this.dom.dragCenter&&(this.dom.dragCenter.parentNode&&this.dom.dragCenter.parentNode.removeChild(this.dom.dragCenter),this.dom.dragCenter=null,this.hammerDragCenter&&(this.hammerDragCenter.destroy(),this.hammerDragCenter=null))}},{key:"_repaintDeleteButton",value:function(t){var e=(this.options.editable.overrideItems||null==this.editable)&&this.options.editable.remove||!this.options.editable.overrideItems&&null!=this.editable&&this.editable.remove;if(this.selected&&e&&!this.dom.deleteButton){var i=this,n=document.createElement("div");this.options.rtl?n.className="vis-delete-rtl":n.className="vis-delete";var r=this.options.locales[this.options.locale];r||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),r=this.options.locales.en),n.title=r.deleteSelected,this.hammerDeleteButton=new kL(n).on("tap",(function(t){t.stopPropagation(),i.parent.removeFromDataSet(i)})),t.appendChild(n),this.dom.deleteButton=n}else this.selected&&e||!this.dom.deleteButton||(this.dom.deleteButton.parentNode&&this.dom.deleteButton.parentNode.removeChild(this.dom.deleteButton),this.dom.deleteButton=null,this.hammerDeleteButton&&(this.hammerDeleteButton.destroy(),this.hammerDeleteButton=null))}},{key:"_repaintOnItemUpdateTimeTooltip",value:function(t){if(this.options.tooltipOnItemUpdateTime){var e=(this.options.editable.updateTime||!0===this.data.editable)&&!1!==this.data.editable;if(this.selected&&e&&!this.dom.onItemUpdateTimeTooltip){var i=document.createElement("div");i.className="vis-onUpdateTime-tooltip",t.appendChild(i),this.dom.onItemUpdateTimeTooltip=i}else!this.selected&&this.dom.onItemUpdateTimeTooltip&&(this.dom.onItemUpdateTimeTooltip.parentNode&&this.dom.onItemUpdateTimeTooltip.parentNode.removeChild(this.dom.onItemUpdateTimeTooltip),this.dom.onItemUpdateTimeTooltip=null);if(this.dom.onItemUpdateTimeTooltip){this.dom.onItemUpdateTimeTooltip.style.visibility=this.parent.itemSet.touchParams.itemIsDragging?"visible":"hidden",this.dom.onItemUpdateTimeTooltip.style.transform="translateX(-50%)",this.dom.onItemUpdateTimeTooltip.style.left="50%";var n,r,o=this.parent.itemSet.body.domProps.scrollTop;if(("top"==this.options.orientation.item?this.top:this.parent.height-this.top-this.height)+this.parent.top-50<-o?(this.dom.onItemUpdateTimeTooltip.style.bottom="",this.dom.onItemUpdateTimeTooltip.style.top="".concat(this.height+2,"px")):(this.dom.onItemUpdateTimeTooltip.style.top="",this.dom.onItemUpdateTimeTooltip.style.bottom="".concat(this.height+2,"px")),this.options.tooltipOnItemUpdateTime&&this.options.tooltipOnItemUpdateTime.template)n=Uf(r=this.options.tooltipOnItemUpdateTime.template).call(r,this)(this.data);else n="start: ".concat(hI(this.data.start).format("MM/DD/YYYY hh:mm")),this.data.end&&(n+="<br> end: ".concat(hI(this.data.end).format("MM/DD/YYYY hh:mm")));this.dom.onItemUpdateTimeTooltip.innerHTML=SA.xss(n)}}}},{key:"_getItemData",value:function(){return this.parent.itemSet.itemsData.get(this.id)}},{key:"_updateContents",value:function(t){var e,i,n,r,o,s,a=this._getItemData(),l=(this.dom.box||this.dom.point).getElementsByClassName("vis-item-visible-frame")[0];this.options.visibleFrameTemplate?(r=Uf(o=this.options.visibleFrameTemplate).call(o,this),n=SA.xss(r(a,l))):n="";if(l)if(n instanceof Object&&!(n instanceof Element))r(a,l);else if(this._contentToString(this.itemVisibleFrameContent)!==this._contentToString(n)){if(n instanceof Element)l.innerHTML="",l.appendChild(n);else if(null!=n)l.innerHTML=SA.xss(n);else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.itemVisibleFrameContent=n}this.options.template?e=(i=Uf(s=this.options.template).call(s,this))(a,t,this.data):e=this.data.content;if(e instanceof Object&&!(e instanceof Element))i(a,t);else if(this._contentToString(this.content)!==this._contentToString(e)){if(e instanceof Element)t.innerHTML="",t.appendChild(e);else if(null!=e)t.innerHTML=SA.xss(e);else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.content=e}}},{key:"_updateDataAttributes",value:function(t){if(this.options.dataAttributes&&this.options.dataAttributes.length>0){var e=[];if(tf(this.options.dataAttributes))e=this.options.dataAttributes;else{if("all"!=this.options.dataAttributes)return;e=gf(this.data)}var i,n=HN(e);try{for(n.s();!(i=n.n()).done;){var r=i.value,o=this.data[r];null!=o?t.setAttribute("data-".concat(r),o):t.removeAttribute("data-".concat(r))}}catch(t){n.e(t)}finally{n.f()}}}},{key:"_updateStyle",value:function(t){this.style&&(SA.removeCssText(t,this.style),this.style=null),this.data.style&&(SA.addCssText(t,this.data.style),this.style=this.data.style)}},{key:"_contentToString",value:function(t){return"string"==typeof t?t:t&&"outerHTML"in t?t.outerHTML:t}},{key:"_updateEditStatus",value:function(){this.options&&("boolean"==typeof this.options.editable?this.editable={updateTime:this.options.editable,updateGroup:this.options.editable,remove:this.options.editable}:"object"===Nd(this.options.editable)&&(this.editable={},SA.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.options.editable))),this.options&&this.options.editable&&!0===this.options.editable.overrideItems||this.data&&("boolean"==typeof this.data.editable?this.editable={updateTime:this.data.editable,updateGroup:this.data.editable,remove:this.data.editable}:"object"===Nd(this.data.editable)&&(this.editable={},SA.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.data.editable)))}},{key:"getWidthLeft",value:function(){return 0}},{key:"getWidthRight",value:function(){return 0}},{key:"getTitle",value:function(){var t;return this.options.tooltip&&this.options.tooltip.template?Uf(t=this.options.tooltip.template).call(t,this)(this._getItemData(),this.data):this.data.title}}]),t}();function GN(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}BN.prototype.stack=!0;var WN=function(t){qk(i,t);var e=GN(i);function i(t,n,r){var o;if(Sc(this,i),(o=e.call(this,t,n,r)).props={dot:{width:0,height:0},line:{width:0,height:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return o}return Wd(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e,i=this.data.align||this.options.align,n=this.width*t.getMillisecondsPerPixel();return e="right"==i?this.data.start.getTime()>t.start&&this.data.start.getTime()-n<t.end:"left"==i?this.data.start.getTime()+n>t.start&&this.data.start.getTime()<t.end:this.data.start.getTime()+n/2>t.start&&this.data.start.getTime()-n/2<t.end,e}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-line",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-dot",this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}if(!this.dom.line.parentNode){var e=this.parent.dom.background;if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className="vis-item vis-box".concat(e),this.dom.line.className="vis-item vis-line".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},dot:{height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},line:{width:this.dom.line.offsetWidth},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.props.dot.height=t.dot.height,this.props.dot.width=t.dot.width,this.props.line.width=t.line.width,this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.box)}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Uf(e=this._createDomElement).call(e,this),Uf(i=this._appendDomElement).call(i,this),Uf(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(o=a._getDomComponentsSizes())},function(){var t;a.dirty&&Uf(t=a._updateDomComponentsSizes).call(t,a)(o)},Uf(r=this._repaintDomAdditionals).call(r,this)];return t?l:(am(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.remove?t.box.remove():t.box.parentNode&&t.box.parentNode.removeChild(t.box),t.line.remove?t.line.remove():t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.remove?t.dot.remove():t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot),this.displayed=!1}}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n;if(void 0!==e||void 0!==i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3]?-1*e:e;t.style.transform=void 0!==i?void 0!==e?Up(n="translate(".concat(r,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.box,this.boxX,this.boxY,t),e(this.dom.dot,this.dotX,this.dotY,t),e(this.dom.line,this.lineX,this.lineY,t)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=void 0===this.data.align?this.options.align:this.data.align,i=this.props.line.width,n=this.props.dot.width;"right"==e?(this.boxX=t-this.width,this.lineX=t-i,this.dotX=t-i/2-n/2):"left"==e?(this.boxX=t,this.lineX=t,this.dotX=t+i/2-n/2):(this.boxX=t-this.width/2,this.lineX=this.options.rtl?t-i:t-i/2,this.dotX=t-n/2),this.options.rtl?this.right=this.boxX:this.left=this.boxX,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.line.style;if("top"==t){var i=this.parent.top+this.top+1;this.boxY=this.top||0,e.height="".concat(i,"px"),e.bottom="",e.top="0"}else{var n=this.parent.itemSet.props.height-this.parent.top-this.parent.height+this.top;this.boxY=this.parent.height-this.top-(this.height||0),e.height="".concat(n,"px"),e.top="",e.bottom="0"}this.dotY=-this.props.dot.height/2,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}}]),i}(BN);function VN(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}var UN=function(t){qk(i,t);var e=VN(i);function i(t,n,r){var o;if(Sc(this,i),(o=e.call(this,t,n,r)).props={dot:{top:0,width:0,height:0},content:{height:0,marginLeft:0,marginRight:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return o}return Wd(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e=this.width*t.getMillisecondsPerPixel();return this.data.start.getTime()+e>t.start&&this.data.start<t.end}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.point=document.createElement("div"),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.point.appendChild(this.dom.content),this.dom.dot=document.createElement("div"),this.dom.point.appendChild(this.dom.dot),this.dom.point["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.point.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.point)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.point),this._updateStyle(this.dom.point);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.point.className="vis-item vis-point".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{dot:{width:this.dom.dot.offsetWidth,height:this.dom.dot.offsetHeight},content:{width:this.dom.content.offsetWidth,height:this.dom.content.offsetHeight},point:{width:this.dom.point.offsetWidth,height:this.dom.point.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.dot.width=t.dot.width,this.props.dot.height=t.dot.height,this.props.content.height=t.content.height,this.options.rtl?this.dom.content.style.marginRight="".concat(this.props.dot.width/2,"px"):this.dom.content.style.marginLeft="".concat(this.props.dot.width/2,"px"),this.width=t.point.width,this.height=t.point.height,this.dom.dot.style.top="".concat((this.height-this.props.dot.height)/2,"px");var e=this.props.dot.width,i=this.options.rtl?e/2:e/2*-1;this.dom.dot.style.transform="translateX(".concat(i,"px"),this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.point),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.point)}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Uf(e=this._createDomElement).call(e,this),Uf(i=this._appendDomElement).call(i,this),Uf(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(o=a._getDomComponentsSizes())},function(){var t;a.dirty&&Uf(t=a._updateDomComponentsSizes).call(t,a)(o)},Uf(r=this._repaintDomAdditionals).call(r,this)];return t?l:(am(l).call(l,(function(t){s=t()})),s)}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n;if(void 0!==e||void 0!==i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3]?-1*e:e;t.style.transform=void 0!==i?void 0!==e?Up(n="translate(".concat(r,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.point,this.pointX,this.pointY,t)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){this.displayed&&(this.dom.point.parentNode&&this.dom.point.parentNode.removeChild(this.dom.point),this.displayed=!1)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start);this.pointX=t,this.options.rtl?this.right=t-this.props.dot.width:this.left=t-this.props.dot.width,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item;this.pointY="top"==t?this.top:this.parent.height-this.top-this.height,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.props.dot.width}},{key:"getWidthRight",value:function(){return this.props.dot.width}}]),i}(BN);function XN(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}var qN=function(t){qk(i,t);var e=XN(i);function i(t,n,r){var o;if(Sc(this,i),(o=e.call(this,t,n,r)).props={content:{width:0}},o.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return o}return Wd(i,[{key:"isVisible",value:function(t){return!this.cluster&&(this.data.start<t.end&&this.data.end>t.start)}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.visibleFrame=document.createElement("div"),this.dom.visibleFrame.className="vis-item-visible-frame",this.dom.box.appendChild(this.dom.visibleFrame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className=this.baseClassName+e,this.dom.content.style.maxWidth="none"}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.frame).overflow,this.whiteSpace="nowrap"!==window.getComputedStyle(this.dom.content).whiteSpace,{content:{width:this.dom.content.offsetWidth},box:{height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=t.box.height,this.dom.content.style.maxWidth="",this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDeleteButton(this.dom.box),this._repaintDragCenter(),this._repaintDragLeft(),this._repaintDragRight()}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Uf(e=this._createDomElement).call(e,this),Uf(i=this._appendDomElement).call(i,this),Uf(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(o=Uf(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&Uf(t=a._updateDomComponentsSizes).call(t,a)(o)},Uf(r=this._repaintDomAdditionals).call(r,this)];return t?l:(am(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom.box;t.parentNode&&t.parentNode.removeChild(t),this.displayed=!1}}},{key:"repositionX",value:function(t){var e,i,n=this.parent.width,r=this.conversion.toScreen(this.data.start),o=this.conversion.toScreen(this.data.end),s=void 0===this.data.align?this.options.align:this.data.align;!1===this.data.limitSize||void 0!==t&&!0!==t||(r<-n&&(r=-n),o>2*n&&(o=2*n));var a=Math.max(Math.round(1e3*(o-r))/1e3,1);switch(this.overflow?(this.options.rtl?this.right=r:this.left=r,this.width=a+this.props.content.width,i=this.props.content.width):(this.options.rtl?this.right=r:this.left=r,this.width=a,i=Math.min(o-r,this.props.content.width)),this.options.rtl?this.dom.box.style.transform="translateX(".concat(-1*this.right,"px)"):this.dom.box.style.transform="translateX(".concat(this.left,"px)"),this.dom.box.style.width="".concat(a,"px"),this.whiteSpace&&(this.height=this.dom.box.offsetHeight),s){case"left":this.dom.content.style.transform="translateX(0)";break;case"right":if(this.options.rtl){var l=-1*Math.max(a-i,0);this.dom.content.style.transform="translateX(".concat(l,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max(a-i,0),"px)");break;case"center":if(this.options.rtl){var h=-1*Math.max((a-i)/2,0);this.dom.content.style.transform="translateX(".concat(h,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max((a-i)/2,0),"px)");break;default:if(e=this.overflow?o>0?Math.max(-r,0):-i:r<0?-r:0,this.options.rtl){var u=-1*e;this.dom.content.style.transform="translateX(".concat(u,"px)")}else this.dom.content.style.transform="translateX(".concat(e,"px)")}}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;e.style.top="".concat("top"==t?this.top:this.parent.height-this.top-this.height,"px")}},{key:"_repaintDragLeft",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragLeft){var t=document.createElement("div");t.className="vis-drag-left",t.dragLeftItem=this,this.dom.box.appendChild(t),this.dom.dragLeft=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragLeft||(this.dom.dragLeft.parentNode&&this.dom.dragLeft.parentNode.removeChild(this.dom.dragLeft),this.dom.dragLeft=null)}},{key:"_repaintDragRight",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragRight){var t=document.createElement("div");t.className="vis-drag-right",t.dragRightItem=this,this.dom.box.appendChild(t),this.dom.dragRight=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragRight||(this.dom.dragRight.parentNode&&this.dom.dragRight.parentNode.removeChild(this.dom.dragRight),this.dom.dragRight=null)}}]),i}(BN);function $N(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}qN.prototype.baseClassName="vis-item vis-range";var ZN=function(t){qk(i,t);var e=$N(i);function i(t,n,r){var o;if(Sc(this,i),(o=e.call(this,t,n,r)).props={content:{width:0}},o.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return o}return Wd(i,[{key:"isVisible",value:function(t){return this.data.start<t.end&&this.data.end>t.start}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.background;if(!t)throw new Error("Cannot redraw item: parent has no background container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.content),this._updateStyle(this.dom.box);var t=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"");this.dom.box.className=this.baseClassName+t}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.content).overflow,{content:{width:this.dom.content.offsetWidth}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=0,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Uf(e=this._createDomElement).call(e,this),Uf(i=this._appendDomElement).call(i,this),Uf(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(o=Uf(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&Uf(t=a._updateDomComponentsSizes).call(t,a)(o)},Uf(r=this._repaintDomAdditionals).call(r,this)];return t?l:(am(l).call(l,(function(t){s=t()})),s)}},{key:"repositionY",value:function(t){var e,i=this.options.orientation.item;if(void 0!==this.data.subgroup){var n=this.data.subgroup;this.dom.box.style.height="".concat(this.parent.subgroups[n].height,"px"),this.dom.box.style.top="".concat("top"==i?this.parent.top+this.parent.subgroups[n].top:this.parent.top+this.parent.height-this.parent.subgroups[n].top-this.parent.subgroups[n].height,"px"),this.dom.box.style.bottom=""}else this.parent instanceof YN?(e=Math.max(this.parent.height,this.parent.itemSet.body.domProps.center.height,this.parent.itemSet.body.domProps.centerContainer.height),this.dom.box.style.bottom="bottom"==i?"0":"",this.dom.box.style.top="top"==i?"0":""):(e=this.parent.height,this.dom.box.style.top="".concat(this.parent.top,"px"),this.dom.box.style.bottom="");this.dom.box.style.height="".concat(e,"px")}}]),i}(BN);ZN.prototype.baseClassName="vis-item vis-background",ZN.prototype.stack=!1,ZN.prototype.show=qN.prototype.show,ZN.prototype.hide=qN.prototype.hide,ZN.prototype.repositionX=qN.prototype.repositionX;SL("div.vis-tooltip{background-color:#f5f4ed;border:1px solid #808074;-moz-border-radius:3px;-webkit-border-radius:3px;border-radius:3px;box-shadow:3px 3px 10px rgba(0,0,0,.2);color:#000;font-family:verdana;font-size:14px;padding:5px;pointer-events:none;position:absolute;visibility:hidden;white-space:nowrap;z-index:5}");var KN=function(){function t(e,i){Sc(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Wd(t,[{key:"setPosition",value:function(t,e){this.x=Yg(t),this.y=Yg(e)}},{key:"setText",value:function(t){t instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(t)):this.frame.innerHTML=SA.xss(t)}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,r=this.frame.parentNode.clientWidth,o=0,s=0;if("flip"==this.overflowMethod||"none"==this.overflowMethod){var a=!1,l=!0;"flip"==this.overflowMethod&&(this.y-e<this.padding&&(l=!1),this.x+i>r-this.padding&&(a=!0)),o=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(o=this.x)+i+this.padding>r&&(o=r-i-this.padding),o<this.padding&&(o=this.padding);this.frame.style.left=o+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),JN={},QN={get exports(){return JN},set exports(t){JN=t}},tR=Sl.every;In({target:"Array",proto:!0,forced:!Zf("every")},{every:function(t){return tR(this,t,arguments.length>1?arguments[1]:void 0)}});var eR=yp("Array").every,iR=_e,nR=eR,rR=Array.prototype,oR=function(t){var e=t.every;return t===rR||iR(rR,t)&&e===rR.every?nR:e},sR=oR;!function(t){t.exports=sR}(QN);var aR=n(JN);function lR(t,e){var i=void 0!==Fp&&Ea(t)||t["@@iterator"];if(!i){if(tf(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return hR(t,e);var n=qp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return hR(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function hR(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function uR(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}var cR=function(t){qk(i,t);var e=uR(i);function i(t,n,r){var o;Sc(this,i);var s=fv({},{fitOnDoubleClick:!0},r,{editable:!1});if((o=e.call(this,t,n,s)).props={content:{width:0,height:0}},!t||null==t.uiItems)throw new Error('Property "uiItems" missing in item '+t.id);return o.id=qP(),o.group=t.group,o._setupRange(),o.emitter=o.data.eventEmitter,o.range=o.data.range,o.attached=!1,o.isCluster=!0,o.data.isCluster=!0,o}return Wd(i,[{key:"hasItems",value:function(){return this.data.uiItems&&this.data.uiItems.length&&this.attached}},{key:"setUiItems",value:function(t){this.detach(),this.data.uiItems=t,this._setupRange(),this.attach()}},{key:"isVisible",value:function(t){var e=this.data.end?this.data.end-this.data.start:0,i=this.width*t.getMillisecondsPerPixel(),n=Math.max(this.data.start.getTime()+e,this.data.start.getTime()+i);return this.data.start<t.end&&n>t.start&&this.hasItems()}},{key:"getData",value:function(){return{isCluster:!0,id:this.id,items:this.data.items||[],data:this.data}}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a,l,h=[Uf(e=this._createDomElement).call(e,this),Uf(i=this._appendDomElement).call(i,this),Uf(n=this._updateDirtyDomComponents).call(n,this),Uf(r=function(){this.dirty&&(a=this._getDomComponentsSizes())}).call(r,this),Uf(o=function(){var t;this.dirty&&Uf(t=this._updateDomComponentsSizes).call(t,this)(a)}).call(o,this),Uf(s=this._repaintDomAdditionals).call(s,this)];return t?h:(am(h).call(h,(function(t){l=t()})),l)}},{key:"show",value:function(){this.displayed||this.redraw()}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.parentNode&&t.box.parentNode.removeChild(t.box),this.options.showStipes&&(t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot)),this.displayed=!1}}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=this.data.end?this.conversion.toScreen(this.data.end):0;if(e)this.repositionXWithRanges(t,e);else{var i=void 0===this.data.align?this.options.align:this.data.align;this.repositionXWithoutRanges(t,i)}this.options.showStipes&&(this.dom.line.style.display=this._isStipeVisible()?"block":"none",this.dom.dot.style.display=this._isStipeVisible()?"block":"none",this._isStipeVisible()&&this.repositionStype(t,e))}},{key:"repositionStype",value:function(t,e){this.dom.line.style.display="block",this.dom.dot.style.display="block";var i=this.dom.line.offsetWidth,n=this.dom.dot.offsetWidth;if(e){var r=i+t+(e-t)/2,o=r-n/2,s=this.options.rtl?-1*r:r,a=this.options.rtl?-1*o:o;this.dom.line.style.transform="translateX(".concat(s,"px)"),this.dom.dot.style.transform="translateX(".concat(a,"px)")}else{var l=this.options.rtl?-1*t:t,h=this.options.rtl?-1*(t-n/2):t-n/2;this.dom.line.style.transform="translateX(".concat(l,"px)"),this.dom.dot.style.transform="translateX(".concat(h,"px)")}}},{key:"repositionXWithoutRanges",value:function(t,e){"right"==e?this.options.rtl?(this.right=t-this.width,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width,this.dom.box.style.left=this.left+"px"):"left"==e?this.options.rtl?(this.right=t,this.dom.box.style.right=this.right+"px"):(this.left=t,this.dom.box.style.left=this.left+"px"):this.options.rtl?(this.right=t-this.width/2,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width/2,this.dom.box.style.left=this.left+"px")}},{key:"repositionXWithRanges",value:function(t,e){var i=Math.round(Math.max(e-t+.5,1));this.options.rtl?this.right=t:this.left=t,this.width=Math.max(i,this.minWidth||0),this.options.rtl?this.dom.box.style.right=this.right+"px":this.dom.box.style.left=this.left+"px",this.dom.box.style.width=i+"px"}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;if(e.style.top="top"==t?(this.top||0)+"px":(this.parent.height-this.top-this.height||0)+"px",this.options.showStipes){if("top"==t)this.dom.line.style.top="0",this.dom.line.style.height=this.parent.top+this.top+1+"px",this.dom.line.style.bottom="";else{var i=this.parent.itemSet.props.height,n=i-this.parent.top-this.parent.height+this.top;this.dom.line.style.top=i-n+"px",this.dom.line.style.bottom="0"}this.dom.dot.style.top=-this.dom.dot.offsetHeight/2+"px"}}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}},{key:"move",value:function(){this.repositionX(),this.repositionY()}},{key:"attach",value:function(){var t,e,i=lR(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){e.value.cluster=this}}catch(t){i.e(t)}finally{i.f()}this.data.items=cf(t=this.data.uiItems).call(t,(function(t){return t.data})),this.attached=!0,this.dirty=!0}},{key:"detach",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this.hasItems()){var e,i=lR(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){delete e.value.cluster}}catch(t){i.e(t)}finally{i.f()}this.attached=!1,t&&this.group&&(this.group.remove(this),this.group=null),this.data.items=[],this.dirty=!0}}},{key:"_onDoubleClick",value:function(){this._fit()}},{key:"_setupRange",value:function(){var t,e,i,n=cf(t=this.data.uiItems).call(t,(function(t){return{start:t.data.start.valueOf(),end:t.data.end?t.data.end.valueOf():t.data.start.valueOf()}}));this.data.min=Math.min.apply(Math,Np(cf(n).call(n,(function(t){return Math.min(t.start,t.end||t.start)})))),this.data.max=Math.max.apply(Math,Np(cf(n).call(n,(function(t){return Math.max(t.start,t.end||t.start)}))));var r=cf(e=this.data.uiItems).call(e,(function(t){return t.center})),o=uM(r).call(r,(function(t,e){return t+e}),0)/this.data.uiItems.length;WE(i=this.data.uiItems).call(i,(function(t){return t.data.end}))?(this.data.start=new Date(this.data.min),this.data.end=new Date(this.data.max)):(this.data.start=new Date(o),this.data.end=null)}},{key:"_getUiItems",value:function(){var t,e=this;return this.data.uiItems&&this.data.uiItems.length?ig(t=this.data.uiItems).call(t,(function(t){return t.cluster===e})):[]}},{key:"_createDomElement",value:function(){if(!this.dom){var t;if(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.options.showStipes&&(this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-cluster-line",this.dom.line.style.display="none",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-cluster-dot",this.dom.dot.style.display="none"),this.options.fitOnDoubleClick)this.dom.box.ondblclick=Uf(t=i.prototype._onDoubleClick).call(t,this);this.dom.box["vis-item"]=this,this.dirty=!0}}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}var e=this.parent.dom.background;if(this.options.showStipes){if(!this.dom.line.parentNode){if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.baseClassName+" "+(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+" vis-readonly";this.dom.box.className="vis-item "+t,this.options.showStipes&&(this.dom.line.className="vis-item vis-cluster-line "+(this.selected?" vis-selected":""),this.dom.dot.className="vis-item vis-cluster-dot "+(this.selected?" vis-selected":"")),this.data.end&&(this.dom.content.style.maxWidth="none")}}},{key:"_getDomComponentsSizes",value:function(){var t={previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}};return this.options.showStipes&&(t.dot={height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},t.line={width:this.dom.line.offsetWidth}),t}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.data.end?this.minWidth=t.box.width:this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box)}},{key:"_isStipeVisible",value:function(){return this.minWidth>=this.width||!this.data.end}},{key:"_getFitRange",value:function(){var t=.05*(this.data.max-this.data.min)/2;return{fitStart:this.data.min-t,fitEnd:this.data.max+t}}},{key:"_fit",value:function(){if(this.emitter){var t=this._getFitRange(),e=t.fitStart,i=t.fitEnd,n={start:new Date(e),end:new Date(i),animation:!0};this.emitter.emit("fit",n)}}},{key:"_getItemData",value:function(){return this.data}}]),i}(BN);function dR(t,e){var i=void 0!==Fp&&Ea(t)||t["@@iterator"];if(!i){if(tf(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return pR(t,e);var n=qp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return pR(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function pR(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}cR.prototype.baseClassName="vis-item vis-range vis-cluster";var fR="__ungrouped__",mR=function(){function t(e){Sc(this,t),this.itemSet=e,this.groups={},this.cache={},this.cache[-1]=[]}return Wd(t,[{key:"createClusterItem",value:function(t,e,i){return new cR(t,e,i)}},{key:"setItems",value:function(t,e){this.items=t||[],this.dataChanged=!0,this.applyOnChangedLevel=!1,e&&e.applyOnChangedLevel&&(this.applyOnChangedLevel=e.applyOnChangedLevel)}},{key:"updateData",value:function(){this.dataChanged=!0,this.applyOnChangedLevel=!1}},{key:"getClusters",value:function(t,e,i){var n="boolean"==typeof i?{}:i,r=n.maxItems,o=n.clusterCriteria;o||(o=function(){return!0}),r=r||1;var s=-1,a=0;if(e>0){if(e>=1)return[];s=Math.abs(Math.round(Math.log(100/e)/Math.log(2))),a=Math.abs(Math.pow(2,s))}if(this.dataChanged){var l=s!=this.cacheLevel;(!this.applyOnChangedLevel||l)&&(this._dropLevelsCache(),this._filterData())}this.cacheLevel=s;var h=this.cache[s];if(!h){for(var u in h=[],this.groups)if(this.groups.hasOwnProperty(u))for(var c=this.groups[u],d=c.length,p=0;p<d;){for(var f=c[p],m=1,v=p-1;v>=0&&f.center-c[v].center<a/2;)!c[v].cluster&&o(f.data,c[v].data)&&m++,v--;for(var g=p+1;g<c.length&&c[g].center-f.center<a/2;)o(f.data,c[g].data)&&m++,g++;for(var y=h.length-1;y>=0&&f.center-h[y].center<a;)f.group==h[y].group&&o(f.data,h[y].data)&&m++,y--;if(m>r){for(var b=m-r+1,_=[],w=p;_.length<b&&w<c.length;)o(c[p].data,c[w].data)&&_.push(c[w]),w++;var k=this.itemSet.getGroupId(f.data),x=this.itemSet.groups[k]||this.itemSet.groups[fR],D=this._getClusterForItems(_,x,t,i);h.push(D),p+=b}else delete f.cluster,p+=1}this.cache[s]=h}return h}},{key:"_filterData",value:function(){var t={};this.groups=t;for(var e=0,i=fg(this.items);e<i.length;e++){var n=i[e],r=n.parent?n.parent.groupId:"",o=t[r];o||(o=[],t[r]=o),o.push(n),n.data.start&&(n.data.end?n.center=(n.data.start.valueOf()+n.data.end.valueOf())/2:n.center=n.data.start.valueOf())}for(var s in t){var a;if(t.hasOwnProperty(s))LE(a=t[s]).call(a,(function(t,e){return t.center-e.center}))}this.dataChanged=!1}},{key:"_getClusterForItems",value:function(t,e,i,n){var r,o,s=cf(r=i||[]).call(r,(function(t){var e;return{cluster:t,itemsIds:new HO(cf(e=t.data.uiItems).call(e,(function(t){return t.id})))}}));if(s.length){var a,l=dR(s);try{var h=function(){var e=a.value;if(e.itemsIds.size===t.length&&aR(t).call(t,(function(t){return e.itemsIds.has(t.id)})))return o=e.cluster,"break"};for(l.s();!(a=l.n()).done;){if("break"===h())break}}catch(t){l.e(t)}finally{l.f()}}if(o)return o.setUiItems(t),o.group!==e&&(o.group&&o.group.remove(o),e&&(e.add(o),o.group=e)),o;var u=n.titleTemplate||"",c={toScreen:this.itemSet.body.util.toScreen,toTime:this.itemSet.body.util.toTime},d=u.replace(/{count}/,t.length),p='<div title="'+d+'">'+t.length+"</div>",f=fv({},n,this.itemSet.options),m={content:p,title:d,group:e,uiItems:t,eventEmitter:this.itemSet.body.emitter,range:this.itemSet.body.range};return o=this.createClusterItem(m,c,f),e&&(e.add(o),o.group=e),o.attach(),o}},{key:"_dropLevelsCache",value:function(){this.cache={},this.cacheLevel=-1,this.cache[this.cacheLevel]=[]}}]),t}();SL('.vis-itemset{box-sizing:border-box;margin:0;padding:0;position:relative}.vis-itemset .vis-background,.vis-itemset .vis-foreground{height:100%;overflow:visible;position:absolute;width:100%}.vis-axis{height:0;left:0;position:absolute;width:100%;z-index:1}.vis-foreground .vis-group{border-bottom:1px solid #bfbfbf;box-sizing:border-box;position:relative}.vis-foreground .vis-group:last-child{border-bottom:none}.vis-nesting-group{cursor:pointer}.vis-label.vis-nested-group.vis-group-level-unknown-but-gte1{background:#f5f5f5}.vis-label.vis-nested-group.vis-group-level-0{background-color:#fff}.vis-ltr .vis-label.vis-nested-group.vis-group-level-0 .vis-inner{padding-left:0}.vis-rtl .vis-label.vis-nested-group.vis-group-level-0 .vis-inner{padding-right:0}.vis-label.vis-nested-group.vis-group-level-1{background-color:rgba(0,0,0,.05)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-1 .vis-inner{padding-left:15px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-1 .vis-inner{padding-right:15px}.vis-label.vis-nested-group.vis-group-level-2{background-color:rgba(0,0,0,.1)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-2 .vis-inner{padding-left:30px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-2 .vis-inner{padding-right:30px}.vis-label.vis-nested-group.vis-group-level-3{background-color:rgba(0,0,0,.15)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-3 .vis-inner{padding-left:45px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-3 .vis-inner{padding-right:45px}.vis-label.vis-nested-group.vis-group-level-4{background-color:rgba(0,0,0,.2)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-4 .vis-inner{padding-left:60px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-4 .vis-inner{padding-right:60px}.vis-label.vis-nested-group.vis-group-level-5{background-color:rgba(0,0,0,.25)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-5 .vis-inner{padding-left:75px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-5 .vis-inner{padding-right:75px}.vis-label.vis-nested-group.vis-group-level-6{background-color:rgba(0,0,0,.3)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-6 .vis-inner{padding-left:90px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-6 .vis-inner{padding-right:90px}.vis-label.vis-nested-group.vis-group-level-7{background-color:rgba(0,0,0,.35)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-7 .vis-inner{padding-left:105px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-7 .vis-inner{padding-right:105px}.vis-label.vis-nested-group.vis-group-level-8{background-color:rgba(0,0,0,.4)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-8 .vis-inner{padding-left:120px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-8 .vis-inner{padding-right:120px}.vis-label.vis-nested-group.vis-group-level-9{background-color:rgba(0,0,0,.45)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-9 .vis-inner{padding-left:135px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-9 .vis-inner{padding-right:135px}.vis-label.vis-nested-group{background-color:rgba(0,0,0,.5)}.vis-ltr .vis-label.vis-nested-group .vis-inner{padding-left:150px}.vis-rtl .vis-label.vis-nested-group .vis-inner{padding-right:150px}.vis-group-level-unknown-but-gte1{border:1px solid red}.vis-label.vis-nesting-group:before{display:inline-block;width:15px}.vis-label.vis-nesting-group.expanded:before{content:"\\25BC"}.vis-label.vis-nesting-group.collapsed:before{content:"\\25B6"}.vis-rtl .vis-label.vis-nesting-group.collapsed:before{content:"\\25C0"}.vis-ltr .vis-label:not(.vis-nesting-group):not(.vis-group-level-0){padding-left:15px}.vis-rtl .vis-label:not(.vis-nesting-group):not(.vis-group-level-0){padding-right:15px}.vis-overlay{height:100%;left:0;position:absolute;top:0;width:100%;z-index:10}');function vR(t,e){var i=void 0!==Fp&&Ea(t)||t["@@iterator"];if(!i){if(tf(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return gR(t,e);var n=qp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gR(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function gR(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function yR(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}SL(".vis-labelset{overflow:hidden}.vis-labelset,.vis-labelset .vis-label{box-sizing:border-box;position:relative}.vis-labelset .vis-label{border-bottom:1px solid #bfbfbf;color:#4d4d4d;left:0;top:0;width:100%}.vis-labelset .vis-label.draggable{cursor:pointer}.vis-group-is-dragging{background:rgba(0,0,0,.1)}.vis-labelset .vis-label:last-child{border-bottom:none}.vis-labelset .vis-label .vis-inner{display:inline-block;padding:5px}.vis-labelset .vis-label .vis-inner.vis-hidden{padding:0}");var bR="__ungrouped__",_R="__background__",wR=function(t){qk(i,t);var e=yR(i);function i(t,n){var r;Sc(this,i),(r=e.call(this)).body=t,r.defaultOptions={type:null,orientation:{item:"bottom"},align:"auto",stack:!0,stackSubgroups:!0,groupOrderSwap:function(t,e,i){var n=e.order;e.order=t.order,t.order=n},groupOrder:"order",selectable:!0,multiselect:!1,longSelectPressTime:251,itemsAlwaysDraggable:{item:!1,range:!1},editable:{updateTime:!1,updateGroup:!1,add:!1,remove:!1,overrideItems:!1},groupEditable:{order:!1,add:!1,remove:!1},snap:DL.snap,onDropObjectOnItem:function(t,e,i){i(e)},onAdd:function(t,e){e(t)},onUpdate:function(t,e){e(t)},onMove:function(t,e){e(t)},onRemove:function(t,e){e(t)},onMoving:function(t,e){e(t)},onAddGroup:function(t,e){e(t)},onMoveGroup:function(t,e){e(t)},onRemoveGroup:function(t,e){e(t)},margin:{item:{horizontal:10,vertical:10},axis:20},showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:500},tooltipOnItemUpdateTime:!1},r.options=SA.extend({},r.defaultOptions),r.options.rtl=n.rtl,r.options.onTimeout=n.onTimeout,r.conversion={toScreen:t.util.toScreen,toTime:t.util.toTime},r.dom={},r.props={},r.hammer=null;var o=Ek(r);return r.itemsData=null,r.groupsData=null,r.itemsSettingTime=null,r.initialItemSetDrawn=!1,r.userContinueNotBail=null,r.sequentialSelection=!1,r.itemListeners={add:function(t,e,i){o._onAdd(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()},update:function(t,e,i){o._onUpdate(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()},remove:function(t,e,i){o._onRemove(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()}},r.groupListeners={add:function(t,e,i){if(o._onAddGroups(e.items),o.groupsData&&o.groupsData.length>0){var n,r=o.groupsData.getDataSet();am(n=r.get()).call(n,(function(t){if(t.nestedGroups){var e;0!=t.showNested&&(t.showNested=!0);var n=[];am(e=t.nestedGroups).call(e,(function(e){var i=r.get(e);i&&(i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),n=Up(n).call(n,i))})),r.update(n,i)}}))}},update:function(t,e,i){o._onUpdateGroups(e.items)},remove:function(t,e,i){o._onRemoveGroups(e.items)}},r.items={},r.groups={},r.groupIds=[],r.selection=[],r.popup=null,r.popupTimer=null,r.touchParams={},r.groupTouchParams={group:null,isDragging:!1},r._create(),r.setOptions(n),r.clusters=[],r}return Wd(i,[{key:"_create",value:function(){var t,e,i,n,r,o,s,a,l,h,u,c,d,p,f,m=this,v=document.createElement("div");v.className="vis-itemset",v["vis-itemset"]=this,this.dom.frame=v;var g=document.createElement("div");g.className="vis-background",v.appendChild(g),this.dom.background=g;var y=document.createElement("div");y.className="vis-foreground",v.appendChild(y),this.dom.foreground=y;var b=document.createElement("div");b.className="vis-axis",this.dom.axis=b;var _=document.createElement("div");_.className="vis-labelset",this.dom.labelSet=_,this._updateUngrouped();var w=new YN(_R,null,this);w.show(),this.groups[_R]=w,this.hammer=new kL(this.body.dom.centerContainer),this.hammer.on("hammer.input",(function(t){t.isFirst&&m._onTouch(t)})),this.hammer.on("panstart",Uf(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",Uf(e=this._onDrag).call(e,this)),this.hammer.on("panend",Uf(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:kL.ALL}),this.hammer.get("press").set({time:1e4}),this.hammer.on("tap",Uf(n=this._onSelectItem).call(n,this)),this.hammer.on("press",Uf(r=this._onMultiSelectItem).call(r,this)),this.hammer.get("press").set({time:1e4}),this.hammer.on("doubletap",Uf(o=this._onAddItem).call(o,this)),this.options.rtl?this.groupHammer=new kL(this.body.dom.rightContainer):this.groupHammer=new kL(this.body.dom.leftContainer),this.groupHammer.on("tap",Uf(s=this._onGroupClick).call(s,this)),this.groupHammer.on("panstart",Uf(a=this._onGroupDragStart).call(a,this)),this.groupHammer.on("panmove",Uf(l=this._onGroupDrag).call(l,this)),this.groupHammer.on("panend",Uf(h=this._onGroupDragEnd).call(h,this)),this.groupHammer.get("pan").set({threshold:5,direction:kL.DIRECTION_VERTICAL}),this.body.dom.centerContainer.addEventListener("mouseover",Uf(u=this._onMouseOver).call(u,this)),this.body.dom.centerContainer.addEventListener("mouseout",Uf(c=this._onMouseOut).call(c,this)),this.body.dom.centerContainer.addEventListener("mousemove",Uf(d=this._onMouseMove).call(d,this)),this.body.dom.centerContainer.addEventListener("contextmenu",Uf(p=this._onDragEnd).call(p,this)),this.body.dom.centerContainer.addEventListener("mousewheel",Uf(f=this._onMouseWheel).call(f,this)),this.show()}},{key:"setOptions",value:function(t){var e=this;if(t){var i,n;SA.selectiveExtend(["type","rtl","align","order","stack","stackSubgroups","selectable","multiselect","sequentialSelection","multiselectPerGroup","longSelectPressTime","groupOrder","dataAttributes","template","groupTemplate","visibleFrameTemplate","hide","snap","groupOrderSwap","showTooltips","tooltip","tooltipOnItemUpdateTime","groupHeightMode","onTimeout"],this.options,t),"itemsAlwaysDraggable"in t&&("boolean"==typeof t.itemsAlwaysDraggable?(this.options.itemsAlwaysDraggable.item=t.itemsAlwaysDraggable,this.options.itemsAlwaysDraggable.range=!1):"object"===Nd(t.itemsAlwaysDraggable)&&(SA.selectiveExtend(["item","range"],this.options.itemsAlwaysDraggable,t.itemsAlwaysDraggable),this.options.itemsAlwaysDraggable.item||(this.options.itemsAlwaysDraggable.range=!1))),"sequentialSelection"in t&&"boolean"==typeof t.sequentialSelection&&(this.options.sequentialSelection=t.sequentialSelection),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.item="top"===t.orientation?"top":"bottom":"object"===Nd(t.orientation)&&"item"in t.orientation&&(this.options.orientation.item=t.orientation.item)),"margin"in t&&("number"==typeof t.margin?(this.options.margin.axis=t.margin,this.options.margin.item.horizontal=t.margin,this.options.margin.item.vertical=t.margin):"object"===Nd(t.margin)&&(SA.selectiveExtend(["axis"],this.options.margin,t.margin),"item"in t.margin&&("number"==typeof t.margin.item?(this.options.margin.item.horizontal=t.margin.item,this.options.margin.item.vertical=t.margin.item):"object"===Nd(t.margin.item)&&SA.selectiveExtend(["horizontal","vertical"],this.options.margin.item,t.margin.item)))),am(i=["locale","locales"]).call(i,(function(i){i in t&&(e.options[i]=t[i])})),"editable"in t&&("boolean"==typeof t.editable?(this.options.editable.updateTime=t.editable,this.options.editable.updateGroup=t.editable,this.options.editable.add=t.editable,this.options.editable.remove=t.editable,this.options.editable.overrideItems=!1):"object"===Nd(t.editable)&&SA.selectiveExtend(["updateTime","updateGroup","add","remove","overrideItems"],this.options.editable,t.editable)),"groupEditable"in t&&("boolean"==typeof t.groupEditable?(this.options.groupEditable.order=t.groupEditable,this.options.groupEditable.add=t.groupEditable,this.options.groupEditable.remove=t.groupEditable):"object"===Nd(t.groupEditable)&&SA.selectiveExtend(["order","add","remove"],this.options.groupEditable,t.groupEditable));am(n=["onDropObjectOnItem","onAdd","onUpdate","onRemove","onMove","onMoving","onAddGroup","onMoveGroup","onRemoveGroup"]).call(n,(function(i){var n=t[i];if(n){var r;if("function"!=typeof n)throw new Error(Up(r="option ".concat(i," must be a function ")).call(r,i,"(item, callback)"));e.options[i]=n}})),t.cluster?(fv(this.options,{cluster:t.cluster}),this.clusterGenerator||(this.clusterGenerator=new mR(this)),this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.clusterGenerator?(this._detachAllClusters(),this.clusters=[],this.clusterGenerator=null,this.options.cluster=void 0,this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.markDirty()}}},{key:"markDirty",value:function(t){this.groupIds=[],t&&(t.refreshItems&&am(SA).call(SA,this.items,(function(t){t.dirty=!0,t.displayed&&t.redraw()})),t.restackGroups&&am(SA).call(SA,this.groups,(function(t,e){e!==_R&&(t.stackDirty=!0)})))}},{key:"destroy",value:function(){this.clearPopupTimer(),this.hide(),this.setItems(null),this.setGroups(null),this.hammer&&this.hammer.destroy(),this.groupHammer&&this.groupHammer.destroy(),this.hammer=null,this.body=null,this.conversion=null}},{key:"hide",value:function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.axis.parentNode&&this.dom.axis.parentNode.removeChild(this.dom.axis),this.dom.labelSet.parentNode&&this.dom.labelSet.parentNode.removeChild(this.dom.labelSet)}},{key:"show",value:function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame),this.dom.axis.parentNode||this.body.dom.backgroundVertical.appendChild(this.dom.axis),this.dom.labelSet.parentNode||(this.options.rtl?this.body.dom.right.appendChild(this.dom.labelSet):this.body.dom.left.appendChild(this.dom.labelSet))}},{key:"setPopupTimer",value:function(t){if(this.clearPopupTimer(),t){var e=this.options.tooltip.delay||"number"==typeof this.options.tooltip.delay?this.options.tooltip.delay:500;this.popupTimer=Xy((function(){t.show()}),e)}}},{key:"clearPopupTimer",value:function(){null!=this.popupTimer&&(clearTimeout(this.popupTimer),this.popupTimer=null)}},{key:"setSelection",value:function(t){var e;null==t&&(t=[]),tf(t)||(t=[t]);var i,n=ig(e=this.selection).call(e,(function(e){return-1===Qg(t).call(t,e)})),r=vR(n);try{for(r.s();!(i=r.n()).done;){var o=i.value,s=this.getItemById(o);s&&s.unselect()}}catch(t){r.e(t)}finally{r.f()}this.selection=Np(t);var a,l=vR(t);try{for(l.s();!(a=l.n()).done;){var h=a.value,u=this.getItemById(h);u&&u.select()}}catch(t){l.e(t)}finally{l.f()}}},{key:"getSelection",value:function(){var t;return Up(t=this.selection).call(t,[])}},{key:"getVisibleItems",value:function(){var t,e,i=this.body.range.getRange();this.options.rtl?(t=this.body.util.toScreen(i.start),e=this.body.util.toScreen(i.end)):(e=this.body.util.toScreen(i.start),t=this.body.util.toScreen(i.end));var n=[];for(var r in this.groups)if(this.groups.hasOwnProperty(r)){var o,s=this.groups[r],a=vR(s.isVisible?s.visibleItems:[]);try{for(a.s();!(o=a.n()).done;){var l=o.value;this.options.rtl?l.right<e&&l.right+l.width>t&&n.push(l.id):l.left<t&&l.left+l.width>e&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getItemsAtCurrentTime",value:function(t){var e,i;this.options.rtl?(e=this.body.util.toScreen(t),i=this.body.util.toScreen(t)):(i=this.body.util.toScreen(t),e=this.body.util.toScreen(t));var n=[];for(var r in this.groups)if(this.groups.hasOwnProperty(r)){var o,s=this.groups[r],a=vR(s.isVisible?s.visibleItems:[]);try{for(a.s();!(o=a.n()).done;){var l=o.value;this.options.rtl?l.right<i&&l.right+l.width>e&&n.push(l.id):l.left<e&&l.left+l.width>i&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getVisibleGroups",value:function(){var t=[];for(var e in this.groups){if(this.groups.hasOwnProperty(e))this.groups[e].isVisible&&t.push(e)}return t}},{key:"getItemById",value:function(t){var e;return this.items[t]||hN(e=this.clusters).call(e,(function(e){return e.id===t}))}},{key:"_deselect",value:function(t){for(var e=this.selection,i=0,n=e.length;i<n;i++)if(e[i]==t){Zm(e).call(e,i,1);break}}},{key:"redraw",value:function(){var t=this.options.margin,e=this.body.range,i=SA.option.asSize,n=this.options,r=n.orientation.item,o=!1,s=this.dom.frame;this.props.top=this.body.domProps.top.height+this.body.domProps.border.top,this.options.rtl?this.props.right=this.body.domProps.right.width+this.body.domProps.border.right:this.props.left=this.body.domProps.left.width+this.body.domProps.border.left,s.className="vis-itemset",this.options.cluster&&this._clusterItems(),o=this._orderGroups()||o;var a=e.end-e.start,l=a!=this.lastVisibleInterval||this.props.width!=this.props.lastWidth,h=e.start!=this.lastRangeStart,u=n.stack!=this.lastStack,c=n.stackSubgroups!=this.lastStackSubgroups,d=l||h||u||c;this.lastVisibleInterval=a,this.lastRangeStart=e.start,this.lastStack=n.stack,this.lastStackSubgroups=n.stackSubgroups,this.props.lastWidth=this.props.width;var p=this._firstGroup(),f={item:t.item,axis:t.axis},m={item:t.item,axis:t.item.vertical/2},v=0,g=t.axis+t.item.vertical;this.groups[_R].redraw(e,m,d);var y={},b=0;if(am(SA).call(SA,this.groups,(function(t,i){if(i!==_R){var n=t==p?f:m;y[i]=t.redraw(e,n,d,!0),b=y[i].length}})),b>0){for(var _={},w=function(t){am(SA).call(SA,y,(function(e,i){_[i]=e[t]()}))},k=0;k<b;k++)w(k);am(SA).call(SA,this.groups,(function(t,e){if(e!==_R){var i=_[e];o=i||o,v+=t.height}})),v=Math.max(v,g)}return v=Math.max(v,g),s.style.height=i(v),this.props.width=s.offsetWidth,this.props.height=v,this.dom.axis.style.top=i("top"==r?this.body.domProps.top.height+this.body.domProps.border.top:this.body.domProps.top.height+this.body.domProps.centerContainer.height),this.options.rtl?this.dom.axis.style.right="0":this.dom.axis.style.left="0",this.hammer.get("press").set({time:this.options.longSelectPressTime}),this.initialItemSetDrawn=!0,o=this._isResized()||o}},{key:"_firstGroup",value:function(){var t="top"==this.options.orientation.item?0:this.groupIds.length-1,e=this.groupIds[t];return this.groups[e]||this.groups[bR]||null}},{key:"_updateUngrouped",value:function(){var t,e,i=this.groups[bR];if(this.groupsData){if(i)for(e in i.dispose(),delete this.groups[bR],this.items)if(this.items.hasOwnProperty(e)){(t=this.items[e]).parent&&t.parent.remove(t);var n=this.getGroupId(t.data),r=this.groups[n];r&&r.add(t)||t.hide()}}else if(!i){for(e in i=new FN(null,null,this),this.groups[bR]=i,this.items)this.items.hasOwnProperty(e)&&(t=this.items[e],i.add(t));i.show()}}},{key:"getLabelSet",value:function(){return this.dom.labelSet}},{key:"setItems",value:function(t){this.itemsSettingTime=new Date;var e,i=this,n=this.itemsData;if(t){if(!gA(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.itemsData=wA(t)}else this.itemsData=null;if(n&&(am(SA).call(SA,this.itemListeners,(function(t,e){n.off(e,t)})),n.dispose(),e=n.getIds(),this._onRemove(e)),this.itemsData){var r=this.id;am(SA).call(SA,this.itemListeners,(function(t,e){i.itemsData.on(e,t,r)})),e=this.itemsData.getIds(),this._onAdd(e),this._updateUngrouped()}this.body.emitter.emit("_change",{queue:!0})}},{key:"getItems",value:function(){return null!=this.itemsData?this.itemsData.rawDS:null}},{key:"setGroups",value:function(t){var e,i=this;if(this.groupsData&&(am(SA).call(SA,this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null,this._onRemoveGroups(e)),t){if(!gA(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var n,r=this.groupsData.getDataSet();am(n=r.get()).call(n,(function(t){var e;t.nestedGroups&&am(e=t.nestedGroups).call(e,(function(e){var i=r.get(e);i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),r.update(i)}))}));var o=this.id;am(SA).call(SA,this.groupListeners,(function(t,e){i.groupsData.on(e,t,o)})),e=this.groupsData.getIds(),this._onAddGroups(e)}this._updateUngrouped(),this._order(),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems(),this.markDirty({refreshItems:!0,restackGroups:!0})),this.body.emitter.emit("_change",{queue:!0})}},{key:"getGroups",value:function(){return this.groupsData}},{key:"removeItem",value:function(t){var e=this,i=this.itemsData.get(t);i&&this.options.onRemove(i,(function(i){i&&e.itemsData.remove(t)}))}},{key:"_getType",value:function(t){return t.type||this.options.type||(t.end?"range":"box")}},{key:"getGroupId",value:function(t){return"background"==this._getType(t)&&null==t.group?_R:this.groupsData?t.group:bR}},{key:"_onUpdate",value:function(t){var e=this,n=this;am(t).call(t,(function(t){var r,o=n.itemsData.get(t),s=n.items[t],a=o?n._getType(o):null,l=i.types[a];if(s&&(l&&s instanceof l?n._updateItem(s,o):(r=s.selected,n._removeItem(s),s=null)),!s&&o){if(!l)throw new TypeError('Unknown item type "'.concat(a,'"'));(s=new l(o,n.conversion,n.options)).id=t,n._addItem(s),r&&(e.selection.push(t),s.select())}})),this._order(),this.options.cluster&&(this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this._clusterItems()),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemove",value:function(t){var e=0,i=this;am(t).call(t,(function(t){var n=i.items[t];n&&(e++,i._removeItem(n))})),e&&(this._order(),this.body.emitter.emit("_change",{queue:!0}))}},{key:"_order",value:function(){am(SA).call(SA,this.groups,(function(t){t.order()}))}},{key:"_onUpdateGroups",value:function(t){this._onAddGroups(t)}},{key:"_onAddGroups",value:function(t){var e=this;am(t).call(t,(function(t){var i=e.groupsData.get(t),n=e.groups[t];if(n)n.setData(i);else{if(t==bR||t==_R)throw new Error("Illegal group id. ".concat(t," is a reserved id."));var r=gy(e.options);for(var o in SA.extend(r,{height:null}),n=new FN(t,i,e),e.groups[t]=n,e.items)if(e.items.hasOwnProperty(o)){var s=e.items[o];s.data.group==t&&n.add(s)}n.order(),n.show()}})),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemoveGroups",value:function(t){var e=this;am(t).call(t,(function(t){var i=e.groups[t];i&&(i.dispose(),delete e.groups[t])})),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems()),this.markDirty({restackGroups:!!this.options.cluster}),this.body.emitter.emit("_change",{queue:!0})}},{key:"_orderGroups",value:function(){if(this.groupsData){var t=this.groupsData.getIds({order:this.options.groupOrder});t=this._orderNestedGroups(t);var e=!SA.equalArray(t,this.groupIds);if(e){var i=this.groups;am(t).call(t,(function(t){i[t].hide()})),am(t).call(t,(function(t){i[t].show()})),this.groupIds=t}return e}return!1}},{key:"_orderNestedGroups",value:function(t){var e=this;return function t(e,i){var n=[];return am(i).call(i,(function(i){if(n.push(i),e.groupsData.get(i).nestedGroups){var r,o=cf(r=e.groupsData.get({filter:function(t){return t.nestedInGroup==i},order:e.options.groupOrder})).call(r,(function(t){return t.id}));n=Up(n).call(n,t(e,o))}})),n}(this,ig(t).call(t,(function(t){return!e.groupsData.get(t).nestedInGroup})))}},{key:"_addItem",value:function(t){this.items[t.id]=t;var e=this.getGroupId(t.data),i=this.groups[e];i?i&&i.data&&i.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1,i&&i.add(t)}},{key:"_updateItem",value:function(t,e){t.setData(e);var i=this.getGroupId(t.data),n=this.groups[i];n?n&&n.data&&n.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1}},{key:"_removeItem",value:function(t){var e,i;t.hide(),delete this.items[t.id];var n=Qg(e=this.selection).call(e,t.id);-1!=n&&Zm(i=this.selection).call(i,n,1),t.parent&&t.parent.remove(t),null!=this.popup&&this.popup.hide()}},{key:"_constructByEndArray",value:function(t){for(var e=[],i=0;i<t.length;i++)t[i]instanceof qN&&e.push(t[i]);return e}},{key:"_onTouch",value:function(t){this.touchParams.item=this.itemFromTarget(t),this.touchParams.dragLeftItem=t.target.dragLeftItem||!1,this.touchParams.dragRightItem=t.target.dragRightItem||!1,this.touchParams.itemProps=null}},{key:"_getGroupIndex",value:function(t){for(var e=0;e<this.groupIds.length;e++)if(t==this.groupIds[e])return e}},{key:"_onDragStart",value:function(t){var e=this;if(!this.touchParams.itemIsDragging){var i,n=this.touchParams.item||null,r=this;if(n&&(n.selected||this.options.itemsAlwaysDraggable.item)){if(this.options.editable.overrideItems&&!this.options.editable.updateTime&&!this.options.editable.updateGroup)return;if(null!=n.editable&&!n.editable.updateTime&&!n.editable.updateGroup&&!this.options.editable.overrideItems)return;var o=this.touchParams.dragLeftItem,s=this.touchParams.dragRightItem;if(this.touchParams.itemIsDragging=!0,this.touchParams.selectedItem=n,o)i={item:o,initialX:t.center.x,dragLeft:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(s)i={item:s,initialX:t.center.x,dragRight:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey))this._onDragStartAddItem(t);else{this.groupIds.length<1&&this.redraw();var a=this._getGroupIndex(n.data.group),l=this.options.itemsAlwaysDraggable.item&&!n.selected?[n.id]:this.getSelection();this.touchParams.itemProps=cf(l).call(l,(function(i){var n=r.items[i],o=r._getGroupIndex(n.data.group);return{item:n,initialX:t.center.x,groupOffset:a-o,data:e._cloneItemData(n.data)}}))}t.stopPropagation()}else this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey)&&this._onDragStartAddItem(t)}}},{key:"_onDragStartAddItem",value:function(t){var e=this.options.snap||null,i=this.dom.frame.getBoundingClientRect(),n=this.options.rtl?i.right-t.center.x+10:t.center.x-i.left-10,r=this.body.util.toTime(n),o=this.body.util.getScale(),s=this.body.util.getStep(),a=e?e(r,o,s):r,l={type:"range",start:a,end:a,content:"new item"},h=qP();l[this.itemsData.idProp]=h;var u=this.groupFromTarget(t);u&&(l.group=u.groupId);var c=new qN(l,this.conversion,this.options);c.id=h,c.data=this._cloneItemData(l),this._addItem(c),this.touchParams.selectedItem=c;var d={item:c,initialX:t.center.x,data:c.data};this.options.rtl?d.dragLeft=!0:d.dragRight=!0,this.touchParams.itemProps=[d],t.stopPropagation()}},{key:"_onDrag",value:function(t){var e=this;if(null!=this.popup&&this.options.showTooltips&&!this.popup.hidden){var i=this.body.dom.centerContainer,n=i.getBoundingClientRect();this.popup.setPosition(t.center.x-n.left+i.offsetLeft,t.center.y-n.top+i.offsetTop),this.popup.show()}if(this.touchParams.itemProps){var r;t.stopPropagation();var o=this,s=this.options.snap||null,a=this.body.dom.root.offsetLeft,l=this.options.rtl?a+this.body.domProps.right.width:a+this.body.domProps.left.width,h=this.body.util.getScale(),u=this.body.util.getStep(),c=this.touchParams.selectedItem,d=(this.options.editable.overrideItems||null==c.editable)&&this.options.editable.updateGroup||!this.options.editable.overrideItems&&null!=c.editable&&c.editable.updateGroup,p=null;if(d&&c&&null!=c.data.group){var f=o.groupFromTarget(t);f&&(p=this._getGroupIndex(f.groupId))}am(r=this.touchParams.itemProps).call(r,(function(i){var n,r,a,f,m,v=o.body.util.toTime(t.center.x-l),g=o.body.util.toTime(i.initialX-l);n=e.options.rtl?-(v-g):v-g;var y=e._cloneItemData(i.item.data);if(null==i.item.editable||i.item.editable.updateTime||i.item.editable.updateGroup||o.options.editable.overrideItems){if((e.options.editable.overrideItems||null==c.editable)&&e.options.editable.updateTime||!e.options.editable.overrideItems&&null!=c.editable&&c.editable.updateTime)if(i.dragLeft)e.options.rtl?null!=y.end&&(a=SA.convert(i.data.end,"Date"),m=new Date(a.valueOf()+n),y.end=s?s(m,h,u):m):null!=y.start&&(r=SA.convert(i.data.start,"Date"),f=new Date(r.valueOf()+n),y.start=s?s(f,h,u):f);else if(i.dragRight)e.options.rtl?null!=y.start&&(r=SA.convert(i.data.start,"Date"),f=new Date(r.valueOf()+n),y.start=s?s(f,h,u):f):null!=y.end&&(a=SA.convert(i.data.end,"Date"),m=new Date(a.valueOf()+n),y.end=s?s(m,h,u):m);else if(null!=y.start)if(r=SA.convert(i.data.start,"Date").valueOf(),f=new Date(r+n),null!=y.end){var b=(a=SA.convert(i.data.end,"Date")).valueOf()-r.valueOf();y.start=s?s(f,h,u):f,y.end=new Date(y.start.valueOf()+b)}else y.start=s?s(f,h,u):f;if(d&&!i.dragLeft&&!i.dragRight&&null!=p&&null!=y.group){var _=p-i.groupOffset;_=Math.max(0,_),_=Math.min(o.groupIds.length-1,_),y.group=o.groupIds[_]}y=e._cloneItemData(y),o.options.onMoving(y,(function(t){t&&i.item.setData(e._cloneItemData(t,"Date"))}))}})),this.body.emitter.emit("_change")}}},{key:"_moveToGroup",value:function(t,e){var i=this.groups[e];if(i&&i.groupId!=t.data.group){var n=t.parent;n.remove(t),n.order(),t.data.group=i.groupId,i.add(t),i.order()}}},{key:"_onDragEnd",value:function(t){var e=this;if(this.touchParams.itemIsDragging=!1,this.touchParams.itemProps){t.stopPropagation();var i=this,n=this.touchParams.itemProps;this.touchParams.itemProps=null,am(n).call(n,(function(t){var n=t.item.id;if(null!=i.itemsData.get(n)){var r=e._cloneItemData(t.item.data);i.options.onMove(r,(function(r){r?(r[e.itemsData.idProp]=n,e.itemsData.update(r)):(t.item.setData(t.data),i.body.emitter.emit("_change"))}))}else i.options.onAdd(t.item.data,(function(e){i._removeItem(t.item),e&&i.itemsData.add(e),i.body.emitter.emit("_change")}))}))}}},{key:"_onGroupClick",value:function(t){var e=this,i=this.groupFromTarget(t);Xy((function(){e.toggleGroupShowNested(i)}),1)}},{key:"toggleGroupShowNested",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;if(t&&t.nestedGroups){var i=this.groupsData.getDataSet();t.showNested=null!=e?!!e:!t.showNested;var n=i.get(t.groupId);n.showNested=t.showNested;for(var r,o=t.nestedGroups,s=o;s.length>0;){var a=s;s=[];for(var l=0;l<a.length;l++){var h=i.get(a[l]);h.nestedGroups&&(s=Up(s).call(s,h.nestedGroups))}s.length>0&&(o=Up(o).call(o,s))}if(n.showNested){for(var u=i.get(n.nestedGroups),c=0;c<u.length;c++){var d=u[c];d.nestedGroups&&d.nestedGroups.length>0&&(null==d.showNested||1==d.showNested)&&u.push.apply(u,Np(i.get(d.nestedGroups)))}r=cf(u).call(u,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}))}else{var p;r=cf(p=i.get(o)).call(p,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}))}i.update(Up(r).call(r,n)),n.showNested?(SA.removeClassName(t.dom.label,"collapsed"),SA.addClassName(t.dom.label,"expanded")):(SA.removeClassName(t.dom.label,"expanded"),SA.addClassName(t.dom.label,"collapsed"))}}},{key:"toggleGroupDragClassName",value:function(t){t.dom.label.classList.toggle("vis-group-is-dragging"),t.dom.foreground.classList.toggle("vis-group-is-dragging")}},{key:"_onGroupDragStart",value:function(t){this.groupTouchParams.isDragging||this.options.groupEditable.order&&(this.groupTouchParams.group=this.groupFromTarget(t),this.groupTouchParams.group&&(t.stopPropagation(),this.groupTouchParams.isDragging=!0,this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.originalOrder=this.groupsData.getIds({order:this.options.groupOrder})))}},{key:"_onGroupDrag",value:function(t){if(this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this.groupsData.getDataSet(),i=this.groupFromTarget(t);if(i&&i.height!=this.groupTouchParams.group.height){var n=i.top<this.groupTouchParams.group.top,r=t.center?t.center.y:t.clientY,o=i.dom.foreground.getBoundingClientRect(),s=this.groupTouchParams.group.height;if(n){if(o.top+s<r)return}else{var a=i.height;if(o.top+a-s>r)return}}if(i&&i!=this.groupTouchParams.group){var l=e.get(i.groupId),h=e.get(this.groupTouchParams.group.groupId);h&&l&&(this.options.groupOrderSwap(h,l,e),e.update(h),e.update(l));var u=e.getIds({order:this.options.groupOrder});if(!SA.equalArray(u,this.groupTouchParams.originalOrder))for(var c=this.groupTouchParams.originalOrder,d=this.groupTouchParams.group.groupId,p=Math.min(c.length,u.length),f=0,m=0,v=0;f<p;){for(;f+m<p&&f+v<p&&u[f+m]==c[f+v];)f++;if(f+m>=p)break;if(u[f+m]==d)m=1;else if(c[f+v]==d)v=1;else{var g=Qg(u).call(u,c[f+v]),y=e.get(u[f+m]),b=e.get(c[f+v]);this.options.groupOrderSwap(y,b,e),e.update(y),e.update(b);var _=u[f+m];u[f+m]=c[f+v],u[g]=_,f++}}}}}},{key:"_onGroupDragEnd",value:function(t){if(this.groupTouchParams.isDragging=!1,this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this,i=e.groupTouchParams.group.groupId,n=e.groupsData.getDataSet(),r=SA.extend({},n.get(i));e.options.onMoveGroup(r,(function(t){if(t)t[n._idProp]=i,n.update(t);else{var r=n.getIds({order:e.options.groupOrder});if(!SA.equalArray(r,e.groupTouchParams.originalOrder))for(var o=e.groupTouchParams.originalOrder,s=Math.min(o.length,r.length),a=0;a<s;){for(;a<s&&r[a]==o[a];)a++;if(a>=s)break;var l=Qg(r).call(r,o[a]),h=n.get(r[a]),u=n.get(o[a]);e.options.groupOrderSwap(h,u,n),n.update(h),n.update(u);var c=r[a];r[a]=o[a],r[l]=c,a++}}})),e.body.emitter.emit("groupDragged",{groupId:i}),this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.group=null}}},{key:"_onSelectItem",value:function(t){if(this.options.selectable){var e=t.srcEvent&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey),i=t.srcEvent&&t.srcEvent.shiftKey;if(e||i)this._onMultiSelectItem(t);else{var n=this.getSelection(),r=this.itemFromTarget(t),o=r&&r.selectable?[r.id]:[];this.setSelection(o);var s=this.getSelection();(s.length>0||n.length>0)&&this.body.emitter.emit("select",{items:s,event:t})}}}},{key:"_onMouseOver",value:function(t){var e=this.itemFromTarget(t);if(e&&e!==this.itemFromRelatedTarget(t)){var i=e.getTitle();if(this.options.showTooltips&&i){null==this.popup&&(this.popup=new KN(this.body.dom.root,this.options.tooltip.overflowMethod||"flip")),this.popup.setText(i);var n=this.body.dom.centerContainer,r=n.getBoundingClientRect();this.popup.setPosition(t.clientX-r.left+n.offsetLeft,t.clientY-r.top+n.offsetTop),this.setPopupTimer(this.popup)}else this.clearPopupTimer(),null!=this.popup&&this.popup.hide();this.body.emitter.emit("itemover",{item:e.id,event:t})}}},{key:"_onMouseOut",value:function(t){var e=this.itemFromTarget(t);e&&(e!==this.itemFromRelatedTarget(t)&&(this.clearPopupTimer(),null!=this.popup&&this.popup.hide(),this.body.emitter.emit("itemout",{item:e.id,event:t})))}},{key:"_onMouseMove",value:function(t){if(this.itemFromTarget(t)&&(null!=this.popupTimer&&this.setPopupTimer(this.popup),this.options.showTooltips&&this.options.tooltip.followMouse&&this.popup&&!this.popup.hidden)){var e=this.body.dom.centerContainer,i=e.getBoundingClientRect();this.popup.setPosition(t.clientX-i.left+e.offsetLeft,t.clientY-i.top+e.offsetTop),this.popup.show()}}},{key:"_onMouseWheel",value:function(t){this.touchParams.itemIsDragging&&this._onDragEnd(t)}},{key:"_onUpdateItem",value:function(t){if(this.options.selectable&&(this.options.editable.updateTime||this.options.editable.updateGroup)){var e=this;if(t){var i=e.itemsData.get(t.id);this.options.onUpdate(i,(function(t){t&&e.itemsData.update(t)}))}}}},{key:"_onDropObjectOnItem",value:function(t){var e=this.itemFromTarget(t),i=JSON.parse(t.dataTransfer.getData("text"));this.options.onDropObjectOnItem(i,e)}},{key:"_onAddItem",value:function(t){if(this.options.selectable&&this.options.editable.add){var e,i,n=this,r=this.options.snap||null,o=this.dom.frame.getBoundingClientRect(),s=this.options.rtl?o.right-t.center.x:t.center.x-o.left,a=this.body.util.toTime(s),l=this.body.util.getScale(),h=this.body.util.getStep();"drop"==t.type?((i=JSON.parse(t.dataTransfer.getData("text"))).content=i.content?i.content:"new item",i.start=i.start?i.start:r?r(a,l,h):a,i.type=i.type||"box",i[this.itemsData.idProp]=i.id||qP(),"range"!=i.type||i.end||(e=this.body.util.toTime(s+this.props.width/5),i.end=r?r(e,l,h):e)):((i={start:r?r(a,l,h):a,content:"new item"})[this.itemsData.idProp]=qP(),"range"===this.options.type&&(e=this.body.util.toTime(s+this.props.width/5),i.end=r?r(e,l,h):e));var u=this.groupFromTarget(t);u&&(i.group=u.groupId),i=this._cloneItemData(i),this.options.onAdd(i,(function(e){e&&(n.itemsData.add(e),"drop"==t.type&&n.setSelection([e.id]))}))}}},{key:"_onMultiSelectItem",value:function(t){var e=this;if(this.options.selectable){var n=this.itemFromTarget(t);if(n){var r=this.options.multiselect?this.getSelection():[];if((t.srcEvent&&t.srcEvent.shiftKey||!1||this.options.sequentialSelection)&&this.options.multiselect){var o=this.itemsData.get(n.id).group,s=void 0;this.options.multiselectPerGroup&&r.length>0&&(s=this.itemsData.get(r[0]).group),this.options.multiselectPerGroup&&null!=s&&s!=o||r.push(n.id);var a=i._getItemRange(this.itemsData.get(r));if(!this.options.multiselectPerGroup||s==o)for(var l in r=[],this.items)if(this.items.hasOwnProperty(l)){var h=this.items[l],u=h.data.start,c=void 0!==h.data.end?h.data.end:u;!(u>=a.min&&c<=a.max)||this.options.multiselectPerGroup&&s!=this.itemsData.get(h.id).group||h instanceof ZN||r.push(h.id)}}else{var d=Qg(r).call(r,n.id);-1==d?r.push(n.id):Zm(r).call(r,d,1)}var p=ig(r).call(r,(function(t){return e.getItemById(t).selectable}));this.setSelection(p),this.body.emitter.emit("select",{items:this.getSelection(),event:t})}}}},{key:"itemFromElement",value:function(t){for(var e=t;e;){if(e.hasOwnProperty("vis-item"))return e["vis-item"];e=e.parentNode}return null}},{key:"itemFromTarget",value:function(t){return this.itemFromElement(t.target)}},{key:"itemFromRelatedTarget",value:function(t){return this.itemFromElement(t.relatedTarget)}},{key:"groupFromTarget",value:function(t){var e=t.center?t.center.y:t.clientY,i=this.groupIds;i.length<=0&&this.groupsData&&(i=this.groupsData.getIds({order:this.options.groupOrder}));for(var n=0;n<i.length;n++){var r=i[n],o=this.groups[r],s=o.dom.foreground,a=s.getBoundingClientRect();if(e>=a.top&&e<a.top+s.offsetHeight)return o;if("top"===this.options.orientation.item){if(n===this.groupIds.length-1&&e>a.top)return o}else if(0===n&&e<a.top+s.offset)return o}return null}},{key:"_cloneItemData",value:function(t,e){var i=SA.extend({},t);return e||(e=this.itemsData.type),null!=i.start&&(i.start=SA.convert(i.start,e&&e.start||"Date")),null!=i.end&&(i.end=SA.convert(i.end,e&&e.end||"Date")),i}},{key:"_clusterItems",value:function(){if(this.options.cluster){var t=this.body.range.conversion(this.body.domProps.center.width).scale,e=this.clusterGenerator.getClusters(this.clusters,t,this.options.cluster);if(this.clusters!=e){if(this._detachAllClusters(),e){var i,n=vR(e);try{for(n.s();!(i=n.n()).done;){i.value.attach()}}catch(t){n.e(t)}finally{n.f()}this.clusters=e}this._updateClusters(e)}}}},{key:"_detachAllClusters",value:function(){if(this.options.cluster&&this.clusters&&this.clusters.length){var t,e=vR(this.clusters);try{for(e.s();!(t=e.n()).done;){t.value.detach()}}catch(t){e.e(t)}finally{e.f()}}}},{key:"_updateClusters",value:function(t){if(this.clusters&&this.clusters.length){var e,i,n=new HO(cf(t).call(t,(function(t){return t.id}))),r=ig(e=this.clusters).call(e,(function(t){return!n.has(t.id)})),o=!1,s=vR(r);try{for(s.s();!(i=s.n()).done;){var a,l,h=i.value,u=Qg(a=this.selection).call(a,h.id);if(-1!==u)h.unselect(),Zm(l=this.selection).call(l,u,1),o=!0}}catch(t){s.e(t)}finally{s.f()}if(o){var c=this.getSelection();this.body.emitter.emit("select",{items:c,event:event})}}this.clusters=t||[]}}],[{key:"_getItemRange",value:function(t){var e=null,i=null;return am(t).call(t,(function(t){(null==i||t.start<i)&&(i=t.start),null!=t.end?(null==e||t.end>e)&&(e=t.end):(null==e||t.start>e)&&(e=t.start)})),{min:i,max:e}}},{key:"itemSetFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("vis-itemset"))return e["vis-itemset"];e=e.parentNode}return null}}]),i}(HA);wR.types={background:ZN,box:WN,range:qN,point:UN},wR.prototype._onAdd=wR.prototype._onUpdate;var kR,xR=!1,DR="background: #FFeeee; color: #dd0000",SR=function(){function t(){Sc(this,t)}return Wd(t,null,[{key:"validate",value:function(e,i,n){xR=!1,kR=i;var r=i;return void 0!==n&&(r=i[n]),t.parse(e,r,[]),xR}},{key:"parse",value:function(e,i,n){for(var r in e)e.hasOwnProperty(r)&&t.check(r,e,i,n)}},{key:"check",value:function(e,i,n,r){if(void 0!==n[e]||void 0!==n.__any__){var o=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",s="object"===t.getType(i[e]));var a=n[o];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,o,a,r)}else t.getSuggestion(e,n,r)}},{key:"checkFields",value:function(e,i,n,r,o,s){var a=function(i){console.log("%c"+i+t.printLocation(s,e),DR)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===Qg(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),xR=!0):"object"===l&&"__any__"!==r&&(s=SA.copyAndExtendArray(s,e),t.parse(i[e],n[r],s)):void 0===o.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(gf(o))+". Received ["+l+'] "'+i[e]+'"'),xR=!0)}},{key:"getType",value:function(t){var e=Nd(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":tf(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var r,o=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,kR,[],!0);r=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':s.distance<=4&&o.distance>s.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(gf(i))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+r,DR),xR=!0}},{key:"findInOptions",value:function(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var c=void 0;if(void 0!==i[u].__type__&&!0===r){var d=t.findInOptions(e,i[u],SA.copyAndExtendArray(n,u));o>d.distance&&(s=d.closestMatch,a=d.path,o=d.distance,h=d.indexMatch)}else{var p;-1!==Qg(p=u.toLowerCase()).call(p,l)&&(h=u),o>(c=t.levenshteinDistance(e,u))&&(s=u,a=SA.copyArray(n),o=c)}}return{closestMatch:s,path:a,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var r=0;r<n+1;r++)i+="  ";i+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return Dy(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,r=[];for(i=0;i<=e.length;i++)r[i]=[i];for(n=0;n<=t.length;n++)r[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?r[i][n]=r[i-1][n-1]:r[i][n]=Math.min(r[i-1][n-1]+1,Math.min(r[i][n-1]+1,r[i-1][n]+1));return r[e.length][t.length]}}]),t}(),CR="string",TR="boolean",MR="number",OR="array",ER="date",PR="object",IR="moment",AR={configure:{enabled:{boolean:TR},filter:{boolean:TR,function:"function"},container:{dom:"dom"},__type__:{object:PR,boolean:TR,function:"function"}},align:{string:CR},alignCurrentTime:{string:CR,undefined:"undefined"},rtl:{boolean:TR,undefined:"undefined"},rollingMode:{follow:{boolean:TR},offset:{number:MR,undefined:"undefined"},__type__:{object:PR}},onTimeout:{timeoutMs:{number:MR},callback:{function:"function"},__type__:{object:PR}},verticalScroll:{boolean:TR,undefined:"undefined"},horizontalScroll:{boolean:TR,undefined:"undefined"},autoResize:{boolean:TR},throttleRedraw:{number:MR},clickToUse:{boolean:TR},dataAttributes:{string:CR,array:OR},editable:{add:{boolean:TR,undefined:"undefined"},remove:{boolean:TR,undefined:"undefined"},updateGroup:{boolean:TR,undefined:"undefined"},updateTime:{boolean:TR,undefined:"undefined"},overrideItems:{boolean:TR,undefined:"undefined"},__type__:{boolean:TR,object:PR}},end:{number:MR,date:ER,string:CR,moment:IR},format:{minorLabels:{millisecond:{string:CR,undefined:"undefined"},second:{string:CR,undefined:"undefined"},minute:{string:CR,undefined:"undefined"},hour:{string:CR,undefined:"undefined"},weekday:{string:CR,undefined:"undefined"},day:{string:CR,undefined:"undefined"},week:{string:CR,undefined:"undefined"},month:{string:CR,undefined:"undefined"},year:{string:CR,undefined:"undefined"},__type__:{object:PR,function:"function"}},majorLabels:{millisecond:{string:CR,undefined:"undefined"},second:{string:CR,undefined:"undefined"},minute:{string:CR,undefined:"undefined"},hour:{string:CR,undefined:"undefined"},weekday:{string:CR,undefined:"undefined"},day:{string:CR,undefined:"undefined"},week:{string:CR,undefined:"undefined"},month:{string:CR,undefined:"undefined"},year:{string:CR,undefined:"undefined"},__type__:{object:PR,function:"function"}},__type__:{object:PR}},moment:{function:"function"},groupHeightMode:{string:CR},groupOrder:{string:CR,function:"function"},groupEditable:{add:{boolean:TR,undefined:"undefined"},remove:{boolean:TR,undefined:"undefined"},order:{boolean:TR,undefined:"undefined"},__type__:{boolean:TR,object:PR}},groupOrderSwap:{function:"function"},height:{string:CR,number:MR},hiddenDates:{start:{date:ER,number:MR,string:CR,moment:IR},end:{date:ER,number:MR,string:CR,moment:IR},repeat:{string:CR},__type__:{object:PR,array:OR}},itemsAlwaysDraggable:{item:{boolean:TR,undefined:"undefined"},range:{boolean:TR,undefined:"undefined"},__type__:{boolean:TR,object:PR}},limitSize:{boolean:TR},locale:{string:CR},locales:{__any__:{any:"any"},__type__:{object:PR}},longSelectPressTime:{number:MR},margin:{axis:{number:MR},item:{horizontal:{number:MR,undefined:"undefined"},vertical:{number:MR,undefined:"undefined"},__type__:{object:PR,number:MR}},__type__:{object:PR,number:MR}},max:{date:ER,number:MR,string:CR,moment:IR},maxHeight:{number:MR,string:CR},maxMinorChars:{number:MR},min:{date:ER,number:MR,string:CR,moment:IR},minHeight:{number:MR,string:CR},moveable:{boolean:TR},multiselect:{boolean:TR},multiselectPerGroup:{boolean:TR},onAdd:{function:"function"},onDropObjectOnItem:{function:"function"},onUpdate:{function:"function"},onMove:{function:"function"},onMoving:{function:"function"},onRemove:{function:"function"},onAddGroup:{function:"function"},onMoveGroup:{function:"function"},onRemoveGroup:{function:"function"},onInitialDrawComplete:{function:"function"},order:{function:"function"},orientation:{axis:{string:CR,undefined:"undefined"},item:{string:CR,undefined:"undefined"},__type__:{string:CR,object:PR}},selectable:{boolean:TR},sequentialSelection:{boolean:TR},showCurrentTime:{boolean:TR},showMajorLabels:{boolean:TR},showMinorLabels:{boolean:TR},showWeekScale:{boolean:TR},stack:{boolean:TR},stackSubgroups:{boolean:TR},cluster:{maxItems:{number:MR,undefined:"undefined"},titleTemplate:{string:CR,undefined:"undefined"},clusterCriteria:{function:"function",undefined:"undefined"},showStipes:{boolean:TR,undefined:"undefined"},fitOnDoubleClick:{boolean:TR,undefined:"undefined"},__type__:{boolean:TR,object:PR}},snap:{function:"function",null:"null"},start:{date:ER,number:MR,string:CR,moment:IR},template:{function:"function"},loadingScreenTemplate:{function:"function"},groupTemplate:{function:"function"},visibleFrameTemplate:{string:CR,function:"function"},showTooltips:{boolean:TR},tooltip:{followMouse:{boolean:TR},overflowMethod:{string:["cap","flip","none"]},delay:{number:MR},template:{function:"function"},__type__:{object:PR}},tooltipOnItemUpdateTime:{template:{function:"function"},__type__:{boolean:TR,object:PR}},timeAxis:{scale:{string:CR,undefined:"undefined"},step:{number:MR,undefined:"undefined"},__type__:{object:PR}},type:{string:CR},width:{string:CR,number:MR},preferZoom:{boolean:TR},zoomable:{boolean:TR},zoomKey:{string:["ctrlKey","altKey","shiftKey","metaKey",""]},zoomFriction:{number:MR},zoomMax:{number:MR},zoomMin:{number:MR},xss:{disabled:{boolean:TR},filterOptions:{__any__:{any:"any"},__type__:{object:PR}},__type__:{object:PR}},__type__:{object:PR}},LR={global:{align:["center","left","right"],alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],direction:!1,autoResize:!0,clickToUse:!1,editable:{add:!1,remove:!1,updateGroup:!1,updateTime:!1},end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}},groupHeightMode:["auto","fixed","fitItems"],groupsDraggable:!1,height:"",locale:"",longSelectPressTime:251,margin:{axis:[20,0,100,1],item:{horizontal:[10,0,100,1],vertical:[10,0,100,1]}},max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!1,multiselect:!1,multiselectPerGroup:!1,orientation:{axis:["both","bottom","top"],item:["bottom","top"]},preferZoom:!1,selectable:!0,showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,stack:!0,stackSubgroups:!0,cluster:!1,start:"",showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:[500,0,99999,100]},tooltipOnItemUpdateTime:!1,type:["box","point","range","background"],width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","shiftKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],xss:{disabled:!1}}},NR={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},RR=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Sc(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Wd(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return NR[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===SA.isString(t)){if(!0===SA.isValidRGB(t)){var r=t.substr(4).substr(0,t.length-5).split(",");i={r:r[0],g:r[1],b:r[2],a:1}}else if(!0===SA.isValidRGBA(t)){var o=t.substr(5).substr(0,t.length-6).split(",");i={r:o[0],g:o[1],b:o[2],a:o[3]}}else if(!0===SA.isValidHex(t)){var s=SA.hexToRGB(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Dy(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=SA.extend({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Xy((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=SA.extend({},t)),this.color=t;var e=SA.RGBToHSV(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,r=this.centerCoordinates.x+n*Math.sin(i*e.h),o=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=o-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=SA.RGBToHSV(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=SA.HSVToRGB(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=SA.RGBToHSV(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,r=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,r),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),sb(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var r=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var o=document.createElement("DIV");o.style.color="red",o.style.fontWeight="bold",o.style.padding="10px",o.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(o)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=Uf(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=Uf(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=Uf(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=Uf(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new kL(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),xL(this.hammer,(function(e){t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,r,o=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,o,s),this.centerCoordinates={x:.5*o,y:.5*s},this.r=.49*o;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(r=0;r<this.r;r++)e=this.centerCoordinates.x+r*Math.sin(l*n),i=this.centerCoordinates.y+r*Math.cos(l*n),a=SA.HSVToRGB(.002777777777777778*n,r*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,o,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,r=.5*this.colorPickerDiv.clientHeight,o=.5*this.colorPickerDiv.clientWidth,s=i-o,a=n-r,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),o),u=Math.cos(l)*h+r,c=Math.sin(l)*h+o;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=c-.5*this.colorPickerSelector.clientWidth+"px";var d=l/(2*Math.PI);d=d<0?d+1:d;var p=h/this.r,f=SA.RGBToHSV(this.color.r,this.color.g,this.color.b);f.h=d,f.s=p;var m=SA.HSVToRGB(f.h,f.s,f.v);m.a=this.color.a,this.color=m,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();SL('div.vis-configuration{display:block;float:left;font-size:12px;position:relative}div.vis-configuration-wrapper{display:block;width:700px}div.vis-configuration-wrapper:after{clear:both;content:"";display:block}div.vis-configuration.vis-config-option-container{background-color:#fff;border:2px solid #f7f8fa;border-radius:4px;display:block;left:10px;margin-top:20px;padding-left:5px;width:495px}div.vis-configuration.vis-config-button{background-color:#f7f8fa;border:2px solid #ceced0;border-radius:4px;cursor:pointer;display:block;height:25px;left:10px;line-height:25px;margin-bottom:30px;margin-top:20px;padding-left:5px;vertical-align:middle;width:495px}div.vis-configuration.vis-config-button.hover{background-color:#4588e6;border:2px solid #214373;color:#fff}div.vis-configuration.vis-config-item{display:block;float:left;height:25px;line-height:25px;vertical-align:middle;width:495px}div.vis-configuration.vis-config-item.vis-config-s2{background-color:#f7f8fa;border-radius:3px;left:10px;padding-left:5px}div.vis-configuration.vis-config-item.vis-config-s3{background-color:#e4e9f0;border-radius:3px;left:20px;padding-left:5px}div.vis-configuration.vis-config-item.vis-config-s4{background-color:#cfd8e6;border-radius:3px;left:30px;padding-left:5px}div.vis-configuration.vis-config-header{font-size:18px;font-weight:700}div.vis-configuration.vis-config-label{height:25px;line-height:25px;width:120px}div.vis-configuration.vis-config-label.vis-config-s3{width:110px}div.vis-configuration.vis-config-label.vis-config-s4{width:100px}div.vis-configuration.vis-config-colorBlock{border:1px solid #444;border-radius:2px;cursor:pointer;height:19px;margin:0;padding:0;top:1px;width:30px}input.vis-configuration.vis-config-checkbox{left:-5px}input.vis-configuration.vis-config-rangeinput{margin:0;padding:1px;pointer-events:none;position:relative;top:-5px;width:60px}input.vis-configuration.vis-config-range{-webkit-appearance:none;background-color:transparent;border:0 solid #fff;height:20px;width:300px}input.vis-configuration.vis-config-range::-webkit-slider-runnable-track{background:#dedede;background:-moz-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#dedede),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#dedede,#c8c8c8 99%);background:-o-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:linear-gradient(180deg,#dedede 0,#c8c8c8 99%);border:1px solid #999;border-radius:3px;box-shadow:0 0 3px 0 #aaa;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#dedede",endColorstr="#c8c8c8",GradientType=0);height:5px;width:300px}input.vis-configuration.vis-config-range::-webkit-slider-thumb{-webkit-appearance:none;background:#3876c2;background:-moz-linear-gradient(top,#3876c2 0,#385380 100%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#3876c2),color-stop(100%,#385380));background:-webkit-linear-gradient(top,#3876c2,#385380);background:-o-linear-gradient(top,#3876c2 0,#385380 100%);background:-ms-linear-gradient(top,#3876c2 0,#385380 100%);background:linear-gradient(180deg,#3876c2 0,#385380);border:1px solid #14334b;border-radius:50%;box-shadow:0 0 1px 0 #111927;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#3876c2",endColorstr="#385380",GradientType=0);height:17px;margin-top:-7px;width:17px}input.vis-configuration.vis-config-range:focus{outline:none}input.vis-configuration.vis-config-range:focus::-webkit-slider-runnable-track{background:#9d9d9d;background:-moz-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#9d9d9d),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#9d9d9d,#c8c8c8 99%);background:-o-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:linear-gradient(180deg,#9d9d9d 0,#c8c8c8 99%);filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#9d9d9d",endColorstr="#c8c8c8",GradientType=0)}input.vis-configuration.vis-config-range::-moz-range-track{background:#dedede;background:-moz-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#dedede),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#dedede,#c8c8c8 99%);background:-o-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:linear-gradient(180deg,#dedede 0,#c8c8c8 99%);border:1px solid #999;border-radius:3px;box-shadow:0 0 3px 0 #aaa;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#dedede",endColorstr="#c8c8c8",GradientType=0);height:10px;width:300px}input.vis-configuration.vis-config-range::-moz-range-thumb{background:#385380;border:none;border-radius:50%;height:16px;width:16px}input.vis-configuration.vis-config-range:-moz-focusring{outline:1px solid #fff;outline-offset:-1px}input.vis-configuration.vis-config-range::-ms-track{background:transparent;border-color:transparent;border-width:6px 0;color:transparent;height:5px;width:300px}input.vis-configuration.vis-config-range::-ms-fill-lower{background:#777;border-radius:10px}input.vis-configuration.vis-config-range::-ms-fill-upper{background:#ddd;border-radius:10px}input.vis-configuration.vis-config-range::-ms-thumb{background:#385380;border:none;border-radius:50%;height:16px;width:16px}input.vis-configuration.vis-config-range:focus::-ms-fill-lower{background:#888}input.vis-configuration.vis-config-range:focus::-ms-fill-upper{background:#ccc}.vis-configuration-popup{background:rgba(57,76,89,.85);border:2px solid #f2faff;border-radius:4px;color:#fff;font-size:14px;height:30px;line-height:30px;position:absolute;text-align:center;-webkit-transition:opacity .3s ease-in-out;-moz-transition:opacity .3s ease-in-out;transition:opacity .3s ease-in-out;width:150px}.vis-configuration-popup:after,.vis-configuration-popup:before{border:solid transparent;content:" ";height:0;left:100%;pointer-events:none;position:absolute;top:50%;width:0}.vis-configuration-popup:after{border-color:rgba(136,183,213,0) rgba(136,183,213,0) rgba(136,183,213,0) rgba(57,76,89,.85);border-width:8px;margin-top:-8px}.vis-configuration-popup:before{border-color:rgba(194,225,245,0) rgba(194,225,245,0) rgba(194,225,245,0) #f2faff;border-width:12px;margin-top:-12px}');var FR=function(){function t(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;Sc(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},SA.extend(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new RR(r),this.wrapper=void 0}return Wd(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(tf(t))this.options.filter=t.join();else if("object"===Nd(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==ig(t)&&(this.options.filter=ig(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===ig(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=ig(this.options),e=0,i=!1;for(var n in this.configureOptions)this.configureOptions.hasOwnProperty(n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===Qg(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return am(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerHTML=SA.xss(t),this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");return n.className="vis-configuration vis-config-label vis-config-s"+e.length,n.innerHTML=!0===i?SA.xss("<i><b>"+t+":</b></i>"):SA.xss(t+":"),n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var r=0;void 0!==e&&-1!==Qg(t).call(t,e)&&(r=Qg(t).call(t,e));for(var o=0;o<t.length;o++){var s=document.createElement("option");s.value=t[o],o===r&&(s.selected="selected"),s.innerHTML=t[o],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],r=t[1],o=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=r,a.max=o}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){var u=1.2;e<0&&e*u<r?(a.min=Math.ceil(e*u),h=a.min,l="range increased"):e/u<r&&(a.min=Math.ceil(e/u),h=a.min,l="range increased"),e*u>o&&1!==o&&(a.max=Math.ceil(e*u),h=a.max,l="range increased"),a.value=e}else a.value=n;var c=document.createElement("input");c.className="vis-configuration vis-config-rangeinput",c.value=Number(a.value);var d=this;a.onchange=function(){c.value=this.value,d._update(Number(this.value),i)},a.oninput=function(){c.value=this.value};var p=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,p,a,c);""!==l&&this.popupHistory[f]!==h&&(this.popupHistory[f]=h,this._setupPopup(l,f))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerHTML=SA.xss(t),n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Xy((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Xy((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Nd(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var r=this;n.onchange=function(){r._update(this.checked,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var r=this;n.onchange=function(){r._update(this.value,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,r=t[1],o=document.createElement("div");"none"!==(e=void 0===e?r:e)?(o.className="vis-configuration vis-config-colorBlock",o.style.backgroundColor=e):o.className="vis-configuration vis-config-colorBlock none",e=void 0===e?r:e,o.onclick=function(){n._showColorPicker(e,o,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var r="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=r,n._update(r,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,r=ig(this.options),o=!1;for(var s in t)if(t.hasOwnProperty(s)){n=!0;var a=t[s],l=SA.copyAndExtendArray(e,s);if("function"==typeof r&&!1===(n=r(s,e))&&!tf(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){o=!0;var h=this._getValue(l);if(tf(a))this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){var u=!0;if(-1!==Qg(e).call(e,"physics")&&this.moduleOptions.physics.solver!==s&&(u=!1),!0===u)if(void 0!==a.enabled){var c=SA.copyAndExtendArray(l,"enabled"),d=this._getValue(c);if(!0===d){var p=this._makeLabel(s,l,!0);this._makeItem(l,p),o=this._handleObject(a,l)||o}else this._makeCheckbox(a,d,l)}else{var f=this._makeLabel(s,l,!0);this._makeItem(l,f),o=this._handleObject(a,l)||o}}else console.error("dont know how to handle",a,s,l)}}return o}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var r=0;r<e.length;r++)"global"!==e[r]&&(void 0===n[e[r]]&&(n[e[r]]={}),r!==e.length-1?n=n[e[r]]:n[e[r]]=t);return i}},{key:"_printOptions",value:function(){var t=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+Dy(t,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}();function jR(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}var YR=function(t){qk(i,t);var e=jR(i);function i(t,n,r,o){var s,a,l,h,u,c,d,p;if(Sc(this,i),(p=e.call(this)).initTime=new Date,p.itemsDone=!1,!(Ek(p)instanceof i))throw new SyntaxError("Constructor must be called with the new operator");if(!tf(r)&&!gA(r)&&r instanceof Object){var f=o;o=r,r=f}o&&o.throttleRedraw&&console.warn('Timeline option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var m=Ek(p);if(p.defaultOptions={autoResize:!0,longSelectPressTime:251,orientation:{axis:"bottom",item:"bottom"},moment:hI},p.options=SA.deepExtend({},p.defaultOptions),o&&SA.setupXSSProtection(o.xss),p._create(t),!o||o&&void 0===o.rtl){var v;p.dom.root.style.visibility="hidden";for(var g=p.dom.root;!v&&g;)v=window.getComputedStyle(g,null).direction,g=g.parentElement;p.options.rtl=v&&"rtl"==v.toLowerCase()}else p.options.rtl=o.rtl;o&&(o.rollingMode&&(p.options.rollingMode=o.rollingMode),o.onInitialDrawComplete&&(p.options.onInitialDrawComplete=o.onInitialDrawComplete),o.onTimeout&&(p.options.onTimeout=o.onTimeout),o.loadingScreenTemplate&&(p.options.loadingScreenTemplate=o.loadingScreenTemplate));var y=document.createElement("div");if(p.options.loadingScreenTemplate){var b,_=Uf(b=p.options.loadingScreenTemplate).call(b,Ek(p)),w=_(p.dom.loadingScreen);w instanceof Object&&!(w instanceof Element)?_(y):w instanceof Element?(y.innerHTML="",y.appendChild(w)):null!=w&&(y.innerHTML=SA.xss(w))}function k(t,e){m.hasListeners(t)&&m.emit(t,m.getEventProperties(e))}return p.dom.loadingScreen.appendChild(y),p.components=[],p.body={dom:p.dom,domProps:p.props,emitter:{on:Uf(s=p.on).call(s,Ek(p)),off:Uf(a=p.off).call(a,Ek(p)),emit:Uf(l=p.emit).call(l,Ek(p))},hiddenDates:[],util:{getScale:function(){return m.timeAxis.step.scale},getStep:function(){return m.timeAxis.step.step},toScreen:Uf(h=m._toScreen).call(h,m),toGlobalScreen:Uf(u=m._toGlobalScreen).call(u,m),toTime:Uf(c=m._toTime).call(c,m),toGlobalTime:Uf(d=m._toGlobalTime).call(d,m)}},p.range=new mL(p.body,p.options),p.components.push(p.range),p.body.range=p.range,p.timeAxis=new TL(p.body,p.options),p.timeAxis2=null,p.components.push(p.timeAxis),p.currentTime=new ZL(p.body,p.options),p.components.push(p.currentTime),p.itemSet=new wR(p.body,p.options),p.components.push(p.itemSet),p.itemsData=null,p.groupsData=null,p.dom.root.onclick=function(t){k("click",t)},p.dom.root.ondblclick=function(t){k("doubleClick",t)},p.dom.root.oncontextmenu=function(t){k("contextmenu",t)},p.dom.root.onmouseover=function(t){k("mouseOver",t)},window.PointerEvent?(p.dom.root.onpointerdown=function(t){k("mouseDown",t)},p.dom.root.onpointermove=function(t){k("mouseMove",t)},p.dom.root.onpointerup=function(t){k("mouseUp",t)}):(p.dom.root.onmousemove=function(t){k("mouseMove",t)},p.dom.root.onmousedown=function(t){k("mouseDown",t)},p.dom.root.onmouseup=function(t){k("mouseUp",t)}),p.initialFitDone=!1,p.on("changed",(function(){if(null!=m.itemsData){if(!m.initialFitDone&&!m.options.rollingMode)if(m.initialFitDone=!0,null!=m.options.start||null!=m.options.end){if(null==m.options.start||null==m.options.end)var t=m.getItemRange();var e=null!=m.options.start?m.options.start:t.min,i=null!=m.options.end?m.options.end:t.max;m.setWindow(e,i,{animation:!1})}else m.fit({animation:!1});m.initialDrawDone||!m.initialRangeChangeDone&&(m.options.start||m.options.end)&&!m.options.rollingMode||(m.initialDrawDone=!0,m.itemSet.initialDrawDone=!0,m.dom.root.style.visibility="visible",m.dom.loadingScreen.parentNode.removeChild(m.dom.loadingScreen),m.options.onInitialDrawComplete&&Xy((function(){return m.options.onInitialDrawComplete()}),0))}})),p.on("destroyTimeline",(function(){m.destroy()})),o&&p.setOptions(o),p.body.emitter.on("fit",(function(t){p._onFit(t),p.redraw()})),r&&p.setGroups(r),n&&p.setItems(n),p._redraw(),p}return Wd(i,[{key:"_createConfigurator",value:function(){return new FR(this,this.dom.container,LR)}},{key:"redraw",value:function(){this.itemSet&&this.itemSet.markDirty({refreshItems:!0}),this._redraw()}},{key:"setOptions",value:function(t){if(!0===SR.validate(t,AR)&&console.log("%cErrors have been found in the supplied options object.",DR),qL.prototype.setOptions.call(this,t),"type"in t&&t.type!==this.options.type){this.options.type=t.type;var e=this.itemsData;if(e){var i=this.getSelection();this.setItems(null),this.setItems(e.rawDS),this.setSelection(i)}}}},{key:"setItems",value:function(t){var e;this.itemsDone=!1,e=t?gA(t)?wA(t):wA(new sI(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=e,this.itemSet&&this.itemSet.setItems(null!=e?e.rawDS:null)}},{key:"setGroups",value:function(t){var e;t?(tf(t)&&(t=new sI(t)),e=new aI(t,{filter:function(t){return!1!==t.visible}})):e=null,null!=this.groupsData&&"function"==typeof this.groupsData.setData&&this.groupsData.setData(null),this.groupsData=e,this.itemSet.setGroups(e)}},{key:"setData",value:function(t){t&&t.groups&&this.setGroups(t.groups),t&&t.items&&this.setItems(t.items)}},{key:"setSelection",value:function(t,e){this.itemSet&&this.itemSet.setSelection(t),e&&e.focus&&this.focus(t,e)}},{key:"getSelection",value:function(){return this.itemSet&&this.itemSet.getSelection()||[]}},{key:"focus",value:function(t,e){if(this.itemsData&&null!=t){var i=tf(t)?t:[t],n=this.itemsData.get(i),r=null,o=null;if(am(n).call(n,(function(t){var e=t.start.valueOf(),i="end"in t?t.end.valueOf():t.start.valueOf();(null===r||e<r)&&(r=e),(null===o||i>o)&&(o=i)})),null!==r&&null!==o){var s=this,a=this.itemSet.items[i[0]],l=-1*this._getScrollTop(),h=null,u=function(){var t=BR(s,a);t.shouldScroll&&t.itemTop!=h.itemTop&&(s._setScrollTop(-t.scrollOffset),s._redraw())},c=!e||void 0===e.zoom||e.zoom,d=(r+o)/2,p=c?1.1*(o-r):Math.max(this.range.end-this.range.start,1.1*(o-r)),f=!e||void 0===e.animation||e.animation;f||(h={shouldScroll:!1,scrollOffset:-1,itemTop:-1}),this.range.setRange(d-p/2,d+p/2,{animation:f},(function(){u(),Xy(u,100)}),(function(t,e,i){var n=BR(s,a);if(!1!==n&&(h||(h=n),h.itemTop!=n.itemTop||h.shouldScroll)){h.itemTop!=n.itemTop&&n.shouldScroll&&(h=n,l=-1*s._getScrollTop());var r=l,o=h.scrollOffset,u=i?o:r+(o-r)*t;s._setScrollTop(-u),e||s._redraw()}}))}}}},{key:"fit",value:function(t,e){var i,n=!t||void 0===t.animation||t.animation;1===this.itemsData.length&&void 0===this.itemsData.get()[0].end?(i=this.getDataRange(),this.moveTo(i.min.valueOf(),{animation:n},e)):(i=this.getItemRange(),this.range.setRange(i.min,i.max,{animation:n},e))}},{key:"getItemRange",value:function(){var t=this,e=this.getDataRange(),i=null!==e.min?e.min.valueOf():null,n=null!==e.max?e.max.valueOf():null,r=null,o=null;if(null!=i&&null!=n){var s=n-i;s<=0&&(s=10);var a=s/this.props.center.width,l={},h=0;if(am(SA).call(SA,this.itemSet.items,(function(t,e){if(t.groupShowing){l[e]=t.redraw(!0),h=l[e].length}})),h>0)for(var u=function(t){am(SA).call(SA,l,(function(e){e[t]()}))},c=0;c<h;c++)u(c);if(am(SA).call(SA,this.itemSet.items,(function(e){var s,l,h=HR(e),u=zR(e);t.options.rtl?(s=h-(e.getWidthRight()+10)*a,l=u+(e.getWidthLeft()+10)*a):(s=h-(e.getWidthLeft()+10)*a,l=u+(e.getWidthRight()+10)*a),s<i&&(i=s,r=e),l>n&&(n=l,o=e)})),r&&o){var d=r.getWidthLeft()+10,p=o.getWidthRight()+10,f=this.props.center.width-d-p;f>0&&(this.options.rtl?(i=HR(r)-p*s/f,n=zR(o)+d*s/f):(i=HR(r)-d*s/f,n=zR(o)+p*s/f))}}return{min:null!=i?new Date(i):null,max:null!=n?new Date(n):null}}},{key:"getDataRange",value:function(){var t,e=null,i=null;this.itemsData&&am(t=this.itemsData).call(t,(function(t){var n=SA.convert(t.start,"Date").valueOf(),r=SA.convert(null!=t.end?t.end:t.start,"Date").valueOf();(null===e||n<e)&&(e=n),(null===i||r>i)&&(i=r)}));return{min:null!=e?new Date(e):null,max:null!=i?new Date(i):null}}},{key:"getEventProperties",value:function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=this.dom.centerContainer.getBoundingClientRect(),r=this.options.rtl?n.right-e:e-n.left,o=i-n.top,s=this.itemSet.itemFromTarget(t),a=this.itemSet.groupFromTarget(t),l=XL.customTimeFromTarget(t),h=this.itemSet.options.snap||null,u=this.body.util.getScale(),c=this.body.util.getStep(),d=this._toTime(r),p=h?h(d,u,c):d,f=SA.getTarget(t),m=null;return null!=s?m="item":null!=l?m="custom-time":SA.hasParent(f,this.timeAxis.dom.foreground)||this.timeAxis2&&SA.hasParent(f,this.timeAxis2.dom.foreground)?m="axis":SA.hasParent(f,this.itemSet.dom.labelSet)?m="group-label":SA.hasParent(f,this.currentTime.bar)?m="current-time":SA.hasParent(f,this.dom.center)&&(m="background"),{event:t,item:s?s.id:null,isCluster:!!s&&!!s.isCluster,items:s?s.items||[]:null,group:a?a.groupId:null,customTime:l?l.options.id:null,what:m,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:r,y:o,time:d,snappedTime:p}}},{key:"toggleRollingMode",value:function(){this.range.rolling?this.range.stopRolling():(null==this.options.rollingMode&&this.setOptions(this.options),this.range.startRolling())}},{key:"_redraw",value:function(){qL.prototype._redraw.call(this)}},{key:"_onFit",value:function(t){var e=t.start,i=t.end,n=t.animation;i?this.range.setRange(e,i,{animation:n}):this.moveTo(e.valueOf(),{animation:n})}}]),i}(qL);function HR(t){return SA.convert(t.data.start,"Date").valueOf()}function zR(t){var e=null!=t.data.end?t.data.end:t.data.start;return SA.convert(e,"Date").valueOf()}function BR(t,e){if(!e.parent)return!1;var i=t.options.rtl?t.props.rightContainer.height:t.props.leftContainer.height,n=t.props.center.height,r=e.parent,o=r.top,s=!0,a=t.timeAxis.options.orientation.axis,l=function(){return"bottom"==a?r.height-e.top-e.height:e.top},h=-1*t._getScrollTop(),u=o+l(),c=e.height;return u<h?o+i<=o+l()+c&&(o+=l()-t.itemSet.options.margin.item.vertical):u+c>h+i?o+=l()+c-i+t.itemSet.options.margin.item.vertical:s=!1,{shouldScroll:s,scrollOffset:o=Math.min(o,n-i),itemTop:u}}var GR=function(){function t(e,i,n,r,o,s){var a=arguments.length>6&&void 0!==arguments[6]&&arguments[6],l=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(Sc(this,t),this.majorSteps=[1,2,5,10],this.minorSteps=[.25,.5,1,2],this.customLines=null,this.containerHeight=o,this.majorCharHeight=s,this._start=e,this._end=i,this.scale=1,this.minorStepIdx=-1,this.magnitudefactor=1,this.determineScale(),this.zeroAlign=a,this.autoScaleStart=n,this.autoScaleEnd=r,this.formattingFunction=l,n||r){var h=this,u=function(t){var e=t-t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx]);return t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx])>h.magnitudefactor*h.minorSteps[h.minorStepIdx]*.5?e+h.magnitudefactor*h.minorSteps[h.minorStepIdx]:e};n&&(this._start-=2*this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._start=u(this._start)),r&&(this._end+=this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._end=u(this._end)),this.determineScale()}}return Wd(t,[{key:"setCharHeight",value:function(t){this.majorCharHeight=t}},{key:"setHeight",value:function(t){this.containerHeight=t}},{key:"determineScale",value:function(){var t=this._end-this._start;this.scale=this.containerHeight/t;var e=this.majorCharHeight/this.scale,i=t>0?Math.round(Math.log(t)/Math.LN10):0;this.minorStepIdx=-1,this.magnitudefactor=Math.pow(10,i);var n=0;i<0&&(n=i);for(var r=!1,o=n;Math.abs(o)<=Math.abs(i);o++){this.magnitudefactor=Math.pow(10,o);for(var s=0;s<this.minorSteps.length;s++){if(this.magnitudefactor*this.minorSteps[s]>=e){r=!0,this.minorStepIdx=s;break}}if(!0===r)break}}},{key:"is_major",value:function(t){return t%(this.magnitudefactor*this.majorSteps[this.minorStepIdx])==0}},{key:"getStep",value:function(){return this.magnitudefactor*this.minorSteps[this.minorStepIdx]}},{key:"getFirstMajor",value:function(){var t=this.magnitudefactor*this.majorSteps[this.minorStepIdx];return this.convertValue(this._start+(t-this._start%t)%t)}},{key:"formatValue",value:function(t){var e=t.toPrecision(5);return"function"==typeof this.formattingFunction&&(e=this.formattingFunction(t)),"number"==typeof e?"".concat(e):"string"==typeof e?e:t.toPrecision(5)}},{key:"getLines",value:function(){for(var t=[],e=this.getStep(),i=(e-this._start%e)%e,n=this._start+i;this._end-n>1e-5;n+=e)n!=this._start&&t.push({major:this.is_major(n),y:this.convertValue(n),val:this.formatValue(n)});return t}},{key:"followScale",value:function(t){var e=this.minorStepIdx,i=this._start,n=this._end,r=this,o=function(){r.magnitudefactor*=2},s=function(){r.magnitudefactor/=2};t.minorStepIdx<=1&&this.minorStepIdx<=1||t.minorStepIdx>1&&this.minorStepIdx>1||(t.minorStepIdx<this.minorStepIdx?(this.minorStepIdx=1,2==e||o(),o()):(this.minorStepIdx=2,1==e||s(),s()));for(var a=t.convertValue(0),l=t.getStep()*t.scale,h=!1,u=0;!h&&u++<5;){this.scale=l/(this.minorSteps[this.minorStepIdx]*this.magnitudefactor);var c=this.containerHeight/this.scale;this._start=i,this._end=this._start+c;var d=this._end*this.scale,p=this.magnitudefactor*this.majorSteps[this.minorStepIdx],f=this.getFirstMajor()-t.getFirstMajor();if(this.zeroAlign){var m=a-d;this._end+=m/this.scale,this._start=this._end-c}else this.autoScaleStart?(this._start-=f/this.scale,this._end=this._start+c):(this._start+=p-f/this.scale,this._end=this._start+c);if(!this.autoScaleEnd&&this._end>n+1e-5)s(),h=!1;else{if(!this.autoScaleStart&&this._start<i-1e-5){if(!(this.zeroAlign&&i>=0)){s(),h=!1;continue}console.warn("Can't adhere to given 'min' range, due to zeroalign")}this.autoScaleStart&&this.autoScaleEnd&&c<n-i?(o(),h=!1):h=!0}}}},{key:"convertValue",value:function(t){return this.containerHeight-(t-this._start)*this.scale}},{key:"screenToValue",value:function(t){return(this.containerHeight-t)/this.scale+this._start}}]),t}();function WR(t,e){var i=void 0!==Fp&&Ea(t)||t["@@iterator"];if(!i){if(tf(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return VR(t,e);var n=qp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return VR(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function VR(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function UR(t){var e=function(){if("undefined"==typeof Reflect||!zP)return!1;if(zP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(zP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ex(t);if(e){var r=ex(this).constructor;i=zP(n,arguments,r)}else i=n.apply(this,arguments);return $k(this,i)}}SL(".vis-panel.vis-background.vis-horizontal .vis-grid.vis-horizontal{border-bottom:1px solid;height:0;position:absolute;width:100%}.vis-panel.vis-background.vis-horizontal .vis-grid.vis-minor{border-color:#e5e5e5}.vis-panel.vis-background.vis-horizontal .vis-grid.vis-major{border-color:#bfbfbf}.vis-data-axis .vis-y-axis.vis-major{color:#4d4d4d;position:absolute;white-space:nowrap;width:100%}.vis-data-axis .vis-y-axis.vis-major.vis-measure{border:0;margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-minor{color:#bebebe;position:absolute;white-space:nowrap;width:100%}.vis-data-axis .vis-y-axis.vis-minor.vis-measure{border:0;margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-title{bottom:20px;color:#4d4d4d;position:absolute;text-align:center;white-space:nowrap}.vis-data-axis .vis-y-axis.vis-title.vis-measure{margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-title.vis-left{bottom:0;-webkit-transform:rotate(-90deg);-moz-transform:rotate(-90deg);-ms-transform:rotate(-90deg);-o-transform:rotate(-90deg);transform:rotate(-90deg);-webkit-transform-origin:left top;-moz-transform-origin:left top;-ms-transform-origin:left top;-o-transform-origin:left top;transform-origin:left bottom}.vis-data-axis .vis-y-axis.vis-title.vis-right{bottom:0;-webkit-transform:rotate(90deg);-moz-transform:rotate(90deg);-ms-transform:rotate(90deg);-o-transform:rotate(90deg);transform:rotate(90deg);-webkit-transform-origin:right bottom;-moz-transform-origin:right bottom;-ms-transform-origin:right bottom;-o-transform-origin:right bottom;transform-origin:right bottom}.vis-legend{background-color:rgba(247,252,255,.65);border:1px solid #b3b3b3;box-shadow:2px 2px 10px hsla(0,0%,60%,.55);padding:5px}.vis-legend-text{display:inline-block;white-space:nowrap}");var XR=function(t){qk(i,t);var e=UR(i);function i(t,n,r,o){var s;Sc(this,i),(s=e.call(this)).id=qP(),s.body=t,s.defaultOptions={orientation:"left",showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,majorLinesOffset:7,minorLinesOffset:4,labelOffsetX:10,labelOffsetY:2,iconWidth:20,width:"40px",visible:!0,alignZeros:!0,left:{range:{min:void 0,max:void 0},format:function(t){return"".concat(YA(t.toPrecision(3)))},title:{text:void 0,style:void 0}},right:{range:{min:void 0,max:void 0},format:function(t){return"".concat(YA(t.toPrecision(3)))},title:{text:void 0,style:void 0}}},s.linegraphOptions=o,s.linegraphSVG=r,s.props={},s.DOMelements={lines:{},labels:{},title:{}},s.dom={},s.scale=void 0,s.range={start:0,end:0},s.options=SA.extend({},s.defaultOptions),s.conversionFactor=1,s.setOptions(n),s.width=Number("".concat(s.options.width).replace("px","")),s.minWidth=s.width,s.height=s.linegraphSVG.getBoundingClientRect().height,s.hidden=!1,s.stepPixels=25,s.zeroCrossing=-1,s.amountOfSteps=-1,s.lineOffset=0,s.master=!0,s.masterAxis=null,s.svgElements={},s.iconsRemoved=!1,s.groups={},s.amountOfGroups=0,s._create(),null==s.scale&&s._redrawLabels(),s.framework={svg:s.svg,svgElements:s.svgElements,options:s.options,groups:s.groups};var a=Ek(s);return s.body.emitter.on("verticalDrag",(function(){a.dom.lineContainer.style.top="".concat(a.body.domProps.scrollTop,"px")})),s}return Wd(i,[{key:"addGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1}},{key:"updateGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.amountOfGroups+=1),this.groups[t]=e}},{key:"removeGroup",value:function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)}},{key:"setOptions",value:function(t){if(t){var e=!1;this.options.orientation!=t.orientation&&void 0!==t.orientation&&(e=!0);SA.selectiveDeepExtend(["orientation","showMinorLabels","showMajorLabels","icons","majorLinesOffset","minorLinesOffset","labelOffsetX","labelOffsetY","iconWidth","width","visible","left","right","alignZeros"],this.options,t),this.minWidth=Number("".concat(this.options.width).replace("px","")),!0===e&&this.dom.frame&&(this.hide(),this.show())}}},{key:"_create",value:function(){this.dom.frame=document.createElement("div"),this.dom.frame.style.width=this.options.width,this.dom.frame.style.height=this.height,this.dom.lineContainer=document.createElement("div"),this.dom.lineContainer.style.width="100%",this.dom.lineContainer.style.height=this.height,this.dom.lineContainer.style.position="relative",this.dom.lineContainer.style.visibility="visible",this.dom.lineContainer.style.display="block",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.height="100%",this.svg.style.width="100%",this.svg.style.display="block",this.dom.frame.appendChild(this.svg)}},{key:"_redrawGroupIcons",value:function(){var t;wk(this.svgElements);var e=this.options.iconWidth,i=11.5;t="left"===this.options.orientation?4:this.width-e-4;var n=gf(this.groups);LE(n).call(n,(function(t,e){return t<e?-1:1}));var r,o=WR(n);try{for(o.s();!(r=o.n()).done;){var s=r.value;!0!==this.groups[s].visible||void 0!==this.linegraphOptions.visibility[s]&&!0!==this.linegraphOptions.visibility[s]||(this.groups[s].getLegend(e,15,this.framework,t,i),i+=19)}}catch(t){o.e(t)}finally{o.f()}kk(this.svgElements),this.iconsRemoved=!1}},{key:"_cleanupIcons",value:function(){!1===this.iconsRemoved&&(wk(this.svgElements),kk(this.svgElements),this.iconsRemoved=!0)}},{key:"show",value:function(){this.hidden=!1,this.dom.frame.parentNode||("left"===this.options.orientation?this.body.dom.left.appendChild(this.dom.frame):this.body.dom.right.appendChild(this.dom.frame)),this.dom.lineContainer.parentNode||this.body.dom.backgroundHorizontal.appendChild(this.dom.lineContainer),this.dom.lineContainer.style.display="block"}},{key:"hide",value:function(){this.hidden=!0,this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.lineContainer.style.display="none"}},{key:"setRange",value:function(t,e){this.range.start=t,this.range.end=e}},{key:"redraw",value:function(){var t=!1,e=0;for(var i in this.dom.lineContainer.style.top="".concat(this.body.domProps.scrollTop,"px"),this.groups)this.groups.hasOwnProperty(i)&&(!0!==this.groups[i].visible||void 0!==this.linegraphOptions.visibility[i]&&!0!==this.linegraphOptions.visibility[i]||e++);if(0===this.amountOfGroups||0===e)this.hide();else{this.show(),this.height=Number(this.linegraphSVG.style.height.replace("px","")),this.dom.lineContainer.style.height="".concat(this.height,"px"),this.width=!0===this.options.visible?Number("".concat(this.options.width).replace("px","")):0;var n=this.props,r=this.dom.frame;r.className="vis-data-axis",this._calculateCharSize();var o=this.options.orientation,s=this.options.showMinorLabels,a=this.options.showMajorLabels,l=this.body.dom.backgroundHorizontal.offsetWidth;n.minorLabelHeight=s?n.minorCharHeight:0,n.majorLabelHeight=a?n.majorCharHeight:0,n.minorLineWidth=l-this.lineOffset-this.width+2*this.options.minorLinesOffset,n.minorLineHeight=1,n.majorLineWidth=l-this.lineOffset-this.width+2*this.options.majorLinesOffset,n.majorLineHeight=1,"left"===o?(r.style.top="0",r.style.left="0",r.style.bottom="",r.style.width="".concat(this.width,"px"),r.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.left.width,this.props.height=this.body.domProps.left.height):(r.style.top="",r.style.bottom="0",r.style.left="0",r.style.width="".concat(this.width,"px"),r.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.right.width,this.props.height=this.body.domProps.right.height),t=this._redrawLabels(),t=this._isResized()||t,!0===this.options.icons?this._redrawGroupIcons():this._cleanupIcons(),this._redrawTitle(o)}return t}},{key:"_redrawLabels",value:function(){var t=this,e=!1;wk(this.DOMelements.lines),wk(this.DOMelements.labels);var i=this.options.orientation,n=null!=this.options[i].range?this.options[i].range:{},r=!0;null!=n.max&&(this.range.end=n.max,r=!1);var o=!0;null!=n.min&&(this.range.start=n.min,o=!1),this.scale=new GR(this.range.start,this.range.end,o,r,this.dom.frame.offsetHeight,this.props.majorCharHeight,this.options.alignZeros,this.options[i].format),!1===this.master&&null!=this.masterAxis?(this.scale.followScale(this.masterAxis.scale),this.dom.lineContainer.style.display="none"):this.dom.lineContainer.style.display="block",this.maxLabelSize=0;var s=this.scale.getLines();am(s).call(s,(function(e){var n=e.y,r=e.major;t.options.showMinorLabels&&!1===r&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-minor",t.props.minorCharHeight),r&&n>=0&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-major",t.props.majorCharHeight),!0===t.master&&(r?t._redrawLine(n,i,"vis-grid vis-horizontal vis-major",t.options.majorLinesOffset,t.props.majorLineWidth):t._redrawLine(n,i,"vis-grid vis-horizontal vis-minor",t.options.minorLinesOffset,t.props.minorLineWidth))}));var a=0;void 0!==this.options[i].title&&void 0!==this.options[i].title.text&&(a=this.props.titleCharHeight);var l=!0===this.options.icons?Math.max(this.options.iconWidth,a)+this.options.labelOffsetX+15:a+this.options.labelOffsetX+15;return this.maxLabelSize>this.width-l&&!0===this.options.visible?(this.width=this.maxLabelSize+l,this.options.width="".concat(this.width,"px"),kk(this.DOMelements.lines),kk(this.DOMelements.labels),this.redraw(),e=!0):this.maxLabelSize<this.width-l&&!0===this.options.visible&&this.width>this.minWidth?(this.width=Math.max(this.minWidth,this.maxLabelSize+l),this.options.width="".concat(this.width,"px"),kk(this.DOMelements.lines),kk(this.DOMelements.labels),this.redraw(),e=!0):(kk(this.DOMelements.lines),kk(this.DOMelements.labels),e=!1),e}},{key:"convertValue",value:function(t){return this.scale.convertValue(t)}},{key:"screenToValue",value:function(t){return this.scale.screenToValue(t)}},{key:"_redrawLabel",value:function(t,e,i,n,r){var o=Sk("div",this.DOMelements.labels,this.dom.frame);o.className=n,o.innerHTML=SA.xss(e),"left"===i?(o.style.left="-".concat(this.options.labelOffsetX,"px"),o.style.textAlign="right"):(o.style.right="-".concat(this.options.labelOffsetX,"px"),o.style.textAlign="left"),o.style.top="".concat(t-.5*r+this.options.labelOffsetY,"px"),e+="";var s=Math.max(this.props.majorCharWidth,this.props.minorCharWidth);this.maxLabelSize<e.length*s&&(this.maxLabelSize=e.length*s)}},{key:"_redrawLine",value:function(t,e,i,n,r){if(!0===this.master){var o=Sk("div",this.DOMelements.lines,this.dom.lineContainer);o.className=i,o.innerHTML="","left"===e?o.style.left="".concat(this.width-n,"px"):o.style.right="".concat(this.width-n,"px"),o.style.width="".concat(r,"px"),o.style.top="".concat(t,"px")}}},{key:"_redrawTitle",value:function(t){if(wk(this.DOMelements.title),void 0!==this.options[t].title&&void 0!==this.options[t].title.text){var e=Sk("div",this.DOMelements.title,this.dom.frame);e.className="vis-y-axis vis-title vis-".concat(t),e.innerHTML=SA.xss(this.options[t].title.text),void 0!==this.options[t].title.style&&SA.addCssText(e,this.options[t].title.style),"left"===t?e.style.left="".concat(this.props.titleCharHeight,"px"):e.style.right="".concat(this.props.titleCharHeight,"px"),e.style.width="".concat(this.height,"px")}kk(this.DOMelements.title)}},{key:"_calculateCharSize",value:function(){if(!("minorCharHeight"in this.props)){var t=document.createTextNode("0"),e=document.createElement("div");e.className="vis-y-axis vis-minor vis-measure",e.appendChild(t),this.dom.frame.appendChild(e),this.props.minorCharHeight=e.clientHeight,this.props.minorCharWidth=e.clientWidth,this.dom.frame.removeChild(e)}if(!("majorCharHeight"in this.props)){var i=document.createTextNode("0"),n=document.createElement("div");n.className="vis-y-axis vis-major vis-measure",n.appendChild(i),this.dom.frame.appendChild(n),this.props.majorCharHeight=n.clientHeight,this.props.majorCharWidth=n.clientWidth,this.dom.frame.removeChild(n)}if(!("titleCharHeight"in this.props)){var r=document.createTextNode("0"),o=document.createElement("div");o.className="vis-y-axis vis-title vis-measure",o.appendChild(r),this.dom.frame.appendChild(o),this.props.titleCharHeight=o.clientHeight,this.props.titleCharWidth=o.clientWidth,this.dom.frame.removeChild(o)}}}]),i}(HA);function qR(t,e){}function $R(t,e){return{style:(e=void 0===e?{}:e).style||t.options.drawPoints.style,styles:e.styles||t.options.drawPoints.styles,size:e.size||t.options.drawPoints.size,className:e.className||t.className}}function ZR(t,e){}function KR(t,e){}function JR(t,e,i,n){this.id=e;this.options=SA.selectiveBridgeObject(["sampling","style","sort","yAxisOrientation","barChart","drawPoints","shaded","interpolation","zIndex","excludeFromStacking","excludeFromLegend"],i),this.usingDefaultStyle=void 0===t.className,this.groupsUsingDefaultStyles=n,this.zeroPosition=0,this.update(t),1==this.usingDefaultStyle&&(this.groupsUsingDefaultStyles[0]+=1),this.itemsData=[],this.visible=void 0===t.visible||t.visible}function QR(t,e,i,n){this.body=t,this.defaultOptions={enabled:!1,icons:!0,iconSize:20,iconSpacing:6,left:{visible:!0,position:"top-left"},right:{visible:!0,position:"top-right"}},this.side=i,this.options=SA.extend({},this.defaultOptions),this.linegraphOptions=n,this.svgElements={},this.dom={},this.groups={},this.amountOfGroups=0,this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups},this.setOptions(e)}qR.draw=function(t,e,i,n){n=n||0;for(var r=function(t,e){var i=void 0;t.options&&t.options.drawPoints&&t.options.drawPoints.onRender&&"function"==typeof t.options.drawPoints.onRender&&(i=t.options.drawPoints.onRender);e.group.options&&e.group.options.drawPoints&&e.group.options.drawPoints.onRender&&"function"==typeof e.group.options.drawPoints.onRender&&(i=e.group.options.drawPoints.onRender);return i}(i,e),o=0;o<t.length;o++)if(r){var s=r(t[o],e);!0!==s&&"object"!==Nd(s)||Ck(t[o].screen_x+n,t[o].screen_y,$R(e,s),i.svgElements,i.svg,t[o].label)}else Ck(t[o].screen_x+n,t[o].screen_y,$R(e),i.svgElements,i.svg,t[o].label)},qR.drawIcon=function(t,e,i,n,r,o){var s=.5*r,a=Dk("rect",o.svgElements,o.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline"),Ck(e+.5*n,i,$R(t),o.svgElements,o.svg)},ZR.drawIcon=function(t,e,i,n,r,o){var s=.5*r,a=Dk("rect",o.svgElements,o.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline");var l=Math.round(.3*n),h=t.options.barChart.width/l,u=Math.round(.4*r),c=Math.round(.75*r),d=Math.round((n-2*l)/3);if(Tk(e+.5*l+d,i+s-u-1,l,u,t.className+" vis-bar",o.svgElements,o.svg,t.style),Tk(e+1.5*l+d+2,i+s-c-1,l,c,t.className+" vis-bar",o.svgElements,o.svg,t.style),1==t.options.drawPoints.enabled){var p={style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size/h,className:t.className};Ck(e+.5*l+d,i+s-u-1,p,o.svgElements,o.svg),Ck(e+1.5*l+d+2,i+s-c-1,p,o.svgElements,o.svg)}},ZR.draw=function(t,e,i){var n,r,o,s,a,l,h=[],u={},c=0;for(a=0;a<t.length;a++)if("bar"===(s=i.groups[t[a]]).options.style&&!0===s.visible&&(void 0===i.options.groups.visibility[t[a]]||!0===i.options.groups.visibility[t[a]]))for(l=0;l<e[t[a]].length;l++)h.push({screen_x:e[t[a]][l].screen_x,screen_end:e[t[a]][l].screen_end,screen_y:e[t[a]][l].screen_y,x:e[t[a]][l].x,end:e[t[a]][l].end,y:e[t[a]][l].y,groupId:t[a],label:e[t[a]][l].label}),c+=1;if(0!==c)for(LE(h).call(h,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x})),ZR._getDataIntersections(u,h),a=0;a<h.length;a++){var d=null!=(s=i.groups[h[a].groupId]).options.barChart.minWidth?s.options.barChart.minWidth:.1*s.options.barChart.width,p=0;if(void 0===u[r=h[a].screen_x])a+1<h.length&&(n=Math.abs(h[a+1].screen_x-r)),o=ZR._getSafeDrawData(n,s,d);else{var f=a+(u[r].amount-u[r].resolved);f<h.length&&(n=Math.abs(h[f].screen_x-r)),o=ZR._getSafeDrawData(n,s,d),u[r].resolved+=1,!0===s.options.stack&&!0!==s.options.excludeFromStacking?h[a].screen_y<s.zeroPosition?(p=u[r].accumulatedNegative,u[r].accumulatedNegative+=s.zeroPosition-h[a].screen_y):(p=u[r].accumulatedPositive,u[r].accumulatedPositive+=s.zeroPosition-h[a].screen_y):!0===s.options.barChart.sideBySide&&(o.width=o.width/u[r].amount,o.offset+=u[r].resolved*o.width-.5*o.width*(u[r].amount+1))}var m=o.width,v=h[a].screen_x;if(null!=h[a].screen_end?v+=.5*(m=h[a].screen_end-h[a].screen_x):v+=o.offset,Tk(v,h[a].screen_y-p,m,s.zeroPosition-h[a].screen_y,s.className+" vis-bar",i.svgElements,i.svg,s.style),!0===s.options.drawPoints.enabled){var g={screen_x:h[a].screen_x,screen_y:h[a].screen_y-p,x:h[a].x,y:h[a].y,groupId:h[a].groupId,label:h[a].label};qR.draw([g],s,i,o.offset)}}},ZR._getDataIntersections=function(t,e){for(var i,n=0;n<e.length;n++)n+1<e.length&&(i=Math.abs(e[n+1].screen_x-e[n].screen_x)),n>0&&(i=Math.min(i,Math.abs(e[n-1].screen_x-e[n].screen_x))),0===i&&(void 0===t[e[n].screen_x]&&(t[e[n].screen_x]={amount:0,resolved:0,accumulatedPositive:0,accumulatedNegative:0}),t[e[n].screen_x].amount+=1)},ZR._getSafeDrawData=function(t,e,i){var n,r;return t<e.options.barChart.width&&t>0?(n=t<i?i:t,r=0,"left"===e.options.barChart.align?r-=.5*t:"right"===e.options.barChart.align&&(r+=.5*t)):(n=e.options.barChart.width,r=0,"left"===e.options.barChart.align?r-=.5*e.options.barChart.width:"right"===e.options.barChart.align&&(r+=.5*e.options.barChart.width)),{width:n,offset:r}},ZR.getStackedYRange=function(t,e,i,n,r){if(t.length>0){LE(t).call(t,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x}));var o={};ZR._getDataIntersections(o,t),e[n]=ZR._getStackedYRange(o,t),e[n].yAxisOrientation=r,i.push(n)}},ZR._getStackedYRange=function(t,e){for(var i,n=e[0].screen_y,r=e[0].screen_y,o=0;o<e.length;o++)void 0===t[i=e[o].screen_x]?(n=n>e[o].screen_y?e[o].screen_y:n,r=r<e[o].screen_y?e[o].screen_y:r):e[o].screen_y<0?t[i].accumulatedNegative+=e[o].screen_y:t[i].accumulatedPositive+=e[o].screen_y;for(var s in t)t.hasOwnProperty(s)&&(n=(n=n>t[s].accumulatedNegative?t[s].accumulatedNegative:n)>t[s].accumulatedPositive?t[s].accumulatedPositive:n,r=(r=r<t[s].accumulatedNegative?t[s].accumulatedNegative:r)<t[s].accumulatedPositive?t[s].accumulatedPositive:r);return{min:n,max:r}},KR.calcPath=function(t,e){if(null!=t&&t.length>0){return 1==e.options.interpolation.enabled?KR._catmullRom(t,e):KR._linear(t)}},KR.drawIcon=function(t,e,i,n,r,o){var s,a,l=.5*r,h=Dk("rect",o.svgElements,o.svg);(h.setAttributeNS(null,"x",e),h.setAttributeNS(null,"y",i-l),h.setAttributeNS(null,"width",n),h.setAttributeNS(null,"height",2*l),h.setAttributeNS(null,"class","vis-outline"),(s=Dk("path",o.svgElements,o.svg)).setAttributeNS(null,"class",t.className),void 0!==t.style&&s.setAttributeNS(null,"style",t.style),s.setAttributeNS(null,"d","M"+e+","+i+" L"+(e+n)+","+i),1==t.options.shaded.enabled&&(a=Dk("path",o.svgElements,o.svg),"top"==t.options.shaded.orientation?a.setAttributeNS(null,"d","M"+e+", "+(i-l)+"L"+e+","+i+" L"+(e+n)+","+i+" L"+(e+n)+","+(i-l)):a.setAttributeNS(null,"d","M"+e+","+i+" L"+e+","+(i+l)+" L"+(e+n)+","+(i+l)+"L"+(e+n)+","+i),a.setAttributeNS(null,"class",t.className+" vis-icon-fill"),void 0!==t.options.shaded.style&&""!==t.options.shaded.style&&a.setAttributeNS(null,"style",t.options.shaded.style)),1==t.options.drawPoints.enabled)&&Ck(e+.5*n,i,{style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size,className:t.className},o.svgElements,o.svg)},KR.drawShading=function(t,e,i,n){if(1==e.options.shaded.enabled){var r,o=Number(n.svg.style.height.replace("px","")),s=Dk("path",n.svgElements,n.svg),a="L";1==e.options.interpolation.enabled&&(a="C");var l=0;l="top"==e.options.shaded.orientation?0:"bottom"==e.options.shaded.orientation?o:Math.min(Math.max(0,e.zeroPosition),o),r="group"==e.options.shaded.orientation&&null!=i&&null!=i?"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" L"+i[i.length-1][0]+","+i[i.length-1][1]+" "+this.serializePath(i,a,!0)+i[0][0]+","+i[0][1]+" Z":"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" V"+l+" H"+t[0][0]+" Z",s.setAttributeNS(null,"class",e.className+" vis-fill"),void 0!==e.options.shaded.style&&s.setAttributeNS(null,"style",e.options.shaded.style),s.setAttributeNS(null,"d",r)}},KR.draw=function(t,e,i){if(null!=t&&null!=t){var n=Dk("path",i.svgElements,i.svg);n.setAttributeNS(null,"class",e.className),void 0!==e.style&&n.setAttributeNS(null,"style",e.style);var r="L";1==e.options.interpolation.enabled&&(r="C"),n.setAttributeNS(null,"d","M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,r,!1))}},KR.serializePath=function(t,e,i){if(t.length<2)return"";var n,r=e;if(i)for(n=t.length-2;n>0;n--)r+=t[n][0]+","+t[n][1]+" ";else for(n=1;n<t.length;n++)r+=t[n][0]+","+t[n][1]+" ";return r},KR._catmullRomUniform=function(t){var e,i,n,r,o,s,a=[];a.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var l=1/6,h=t.length,u=0;u<h-1;u++)e=0==u?t[0]:t[u-1],i=t[u],n=t[u+1],r=u+2<h?t[u+2]:n,o={screen_x:(-e.screen_x+6*i.screen_x+n.screen_x)*l,screen_y:(-e.screen_y+6*i.screen_y+n.screen_y)*l},s={screen_x:(i.screen_x+6*n.screen_x-r.screen_x)*l,screen_y:(i.screen_y+6*n.screen_y-r.screen_y)*l},a.push([o.screen_x,o.screen_y]),a.push([s.screen_x,s.screen_y]),a.push([n.screen_x,n.screen_y]);return a},KR._catmullRom=function(t,e){var i=e.options.interpolation.alpha;if(0==i||void 0===i)return this._catmullRomUniform(t);var n,r,o,s,a,l,h,u,c,d,p,f,m,v,g,y,b,_,w,k=[];k.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var x=t.length,D=0;D<x-1;D++)n=0==D?t[0]:t[D-1],r=t[D],o=t[D+1],s=D+2<x?t[D+2]:o,h=Math.sqrt(Math.pow(n.screen_x-r.screen_x,2)+Math.pow(n.screen_y-r.screen_y,2)),u=Math.sqrt(Math.pow(r.screen_x-o.screen_x,2)+Math.pow(r.screen_y-o.screen_y,2)),c=Math.sqrt(Math.pow(o.screen_x-s.screen_x,2)+Math.pow(o.screen_y-s.screen_y,2)),v=Math.pow(c,i),y=Math.pow(c,2*i),g=Math.pow(u,i),b=Math.pow(u,2*i),w=Math.pow(h,i),d=2*(_=Math.pow(h,2*i))+3*w*g+b,p=2*y+3*v*g+b,(f=3*w*(w+g))>0&&(f=1/f),(m=3*v*(v+g))>0&&(m=1/m),a={screen_x:(-b*n.screen_x+d*r.screen_x+_*o.screen_x)*f,screen_y:(-b*n.screen_y+d*r.screen_y+_*o.screen_y)*f},l={screen_x:(y*r.screen_x+p*o.screen_x-b*s.screen_x)*m,screen_y:(y*r.screen_y+p*o.screen_y-b*s.screen_y)*m},0==a.screen_x&&0==a.screen_y&&(a=r),0==l.screen_x&&0==l.screen_y&&(l=o),k.push([a.screen_x,a.screen_y]),k.push([l.screen_x,l.screen_y]),k.push([o.screen_x,o.screen_y]);return k},KR._linear=function(t){for(var e=[],i=0;i<t.length;i++)e.push([t[i].screen_x,t[i].screen_y]);return e},JR.prototype.setItems=function(t){null!=t?(this.itemsData=t,1==LE(this.options)&&SA.insertSort(this.itemsData,(function(t,e){return t.x>e.x?1:-1}))):this.itemsData=[]},JR.prototype.getItems=function(){return this.itemsData},JR.prototype.setZeroPosition=function(t){this.zeroPosition=t},JR.prototype.setOptions=function(t){if(void 0!==t){SA.selectiveDeepExtend(["sampling","style","sort","yAxisOrientation","barChart","zIndex","excludeFromStacking","excludeFromLegend"],this.options,t),"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),SA.mergeOptions(this.options,t,"interpolation"),SA.mergeOptions(this.options,t,"drawPoints"),SA.mergeOptions(this.options,t,"shaded"),t.interpolation&&"object"==Nd(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5))}},JR.prototype.update=function(t){this.group=t,this.content=t.content||"graph",this.className=t.className||this.className||"vis-graph-group"+this.groupsUsingDefaultStyles[0]%10,this.visible=void 0===t.visible||t.visible,this.style=t.style,this.setOptions(t.options)},JR.prototype.getLegend=function(t,e,i,n,r){null!=i&&null!=i||(i={svg:document.createElementNS("http://www.w3.org/2000/svg","svg"),svgElements:{},options:this.options,groups:[this]});switch(null!=n&&null!=n||(n=0),null!=r&&null!=r||(r=.5*e),this.options.style){case"line":KR.drawIcon(this,n,r,t,e,i);break;case"points":case"point":qR.drawIcon(this,n,r,t,e,i);break;case"bar":ZR.drawIcon(this,n,r,t,e,i)}return{icon:i.svg,label:this.content,orientation:this.options.yAxisOrientation}},JR.prototype.getYRange=function(t){for(var e=t[0].y,i=t[0].y,n=0;n<t.length;n++)e=e>t[n].y?t[n].y:e,i=i<t[n].y?t[n].y:i;return{min:e,max:i,yAxisOrientation:this.options.yAxisOrientation}},QR.prototype=new HA,QR.prototype.clear=function(){this.groups={},this.amountOfGroups=0},QR.prototype.addGroup=function(t,e){1!=e.options.excludeFromLegend&&(this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1)},QR.prototype.updateGroup=function(t,e){this.groups[t]=e},QR.prototype.removeGroup=function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)},QR.prototype._create=function(){this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-legend",this.dom.frame.style.position="absolute",this.dom.frame.style.top="10px",this.dom.frame.style.display="block",this.dom.textArea=document.createElement("div"),this.dom.textArea.className="vis-legend-text",this.dom.textArea.style.position="relative",this.dom.textArea.style.top="0px",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.width=this.options.iconSize+5+"px",this.svg.style.height="100%",this.dom.frame.appendChild(this.svg),this.dom.frame.appendChild(this.dom.textArea)},QR.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},QR.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},QR.prototype.setOptions=function(t){SA.selectiveDeepExtend(["enabled","orientation","icons","left","right"],this.options,t)},QR.prototype.redraw=function(){var t=0,e=gf(this.groups);LE(e).call(e,(function(t,e){return t<e?-1:1}));for(var i=0;i<e.length;i++){var n=e[i];1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||t++}if(0==this.options[this.side].visible||0==this.amountOfGroups||0==this.options.enabled||0==t)this.hide();else{if(this.show(),"top-left"==this.options[this.side].position||"bottom-left"==this.options[this.side].position?(this.dom.frame.style.left="4px",this.dom.frame.style.textAlign="left",this.dom.textArea.style.textAlign="left",this.dom.textArea.style.left=this.options.iconSize+15+"px",this.dom.textArea.style.right="",this.svg.style.left="0px",this.svg.style.right=""):(this.dom.frame.style.right="4px",this.dom.frame.style.textAlign="right",this.dom.textArea.style.textAlign="right",this.dom.textArea.style.right=this.options.iconSize+15+"px",this.dom.textArea.style.left="",this.svg.style.right="0px",this.svg.style.left=""),"top-left"==this.options[this.side].position||"top-right"==this.options[this.side].position)this.dom.frame.style.top=4-Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.bottom="";else{var r=this.body.domProps.center.height-this.body.domProps.centerContainer.height;this.dom.frame.style.bottom=4+r+Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.top=""}0==this.options.icons?(this.dom.frame.style.width=this.dom.textArea.offsetWidth+10+"px",this.dom.textArea.style.right="",this.dom.textArea.style.left="",this.svg.style.width="0px"):(this.dom.frame.style.width=this.options.iconSize+15+this.dom.textArea.offsetWidth+10+"px",this.drawLegendIcons());var o="";for(i=0;i<e.length;i++)n=e[i],1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||(o+=this.groups[n].content+"<br />");this.dom.textArea.innerHTML=SA.xss(o),this.dom.textArea.style.lineHeight=.75*this.options.iconSize+this.options.iconSpacing+"px"}},QR.prototype.drawLegendIcons=function(){if(this.dom.frame.parentNode){var t=gf(this.groups);LE(t).call(t,(function(t,e){return t<e?-1:1})),xk(this.svgElements);var e=window.getComputedStyle(this.dom.frame).paddingTop,i=Number(e.replace("px","")),n=i,r=this.options.iconSize,o=.75*this.options.iconSize,s=i+.5*o+3;this.svg.style.width=r+5+i+"px";for(var a=0;a<t.length;a++){var l=t[a];1!=this.groups[l].visible||void 0!==this.linegraphOptions.visibility[l]&&1!=this.linegraphOptions.visibility[l]||(this.groups[l].getLegend(r,o,this.framework,n,s),s+=o+this.options.iconSpacing)}}};var tF="__ungrouped__";function eF(t,e){this.id=qP(),this.body=t,this.defaultOptions={yAxisOrientation:"left",defaultGroup:"default",sort:!0,sampling:!0,stack:!1,graphHeight:"400px",shaded:{enabled:!1,orientation:"bottom"},style:"line",barChart:{width:50,sideBySide:!1,align:"center"},interpolation:{enabled:!0,parametrization:"centripetal",alpha:.5},drawPoints:{enabled:!0,size:6,style:"square"},dataAxis:{},legend:{},groups:{visibility:{}}},this.options=SA.extend({},this.defaultOptions),this.dom={},this.props={},this.hammer=null,this.groups={},this.abortedGraphUpdate=!1,this.updateSVGheight=!1,this.updateSVGheightOnResize=!1,this.forceGraphUpdate=!0;var i=this;this.itemsData=null,this.groupsData=null,this.itemListeners={add:function(t,e,n){i._onAdd(e.items)},update:function(t,e,n){i._onUpdate(e.items)},remove:function(t,e,n){i._onRemove(e.items)}},this.groupListeners={add:function(t,e,n){i._onAddGroups(e.items)},update:function(t,e,n){i._onUpdateGroups(e.items)},remove:function(t,e,n){i._onRemoveGroups(e.items)}},this.items={},this.selection=[],this.lastStart=this.body.range.start,this.touchParams={},this.svgElements={},this.setOptions(e),this.groupsUsingDefaultStyles=[0],this.body.emitter.on("rangechanged",(function(){i.svg.style.left=SA.option.asSize(-i.props.width),i.forceGraphUpdate=!0,i.redraw.call(i)})),this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups}}eF.prototype=new HA,eF.prototype._create=function(){var t=document.createElement("div");t.className="vis-line-graph",this.dom.frame=t,this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="relative",this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",this.svg.style.display="block",t.appendChild(this.svg),this.options.dataAxis.orientation="left",this.yAxisLeft=new XR(this.body,this.options.dataAxis,this.svg,this.options.groups),this.options.dataAxis.orientation="right",this.yAxisRight=new XR(this.body,this.options.dataAxis,this.svg,this.options.groups),delete this.options.dataAxis.orientation,this.legendLeft=new QR(this.body,this.options.legend,"left",this.options.groups),this.legendRight=new QR(this.body,this.options.legend,"right",this.options.groups),this.show()},eF.prototype.setOptions=function(t){if(t){void 0===t.graphHeight&&void 0!==t.height?(this.updateSVGheight=!0,this.updateSVGheightOnResize=!0):void 0!==this.body.domProps.centerContainer.height&&void 0!==t.graphHeight&&Yg((t.graphHeight+"").replace("px",""))<this.body.domProps.centerContainer.height&&(this.updateSVGheight=!0),SA.selectiveDeepExtend(["sampling","defaultGroup","stack","height","graphHeight","yAxisOrientation","style","barChart","dataAxis","sort","groups"],this.options,t),SA.mergeOptions(this.options,t,"interpolation"),SA.mergeOptions(this.options,t,"drawPoints"),SA.mergeOptions(this.options,t,"shaded"),SA.mergeOptions(this.options,t,"legend"),t.interpolation&&"object"==Nd(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5)),this.yAxisLeft&&void 0!==t.dataAxis&&(this.yAxisLeft.setOptions(this.options.dataAxis),this.yAxisRight.setOptions(this.options.dataAxis)),this.legendLeft&&void 0!==t.legend&&(this.legendLeft.setOptions(this.options.legend),this.legendRight.setOptions(this.options.legend)),this.groups.hasOwnProperty(tF)&&this.groups[tF].setOptions(t)}this.dom.frame&&(this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0}))},eF.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},eF.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},eF.prototype.setItems=function(t){var e,i=this,n=this.itemsData;if(t){if(!gA(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.itemsData=wA(t)}else this.itemsData=null;if(n&&(am(SA).call(SA,this.itemListeners,(function(t,e){n.off(e,t)})),n.dispose(),e=n.getIds(),this._onRemove(e)),this.itemsData){var r=this.id;am(SA).call(SA,this.itemListeners,(function(t,e){i.itemsData.on(e,t,r)})),e=this.itemsData.getIds(),this._onAdd(e)}},eF.prototype.setGroups=function(t){var e,i=this;if(this.groupsData){am(SA).call(SA,this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null;for(var n=0;n<e.length;n++)this._removeGroup(e[n])}if(t){if(!gA(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var r=this.id;am(SA).call(SA,this.groupListeners,(function(t,e){i.groupsData.on(e,t,r)})),e=this.groupsData.getIds(),this._onAddGroups(e)}},eF.prototype._onUpdate=function(t){this._updateAllGroupData(t)},eF.prototype._onAdd=function(t){this._onUpdate(t)},eF.prototype._onRemove=function(t){this._onUpdate(t)},eF.prototype._onUpdateGroups=function(t){this._updateAllGroupData(null,t)},eF.prototype._onAddGroups=function(t){this._onUpdateGroups(t)},eF.prototype._onRemoveGroups=function(t){for(var e=0;e<t.length;e++)this._removeGroup(t[e]);this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})},eF.prototype._removeGroup=function(t){this.groups.hasOwnProperty(t)&&("right"==this.groups[t].options.yAxisOrientation?(this.yAxisRight.removeGroup(t),this.legendRight.removeGroup(t),this.legendRight.redraw()):(this.yAxisLeft.removeGroup(t),this.legendLeft.removeGroup(t),this.legendLeft.redraw()),delete this.groups[t])},eF.prototype._updateGroup=function(t,e){this.groups.hasOwnProperty(e)?(this.groups[e].update(t),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.updateGroup(e,this.groups[e]),this.legendRight.updateGroup(e,this.groups[e]),this.yAxisLeft.removeGroup(e),this.legendLeft.removeGroup(e)):(this.yAxisLeft.updateGroup(e,this.groups[e]),this.legendLeft.updateGroup(e,this.groups[e]),this.yAxisRight.removeGroup(e),this.legendRight.removeGroup(e))):(this.groups[e]=new JR(t,e,this.options,this.groupsUsingDefaultStyles),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.addGroup(e,this.groups[e]),this.legendRight.addGroup(e,this.groups[e])):(this.yAxisLeft.addGroup(e,this.groups[e]),this.legendLeft.addGroup(e,this.groups[e]))),this.legendLeft.redraw(),this.legendRight.redraw()},eF.prototype._updateAllGroupData=function(t,e){if(null!=this.itemsData){var i={},n=this.itemsData.get(),r=this.itemsData.idProp,o={};t&&cf(t).call(t,(function(t){o[t]=t}));for(var s={},a=0;a<n.length;a++){var l=n[a],h=l.group;null==h&&(h=tF),s.hasOwnProperty(h)?s[h]++:s[h]=1}var u={};if(!e&&t)for(h in this.groups)if(this.groups.hasOwnProperty(h)){var c=(m=this.groups[h]).getItems();i[h]=ig(c).call(c,(function(t){return u[t[r]]=t[r],t[r]!==o[t[r]]}));var d=s[h];s[h]-=i[h].length,i[h].length<d&&(i[h][d-1]={})}for(a=0;a<n.length;a++)if(null==(h=(l=n[a]).group)&&(h=tF),e||!t||l[r]===o[l[r]]||!u.hasOwnProperty(l[r])){i.hasOwnProperty(h)||(i[h]=new Array(s[h]));var p=SA.bridgeObject(l);p.x=SA.convert(l.x,"Date"),p.end=SA.convert(l.end,"Date"),p.orginalY=l.y,p.y=Number(l.y),p[r]=l[r];var f=i[h].length-s[h]--;i[h][f]=p}for(h in this.groups)this.groups.hasOwnProperty(h)&&(i.hasOwnProperty(h)||(i[h]=new Array(0)));for(h in i)if(i.hasOwnProperty(h))if(0==i[h].length)this.groups.hasOwnProperty(h)&&this._removeGroup(h);else{var m=void 0;null!=this.groupsData&&(m=this.groupsData.get(h)),null==m&&(m={id:h,content:this.options.defaultGroup+h}),this._updateGroup(m,h),this.groups[h].setItems(i[h])}this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})}},eF.prototype.redraw=function(){var t=!1;this.props.width=this.dom.frame.offsetWidth,this.props.height=this.body.domProps.centerContainer.height-this.body.domProps.border.top-this.body.domProps.border.bottom,t=this._isResized()||t;var e,i=this.body.range.end-this.body.range.start,n=i!=this.lastVisibleInterval;(this.lastVisibleInterval=i,1==t)&&(this.svg.style.width=SA.option.asSize(3*this.props.width),this.svg.style.left=SA.option.asSize(-this.props.width),-1==Qg(e=this.options.height+"").call(e,"%")&&1!=this.updateSVGheightOnResize||(this.updateSVGheight=!0));if(1==this.updateSVGheight?(this.options.graphHeight!=this.props.height+"px"&&(this.options.graphHeight=this.props.height+"px",this.svg.style.height=this.props.height+"px"),this.updateSVGheight=!1):this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",1==t||1==n||1==this.abortedGraphUpdate||1==this.forceGraphUpdate)t=this._updateGraph()||t,this.forceGraphUpdate=!1,this.lastStart=this.body.range.start,this.svg.style.left=-this.props.width+"px";else if(0!=this.lastStart){var r=this.body.range.start-this.lastStart,o=this.body.range.end-this.body.range.start;if(0!=this.props.width){var s=r*(this.props.width/o);this.svg.style.left=-this.props.width-s+"px"}}return this.legendLeft.redraw(),this.legendRight.redraw(),t},eF.prototype._getSortedGroupIds=function(){var t=[];for(var e in this.groups)if(this.groups.hasOwnProperty(e)){var i=this.groups[e];1!=i.visible||void 0!==this.options.groups.visibility[e]&&1!=this.options.groups.visibility[e]||t.push({id:e,zIndex:i.options.zIndex})}SA.insertSort(t,(function(t,e){var i=t.zIndex,n=e.zIndex;return void 0===i&&(i=0),void 0===n&&(n=0),i==n?0:i<n?-1:1}));for(var n=new Array(t.length),r=0;r<t.length;r++)n[r]=t[r].id;return n},eF.prototype._updateGraph=function(){if(wk(this.svgElements),0!=this.props.width&&null!=this.itemsData){var t,e,i={},n=this.body.util.toGlobalTime(-this.body.domProps.root.width),r=this.body.util.toGlobalTime(2*this.body.domProps.root.width),o=this._getSortedGroupIds();if(o.length>0){var s={};for(this._getRelevantData(o,s,n,r),this._applySampling(o,s),e=0;e<o.length;e++)this._convertXcoordinates(s[o[e]]);if(this._getYRanges(o,s,i),1==this._updateYAxis(o,i))return kk(this.svgElements),this.abortedGraphUpdate=!0,!0;this.abortedGraphUpdate=!1;var a=void 0;for(e=0;e<o.length;e++)t=this.groups[o[e]],!0===this.options.stack&&"line"===this.options.style&&(null!=t.options.excludeFromStacking&&t.options.excludeFromStacking||(null!=a&&(this._stack(s[t.id],s[a.id]),1==t.options.shaded.enabled&&"group"!==t.options.shaded.orientation&&("top"==t.options.shaded.orientation&&"group"!==a.options.shaded.orientation?(a.options.shaded.orientation="group",a.options.shaded.groupId=t.id):(t.options.shaded.orientation="group",t.options.shaded.groupId=a.id))),a=t)),this._convertYcoordinates(s[o[e]],t);var l={};for(e=0;e<o.length;e++)if("line"===(t=this.groups[o[e]]).options.style&&1==t.options.shaded.enabled){var h=s[o[e]];if(null==h||0==h.length)continue;if(l.hasOwnProperty(o[e])||(l[o[e]]=KR.calcPath(h,t)),"group"===t.options.shaded.orientation){var u=t.options.shaded.groupId;if(-1===Qg(o).call(o,u)){console.log(t.id+": Unknown shading group target given:"+u);continue}l.hasOwnProperty(u)||(l[u]=KR.calcPath(s[u],this.groups[u])),KR.drawShading(l[o[e]],t,l[u],this.framework)}else KR.drawShading(l[o[e]],t,void 0,this.framework)}for(ZR.draw(o,s,this.framework),e=0;e<o.length;e++)if(t=this.groups[o[e]],s[o[e]].length>0)switch(t.options.style){case"line":l.hasOwnProperty(o[e])||(l[o[e]]=KR.calcPath(s[o[e]],t)),KR.draw(l[o[e]],t,this.framework);case"point":case"points":"point"!=t.options.style&&"points"!=t.options.style&&1!=t.options.drawPoints.enabled||qR.draw(s[o[e]],t,this.framework)}}}return kk(this.svgElements),!1},eF.prototype._stack=function(t,e){var i,n,r,o,s;i=0;for(var a=0;a<t.length;a++){o=void 0,s=void 0;for(var l=i;l<e.length;l++){if(e[l].x===t[a].x){o=e[l],s=e[l],i=l;break}if(e[l].x>t[a].x){s=e[l],o=0==l?s:e[l-1],i=l;break}}void 0===s&&(o=e[e.length-1],s=e[e.length-1]),n=s.x-o.x,r=s.y-o.y,t[a].y=0==n?t[a].orginalY+s.y:t[a].orginalY+r/n*(t[a].x-o.x)+o.y}},eF.prototype._getRelevantData=function(t,e,i,n){var r,o,s,a;if(t.length>0)for(o=0;o<t.length;o++){var l=(r=this.groups[t[o]]).getItems();if(1==LE(r.options)){var h=function(t,e){return t.getTime()==e.getTime()?0:t<e?-1:1},u=Math.max(0,SA.binarySearchValue(l,i,"x","before",h)),c=Math.min(l.length,SA.binarySearchValue(l,n,"x","after",h)+1);c<=0&&(c=l.length);var d=new Array(c-u);for(s=u;s<c;s++)a=r.itemsData[s],d[s-u]=a;e[t[o]]=d}else e[t[o]]=r.itemsData}},eF.prototype._applySampling=function(t,e){if(t.length>0)for(var i=0;i<t.length;i++)if(1==this.groups[t[i]].options.sampling){var n=e[t[i]];if(n.length>0){var r,o=n.length,s=o/(this.body.util.toGlobalScreen(n[n.length-1].x)-this.body.util.toGlobalScreen(n[0].x));r=Math.min(Math.ceil(.2*o),Math.max(1,Math.round(s)));for(var a=new Array(o),l=0;l<o;l+=r){a[Math.round(l/r)]=n[l]}e[t[i]]=Zm(a).call(a,0,Math.round(o/r))}}},eF.prototype._getYRanges=function(t,e,i){var n,r,o,s,a=[],l=[];if(t.length>0){for(o=0;o<t.length;o++)n=e[t[o]],s=this.groups[t[o]].options,n.length>0&&(r=this.groups[t[o]],!0===s.stack&&"bar"===s.style?"left"===s.yAxisOrientation?a=Up(a).call(a,n):l=Up(l).call(l,n):i[t[o]]=r.getYRange(n,t[o]));ZR.getStackedYRange(a,i,t,"__barStackLeft","left"),ZR.getStackedYRange(l,i,t,"__barStackRight","right")}},eF.prototype._updateYAxis=function(t,e){var i,n,r=!1,o=!1,s=!1,a=1e9,l=1e9,h=-1e9,u=-1e9;if(t.length>0){for(var c=0;c<t.length;c++){var d=this.groups[t[c]];d&&"right"!=d.options.yAxisOrientation?(o=!0,a=1e9,h=-1e9):d&&d.options.yAxisOrientation&&(s=!0,l=1e9,u=-1e9)}for(c=0;c<t.length;c++)e.hasOwnProperty(t[c])&&!0!==e[t[c]].ignore&&(i=e[t[c]].min,n=e[t[c]].max,"right"!=e[t[c]].yAxisOrientation?(o=!0,a=a>i?i:a,h=h<n?n:h):(s=!0,l=l>i?i:l,u=u<n?n:u));1==o&&this.yAxisLeft.setRange(a,h),1==s&&this.yAxisRight.setRange(l,u)}r=this._toggleAxisVisiblity(o,this.yAxisLeft)||r,r=this._toggleAxisVisiblity(s,this.yAxisRight)||r,1==s&&1==o?(this.yAxisLeft.drawIcons=!0,this.yAxisRight.drawIcons=!0):(this.yAxisLeft.drawIcons=!1,this.yAxisRight.drawIcons=!1),this.yAxisRight.master=!o,this.yAxisRight.masterAxis=this.yAxisLeft,0==this.yAxisRight.master?(this.yAxisLeft.lineOffset=1==s?this.yAxisRight.width:0,r=this.yAxisLeft.redraw()||r,r=this.yAxisRight.redraw()||r):r=this.yAxisRight.redraw()||r;var p=["__barStackLeft","__barStackRight","__lineStackLeft","__lineStackRight"];for(c=0;c<p.length;c++)-1!=Qg(t).call(t,p[c])&&Zm(t).call(t,Qg(t).call(t,p[c]),1);return r},eF.prototype._toggleAxisVisiblity=function(t,e){var i=!1;return 0==t?e.dom.frame.parentNode&&0==e.hidden&&(e.hide(),i=!0):e.dom.frame.parentNode||1!=e.hidden||(e.show(),i=!0),i},eF.prototype._convertXcoordinates=function(t){for(var e=this.body.util.toScreen,i=0;i<t.length;i++)t[i].screen_x=e(t[i].x)+this.props.width,t[i].screen_y=t[i].y,null!=t[i].end?t[i].screen_end=e(t[i].end)+this.props.width:t[i].screen_end=void 0},eF.prototype._convertYcoordinates=function(t,e){var i=this.yAxisLeft,n=Number(this.svg.style.height.replace("px",""));"right"==e.options.yAxisOrientation&&(i=this.yAxisRight);for(var r=0;r<t.length;r++)t[r].screen_y=Math.round(i.convertValue(t[r].y));e.setZeroPosition(Math.min(n,i.convertValue(0)))};var iF="string",nF="boolean",rF="number",oF="date",sF="object",aF="moment",lF={configure:{enabled:{boolean:nF},filter:{boolean:nF,function:"function"},container:{dom:"dom"},__type__:{object:sF,boolean:nF,function:"function"}},alignCurrentTime:{string:iF,undefined:"undefined"},yAxisOrientation:{string:["left","right"]},defaultGroup:{string:iF},sort:{boolean:nF},sampling:{boolean:nF},stack:{boolean:nF},graphHeight:{string:iF,number:rF},shaded:{enabled:{boolean:nF},orientation:{string:["bottom","top","zero","group"]},groupId:{object:sF},__type__:{boolean:nF,object:sF}},style:{string:["line","bar","points"]},barChart:{width:{number:rF},minWidth:{number:rF},sideBySide:{boolean:nF},align:{string:["left","center","right"]},__type__:{object:sF}},interpolation:{enabled:{boolean:nF},parametrization:{string:["centripetal","chordal","uniform"]},alpha:{number:rF},__type__:{object:sF,boolean:nF}},drawPoints:{enabled:{boolean:nF},onRender:{function:"function"},size:{number:rF},style:{string:["square","circle"]},__type__:{object:sF,boolean:nF,function:"function"}},dataAxis:{showMinorLabels:{boolean:nF},showMajorLabels:{boolean:nF},showWeekScale:{boolean:nF},icons:{boolean:nF},width:{string:iF,number:rF},visible:{boolean:nF},alignZeros:{boolean:nF},left:{range:{min:{number:rF,undefined:"undefined"},max:{number:rF,undefined:"undefined"},__type__:{object:sF}},format:{function:"function"},title:{text:{string:iF,number:rF,undefined:"undefined"},style:{string:iF,undefined:"undefined"},__type__:{object:sF}},__type__:{object:sF}},right:{range:{min:{number:rF,undefined:"undefined"},max:{number:rF,undefined:"undefined"},__type__:{object:sF}},format:{function:"function"},title:{text:{string:iF,number:rF,undefined:"undefined"},style:{string:iF,undefined:"undefined"},__type__:{object:sF}},__type__:{object:sF}},__type__:{object:sF}},legend:{enabled:{boolean:nF},icons:{boolean:nF},left:{visible:{boolean:nF},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:sF}},right:{visible:{boolean:nF},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:sF}},__type__:{object:sF,boolean:nF}},groups:{visibility:{any:"any"},__type__:{object:sF}},autoResize:{boolean:nF},throttleRedraw:{number:rF},clickToUse:{boolean:nF},end:{number:rF,date:oF,string:iF,moment:aF},format:{minorLabels:{millisecond:{string:iF,undefined:"undefined"},second:{string:iF,undefined:"undefined"},minute:{string:iF,undefined:"undefined"},hour:{string:iF,undefined:"undefined"},weekday:{string:iF,undefined:"undefined"},day:{string:iF,undefined:"undefined"},week:{string:iF,undefined:"undefined"},month:{string:iF,undefined:"undefined"},quarter:{string:iF,undefined:"undefined"},year:{string:iF,undefined:"undefined"},__type__:{object:sF}},majorLabels:{millisecond:{string:iF,undefined:"undefined"},second:{string:iF,undefined:"undefined"},minute:{string:iF,undefined:"undefined"},hour:{string:iF,undefined:"undefined"},weekday:{string:iF,undefined:"undefined"},day:{string:iF,undefined:"undefined"},week:{string:iF,undefined:"undefined"},month:{string:iF,undefined:"undefined"},quarter:{string:iF,undefined:"undefined"},year:{string:iF,undefined:"undefined"},__type__:{object:sF}},__type__:{object:sF}},moment:{function:"function"},height:{string:iF,number:rF},hiddenDates:{start:{date:oF,number:rF,string:iF,moment:aF},end:{date:oF,number:rF,string:iF,moment:aF},repeat:{string:iF},__type__:{object:sF,array:"array"}},locale:{string:iF},locales:{__any__:{any:"any"},__type__:{object:sF}},max:{date:oF,number:rF,string:iF,moment:aF},maxHeight:{number:rF,string:iF},maxMinorChars:{number:rF},min:{date:oF,number:rF,string:iF,moment:aF},minHeight:{number:rF,string:iF},moveable:{boolean:nF},multiselect:{boolean:nF},orientation:{string:iF},showCurrentTime:{boolean:nF},showMajorLabels:{boolean:nF},showMinorLabels:{boolean:nF},showWeekScale:{boolean:nF},snap:{function:"function",null:"null"},start:{date:oF,number:rF,string:iF,moment:aF},timeAxis:{scale:{string:iF,undefined:"undefined"},step:{number:rF,undefined:"undefined"},__type__:{object:sF}},width:{string:iF,number:rF},zoomable:{boolean:nF},zoomKey:{string:["ctrlKey","altKey","metaKey",""]},zoomMax:{number:rF},zoomMin:{number:rF},zIndex:{number:rF},__type__:{object:sF}},hF={global:{alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],sort:!0,sampling:!0,stack:!1,shaded:{enabled:!1,orientation:["zero","top","bottom","group"]},style:["line","bar","points"],barChart:{width:[50,5,100,5],minWidth:[50,5,100,5],sideBySide:!1,align:["left","center","right"]},interpolation:{enabled:!0,parametrization:["centripetal","chordal","uniform"]},drawPoints:{enabled:!0,size:[6,2,30,1],style:["square","circle"]},dataAxis:{showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,width:[40,0,200,1],visible:!0,alignZeros:!0,left:{title:{text:"",style:""}},right:{title:{text:"",style:""}}},legend:{enabled:!1,icons:!0,left:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]},right:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]}},autoResize:!0,clickToUse:!1,end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",quarter:"[Q]Q",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",quarter:"YYYY",year:""}},height:"",locale:"",max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!0,orientation:["both","bottom","top"],showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,showWeekScale:!1,start:"",width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],zIndex:0}};function uF(t,e,i,n){var r,o,s,a,l,h,u;if(!tf(i)&&!gA(i)&&i instanceof Object){var c=n;n=i,i=c}n&&n.throttleRedraw&&console.warn('Graph2d option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var d=this;this.defaultOptions={start:null,end:null,autoResize:!0,orientation:{axis:"bottom",item:"bottom"},moment:hI,width:null,height:null,maxHeight:null,minHeight:null},this.options=SA.deepExtend({},this.defaultOptions),this._create(t),this.components=[],this.body={dom:this.dom,domProps:this.props,emitter:{on:Uf(r=this.on).call(r,this),off:Uf(o=this.off).call(o,this),emit:Uf(s=this.emit).call(s,this)},hiddenDates:[],util:{getScale:function(){return d.timeAxis.step.scale},getStep:function(){return d.timeAxis.step.step},toScreen:Uf(a=d._toScreen).call(a,d),toGlobalScreen:Uf(l=d._toGlobalScreen).call(l,d),toTime:Uf(h=d._toTime).call(h,d),toGlobalTime:Uf(u=d._toGlobalTime).call(u,d)}},this.range=new mL(this.body),this.components.push(this.range),this.body.range=this.range,this.timeAxis=new TL(this.body),this.components.push(this.timeAxis),this.currentTime=new ZL(this.body),this.components.push(this.currentTime),this.linegraph=new eF(this.body),this.components.push(this.linegraph),this.itemsData=null,this.groupsData=null,this.on("tap",(function(t){d.emit("click",d.getEventProperties(t))})),this.on("doubletap",(function(t){d.emit("doubleClick",d.getEventProperties(t))})),this.dom.root.oncontextmenu=function(t){d.emit("contextmenu",d.getEventProperties(t))},this.initialFitDone=!1,this.on("changed",(function(){if(null!=d.itemsData){if(!d.initialFitDone&&!d.options.rollingMode)if(d.initialFitDone=!0,null!=d.options.start||null!=d.options.end){if(null==d.options.start||null==d.options.end)var t=d.getItemRange();var e=null!=d.options.start?d.options.start:t.min,i=null!=d.options.end?d.options.end:t.max;d.setWindow(e,i,{animation:!1})}else d.fit({animation:!1});d.initialDrawDone||!d.initialRangeChangeDone&&(d.options.start||d.options.end)&&!d.options.rollingMode||(d.initialDrawDone=!0,d.dom.root.style.visibility="visible",d.dom.loadingScreen.parentNode.removeChild(d.dom.loadingScreen),d.options.onInitialDrawComplete&&Xy((function(){return d.options.onInitialDrawComplete()}),0))}})),n&&this.setOptions(n),i&&this.setGroups(i),e&&this.setItems(e),this._redraw()}uF.prototype=new qL,uF.prototype.setOptions=function(t){!0===SR.validate(t,lF)&&console.log("%cErrors have been found in the supplied options object.",DR),qL.prototype.setOptions.call(this,t)},uF.prototype.setItems=function(t){var e,i=null==this.itemsData;if(e=t?gA(t)?wA(t):wA(new sI(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=e,this.linegraph&&this.linegraph.setItems(null!=e?e.rawDS:null),i)if(null!=this.options.start||null!=this.options.end){var n=null!=this.options.start?this.options.start:null,r=null!=this.options.end?this.options.end:null;this.setWindow(n,r,{animation:!1})}else this.fit({animation:!1})},uF.prototype.setGroups=function(t){var e;e=t?gA(t)?t:new sI(t):null,this.groupsData=e,this.linegraph.setGroups(e)},uF.prototype.getLegend=function(t,e,i){return void 0===e&&(e=15),void 0===i&&(i=15),void 0!==this.linegraph.groups[t]?this.linegraph.groups[t].getLegend(e,i):"cannot find group:'"+t+"'"},uF.prototype.isGroupVisible=function(t){return void 0!==this.linegraph.groups[t]&&(this.linegraph.groups[t].visible&&(void 0===this.linegraph.options.groups.visibility[t]||1==this.linegraph.options.groups.visibility[t]))},uF.prototype.getDataRange=function(){var t=null,e=null;for(var i in this.linegraph.groups)if(this.linegraph.groups.hasOwnProperty(i)&&1==this.linegraph.groups[i].visible)for(var n=0;n<this.linegraph.groups[i].itemsData.length;n++){var r=this.linegraph.groups[i].itemsData[n],o=SA.convert(r.x,"Date").valueOf();t=null==t||t>o?o:t,e=null==e||e<o?o:e}return{min:null!=t?new Date(t):null,max:null!=e?new Date(e):null}},uF.prototype.getEventProperties=function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=e-SA.getAbsoluteLeft(this.dom.centerContainer),r=i-SA.getAbsoluteTop(this.dom.centerContainer),o=this._toTime(n),s=XL.customTimeFromTarget(t),a=SA.getTarget(t),l=null;SA.hasParent(a,this.timeAxis.dom.foreground)||this.timeAxis2&&SA.hasParent(a,this.timeAxis2.dom.foreground)?l="axis":SA.hasParent(a,this.linegraph.yAxisLeft.dom.frame)||SA.hasParent(a,this.linegraph.yAxisRight.dom.frame)?l="data-axis":SA.hasParent(a,this.linegraph.legendLeft.dom.frame)||SA.hasParent(a,this.linegraph.legendRight.dom.frame)?l="legend":null!=s?l="custom-time":SA.hasParent(a,this.currentTime.bar)?l="current-time":SA.hasParent(a,this.dom.center)&&(l="background");var h=[],u=this.linegraph.yAxisLeft,c=this.linegraph.yAxisRight;return!u.hidden&&this.itemsData.length>0&&h.push(u.screenToValue(r)),!c.hidden&&this.itemsData.length>0&&h.push(c.screenToValue(r)),{event:t,customTime:s?s.options.id:null,what:l,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:n,y:r,time:o,value:h}},uF.prototype._createConfigurator=function(){return new FR(this,this.dom.container,hF)};var cF=Mk();hI.locale(cF);var dF={Core:qL,DateUtil:pL,Range:mL,stack:NN,TimeStep:DL,components:{items:{Item:BN,BackgroundItem:ZN,BoxItem:WN,ClusterItem:cR,PointItem:UN,RangeItem:qN},BackgroundGroup:YN,Component:HA,CurrentTime:ZL,CustomTime:XL,DataAxis:XR,DataScale:GR,GraphGroup:JR,Group:FN,ItemSet:wR,Legend:QR,LineGraph:eF,TimeAxis:TL}};t.DOMutil=Ok,t.DataSet=sI,t.DataView=aI,t.Graph2d=uF,t.Hammer=kL,t.Queue=nI,t.Timeline=YR,t.keycharm=OL,t.moment=hI,t.timeline=dF,t.util=_k}));
//# sourceMappingURL=vis-timeline-graph2d.min.js.map
